/*
 * Planck.js v0.1.38
 * 
 * Copyright (c) 2016-2018 Ali Shakiba http://shakiba.me/planck.js
 * Copyright (c) 2006-2013 Erin Catto  http://www.gphysics.com
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 */
/*
 * Stage.js 
 * 
 * @copyright 2017 Ali Shakiba http://shakiba.me/stage.js
 * @license The MIT License
 */
!function(t){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=t();else if("function"==typeof define&&define.amd)define([],t);else{var i;"undefined"!=typeof window?i=window:"undefined"!=typeof global?i=global:"undefined"!=typeof self&&(i=self),i.planck=t()}}(function(){return function t(i,e,o){function s(r,a){if(!e[r]){if(!i[r]){var m="function"==typeof require&&require;if(!a&&m)return m(r,!0);if(n)return n(r,!0);var h=new Error("Cannot find module '"+r+"'");throw h.code="MODULE_NOT_FOUND",h}var c=e[r]={exports:{}};i[r][0].call(c.exports,function(t){var e=i[r][1][t];return s(e||t)},c,c.exports,t,i,e,o)}return e[r].exports}for(var n="function"==typeof require&&require,r=0;r<o.length;r++)s(o[r]);return s}({1:[function(t,i,e){function o(t,i){o._super.call(this),this.label("Planck"),i=i||{};var e=this._options={};this._options.speed=i.speed||1,this._options.hz=i.hz||60,Math.abs(this._options.hz)<1&&(this._options.hz=1/this._options.hz),this._options.ratio=i.ratio||16,this._options.lineWidth=2/this._options.ratio,this._world=t;var s=1/this._options.hz,n=0;this.tick(function(i){for(n+=i=.001*i*e.speed;n>s;)t.step(s),n-=s;return this.renderWorld(),!0},!0),t.on("remove-fixture",function(t){t.ui&&t.ui.remove()}),t.on("remove-joint",function(t){t.ui&&t.ui.remove()})}var s=t("../lib/"),n=t("stage-js/platform/web");i.exports=s,s.testbed=function(t,i){"function"==typeof t&&(i=t,t=null),n(function(t,e){function r(t,i){"function"!=typeof i&&"object"!=typeof i&&(l[t]=i)}function a(t,i){var e=String.fromCharCode(t);/\w/.test(e)&&(B[e]=i),B.right=w[39]||B.D,B.left=w[37]||B.A,B.up=w[38]||B.W,B.down=w[40]||B.S,B.fire=w[32]||w[13]}t.on(n.Mouse.START,function(){window.focus(),document.activeElement&&document.activeElement.blur(),e.focus()}),t.MAX_ELAPSE=1e3/30;var m=s.Vec2,h={},c=!1;t.on("resume",function(){c=!1,h._resume&&h._resume()}),t.on("pause",function(){c=!0,h._pause&&h._pause()}),h.isPaused=function(){return c},h.togglePause=function(){c?h.resume():h.pause()},h.pause=function(){t.pause()},h.resume=function(){t.resume(),h.focus()},h.focus=function(){document.activeElement&&document.activeElement.blur(),e.focus()},h.focus=function(){document.activeElement&&document.activeElement.blur(),e.focus()},h.debug=!1,h.width=80,h.height=60,h.x=0,h.y=-10,h.ratio=16,h.hz=60,h.speed=1,h.activeKeys={},h.background="#222222";var _="",l={};h.status=function(t,i){void 0!==i?r(t,i):t&&"object"==typeof t?function(t){for(var i in t)r(i,t[i])}(t):"string"==typeof t&&(_=t),h._status&&h._status(_,l)},h.info=function(t){h._info&&h._info(t)};var u="",p="";!function(){var i=new n.Texture;t.append(n.image(i));var e=[];t.tick(function(){e.length=0},!0),i.draw=function(t){t.save(),t.transform(1,0,0,-1,-h.x,-h.y),t.lineWidth=2/h.ratio,t.lineCap="round";for(var i=e.shift();i;i=e.shift())i(t,h.ratio);t.restore()},h.drawPoint=function(t,i,o){e.push(function(i,e){i.beginPath(),i.arc(t.x,t.y,5/e,0,2*Math.PI),i.strokeStyle=o,i.stroke()}),p+="point"+t.x+","+t.y+","+i+","+o},h.drawCircle=function(t,i,o){e.push(function(e){e.beginPath(),e.arc(t.x,t.y,i,0,2*Math.PI),e.strokeStyle=o,e.stroke()}),p+="circle"+t.x+","+t.y+","+i+","+o},h.drawSegment=function(t,i,o){e.push(function(e){e.beginPath(),e.moveTo(t.x,t.y),e.lineTo(i.x,i.y),e.strokeStyle=o,e.stroke()}),p+="segment"+t.x+","+t.y+","+i.x+","+i.y+","+o},h.drawPolygon=function(t,i){if(t&&t.length){e.push(function(e){e.beginPath(),e.moveTo(t[0].x,t[0].y);for(var o=1;o<t.length;o++)e.lineTo(t[o].x,t[o].y);e.strokeStyle=i,e.closePath(),e.stroke()}),p+="segment";for(var o=1;o<t.length;o++)p+=t[o].x+","+t[o].y+",";p+=i}},h.drawAABB=function(t,i){e.push(function(e){e.beginPath(),e.moveTo(t.lowerBound.x,t.lowerBound.y),e.lineTo(t.upperBound.x,t.lowerBound.y),e.lineTo(t.upperBound.x,t.upperBound.y),e.lineTo(t.lowerBound.x,t.upperBound.y),e.strokeStyle=i,e.closePath(),e.stroke()}),p+="aabb",p+=t.lowerBound.x+","+t.lowerBound.y+",",p+=t.upperBound.x+","+t.upperBound.y+",",p+=i},h.color=function(t,i,e){return t=256*t|0,i=256*i|0,e=256*e|0,"rgb("+t+", "+i+", "+e+")"}}();var d=i(h),f=new o(d,h),y=0,v=0;t.tick(function(t,i){y===h.x&&v===h.y||(f.offset(-h.x,-h.y),y=h.x,v=h.y)}),f.tick(function(i,e){return"function"==typeof h.step&&h.step(i,e),x&&h.drawSegment(x.getPosition(),A,"rgba(255,255,255,0.2)"),u!==p&&(u=p,t.touch()),p="",!0}),f.scale(1,-1),t.background(h.background),t.viewbox(h.width,h.height),t.pin("alignX",-.5),t.pin("alignY",-.5),t.prepend(f);var g,x,b=d.createBody(),A={x:0,y:0};f.attr("spy",!0).on(n.Mouse.START,function(t){if(!x){var i=function(t){var i,e=s.AABB(t,t);return d.queryAABB(e,function(e){if(!i&&e.getBody().isDynamic()&&e.testPoint(t))return i=e.getBody(),!0}),i}(t);i&&(h.mouseForce?x=i:(g=s.MouseJoint({maxForce:1e3},b,i,m(t)),d.createJoint(g)))}}).on(n.Mouse.MOVE,function(t){g&&g.setTarget(t),A.x=t.x,A.y=t.y}).on(n.Mouse.END,function(t){if(g&&(d.destroyJoint(g),g=null),x){var i=m.sub(t,x.getPosition());x.applyForceToCenter(i.mul(h.mouseForce),!0),x=null}}).on(n.Mouse.CANCEL,function(t){g&&(d.destroyJoint(g),g=null),x&&(x=null)}),window.addEventListener("keydown",function(t){switch(t.keyCode){case"P".charCodeAt(0):h.togglePause()}},!1);var w={};window.addEventListener("keydown",function(t){var i=t.keyCode;w[i]=!0,a(i,!0),h.keydown&&h.keydown(i,String.fromCharCode(i))}),window.addEventListener("keyup",function(t){var i=t.keyCode;w[i]=!1,a(i,!1),h.keyup&&h.keyup(i,String.fromCharCode(i))});var B=h.activeKeys})},o._super=n,(o.prototype=n._create(o._super.prototype)).renderWorld=function(t){for(var i=(t=this._world).getBodyList();i;i=i.getNext())for(var e=i.getFixtureList();e;e=e.getNext()){if(!e.ui){e.render&&e.render.stroke?this._options.strokeStyle=e.render.stroke:i.render&&i.render.stroke?this._options.strokeStyle=i.render.stroke:i.isDynamic()?this._options.strokeStyle="rgba(255,255,255,0.9)":i.isKinematic()?this._options.strokeStyle="rgba(255,255,255,0.7)":i.isStatic()&&(this._options.strokeStyle="rgba(255,255,255,0.5)"),e.render&&e.render.fill?this._options.fillStyle=e.render.fill:i.render&&i.render.fill?this._options.fillStyle=i.render.fill:this._options.fillStyle="";var o=e.getType(),s=e.getShape();"circle"==o&&(e.ui=this.drawCircle(s,this._options)),"edge"==o&&(e.ui=this.drawEdge(s,this._options)),"polygon"==o&&(e.ui=this.drawPolygon(s,this._options)),"chain"==o&&(e.ui=this.drawChain(s,this._options)),e.ui&&e.ui.appendTo(this)}if(e.ui){var n=i.getPosition(),r=i.getAngle();e.ui.__lastX===n.x&&e.ui.__lastY===n.y&&e.ui.__lastR===r||(e.ui.__lastX=n.x,e.ui.__lastY=n.y,e.ui.__lastR=r,e.ui.offset(n.x,n.y),e.ui.rotate(r))}}for(var a=t.getJointList();a;a=a.getNext()){o=a.getType();var m=a.getAnchorA();i=a.getAnchorB();if(a.ui||(this._options.strokeStyle="rgba(255,255,255,0.2)",a.ui=this.drawJoint(a,this._options),a.ui.pin("handle",.5),a.ui&&a.ui.appendTo(this)),a.ui){var h=.5*(m.x+i.x),c=.5*(m.y+i.y),_=m.x-i.x,l=m.y-i.y,u=Math.sqrt(_*_+l*l);a.ui.width(u),a.ui.rotate(Math.atan2(l,_)),a.ui.offset(h,c)}}},o.prototype.drawJoint=function(t,i){var e=i.lineWidth,o=i.ratio,s=n.canvas(function(t){this.size(10+2*e,2*e,o),t.scale(o,o),t.beginPath(),t.moveTo(e,e),t.lineTo(e+10,e),t.lineCap="round",t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()});return n.image(s).stretch()},o.prototype.drawCircle=function(t,i){var e=i.lineWidth,o=i.ratio,s=t.m_radius,r=s+e,a=s+e,m=2*s+2*e,h=2*s+2*e,c=n.canvas(function(t){this.size(m,h,o),t.scale(o,o),t.arc(r,a,s,0,2*Math.PI),i.fillStyle&&(t.fillStyle=i.fillStyle,t.fill()),t.lineTo(r,a),t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()}),_=n.image(c).offset(t.m_p.x-r,t.m_p.y-a);return n.create().append(_)},o.prototype.drawEdge=function(t,i){var e=i.lineWidth,o=i.ratio,s=t.m_vertex1,r=t.m_vertex2,a=r.x-s.x,m=r.y-s.y,h=Math.sqrt(a*a+m*m),c=n.canvas(function(t){this.size(h+2*e,2*e,o),t.scale(o,o),t.beginPath(),t.moveTo(e,e),t.lineTo(e+h,e),t.lineCap="round",t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()}),_=Math.min(s.x,r.x),l=Math.min(s.y,r.y),u=n.image(c);u.rotate(Math.atan2(m,a)),u.offset(_-e,l-e);return n.create().append(u)},o.prototype.drawPolygon=function(t,i){var e=i.lineWidth,o=i.ratio,s=t.m_vertices;if(s.length){for(var r=1/0,a=1/0,m=-1/0,h=-1/0,c=0;c<s.length;++c){var _=s[c];r=Math.min(r,_.x),m=Math.max(m,_.x),a=Math.min(a,_.y),h=Math.max(h,_.y)}var l=m-r,u=h-a,p=n.canvas(function(t){this.size(l+2*e,u+2*e,o),t.scale(o,o),t.beginPath();for(var n=0;n<s.length;++n){var m=s[n],h=m.x-r+e,c=m.y-a+e;0==n?t.moveTo(h,c):t.lineTo(h,c)}s.length>2&&t.closePath(),i.fillStyle&&(t.fillStyle=i.fillStyle,t.fill(),t.closePath()),t.lineCap="round",t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()}),d=n.image(p);d.offset(r-e,a-e);return n.create().append(d)}},o.prototype.drawChain=function(t,i){var e=i.lineWidth,o=i.ratio,s=t.m_vertices;if(s.length){for(var r=1/0,a=1/0,m=-1/0,h=-1/0,c=0;c<s.length;++c){var _=s[c];r=Math.min(r,_.x),m=Math.max(m,_.x),a=Math.min(a,_.y),h=Math.max(h,_.y)}var l=m-r,u=h-a,p=n.canvas(function(t){this.size(l+2*e,u+2*e,o),t.scale(o,o),t.beginPath();for(var n=0;n<s.length;++n){var m=s[n],h=m.x-r+e,c=m.y-a+e;0==n?t.moveTo(h,c):t.lineTo(h,c)}s.length,i.fillStyle&&(t.fillStyle=i.fillStyle,t.fill(),t.closePath()),t.lineCap="round",t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()}),d=n.image(p);d.offset(r-e,a-e);return n.create().append(d)}}},{"../lib/":27,"stage-js/platform/web":82}],2:[function(t,i,e){function o(t,i){i=m(i,x),r&&a.assert(h.isValid(i.position)),r&&a.assert(h.isValid(i.linearVelocity)),r&&a.assert(_.isFinite(i.angle)),r&&a.assert(_.isFinite(i.angularVelocity)),r&&a.assert(_.isFinite(i.angularDamping)&&i.angularDamping>=0),r&&a.assert(_.isFinite(i.linearDamping)&&i.linearDamping>=0),this.m_world=t,this.m_awakeFlag=i.awake,this.m_autoSleepFlag=i.allowSleep,this.m_bulletFlag=i.bullet,this.m_fixedRotationFlag=i.fixedRotation,this.m_activeFlag=i.active,this.m_islandFlag=!1,this.m_toiFlag=!1,this.m_userData=i.userData,this.m_type=i.type,this.m_type==g?(this.m_mass=1,this.m_invMass=1):(this.m_mass=0,this.m_invMass=0),this.m_I=0,this.m_invI=0,this.m_xf=u.identity(),this.m_xf.p=h.clone(i.position),this.m_xf.q.setAngle(i.angle),this.m_sweep=new l,this.m_sweep.setTransform(this.m_xf),this.c_velocity=new p,this.c_position=new d,this.m_force=h.zero(),this.m_torque=0,this.m_linearVelocity=h.clone(i.linearVelocity),this.m_angularVelocity=i.angularVelocity,this.m_linearDamping=i.linearDamping,this.m_angularDamping=i.angularDamping,this.m_gravityScale=i.gravityScale,this.m_sleepTime=0,this.m_jointList=null,this.m_contactList=null,this.m_fixtureList=null,this.m_prev=null,this.m_next=null}function s(){this.mass=0,this.center=h.zero(),this.I=0}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=o;var a=t("./util/common"),m=t("./util/options"),h=t("./common/Vec2"),c=t("./common/Rot"),_=t("./common/Math"),l=t("./common/Sweep"),u=t("./common/Transform"),p=t("./common/Velocity"),d=t("./common/Position"),f=t("./Fixture"),y=(t("./Shape"),t("./World"),o.STATIC="static"),v=o.KINEMATIC="kinematic",g=o.DYNAMIC="dynamic",x={type:y,position:h.zero(),angle:0,linearVelocity:h.zero(),angularVelocity:0,linearDamping:0,angularDamping:0,fixedRotation:!1,bullet:!1,gravityScale:1,allowSleep:!0,awake:!0,active:!0,userData:null};o.prototype.isWorldLocked=function(){return!(!this.m_world||!this.m_world.isLocked())},o.prototype.getWorld=function(){return this.m_world},o.prototype.getNext=function(){return this.m_next},o.prototype.setUserData=function(t){this.m_userData=t},o.prototype.getUserData=function(){return this.m_userData},o.prototype.getFixtureList=function(){return this.m_fixtureList},o.prototype.getJointList=function(){return this.m_jointList},o.prototype.getContactList=function(){return this.m_contactList},o.prototype.isStatic=function(){return this.m_type==y},o.prototype.isDynamic=function(){return this.m_type==g},o.prototype.isKinematic=function(){return this.m_type==v},o.prototype.setStatic=function(){return this.setType(y),this},o.prototype.setDynamic=function(){return this.setType(g),this},o.prototype.setKinematic=function(){return this.setType(v),this},o.prototype.getType=function(){return this.m_type},o.prototype.setType=function(t){if(r&&a.assert(t===y||t===v||t===g),r&&a.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()&&this.m_type!=t){this.m_type=t,this.resetMassData(),this.m_type==y&&(this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_sweep.forward(),this.synchronizeFixtures()),this.setAwake(!0),this.m_force.setZero(),this.m_torque=0;for(var i=this.m_contactList;i;){var e=i;i=i.next,this.m_world.destroyContact(e.contact)}this.m_contactList=null;for(var o=this.m_world.m_broadPhase,s=this.m_fixtureList;s;s=s.m_next)for(var n=s.m_proxyCount,m=0;m<n;++m)o.touchProxy(s.m_proxies[m].proxyId)}},o.prototype.isBullet=function(){return this.m_bulletFlag},o.prototype.setBullet=function(t){this.m_bulletFlag=!!t},o.prototype.isSleepingAllowed=function(){return this.m_autoSleepFlag},o.prototype.setSleepingAllowed=function(t){this.m_autoSleepFlag=!!t,0==this.m_autoSleepFlag&&this.setAwake(!0)},o.prototype.isAwake=function(){return this.m_awakeFlag},o.prototype.setAwake=function(t){t?0==this.m_awakeFlag&&(this.m_awakeFlag=!0,this.m_sleepTime=0):(this.m_awakeFlag=!1,this.m_sleepTime=0,this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_force.setZero(),this.m_torque=0)},o.prototype.isActive=function(){return this.m_activeFlag},o.prototype.setActive=function(t){if(r&&a.assert(0==this.isWorldLocked()),t!=this.m_activeFlag)if(this.m_activeFlag=!!t,this.m_activeFlag)for(var i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.createProxies(i,this.m_xf);else{for(i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.destroyProxies(i);for(var o=this.m_contactList;o;){var s=o;o=o.next,this.m_world.destroyContact(s.contact)}this.m_contactList=null}},o.prototype.isFixedRotation=function(){return this.m_fixedRotationFlag},o.prototype.setFixedRotation=function(t){this.m_fixedRotationFlag!=t&&(this.m_fixedRotationFlag=!!t,this.m_angularVelocity=0,this.resetMassData())},o.prototype.getTransform=function(){return this.m_xf},o.prototype.setTransform=function(t,i){if(r&&a.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()){this.m_xf.set(t,i),this.m_sweep.setTransform(this.m_xf);for(var e=this.m_world.m_broadPhase,o=this.m_fixtureList;o;o=o.m_next)o.synchronize(e,this.m_xf,this.m_xf)}},o.prototype.synchronizeTransform=function(){this.m_sweep.getTransform(this.m_xf,1)},o.prototype.synchronizeFixtures=function(){var t=u.identity();this.m_sweep.getTransform(t,0);for(var i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.synchronize(i,t,this.m_xf)},o.prototype.advance=function(t){this.m_sweep.advance(t),this.m_sweep.c.set(this.m_sweep.c0),this.m_sweep.a=this.m_sweep.a0,this.m_sweep.getTransform(this.m_xf,1)},o.prototype.getPosition=function(){return this.m_xf.p},o.prototype.setPosition=function(t){this.setTransform(t,this.m_sweep.a)},o.prototype.getAngle=function(){return this.m_sweep.a},o.prototype.setAngle=function(t){this.setTransform(this.m_xf.p,t)},o.prototype.getWorldCenter=function(){return this.m_sweep.c},o.prototype.getLocalCenter=function(){return this.m_sweep.localCenter},o.prototype.getLinearVelocity=function(){return this.m_linearVelocity},o.prototype.getLinearVelocityFromWorldPoint=function(t){var i=h.sub(t,this.m_sweep.c);return h.add(this.m_linearVelocity,h.cross(this.m_angularVelocity,i))},o.prototype.getLinearVelocityFromLocalPoint=function(t){return this.getLinearVelocityFromWorldPoint(this.getWorldPoint(t))},o.prototype.setLinearVelocity=function(t){this.m_type!=y&&(h.dot(t,t)>0&&this.setAwake(!0),this.m_linearVelocity.set(t))},o.prototype.getAngularVelocity=function(){return this.m_angularVelocity},o.prototype.setAngularVelocity=function(t){this.m_type!=y&&(t*t>0&&this.setAwake(!0),this.m_angularVelocity=t)},o.prototype.getLinearDamping=function(){return this.m_linearDamping},o.prototype.setLinearDamping=function(t){this.m_linearDamping=t},o.prototype.getAngularDamping=function(){return this.m_angularDamping},o.prototype.setAngularDamping=function(t){this.m_angularDamping=t},o.prototype.getGravityScale=function(){return this.m_gravityScale},o.prototype.setGravityScale=function(t){this.m_gravityScale=t},o.prototype.getMass=function(){return this.m_mass},o.prototype.getInertia=function(){return this.m_I+this.m_mass*h.dot(this.m_sweep.localCenter,this.m_sweep.localCenter)},o.prototype.getMassData=function(t){t.mass=this.m_mass,t.I=this.getInertia(),t.center.set(this.m_sweep.localCenter)},o.prototype.resetMassData=function(){if(this.m_mass=0,this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_sweep.localCenter.setZero(),this.isStatic()||this.isKinematic())return this.m_sweep.c0.set(this.m_xf.p),this.m_sweep.c.set(this.m_xf.p),void(this.m_sweep.a0=this.m_sweep.a);r&&a.assert(this.isDynamic());for(var t=h.zero(),i=this.m_fixtureList;i;i=i.m_next)if(0!=i.m_density){var e=new s;i.getMassData(e),this.m_mass+=e.mass,t.wAdd(e.mass,e.center),this.m_I+=e.I}this.m_mass>0?(this.m_invMass=1/this.m_mass,t.mul(this.m_invMass)):(this.m_mass=1,this.m_invMass=1),this.m_I>0&&0==this.m_fixedRotationFlag?(this.m_I-=this.m_mass*h.dot(t,t),r&&a.assert(this.m_I>0),this.m_invI=1/this.m_I):(this.m_I=0,this.m_invI=0);var o=h.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t,this.m_xf),this.m_linearVelocity.add(h.cross(this.m_angularVelocity,h.sub(this.m_sweep.c,o)))},o.prototype.setMassData=function(t){if(r&&a.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()&&this.m_type==g){this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_mass=t.mass,this.m_mass<=0&&(this.m_mass=1),this.m_invMass=1/this.m_mass,t.I>0&&0==this.m_fixedRotationFlag&&(this.m_I=t.I-this.m_mass*h.dot(t.center,t.center),r&&a.assert(this.m_I>0),this.m_invI=1/this.m_I);var i=h.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t.center,this.m_xf),this.m_linearVelocity.add(h.cross(this.m_angularVelocity,h.sub(this.m_sweep.c,i)))}},o.prototype.applyForce=function(t,i,e){this.m_type==g&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_force.add(t),this.m_torque+=h.cross(h.sub(i,this.m_sweep.c),t)))},o.prototype.applyForceToCenter=function(t,i){this.m_type==g&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&this.m_force.add(t))},o.prototype.applyTorque=function(t,i){this.m_type==g&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_torque+=t))},o.prototype.applyLinearImpulse=function(t,i,e){this.m_type==g&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_linearVelocity.wAdd(this.m_invMass,t),this.m_angularVelocity+=this.m_invI*h.cross(h.sub(i,this.m_sweep.c),t)))},o.prototype.applyAngularImpulse=function(t,i){this.m_type==g&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_angularVelocity+=this.m_invI*t))},o.prototype.shouldCollide=function(t){if(this.m_type!=g&&t.m_type!=g)return!1;for(var i=this.m_jointList;i;i=i.next)if(i.other==t&&0==i.joint.m_collideConnected)return!1;return!0},o.prototype.createFixture=function(t,i){if(r&&a.assert(0==this.isWorldLocked()),1==this.isWorldLocked())return null;var e=new f(this,t,i);if(this.m_activeFlag){var o=this.m_world.m_broadPhase;e.createProxies(o,this.m_xf)}return e.m_next=this.m_fixtureList,this.m_fixtureList=e,e.m_density>0&&this.resetMassData(),this.m_world.m_newFixture=!0,e},o.prototype.destroyFixture=function(t){if(r&&a.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()){r&&a.assert(t.m_body==this);var i=!1;if(this.m_fixtureList===t)this.m_fixtureList=t.m_next,i=!0;else for(var e=this.m_fixtureList;null!=e;){if(e.m_next===t){e.m_next=t.m_next,i=!0;break}e=e.m_next}r&&a.assert(i);for(var o=this.m_contactList;o;){var s=o.contact;o=o.next;var n=s.getFixtureA(),m=s.getFixtureB();t!=n&&t!=m||this.m_world.destroyContact(s)}if(this.m_activeFlag){var h=this.m_world.m_broadPhase;t.destroyProxies(h)}t.m_body=null,t.m_next=null,this.m_world.publish("remove-fixture",t),this.resetMassData()}},o.prototype.getWorldPoint=function(t){return u.mul(this.m_xf,t)},o.prototype.getWorldVector=function(t){return c.mul(this.m_xf.q,t)},o.prototype.getLocalPoint=function(t){return u.mulT(this.m_xf,t)},o.prototype.getLocalVector=function(t){return c.mulT(this.m_xf.q,t)}},{"./Fixture":4,"./Shape":8,"./World":10,"./common/Math":18,"./common/Position":19,"./common/Rot":20,"./common/Sweep":21,"./common/Transform":22,"./common/Vec2":23,"./common/Velocity":25,"./util/common":51,"./util/options":53}],3:[function(t,i,e){function o(t){this.contact=t,this.prev,this.next,this.other}function s(t,i,e,s,a){this.m_nodeA=new o(this),this.m_nodeB=new o(this),this.m_fixtureA=t,this.m_fixtureB=e,this.m_indexA=i,this.m_indexB=s,this.m_evaluateFcn=a,this.m_manifold=new f,this.m_prev=null,this.m_next=null,this.m_toi=1,this.m_toiCount=0,this.m_toiFlag=!1,this.m_friction=n(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction),this.m_restitution=r(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution),this.m_tangentSpeed=0,this.m_enabledFlag=!0,this.m_islandFlag=!1,this.m_touchingFlag=!1,this.m_filterFlag=!1,this.m_bulletHitFlag=!1,this.v_points=[],this.v_normal=_.zero(),this.v_normalMass=new u,this.v_K=new u,this.v_pointCount,this.v_tangentSpeed,this.v_friction,this.v_restitution,this.v_invMassA,this.v_invMassB,this.v_invIA,this.v_invIB,this.p_localPoints=[],this.p_localNormal=_.zero(),this.p_localPoint=_.zero(),this.p_localCenterA=_.zero(),this.p_localCenterB=_.zero(),this.p_type,this.p_radiusA,this.p_radiusB,this.p_pointCount,this.p_invMassA,this.p_invMassB,this.p_invIA,this.p_invIB}function n(t,i){return c.sqrt(t*i)}function r(t,i){return t>i?t:i}if(void 0===a)var a=!1;if(void 0===m)var m=!1;var h=t("./util/common"),c=t("./common/Math"),_=t("./common/Vec2"),l=t("./common/Transform"),u=t("./common/Mat22"),p=t("./common/Rot"),d=t("./Settings"),f=t("./Manifold"),y=t("./collision/Distance");i.exports=s,s.prototype.initConstraint=function(t){var i=this.m_fixtureA,e=this.m_fixtureB,o=i.getShape(),s=e.getShape(),n=i.getBody(),r=e.getBody(),c=this.getManifold(),l=c.pointCount;m&&h.assert(l>0),this.v_invMassA=n.m_invMass,this.v_invMassB=r.m_invMass,this.v_invIA=n.m_invI,this.v_invIB=r.m_invI,this.v_friction=this.m_friction,this.v_restitution=this.m_restitution,this.v_tangentSpeed=this.m_tangentSpeed,this.v_pointCount=l,a&&h.debug("pc",this.v_pointCount,l),this.v_K.setZero(),this.v_normalMass.setZero(),this.p_invMassA=n.m_invMass,this.p_invMassB=r.m_invMass,this.p_invIA=n.m_invI,this.p_invIB=r.m_invI,this.p_localCenterA=_.clone(n.m_sweep.localCenter),this.p_localCenterB=_.clone(r.m_sweep.localCenter),this.p_radiusA=o.m_radius,this.p_radiusB=s.m_radius,this.p_type=c.type,this.p_localNormal=_.clone(c.localNormal),this.p_localPoint=_.clone(c.localPoint),this.p_pointCount=l;for(var u=0;u<l;++u){var p=c.points[u],d=this.v_points[u]=new function(){this.rA=_.zero(),this.rB=_.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.normalMass=0,this.tangentMass=0,this.velocityBias=0};t.warmStarting?(d.normalImpulse=t.dtRatio*p.normalImpulse,d.tangentImpulse=t.dtRatio*p.tangentImpulse):(d.normalImpulse=0,d.tangentImpulse=0),d.rA.setZero(),d.rB.setZero(),d.normalMass=0,d.tangentMass=0,d.velocityBias=0,this.p_localPoints[u]=_.clone(p.localPoint)}},s.prototype.getManifold=function(){return this.m_manifold},s.prototype.getWorldManifold=function(t){var i=this.m_fixtureA.getBody(),e=this.m_fixtureB.getBody(),o=this.m_fixtureA.getShape(),s=this.m_fixtureB.getShape();return this.m_manifold.getWorldManifold(t,i.getTransform(),o.m_radius,e.getTransform(),s.m_radius)},s.prototype.setEnabled=function(t){this.m_enabledFlag=!!t},s.prototype.isEnabled=function(){return this.m_enabledFlag},s.prototype.isTouching=function(){return this.m_touchingFlag},s.prototype.getNext=function(){return this.m_next},s.prototype.getFixtureA=function(){return this.m_fixtureA},s.prototype.getFixtureB=function(){return this.m_fixtureB},s.prototype.getChildIndexA=function(){return this.m_indexA},s.prototype.getChildIndexB=function(){return this.m_indexB},s.prototype.flagForFiltering=function(){this.m_filterFlag=!0},s.prototype.setFriction=function(t){this.m_friction=t},s.prototype.getFriction=function(){return this.m_friction},s.prototype.resetFriction=function(){this.m_friction=n(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction)},s.prototype.setRestitution=function(t){this.m_restitution=t},s.prototype.getRestitution=function(){return this.m_restitution},s.prototype.resetRestitution=function(){this.m_restitution=r(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution)},s.prototype.setTangentSpeed=function(t){this.m_tangentSpeed=t},s.prototype.getTangentSpeed=function(){return this.m_tangentSpeed},s.prototype.evaluate=function(t,i,e){this.m_evaluateFcn(t,i,this.m_fixtureA,this.m_indexA,e,this.m_fixtureB,this.m_indexB)},s.prototype.update=function(t){this.m_enabledFlag=!0;var i=!1,e=this.m_touchingFlag,o=this.m_fixtureA.isSensor(),s=this.m_fixtureB.isSensor(),n=o||s,r=this.m_fixtureA.getBody(),a=this.m_fixtureB.getBody(),m=r.getTransform(),h=a.getTransform();if(n){var c=this.m_fixtureA.getShape(),_=this.m_fixtureB.getShape();i=y.testOverlap(c,this.m_indexA,_,this.m_indexB,m,h),this.m_manifold.pointCount=0}else{var l=this.m_manifold;this.m_manifold=new f,this.evaluate(this.m_manifold,m,h),i=this.m_manifold.pointCount>0;for(var u=0;u<this.m_manifold.pointCount;++u){var p=this.m_manifold.points[u];p.normalImpulse=0,p.tangentImpulse=0;for(var d=0;d<l.pointCount;++d){var v=l.points[d];if(v.id.key==p.id.key){p.normalImpulse=v.normalImpulse,p.tangentImpulse=v.tangentImpulse;break}}}i!=e&&(r.setAwake(!0),a.setAwake(!0))}this.m_touchingFlag=i,0==e&&1==i&&t&&t.beginContact(this),1==e&&0==i&&t&&t.endContact(this),0==n&&i&&t&&t.preSolve(this,l)},s.prototype.solvePositionConstraint=function(t){return this._solvePositionConstraint(t,!1)},s.prototype.solvePositionConstraintTOI=function(t,i,e){return this._solvePositionConstraint(t,!0,i,e)},s.prototype._solvePositionConstraint=function(t,i,e,o){var s=this.m_fixtureA,n=this.m_fixtureB,r=s.getBody(),a=n.getBody(),m=(r.c_velocity,a.c_velocity,r.c_position),h=a.c_position,u=_.clone(this.p_localCenterA),y=_.clone(this.p_localCenterB),v=0,g=0;i&&r!=e&&r!=o||(v=this.p_invMassA,g=this.p_invIA);var x=0,b=0;i&&a!=e&&a!=o||(x=this.p_invMassB,b=this.p_invIB);for(var A=_.clone(m.c),w=m.a,B=_.clone(h.c),S=h.a,M=0,C=0;C<this.p_pointCount;++C){var I=l.identity(),P=l.identity();I.q.set(w),P.q.set(S),I.p=_.sub(A,p.mul(I.q,u)),P.p=_.sub(B,p.mul(P.q,y));var T,V,z;switch(this.p_type){case f.e_circles:var k=l.mul(I,this.p_localPoint),L=l.mul(P,this.p_localPoints[0]);(T=_.sub(L,k)).normalize(),V=_.wAdd(.5,k,.5,L),z=_.dot(_.sub(L,k),T)-this.p_radiusA-this.p_radiusB;break;case f.e_faceA:T=p.mul(I.q,this.p_localNormal);var q=l.mul(I,this.p_localPoint),F=l.mul(P,this.p_localPoints[C]);z=_.dot(_.sub(F,q),T)-this.p_radiusA-this.p_radiusB,V=F;break;case f.e_faceB:T=p.mul(P.q,this.p_localNormal);q=l.mul(P,this.p_localPoint),F=l.mul(I,this.p_localPoints[C]);z=_.dot(_.sub(F,q),T)-this.p_radiusA-this.p_radiusB,V=F,T.mul(-1)}var R=_.sub(V,A),E=_.sub(V,B);M=c.min(M,z);var D=i?d.toiBaugarte:d.baumgarte,j=d.linearSlop,Y=d.maxLinearCorrection,J=c.clamp(D*(z+j),-Y,0),O=_.cross(R,T),N=_.cross(E,T),W=v+x+g*O*O+b*N*N,X=W>0?-J/W:0,H=_.mul(X,T);A.wSub(v,H),w-=g*_.cross(R,H),B.wAdd(x,H),S+=b*_.cross(E,H)}return m.c.set(A),m.a=w,h.c.set(B),h.a=S,M},s.prototype.initVelocityConstraint=function(t){var i=this.m_fixtureA,e=this.m_fixtureB,o=i.getBody(),s=e.getBody(),n=o.c_velocity,r=s.c_velocity,c=o.c_position,u=s.c_position,f=this.p_radiusA,y=this.p_radiusB,v=this.getManifold(),g=this.v_invMassA,x=this.v_invMassB,b=this.v_invIA,A=this.v_invIB,w=_.clone(this.p_localCenterA),B=_.clone(this.p_localCenterB),S=_.clone(c.c),M=c.a,C=_.clone(n.v),I=n.w,P=_.clone(u.c),T=u.a,V=_.clone(r.v),z=r.w;m&&h.assert(v.pointCount>0);var k=l.identity(),L=l.identity();k.q.set(M),L.q.set(T),k.p.wSet(1,S,-1,p.mul(k.q,w)),L.p.wSet(1,P,-1,p.mul(L.q,B));var q=v.getWorldManifold(null,k,f,L,y);this.v_normal.set(q.normal);for(var F=0;F<this.v_pointCount;++F){var R=this.v_points[F];R.rA.set(_.sub(q.points[F],S)),R.rB.set(_.sub(q.points[F],P)),a&&h.debug("vcp.rA",q.points[F].x,q.points[F].y,S.x,S.y,R.rA.x,R.rA.y);var E=_.cross(R.rA,this.v_normal),D=_.cross(R.rB,this.v_normal),j=g+x+b*E*E+A*D*D;R.normalMass=j>0?1/j:0;var Y=_.cross(this.v_normal,1),J=_.cross(R.rA,Y),O=_.cross(R.rB,Y),N=g+x+b*J*J+A*O*O;R.tangentMass=N>0?1/N:0,R.velocityBias=0;var W=_.dot(this.v_normal,V)+_.dot(this.v_normal,_.cross(z,R.rB))-_.dot(this.v_normal,C)-_.dot(this.v_normal,_.cross(I,R.rA));W<-d.velocityThreshold&&(R.velocityBias=-this.v_restitution*W)}if(2==this.v_pointCount&&t.blockSolve){var X=this.v_points[0],H=this.v_points[1],Z=_.cross(X.rA,this.v_normal),K=_.cross(X.rB,this.v_normal),G=_.cross(H.rA,this.v_normal),U=_.cross(H.rB,this.v_normal),Q=g+x+b*Z*Z+A*K*K,$=g+x+b*G*G+A*U*U,tt=g+x+b*Z*G+A*K*U;a&&h.debug("k1x2: ",Q,$,tt,g,x,b,Z,G,A,K,U),Q*Q<1e3*(Q*$-tt*tt)?(this.v_K.ex.set(Q,tt),this.v_K.ey.set(tt,$),this.v_normalMass.set(this.v_K.getInverse())):this.v_pointCount=1}c.c.set(S),c.a=M,n.v.set(C),n.w=I,u.c.set(P),u.a=T,r.v.set(V),r.w=z},s.prototype.warmStartConstraint=function(t){for(var i=this.m_fixtureA,e=this.m_fixtureB,o=i.getBody(),s=e.getBody(),n=o.c_velocity,r=s.c_velocity,m=(o.c_position,s.c_position,this.v_invMassA),c=this.v_invIA,l=this.v_invMassB,u=this.v_invIB,p=_.clone(n.v),d=n.w,f=_.clone(r.v),y=r.w,v=this.v_normal,g=_.cross(v,1),x=0;x<this.v_pointCount;++x){var b=this.v_points[x],A=_.wAdd(b.normalImpulse,v,b.tangentImpulse,g);a&&h.debug(c,u,b.rA.x,b.rA.y,b.rB.x,b.rB.y,A.x,A.y),d-=c*_.cross(b.rA,A),p.wSub(m,A),y+=u*_.cross(b.rB,A),f.wAdd(l,A)}n.v.set(p),n.w=d,r.v.set(f),r.w=y},s.prototype.storeConstraintImpulses=function(t){for(var i=this.m_manifold,e=0;e<this.v_pointCount;++e)i.points[e].normalImpulse=this.v_points[e].normalImpulse,i.points[e].tangentImpulse=this.v_points[e].tangentImpulse},s.prototype.solveVelocityConstraint=function(t){var i=this.m_fixtureA.m_body,e=this.m_fixtureB.m_body,o=i.c_velocity,s=(i.c_position,e.c_velocity),n=(e.c_position,this.v_invMassA),r=this.v_invIA,a=this.v_invMassB,l=this.v_invIB,p=_.clone(o.v),d=o.w,f=_.clone(s.v),y=s.w,v=this.v_normal,g=_.cross(v,1),x=this.v_friction;m&&h.assert(1==this.v_pointCount||2==this.v_pointCount);for(var b=0;b<this.v_pointCount;++b){var A=this.v_points[b];(I=_.zero()).wAdd(1,f,1,_.cross(y,A.rB)),I.wSub(1,p,1,_.cross(d,A.rA));var w=_.dot(I,g)-this.v_tangentSpeed,B=A.tangentMass*-w,S=x*A.normalImpulse;B=(P=c.clamp(A.tangentImpulse+B,-S,S))-A.tangentImpulse,A.tangentImpulse=P;var M=_.mul(B,g);p.wSub(n,M),d-=r*_.cross(A.rA,M),f.wAdd(a,M),y+=l*_.cross(A.rB,M)}if(1==this.v_pointCount||0==t.blockSolve)for(var C=0;C<this.v_pointCount;++C){var I;A=this.v_points[C];(I=_.zero()).wAdd(1,f,1,_.cross(y,A.rB)),I.wSub(1,p,1,_.cross(d,A.rA));var P,T=_.dot(I,v);B=-A.normalMass*(T-A.velocityBias);B=(P=c.max(A.normalImpulse+B,0))-A.normalImpulse,A.normalImpulse=P;M=_.mul(B,v);p.wSub(n,M),d-=r*_.cross(A.rA,M),f.wAdd(a,M),y+=l*_.cross(A.rB,M)}else{var V=this.v_points[0],z=this.v_points[1],k=_.neo(V.normalImpulse,z.normalImpulse);m&&h.assert(k.x>=0&&k.y>=0);var L=_.zero().add(f).add(_.cross(y,V.rB)).sub(p).sub(_.cross(d,V.rA)),q=_.zero().add(f).add(_.cross(y,z.rB)).sub(p).sub(_.cross(d,z.rA)),F=_.dot(L,v),R=_.dot(q,v),E=_.neo(F-V.velocityBias,R-z.velocityBias);E.sub(u.mul(this.v_K,k));for(;;){var D=_.neg(u.mul(this.v_normalMass,E));if(D.x>=0&&D.y>=0){var j=_.sub(D,k),Y=_.mul(j.x,v),J=_.mul(j.y,v);p.wSub(n,Y,n,J),d-=r*(_.cross(V.rA,Y)+_.cross(z.rA,J)),f.wAdd(a,Y,a,J),y+=l*(_.cross(V.rB,Y)+_.cross(z.rB,J)),V.normalImpulse=D.x,z.normalImpulse=D.y;break}if(D.x=-V.normalMass*E.x,D.y=0,F=0,R=this.v_K.ex.y*D.x+E.y,D.x>=0&&R>=0){j=_.sub(D,k),Y=_.mul(j.x,v),J=_.mul(j.y,v);p.wSub(n,Y,n,J),d-=r*(_.cross(V.rA,Y)+_.cross(z.rA,J)),f.wAdd(a,Y,a,J),y+=l*(_.cross(V.rB,Y)+_.cross(z.rB,J)),V.normalImpulse=D.x,z.normalImpulse=D.y;break}if(D.x=0,D.y=-z.normalMass*E.y,F=this.v_K.ey.x*D.y+E.x,R=0,D.y>=0&&F>=0){j=_.sub(D,k),Y=_.mul(j.x,v),J=_.mul(j.y,v);p.wSub(n,Y,n,J),d-=r*(_.cross(V.rA,Y)+_.cross(z.rA,J)),f.wAdd(a,Y,a,J),y+=l*(_.cross(V.rB,Y)+_.cross(z.rB,J)),V.normalImpulse=D.x,z.normalImpulse=D.y;break}if(D.x=0,D.y=0,F=E.x,R=E.y,F>=0&&R>=0){j=_.sub(D,k),Y=_.mul(j.x,v),J=_.mul(j.y,v);p.wSub(n,Y,n,J),d-=r*(_.cross(V.rA,Y)+_.cross(z.rA,J)),f.wAdd(a,Y,a,J),y+=l*(_.cross(V.rB,Y)+_.cross(z.rB,J)),V.normalImpulse=D.x,z.normalImpulse=D.y;break}break}}o.v.set(p),o.w=d,s.v.set(f),s.w=y};var v=[];s.addType=function(t,i,e){v[t]=v[t]||{},v[t][i]=e},s.create=function(t,i,e,o){var n,r,a=t.getType(),m=e.getType();if(r=v[a]&&v[a][m])n=new s(t,i,e,o,r);else{if(!(r=v[m]&&v[m][a]))return null;n=new s(e,o,t,i,r)}t=n.getFixtureA(),e=n.getFixtureB(),i=n.getChildIndexA(),o=n.getChildIndexB();var h=t.getBody(),c=e.getBody();return n.m_nodeA.contact=n,n.m_nodeA.other=c,n.m_nodeA.prev=null,n.m_nodeA.next=h.m_contactList,null!=h.m_contactList&&(h.m_contactList.prev=n.m_nodeA),h.m_contactList=n.m_nodeA,n.m_nodeB.contact=n,n.m_nodeB.other=h,n.m_nodeB.prev=null,n.m_nodeB.next=c.m_contactList,null!=c.m_contactList&&(c.m_contactList.prev=n.m_nodeB),c.m_contactList=n.m_nodeB,0==t.isSensor()&&0==e.isSensor()&&(h.setAwake(!0),c.setAwake(!0)),n},s.destroy=function(t,i){var e=t.m_fixtureA,o=t.m_fixtureB,s=e.getBody(),n=o.getBody();t.isTouching()&&i.endContact(t),t.m_nodeA.prev&&(t.m_nodeA.prev.next=t.m_nodeA.next),t.m_nodeA.next&&(t.m_nodeA.next.prev=t.m_nodeA.prev),t.m_nodeA==s.m_contactList&&(s.m_contactList=t.m_nodeA.next),t.m_nodeB.prev&&(t.m_nodeB.prev.next=t.m_nodeB.next),t.m_nodeB.next&&(t.m_nodeB.next.prev=t.m_nodeB.prev),t.m_nodeB==n.m_contactList&&(n.m_contactList=t.m_nodeB.next),t.m_manifold.pointCount>0&&0==e.isSensor()&&0==o.isSensor()&&(s.setAwake(!0),n.setAwake(!0));var r=e.getType(),a=o.getType(),m=v[r][a].destroyFcn;"function"==typeof m&&m(t)}},{"./Manifold":6,"./Settings":7,"./collision/Distance":13,"./common/Mat22":16,"./common/Math":18,"./common/Rot":20,"./common/Transform":22,"./common/Vec2":23,"./util/common":51}],4:[function(t,i,e){function o(t,i){this.aabb=new c,this.fixture=t,this.childIndex=i,this.proxyId}function s(t,i,e){i.shape?(e=i,i=i.shape):"number"==typeof e&&(e={density:e}),e=m(e,_),this.m_body=t,this.m_friction=e.friction,this.m_restitution=e.restitution,this.m_density=e.density,this.m_isSensor=e.isSensor,this.m_filterGroupIndex=e.filterGroupIndex,this.m_filterCategoryBits=e.filterCategoryBits,this.m_filterMaskBits=e.filterMaskBits,this.m_shape=i,this.m_next=null,this.m_proxies=[],this.m_proxyCount=0;for(var s=this.m_shape.getChildCount(),n=0;n<s;++n)this.m_proxies[n]=new o(this,n);this.m_userData=e.userData}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=s;var a=t("./util/common"),m=t("./util/options"),h=t("./common/Vec2"),c=t("./collision/AABB"),_={userData:null,friction:.2,restitution:0,density:0,isSensor:!1,filterGroupIndex:0,filterCategoryBits:1,filterMaskBits:65535};s.prototype.getType=function(){return this.m_shape.getType()},s.prototype.getShape=function(){return this.m_shape},s.prototype.isSensor=function(){return this.m_isSensor},s.prototype.setSensor=function(t){t!=this.m_isSensor&&(this.m_body.setAwake(!0),this.m_isSensor=t)},s.prototype.getUserData=function(){return this.m_userData},s.prototype.setUserData=function(t){this.m_userData=t},s.prototype.getBody=function(){return this.m_body},s.prototype.getNext=function(){return this.m_next},s.prototype.getDensity=function(){return this.m_density},s.prototype.setDensity=function(t){r&&a.assert(Math.isFinite(t)&&t>=0),this.m_density=t},s.prototype.getFriction=function(){return this.m_friction},s.prototype.setFriction=function(t){this.m_friction=t},s.prototype.getRestitution=function(){return this.m_restitution},s.prototype.setRestitution=function(t){this.m_restitution=t},s.prototype.testPoint=function(t){return this.m_shape.testPoint(this.m_body.getTransform(),t)},s.prototype.rayCast=function(t,i,e){return this.m_shape.rayCast(t,i,this.m_body.getTransform(),e)},s.prototype.getMassData=function(t){this.m_shape.computeMass(t,this.m_density)},s.prototype.getAABB=function(t){return r&&a.assert(0<=t&&t<this.m_proxyCount),this.m_proxies[t].aabb},s.prototype.createProxies=function(t,i){r&&a.assert(0==this.m_proxyCount),this.m_proxyCount=this.m_shape.getChildCount();for(var e=0;e<this.m_proxyCount;++e){var o=this.m_proxies[e];this.m_shape.computeAABB(o.aabb,i,e),o.proxyId=t.createProxy(o.aabb,o)}},s.prototype.destroyProxies=function(t){for(var i=0;i<this.m_proxyCount;++i){var e=this.m_proxies[i];t.destroyProxy(e.proxyId),e.proxyId=null}this.m_proxyCount=0},s.prototype.synchronize=function(t,i,e){for(var o=0;o<this.m_proxyCount;++o){var s=this.m_proxies[o],n=new c,r=new c;this.m_shape.computeAABB(n,i,s.childIndex),this.m_shape.computeAABB(r,e,s.childIndex),s.aabb.combine(n,r);var a=h.sub(e.p,i.p);t.moveProxy(s.proxyId,s.aabb,a)}},s.prototype.setFilterData=function(t){this.m_filterGroupIndex=t.groupIndex,this.m_filterCategoryBits=t.categoryBits,this.m_filterMaskBits=t.maskBits,this.refilter()},s.prototype.getFilterGroupIndex=function(){return this.m_filterGroupIndex},s.prototype.getFilterCategoryBits=function(){return this.m_filterCategoryBits},s.prototype.getFilterMaskBits=function(){return this.m_filterMaskBits},s.prototype.refilter=function(){if(null!=this.m_body){for(var t=this.m_body.getContactList();t;){var i=t.contact,e=i.getFixtureA(),o=i.getFixtureB();e!=this&&o!=this||i.flagForFiltering(),t=t.next}var s=this.m_body.getWorld();if(null!=s)for(var n=s.m_broadPhase,r=0;r<this.m_proxyCount;++r)n.touchProxy(this.m_proxies[r].proxyId)}},s.prototype.shouldCollide=function(t){if(t.m_filterGroupIndex==this.m_filterGroupIndex&&0!=t.m_filterGroupIndex)return t.m_filterGroupIndex>0;return 0!=(t.m_filterMaskBits&this.m_filterCategoryBits)&&0!=(t.m_filterCategoryBits&this.m_filterMaskBits)}},{"./collision/AABB":11,"./common/Vec2":23,"./util/common":51,"./util/options":53}],5:[function(t,i,e){function o(){this.other=null,this.joint=null,this.prev=null,this.next=null}function s(t,i,e){i=t.bodyA||i,e=t.bodyB||e,r&&a.assert(i),r&&a.assert(e),r&&a.assert(i!=e),this.m_type="unknown-joint",this.m_bodyA=i,this.m_bodyB=e,this.m_index=0,this.m_collideConnected=!!t.collideConnected,this.m_prev=null,this.m_next=null,this.m_edgeA=new o,this.m_edgeB=new o,this.m_islandFlag=!1,this.m_userData=t.userData}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=s;var a=t("./util/common");s.prototype.isActive=function(){return this.m_bodyA.isActive()&&this.m_bodyB.isActive()},s.prototype.getType=function(){return this.m_type},s.prototype.getBodyA=function(){return this.m_bodyA},s.prototype.getBodyB=function(){return this.m_bodyB},s.prototype.getNext=function(){return this.m_next},s.prototype.getUserData=function(){return this.m_userData},s.prototype.setUserData=function(t){this.m_userData=t},s.prototype.getCollideConnected=function(){return this.m_collideConnected},s.prototype.getAnchorA=function(){},s.prototype.getAnchorB=function(){},s.prototype.getReactionForce=function(t){},s.prototype.getReactionTorque=function(t){},s.prototype.shiftOrigin=function(t){},s.prototype.initVelocityConstraints=function(t){},s.prototype.solveVelocityConstraints=function(t){},s.prototype.solvePositionConstraints=function(t){}},{"./util/common":51}],6:[function(t,i,e){function o(){this.type,this.localNormal=_.zero(),this.localPoint=_.zero(),this.points=[new s,new s],this.pointCount=0}function s(){this.localPoint=_.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.id=new n}function n(){this.cf=new r,this.key}function r(){this.indexA,this.indexB,this.typeA,this.typeB}function a(){this.v=_.zero(),this.id=new n}if(void 0===m)var m=!1;if(void 0===h)var h=!1;var c=t("./util/common"),_=t("./common/Vec2"),l=t("./common/Transform"),u=t("./common/Math"),p=t("./common/Rot");i.exports=o,i.exports.clipSegmentToLine=function(t,i,e,o,s){var n=0,a=_.dot(e,i[0].v)-o,m=_.dot(e,i[1].v)-o;if(a<=0&&t[n++].set(i[0]),m<=0&&t[n++].set(i[1]),a*m<0){var h=a/(a-m);t[n].v.wSet(1-h,i[0].v,h,i[1].v),t[n].id.cf.indexA=s,t[n].id.cf.indexB=i[0].id.cf.indexB,t[n].id.cf.typeA=r.e_vertex,t[n].id.cf.typeB=r.e_face,++n}return n},i.exports.clipVertex=a,i.exports.getPointStates=function(t,i,e,o){for(var s=0;s<e.pointCount;++s){var n=e.points[s].id;t[s]=d.removeState;for(var r=0;r<o.pointCount;++r)if(o.points[r].id.key==n.key){t[s]=d.persistState;break}}for(s=0;s<o.pointCount;++s)for(n=o.points[s].id,i[s]=d.addState,r=0;r<e.pointCount;++r)if(e.points[r].id.key==n.key){i[s]=d.persistState;break}},i.exports.PointState=d,o.e_circles=0,o.e_faceA=1,o.e_faceB=2,o.e_vertex=0,o.e_face=1,n.prototype.set=function(t){this.key=t.key,this.cf.set(t.cf)},r.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.typeA=t.typeA,this.typeB=t.typeB},o.prototype.getWorldManifold=function(t,i,e,s,n){if(0!=this.pointCount){var r=(t=t||new function(){this.normal,this.points=[],this.separations=[]}).normal,a=t.points,h=t.separations;switch(this.type){case o.e_circles:r=_.neo(1,0);var d=l.mul(i,this.localPoint),f=l.mul(s,this.points[0].localPoint),y=_.sub(f,d);_.lengthSquared(y)>u.EPSILON*u.EPSILON&&(r.set(y),r.normalize()),a[0]=_.mid(d,f),h[0]=-n-e,a.length=1,h.length=1;break;case o.e_faceA:r=p.mul(i.q,this.localNormal);var v=l.mul(i,this.localPoint);m&&c.debug("faceA",this.localPoint.x,this.localPoint.y,this.localNormal.x,this.localNormal.y,r.x,r.y);for(var g=0;g<this.pointCount;++g){var x=l.mul(s,this.points[g].localPoint),b=_.clone(x).wAdd(e-_.dot(_.sub(x,v),r),r),A=_.clone(x).wSub(n,r);a[g]=_.mid(b,A),h[g]=_.dot(_.sub(A,b),r),m&&c.debug(g,this.points[g].localPoint.x,this.points[g].localPoint.y,v.x,v.y,i.p.x,i.p.y,i.q.c,i.q.s,s.p.x,s.p.y,s.q.c,s.q.s,e,n,x.x,x.y,b.x,b.y,A.x,A.y,h[g],a[g].x,a[g].y)}a.length=this.pointCount,h.length=this.pointCount;break;case o.e_faceB:r=p.mul(s.q,this.localNormal);for(v=l.mul(s,this.localPoint),g=0;g<this.pointCount;++g){x=l.mul(i,this.points[g].localPoint),A=_.zero().wSet(1,x,n-_.dot(_.sub(x,v),r),r),b=_.zero().wSet(1,x,-e,r);a[g]=_.mid(b,A),h[g]=_.dot(_.sub(b,A),r)}a.length=this.pointCount,h.length=this.pointCount,r.mul(-1)}return t.normal=r,t.points=a,t.separations=h,t}};var d={nullState:0,addState:1,persistState:2,removeState:3};a.prototype.set=function(t){this.v.set(t.v),this.id.set(t.id)}},{"./common/Math":18,"./common/Rot":20,"./common/Transform":22,"./common/Vec2":23,"./util/common":51}],7:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;var n=e;n.maxManifoldPoints=2,n.maxPolygonVertices=12,n.aabbExtension=.1,n.aabbMultiplier=2,n.linearSlop=.005,n.linearSlopSquared=n.linearSlop*n.linearSlop,n.angularSlop=2/180*Math.PI,n.polygonRadius=2*n.linearSlop,n.maxSubSteps=8,n.maxTOIContacts=32,n.maxTOIIterations=20,n.maxDistnceIterations=20,n.velocityThreshold=1,n.maxLinearCorrection=.2,n.maxAngularCorrection=8/180*Math.PI,n.maxTranslation=2,n.maxTranslationSquared=n.maxTranslation*n.maxTranslation,n.maxRotation=.5*Math.PI,n.maxRotationSquared=n.maxRotation*n.maxRotation,n.baumgarte=.2,n.toiBaugarte=.75,n.timeToSleep=.5,n.linearSleepTolerance=.01,n.linearSleepToleranceSqr=Math.pow(n.linearSleepTolerance,2),n.angularSleepTolerance=2/180*Math.PI,n.angularSleepToleranceSqr=Math.pow(n.angularSleepTolerance,2)},{}],8:[function(t,i,e){function o(){this.m_type,this.m_radius}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;t("./common/Math");o.isValid=function(t){return!!t},o.prototype.getRadius=function(){return this.m_radius},o.prototype.getType=function(){return this.m_type},o.prototype._clone=function(){},o.prototype.getChildCount=function(){},o.prototype.testPoint=function(t,i){},o.prototype.rayCast=function(t,i,e,o){},o.prototype.computeAABB=function(t,i,e){},o.prototype.computeMass=function(t,i){},o.prototype.computeDistanceProxy=function(t){}},{"./common/Math":18}],9:[function(t,i,e){function o(t){this.dt=0,this.inv_dt=0,this.velocityIterations=0,this.positionIterations=0,this.warmStarting=!1,this.blockSolve=!0,this.inv_dt0=0,this.dtRatio=1}function s(t){this.m_world=t,this.m_profile=new function(){this.solveInit,this.solveVelocity,this.solvePosition},this.m_stack=[],this.m_bodies=[],this.m_contacts=[],this.m_joints=[]}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=s,i.exports.TimeStep=o;var a=t("./Settings"),m=t("./util/common"),h=t("./util/Timer"),c=t("./common/Vec2"),_=t("./common/Math"),l=t("./Body"),u=t("./Contact"),p=t("./Joint"),d=t("./collision/TimeOfImpact"),f=d.Input,y=d.Output,v=t("./collision/Distance");v.Input,v.Output,v.Proxy,v.Cache;o.prototype.reset=function(t){this.dt>0&&(this.inv_dt0=this.inv_dt),this.dt=t,this.inv_dt=0==t?0:1/t,this.dtRatio=t*this.inv_dt0},s.prototype.clear=function(){this.m_stack.length=0,this.m_bodies.length=0,this.m_contacts.length=0,this.m_joints.length=0},s.prototype.addBody=function(t){r&&m.assert(t instanceof l,"Not a Body!",t),this.m_bodies.push(t)},s.prototype.addContact=function(t){r&&m.assert(t instanceof u,"Not a Contact!",t),this.m_contacts.push(t)},s.prototype.addJoint=function(t){r&&m.assert(t instanceof p,"Not a Joint!",t),this.m_joints.push(t)},s.prototype.solveWorld=function(t){var i=this.m_world,e=this.m_profile;e.solveInit=0,e.solveVelocity=0,e.solvePosition=0;for(var o=i.m_bodyList;o;o=o.m_next)o.m_islandFlag=!1;for(var s=i.m_contactList;s;s=s.m_next)s.m_islandFlag=!1;for(var n=i.m_jointList;n;n=n.m_next)n.m_islandFlag=!1;for(var a=this.m_stack,h=i.m_bodyList;h;h=h.m_next)if(0,!h.m_islandFlag&&0!=h.isAwake()&&0!=h.isActive()&&!h.isStatic()){for(this.clear(),a.push(h),h.m_islandFlag=!0;a.length>0;){o=a.pop();if(r&&m.assert(1==o.isActive()),this.addBody(o),o.setAwake(!0),!o.isStatic()){for(var c=o.m_contactList;c;c=c.next){var _=c.contact;if(!_.m_islandFlag&&(0!=_.isEnabled()&&0!=_.isTouching())){var l=_.m_fixtureA.m_isSensor,u=_.m_fixtureB.m_isSensor;if(!l&&!u){this.addContact(_),_.m_islandFlag=!0;(d=c.other).m_islandFlag||(a.push(d),d.m_islandFlag=!0)}}}for(var p=o.m_jointList;p;p=p.next)if(1!=p.joint.m_islandFlag){var d;0!=(d=p.other).isActive()&&(this.addJoint(p.joint),p.joint.m_islandFlag=!0,d.m_islandFlag||(a.push(d),d.m_islandFlag=!0))}}}this.solveIsland(t);for(var f=0;f<this.m_bodies.length;++f){(o=this.m_bodies[f]).isStatic()&&(o.m_islandFlag=!1)}}},s.prototype.solveIsland=function(t){for(var i=this.m_world,e=this.m_profile,o=i.m_gravity,s=i.m_allowSleep,r=h.now(),l=t.dt,u=0;u<this.m_bodies.length;++u){var p=this.m_bodies[u],d=c.clone(p.m_sweep.c),f=p.m_sweep.a,y=c.clone(p.m_linearVelocity),v=p.m_angularVelocity;p.m_sweep.c0.set(p.m_sweep.c),p.m_sweep.a0=p.m_sweep.a,n&&m.debug("P: ",f,d.x,d.y,v,y.x,y.y),p.isDynamic()&&(y.wAdd(l*p.m_gravityScale,o),y.wAdd(l*p.m_invMass,p.m_force),v+=l*p.m_invI*p.m_torque,n&&m.debug("N: "+l,p.m_gravityScale,o.x,o.y,p.m_invMass,p.m_force.x,p.m_force.y),y.mul(1/(1+l*p.m_linearDamping)),v*=1/(1+l*p.m_angularDamping)),m.debug("A: ",f,d.x,d.y,v,y.x,y.y),p.c_position.c=d,p.c_position.a=f,p.c_velocity.v=y,p.c_velocity.w=v}r=h.now();for(u=0;u<this.m_contacts.length;++u){this.m_contacts[u].initConstraint(t)}n&&this.printBodies("M: ");for(u=0;u<this.m_contacts.length;++u){this.m_contacts[u].initVelocityConstraint(t)}if(n&&this.printBodies("R: "),t.warmStarting)for(u=0;u<this.m_contacts.length;++u){this.m_contacts[u].warmStartConstraint(t)}n&&this.printBodies("Q: ");for(u=0;u<this.m_joints.length;++u){this.m_joints[u].initVelocityConstraints(t)}n&&this.printBodies("E: "),e.solveInit=h.diff(r),r=h.now();for(u=0;u<t.velocityIterations;++u){n&&m.debug("--",u);for(var g=0;g<this.m_joints.length;++g){this.m_joints[g].solveVelocityConstraints(t)}for(g=0;g<this.m_contacts.length;++g){this.m_contacts[g].solveVelocityConstraint(t)}}n&&this.printBodies("D: ");for(u=0;u<this.m_contacts.length;++u){this.m_contacts[u].storeConstraintImpulses(t)}e.solveVelocity=h.diff(r),n&&this.printBodies("C: ");for(u=0;u<this.m_bodies.length;++u){p=this.m_bodies[u],d=c.clone(p.c_position.c),f=p.c_position.a,y=c.clone(p.c_velocity.v),v=p.c_velocity.w;var x=c.mul(l,y);if(c.lengthSquared(x)>a.maxTranslationSquared){var b=a.maxTranslation/x.length();y.mul(b)}var A=l*v;if(A*A>a.maxRotationSquared){v*=b=a.maxRotation/_.abs(A)}d.wAdd(l,y),f+=l*v,p.c_position.c.set(d),p.c_position.a=f,p.c_velocity.v.set(y),p.c_velocity.w=v}n&&this.printBodies("B: "),r=h.now();var w=!1;for(u=0;u<t.positionIterations;++u){var B=0;for(g=0;g<this.m_contacts.length;++g){var S=this.m_contacts[g].solvePositionConstraint(t);B=_.min(B,S)}var M=B>=-3*a.linearSlop,C=!0;for(g=0;g<this.m_joints.length;++g){var I=this.m_joints[g].solvePositionConstraints(t);C=C&&I}if(M&&C){w=!0;break}}n&&this.printBodies("L: ");for(u=0;u<this.m_bodies.length;++u){(p=this.m_bodies[u]).m_sweep.c.set(p.c_position.c),p.m_sweep.a=p.c_position.a,p.m_linearVelocity.set(p.c_velocity.v),p.m_angularVelocity=p.c_velocity.w,p.synchronizeTransform()}if(e.solvePosition=h.diff(r),this.postSolveIsland(),s){var P=1/0,T=a.linearSleepToleranceSqr,V=a.angularSleepToleranceSqr;for(u=0;u<this.m_bodies.length;++u){(p=this.m_bodies[u]).isStatic()||(0==p.m_autoSleepFlag||p.m_angularVelocity*p.m_angularVelocity>V||c.lengthSquared(p.m_linearVelocity)>T?(p.m_sleepTime=0,P=0):(p.m_sleepTime+=l,P=_.min(P,p.m_sleepTime)))}if(P>=a.timeToSleep&&w)for(u=0;u<this.m_bodies.length;++u){(p=this.m_bodies[u]).setAwake(!1)}}},s.prototype.printBodies=function(t){for(var i=0;i<this.m_bodies.length;++i){var e=this.m_bodies[i];m.debug(t,e.c_position.a,e.c_position.c.x,e.c_position.c.y,e.c_velocity.w,e.c_velocity.v.x,e.c_velocity.v.y)}};var g=new o;s.prototype.solveWorldTOI=function(t){n&&m.debug("TOI++++++World");var i=this.m_world;this.m_profile;if(n&&m.debug("Z:",i.m_stepComplete),i.m_stepComplete){for(var e=i.m_bodyList;e;e=e.m_next)e.m_islandFlag=!1,e.m_sweep.alpha0=0,n&&m.debug("b.alpha0:",e.m_sweep.alpha0);for(var o=i.m_contactList;o;o=o.m_next)o.m_toiFlag=!1,o.m_islandFlag=!1,o.m_toiCount=0,o.m_toi=1}if(n)for(o=i.m_contactList;o;o=o.m_next)n&&m.debug("X:",o.m_toiFlag);for(;;){n&&m.debug(";;");var s=null,h=1;for(o=i.m_contactList;o;o=o.m_next)if(n&&m.debug("alpha0::",o.getFixtureA().getBody().m_sweep.alpha0,o.getFixtureB().getBody().m_sweep.alpha0),0!=o.isEnabled()&&(n&&m.debug("toiCount:",o.m_toiCount,a.maxSubSteps),!(o.m_toiCount>a.maxSubSteps))){n&&m.debug("toiFlag:",o.m_toiFlag);var c=1;if(o.m_toiFlag)c=o.m_toi;else{var l=o.getFixtureA(),u=o.getFixtureB();if(n&&m.debug("sensor:",l.isSensor(),u.isSensor()),l.isSensor()||u.isSensor())continue;var p=l.getBody(),v=u.getBody();r&&m.assert(p.isDynamic()||v.isDynamic());var x=p.isAwake()&&!p.isStatic(),b=v.isAwake()&&!v.isStatic();if(n&&m.debug("awakestatic:",p.isAwake(),p.isStatic()),n&&m.debug("awakestatic:",v.isAwake(),v.isStatic()),n&&m.debug("active:",x,b),0==x&&0==b)continue;n&&m.debug("alpha:",c,p.m_sweep.alpha0,v.m_sweep.alpha0);var A=p.isBullet()||!p.isDynamic(),w=v.isBullet()||!v.isDynamic();if(n&&m.debug("collide:",A,w),0==A&&0==w)continue;var B=p.m_sweep.alpha0;p.m_sweep.alpha0<v.m_sweep.alpha0?(B=v.m_sweep.alpha0,p.m_sweep.advance(B)):v.m_sweep.alpha0<p.m_sweep.alpha0&&(B=p.m_sweep.alpha0,v.m_sweep.advance(B)),n&&m.debug("alpha0:",B,p.m_sweep.alpha0,v.m_sweep.alpha0),r&&m.assert(B<1);var S=o.getChildIndexA(),M=o.getChildIndexB(),C=p.m_sweep,I=v.m_sweep;n&&m.debug("sweepA",C.localCenter.x,C.localCenter.y,C.c.x,C.c.y,C.a,C.alpha0,C.c0.x,C.c0.y,C.a0),n&&m.debug("sweepB",I.localCenter.x,I.localCenter.y,I.c.x,I.c.y,I.a,I.alpha0,I.c0.x,I.c0.y,I.a0);var P=new f;P.proxyA.set(l.getShape(),S),P.proxyB.set(u.getShape(),M),P.sweepA.set(p.m_sweep),P.sweepB.set(v.m_sweep),P.tMax=1;var T=new y;d(T,P);var V=T.t;n&&m.debug("state:",T.state,y.e_touching),c=T.state==y.e_touching?_.min(B+(1-B)*V,1):1,o.m_toi=c,o.m_toiFlag=!0}n&&m.debug("minAlpha:",h,c),c<h&&(s=o,h=c)}if(n&&m.debug("minContact:",null==s,1-10*_.EPSILON<h,h),null==s||1-10*_.EPSILON<h){i.m_stepComplete=!0;break}l=s.getFixtureA(),u=s.getFixtureB(),p=l.getBody(),v=u.getBody();var z=p.m_sweep.clone(),k=v.m_sweep.clone();if(p.advance(h),v.advance(h),s.update(i),s.m_toiFlag=!1,++s.m_toiCount,0!=s.isEnabled()&&0!=s.isTouching()){p.setAwake(!0),v.setAwake(!0),this.clear(),this.addBody(p),this.addBody(v),this.addContact(s),p.m_islandFlag=!0,v.m_islandFlag=!0,s.m_islandFlag=!0;for(var L=[p,v],q=0;q<L.length;++q){if((J=L[q]).isDynamic())for(var F=J.m_contactList;F;F=F.next){var R=F.contact;if(!R.m_islandFlag){var E=F.other;if(!E.isDynamic()||J.isBullet()||E.isBullet()){var D=R.m_fixtureA.m_isSensor,j=R.m_fixtureB.m_isSensor;if(!D&&!j){var Y=E.m_sweep.clone();0==E.m_islandFlag&&E.advance(h),R.update(i),0!=R.isEnabled()&&0!=R.isTouching()?(R.m_islandFlag=!0,this.addContact(R),E.m_islandFlag||(E.m_islandFlag=!0,E.isStatic()||E.setAwake(!0),this.addBody(E))):(E.m_sweep.set(Y),E.synchronizeTransform())}}}}}g.reset((1-h)*t.dt),g.dtRatio=1,g.positionIterations=20,g.velocityIterations=t.velocityIterations,g.warmStarting=!1,this.solveIslandTOI(g,p,v);for(q=0;q<this.m_bodies.length;++q){var J;if((J=this.m_bodies[q]).m_islandFlag=!1,J.isDynamic()){J.synchronizeFixtures();for(F=J.m_contactList;F;F=F.next)F.contact.m_toiFlag=!1,F.contact.m_islandFlag=!1}}if(i.findNewContacts(),i.m_subStepping){i.m_stepComplete=!1;break}}else s.setEnabled(!1),p.m_sweep.set(z),v.m_sweep.set(k),p.synchronizeTransform(),v.synchronizeTransform()}if(n)for(e=i.m_bodyList;e;e=e.m_next){o=e.m_sweep.c;var O=e.m_sweep.a,N=e.m_linearVelocity,W=e.m_angularVelocity;n&&m.debug("== ",O,o.x,o.y,W,N.x,N.y)}},s.prototype.solveIslandTOI=function(t,i,e){n&&m.debug("TOI++++++Island");this.m_world,this.m_profile;for(var o=0;o<this.m_bodies.length;++o){(u=this.m_bodies[o]).c_position.c.set(u.m_sweep.c),u.c_position.a=u.m_sweep.a,u.c_velocity.v.set(u.m_linearVelocity),u.c_velocity.w=u.m_angularVelocity}for(o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initConstraint(t)}for(o=0;o<t.positionIterations;++o){for(var s=0,r=0;r<this.m_contacts.length;++r){var h=this.m_contacts[r].solvePositionConstraintTOI(t,i,e);s=_.min(s,h)}if(s>=-1.5*a.linearSlop)break}i.m_sweep.c0.set(i.c_position.c),i.m_sweep.a0=i.c_position.a,e.m_sweep.c0.set(e.c_position.c),e.m_sweep.a0=e.c_position.a;for(o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initVelocityConstraint(t)}for(o=0;o<t.velocityIterations;++o)for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].solveVelocityConstraint(t)}var l=t.dt;for(o=0;o<this.m_bodies.length;++o){var u=this.m_bodies[o],p=c.clone(u.c_position.c),d=u.c_position.a,f=c.clone(u.c_velocity.v),y=u.c_velocity.w,v=c.mul(l,f);if(c.dot(v,v)>a.maxTranslationSquared){var g=a.maxTranslation/v.length();f.mul(g)}var x=l*y;if(x*x>a.maxRotationSquared){y*=g=a.maxRotation/_.abs(x)}p.wAdd(l,f),d+=l*y,u.c_position.c=p,u.c_position.a=d,u.c_velocity.v=f,u.c_velocity.w=y,u.m_sweep.c=p,u.m_sweep.a=d,u.m_linearVelocity=f,u.m_angularVelocity=y,u.synchronizeTransform()}this.postSolveIsland(),n&&m.debug("TOI------Island")},s.prototype.postSolveIsland=function(){for(var t=new function(){this.normalImpulses=[],this.tangentImpulses=[]},i=0;i<this.m_contacts.length;++i){for(var e=this.m_contacts[i],o=0;o<e.v_points.length;++o)t.normalImpulses.push(e.v_points[o].normalImpulse),t.tangentImpulses.push(e.v_points[o].tangentImpulse);this.m_world.postSolve(e,t)}}},{"./Body":2,"./Contact":3,"./Joint":5,"./Settings":7,"./collision/Distance":13,"./collision/TimeOfImpact":15,"./common/Math":18,"./common/Vec2":23,"./util/Timer":50,"./util/common":51}],10:[function(t,i,e){function o(t){if(!(this instanceof o))return new o(t);t&&m.isValid(t)&&(t={gravity:t}),t=r(t,u),this.m_solver=new c(this),this.m_broadPhase=new h,this.m_contactList=null,this.m_contactCount=0,this.m_bodyList=null,this.m_bodyCount=0,this.m_jointList=null,this.m_jointCount=0,this.m_stepComplete=!0,this.m_allowSleep=t.allowSleep,this.m_gravity=m.clone(t.gravity),this.m_clearForces=!0,this.m_newFixture=!1,this.m_locked=!1,this.m_warmStarting=t.warmStarting,this.m_continuousPhysics=t.continuousPhysics,this.m_subStepping=t.subStepping,this.m_blockSolve=t.blockSolve,this.m_velocityIterations=t.velocityIterations,this.m_positionIterations=t.positionIterations,this.m_t=0,this.m_stepCount=0,this.addPair=this.createContact.bind(this)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("./util/options"),a=t("./util/common"),m=(t("./util/Timer"),t("./common/Vec2")),h=t("./collision/BroadPhase"),c=t("./Solver"),_=t("./Body"),l=t("./Contact"),u={gravity:m.zero(),allowSleep:!0,warmStarting:!0,continuousPhysics:!0,subStepping:!1,blockSolve:!0,velocityIterations:8,positionIterations:3};o.prototype.getBodyList=function(){return this.m_bodyList},o.prototype.getJointList=function(){return this.m_jointList},o.prototype.getContactList=function(){return this.m_contactList},o.prototype.getBodyCount=function(){return this.m_bodyCount},o.prototype.getJointCount=function(){return this.m_jointCount},o.prototype.getContactCount=function(){return this.m_contactCount},o.prototype.setGravity=function(t){this.m_gravity=t},o.prototype.getGravity=function(){return this.m_gravity},o.prototype.isLocked=function(){return this.m_locked},o.prototype.setAllowSleeping=function(t){if(t!=this.m_allowSleep&&(this.m_allowSleep=t,0==this.m_allowSleep))for(var i=this.m_bodyList;i;i=i.m_next)i.setAwake(!0)},o.prototype.getAllowSleeping=function(){return this.m_allowSleep},o.prototype.setWarmStarting=function(t){this.m_warmStarting=t},o.prototype.getWarmStarting=function(){return this.m_warmStarting},o.prototype.setContinuousPhysics=function(t){this.m_continuousPhysics=t},o.prototype.getContinuousPhysics=function(){return this.m_continuousPhysics},o.prototype.setSubStepping=function(t){this.m_subStepping=t},o.prototype.getSubStepping=function(){return this.m_subStepping},o.prototype.setAutoClearForces=function(t){this.m_clearForces=t},o.prototype.getAutoClearForces=function(){return this.m_clearForces},o.prototype.clearForces=function(){for(var t=this.m_bodyList;t;t=t.getNext())t.m_force.setZero(),t.m_torque=0},o.prototype.queryAABB=function(t,i){n&&a.assert("function"==typeof i);var e=this.m_broadPhase;this.m_broadPhase.query(t,function(t){var o=e.getUserData(t);return i(o.fixture)})},o.prototype.rayCast=function(t,i,e){n&&a.assert("function"==typeof e);var o=this.m_broadPhase;this.m_broadPhase.rayCast({maxFraction:1,p1:t,p2:i},function(t,i){var s=o.getUserData(i),n=s.fixture,r=s.childIndex,a={};if(n.rayCast(a,t,r)){var h=a.fraction,c=m.add(m.mul(1-h,t.p1),m.mul(h,t.p2));return e(n,c,a.normal,h)}return t.maxFraction})},o.prototype.getProxyCount=function(){return this.m_broadPhase.getProxyCount()},o.prototype.getTreeHeight=function(){return this.m_broadPhase.getTreeHeight()},o.prototype.getTreeBalance=function(){return this.m_broadPhase.getTreeBalance()},o.prototype.getTreeQuality=function(){return this.m_broadPhase.getTreeQuality()},o.prototype.shiftOrigin=function(t){if(n&&a.assert(0==this.m_locked),!this.m_locked){for(var i=this.m_bodyList;i;i=i.m_next)i.m_xf.p.sub(t),i.m_sweep.c0.sub(t),i.m_sweep.c.sub(t);for(var e=this.m_jointList;e;e=e.m_next)e.shiftOrigin(t);this.m_broadPhase.shiftOrigin(t)}},o.prototype.createBody=function(t,i){if(n&&a.assert(0==this.isLocked()),this.isLocked())return null;t&&m.isValid(t)&&(t={position:t,angle:i});var e=new _(this,t);return e.m_prev=null,e.m_next=this.m_bodyList,this.m_bodyList&&(this.m_bodyList.m_prev=e),this.m_bodyList=e,++this.m_bodyCount,e},o.prototype.createDynamicBody=function(t,i){return t?m.isValid(t)&&(t={position:t,angle:i}):t={},t.type="dynamic",this.createBody(t)},o.prototype.createKinematicBody=function(t,i){return t?m.isValid(t)&&(t={position:t,angle:i}):t={},t.type="kinematic",this.createBody(t)},o.prototype.destroyBody=function(t){if(n&&a.assert(this.m_bodyCount>0),n&&a.assert(0==this.isLocked()),!this.isLocked()){if(t.m_destroyed)return!1;for(var i=t.m_jointList;i;){var e=i;i=i.next,this.publish("remove-joint",e.joint),this.destroyJoint(e.joint),t.m_jointList=i}t.m_jointList=null;for(var o=t.m_contactList;o;){var s=o;o=o.next,this.destroyContact(s.contact),t.m_contactList=o}t.m_contactList=null;for(var r=t.m_fixtureList;r;){var m=r;r=r.m_next,this.publish("remove-fixture",m),m.destroyProxies(this.m_broadPhase),t.m_fixtureList=r}return t.m_fixtureList=null,t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_bodyList&&(this.m_bodyList=t.m_next),t.m_destroyed=!0,--this.m_bodyCount,!0}},o.prototype.createJoint=function(t){if(n&&a.assert(!!t.m_bodyA),n&&a.assert(!!t.m_bodyB),n&&a.assert(0==this.isLocked()),this.isLocked())return null;if(t.m_prev=null,t.m_next=this.m_jointList,this.m_jointList&&(this.m_jointList.m_prev=t),this.m_jointList=t,++this.m_jointCount,t.m_edgeA.joint=t,t.m_edgeA.other=t.m_bodyB,t.m_edgeA.prev=null,t.m_edgeA.next=t.m_bodyA.m_jointList,t.m_bodyA.m_jointList&&(t.m_bodyA.m_jointList.prev=t.m_edgeA),t.m_bodyA.m_jointList=t.m_edgeA,t.m_edgeB.joint=t,t.m_edgeB.other=t.m_bodyA,t.m_edgeB.prev=null,t.m_edgeB.next=t.m_bodyB.m_jointList,t.m_bodyB.m_jointList&&(t.m_bodyB.m_jointList.prev=t.m_edgeB),t.m_bodyB.m_jointList=t.m_edgeB,0==t.m_collideConnected)for(var i=t.m_bodyB.getContactList();i;i=i.next)i.other==t.m_bodyA&&i.contact.flagForFiltering();return t},o.prototype.destroyJoint=function(t){if(n&&a.assert(0==this.isLocked()),!this.isLocked()){t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_jointList&&(this.m_jointList=t.m_next);var i=t.m_bodyA,e=t.m_bodyB;if(i.setAwake(!0),e.setAwake(!0),t.m_edgeA.prev&&(t.m_edgeA.prev.next=t.m_edgeA.next),t.m_edgeA.next&&(t.m_edgeA.next.prev=t.m_edgeA.prev),t.m_edgeA==i.m_jointList&&(i.m_jointList=t.m_edgeA.next),t.m_edgeA.prev=null,t.m_edgeA.next=null,t.m_edgeB.prev&&(t.m_edgeB.prev.next=t.m_edgeB.next),t.m_edgeB.next&&(t.m_edgeB.next.prev=t.m_edgeB.prev),t.m_edgeB==e.m_jointList&&(e.m_jointList=t.m_edgeB.next),t.m_edgeB.prev=null,t.m_edgeB.next=null,n&&a.assert(this.m_jointCount>0),--this.m_jointCount,0==t.m_collideConnected)for(var o=e.getContactList();o;)o.other==i&&o.contact.flagForFiltering(),o=o.next;this.publish("remove-joint",t)}};var p=new c.TimeStep;o.prototype.step=function(t,i,e){if((0|i)!==i&&(i=0),i=i||this.m_velocityIterations,e=e||this.m_positionIterations,this.m_stepCount++,this.m_newFixture&&(this.findNewContacts(),this.m_newFixture=!1),this.m_locked=!0,p.reset(t),p.velocityIterations=i,p.positionIterations=e,p.warmStarting=this.m_warmStarting,p.blockSolve=this.m_blockSolve,this.updateContacts(),this.m_stepComplete&&t>0){this.m_solver.solveWorld(p);for(var o=this.m_bodyList;o;o=o.getNext())0!=o.m_islandFlag&&(o.isStatic()||o.synchronizeFixtures());this.findNewContacts()}this.m_continuousPhysics&&t>0&&this.m_solver.solveWorldTOI(p),this.m_clearForces&&this.clearForces(),this.m_locked=!1},o.prototype.findNewContacts=function(){this.m_broadPhase.updatePairs(this.addPair)},o.prototype.createContact=function(t,i){var e=t.fixture,o=i.fixture,s=t.childIndex,n=i.childIndex,r=e.getBody(),a=o.getBody();if(r!=a){for(var m=a.getContactList();m;){if(m.other==r){var h=m.contact.getFixtureA(),c=m.contact.getFixtureB(),_=m.contact.getChildIndexA(),u=m.contact.getChildIndexB();if(h==e&&c==o&&_==s&&u==n)return;if(h==o&&c==e&&_==n&&u==s)return}m=m.next}if(0!=a.shouldCollide(r)&&0!=o.shouldCollide(e)){var p=l.create(e,s,o,n);null!=p&&(p.m_prev=null,null!=this.m_contactList&&(p.m_next=this.m_contactList,this.m_contactList.m_prev=p),this.m_contactList=p,++this.m_contactCount)}}},o.prototype.updateContacts=function(){for(var t,i=this.m_contactList;t=i;){i=t.getNext();var e=t.getFixtureA(),o=t.getFixtureB(),s=t.getChildIndexA(),n=t.getChildIndexB(),r=e.getBody(),a=o.getBody();if(t.m_filterFlag){if(0==a.shouldCollide(r)){this.destroyContact(t);continue}if(0==o.shouldCollide(e)){this.destroyContact(t);continue}t.m_filterFlag=!1}var m=r.isAwake()&&!r.isStatic(),h=a.isAwake()&&!a.isStatic();if(0!=m||0!=h){var c=e.m_proxies[s].proxyId,_=o.m_proxies[n].proxyId;0!=this.m_broadPhase.testOverlap(c,_)?t.update(this):this.destroyContact(t)}}},o.prototype.destroyContact=function(t){l.destroy(t,this),t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_contactList&&(this.m_contactList=t.m_next),--this.m_contactCount},o.prototype._listeners=null,o.prototype.on=function(t,i){return"string"!=typeof t||"function"!=typeof i?this:(this._listeners||(this._listeners={}),this._listeners[t]||(this._listeners[t]=[]),this._listeners[t].push(i),this)},o.prototype.off=function(t,i){if("string"!=typeof t||"function"!=typeof i)return this;var e=this._listeners&&this._listeners[t];if(!e||!e.length)return this;var o=e.indexOf(i);return o>=0&&e.splice(o,1),this},o.prototype.publish=function(t,i,e,o){var s=this._listeners&&this._listeners[t];if(!s||!s.length)return 0;for(var n=0;n<s.length;n++)s[n].call(this,i,e,o);return s.length},o.prototype.beginContact=function(t){this.publish("begin-contact",t)},o.prototype.endContact=function(t){this.publish("end-contact",t)},o.prototype.preSolve=function(t,i){this.publish("pre-solve",t,i)},o.prototype.postSolve=function(t,i){this.publish("post-solve",t,i)}},{"./Body":2,"./Contact":3,"./Solver":9,"./collision/BroadPhase":12,"./common/Vec2":23,"./util/Timer":50,"./util/common":51,"./util/options":53}],11:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);this.lowerBound=a.zero(),this.upperBound=a.zero(),"object"==typeof t&&this.lowerBound.set(t),"object"==typeof i&&this.upperBound.set(i)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;t("../Settings");var r=t("../common/Math"),a=t("../common/Vec2");i.exports=o,o.prototype.isValid=function(){return o.isValid(this)},o.isValid=function(t){var i=a.sub(t.upperBound,t.lowerBound);return i.x>=0&&i.y>=0&&a.isValid(t.lowerBound)&&a.isValid(t.upperBound)},o.prototype.getCenter=function(){return a.neo(.5*(this.lowerBound.x+this.upperBound.x),.5*(this.lowerBound.y+this.upperBound.y))},o.prototype.getExtents=function(){return a.neo(.5*(this.upperBound.x-this.lowerBound.x),.5*(this.upperBound.y-this.lowerBound.y))},o.prototype.getPerimeter=function(){return 2*(this.upperBound.x-this.lowerBound.x+this.upperBound.y-this.lowerBound.y)},o.prototype.combine=function(t,i){i=i||this,this.lowerBound.set(r.min(t.lowerBound.x,i.lowerBound.x),r.min(t.lowerBound.y,i.lowerBound.y)),this.upperBound.set(r.max(t.upperBound.x,i.upperBound.x),r.max(t.upperBound.y,i.upperBound.y))},o.prototype.combinePoints=function(t,i){this.lowerBound.set(r.min(t.x,i.x),r.min(t.y,i.y)),this.upperBound.set(r.max(t.x,i.x),r.max(t.y,i.y))},o.prototype.set=function(t){this.lowerBound.set(t.lowerBound.x,t.lowerBound.y),this.upperBound.set(t.upperBound.x,t.upperBound.y)},o.prototype.contains=function(t){var i=!0;return i=i&&this.lowerBound.x<=t.lowerBound.x,i=i&&this.lowerBound.y<=t.lowerBound.y,i=i&&t.upperBound.x<=this.upperBound.x,i=i&&t.upperBound.y<=this.upperBound.y},o.prototype.extend=function(t){o.extend(this,t)},o.extend=function(t,i){t.lowerBound.x-=i,t.lowerBound.y-=i,t.upperBound.x+=i,t.upperBound.y+=i},o.testOverlap=function(t,i){var e=i.lowerBound.x-t.upperBound.x,o=t.lowerBound.x-i.upperBound.x,s=i.lowerBound.y-t.upperBound.y,n=t.lowerBound.y-i.upperBound.y;return!(e>0||s>0||o>0||n>0)},o.areEqual=function(t,i){return a.areEqual(t.lowerBound,i.lowerBound)&&a.areEqual(t.upperBound,i.upperBound)},o.diff=function(t,i){var e=r.max(0,r.min(t.upperBound.x,i.upperBound.x)-r.max(i.lowerBound.x,t.lowerBound.x)),o=r.max(0,r.min(t.upperBound.y,i.upperBound.y)-r.max(i.lowerBound.y,t.lowerBound.y));return(t.upperBound.x-t.lowerBound.x)*(t.upperBound.y-t.lowerBound.y)+(i.upperBound.x-i.lowerBound.x)*(i.upperBound.y-i.lowerBound.y)-e*o},o.prototype.rayCast=function(t,i){for(var e=-1/0,o=1/0,s=i.p1,n=a.sub(i.p2,i.p1),m=a.abs(n),h=a.zero(),c="x";null!==c;c="x"===c?"y":null)if(m.x<r.EPSILON){if(s[c]<this.lowerBound[c]||this.upperBound[c]<s[c])return!1}else{var _=1/n[c],l=(this.lowerBound[c]-s[c])*_,u=(this.upperBound[c]-s[c])*_,p=-1;if(l>u){var d=l;l=u,u=d,p=1}if(l>e&&(h.setZero(),h[c]=p,e=l),o=r.min(o,u),e>o)return!1}return!(e<0||i.maxFraction<e)&&(t.fraction=e,t.normal=h,!0)},o.prototype.toString=function(){return JSON.stringify(this)}},{"../Settings":7,"../common/Math":18,"../common/Vec2":23}],12:[function(t,i,e){function o(){this.m_tree=new h,this.m_proxyCount=0,this.m_moveBuffer=[],this.queryCallback=this.queryCallback.bind(this)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;t("../Settings");var r=t("../util/common"),a=t("../common/Math"),m=t("./AABB"),h=t("./DynamicTree");i.exports=o,o.prototype.getUserData=function(t){return this.m_tree.getUserData(t)},o.prototype.testOverlap=function(t,i){var e=this.m_tree.getFatAABB(t),o=this.m_tree.getFatAABB(i);return m.testOverlap(e,o)},o.prototype.getFatAABB=function(t){return this.m_tree.getFatAABB(t)},o.prototype.getProxyCount=function(){return this.m_proxyCount},o.prototype.getTreeHeight=function(){return this.m_tree.getHeight()},o.prototype.getTreeBalance=function(){return this.m_tree.getMaxBalance()},o.prototype.getTreeQuality=function(){return this.m_tree.getAreaRatio()},o.prototype.query=function(t,i){this.m_tree.query(t,i)},o.prototype.rayCast=function(t,i){this.m_tree.rayCast(t,i)},o.prototype.shiftOrigin=function(t){this.m_tree.shiftOrigin(t)},o.prototype.createProxy=function(t,i){n&&r.assert(m.isValid(t));var e=this.m_tree.createProxy(t,i);return this.m_proxyCount++,this.bufferMove(e),e},o.prototype.destroyProxy=function(t){this.unbufferMove(t),this.m_proxyCount--,this.m_tree.destroyProxy(t)},o.prototype.moveProxy=function(t,i,e){n&&r.assert(m.isValid(i));this.m_tree.moveProxy(t,i,e)&&this.bufferMove(t)},o.prototype.touchProxy=function(t){this.bufferMove(t)},o.prototype.bufferMove=function(t){this.m_moveBuffer.push(t)},o.prototype.unbufferMove=function(t){for(var i=0;i<this.m_moveBuffer.length;++i)this.m_moveBuffer[i]==t&&(this.m_moveBuffer[i]=null)},o.prototype.updatePairs=function(t){for(n&&r.assert("function"==typeof t),this.m_callback=t;this.m_moveBuffer.length>0;)if(this.m_queryProxyId=this.m_moveBuffer.pop(),null!==this.m_queryProxyId){var i=this.m_tree.getFatAABB(this.m_queryProxyId);this.m_tree.query(i,this.queryCallback)}},o.prototype.queryCallback=function(t){if(t==this.m_queryProxyId)return!0;var i=a.min(t,this.m_queryProxyId),e=a.max(t,this.m_queryProxyId),o=this.m_tree.getUserData(i),s=this.m_tree.getUserData(e);return this.m_callback(o,s),!0}},{"../Settings":7,"../common/Math":18,"../util/common":51,"./AABB":11,"./DynamicTree":14}],13:[function(t,i,e){function o(){this.proxyA=new a,this.proxyB=new a,this.transformA=null,this.transformB=null,this.useRadii=!1}function s(){this.pointA=f.zero(),this.pointB=f.zero(),this.distance,this.iterations}function n(){this.metric=0,this.indexA=[],this.indexB=[],this.count=0}function r(t,i,e){++p.gjkCalls;var o=e.proxyA,s=e.proxyB,n=e.transformA,r=e.transformB;c&&u.debug("cahce:",i.metric,i.count),c&&u.debug("proxyA:",o.m_count),c&&u.debug("proxyB:",s.m_count),c&&u.debug("xfA:",n.p.x,n.p.y,n.q.c,n.q.s),c&&u.debug("xfB:",r.p.x,r.p.y,r.q.c,r.q.s);var a=new h;a.readCache(i,o,n,s,r),c&&u.debug("cache",a.print());for(var m=a.m_v,_=l.maxDistnceIterations,g=[],x=[],b=0,A=0;A<_;){b=a.m_count;for(var w=0;w<b;++w)g[w]=m[w].indexA,x[w]=m[w].indexB;if(a.solve(),3==a.m_count)break;(T=a.getClosestPoint()).lengthSquared();var B=a.getSearchDirection();if(B.lengthSquared()<d.EPSILON*d.EPSILON)break;var S=m[a.m_count];S.indexA=o.getSupport(y.mulT(n.q,f.neg(B))),S.wA=v.mul(n,o.getVertex(S.indexA)),S.indexB=s.getSupport(y.mulT(r.q,B)),S.wB=v.mul(r,s.getVertex(S.indexB)),S.w=f.sub(S.wB,S.wA),++A,++p.gjkIters;var M=!1;for(w=0;w<b;++w)if(S.indexA==g[w]&&S.indexB==x[w]){M=!0;break}if(M)break;++a.m_count}if(p.gjkMaxIters=d.max(p.gjkMaxIters,A),a.getWitnessPoints(t.pointA,t.pointB),t.distance=f.distance(t.pointA,t.pointB),t.iterations=A,c&&u.debug("Distance:",t.distance,t.pointA.x,t.pointA.y,t.pointB.x,t.pointB.y),a.writeCache(i),e.useRadii){var C=o.m_radius,I=s.m_radius;if(t.distance>C+I&&t.distance>d.EPSILON){t.distance-=C+I;var P=f.sub(t.pointB,t.pointA);P.normalize(),t.pointA.wAdd(C,P),t.pointB.wSub(I,P)}else{var T=f.mid(t.pointA,t.pointB);t.pointA.set(T),t.pointB.set(T),t.distance=0}}}function a(){this.m_buffer=[],this.m_vertices=[],this.m_count=0,this.m_radius=0}function m(){this.indexA,this.indexB,this.wA=f.zero(),this.wB=f.zero(),this.w=f.zero(),this.a}function h(){this.m_v1=new m,this.m_v2=new m,this.m_v3=new m,this.m_v=[this.m_v1,this.m_v2,this.m_v3],this.m_count}if(void 0===c)var c=!1;if(void 0===_)var _=!1;i.exports=r,i.exports.Input=o,i.exports.Output=s,i.exports.Proxy=a,i.exports.Cache=n;var l=t("../Settings"),u=t("../util/common"),p=(t("../util/Timer"),t("../common/stats")),d=t("../common/Math"),f=t("../common/Vec2"),y=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),v=(t("../common/Sweep"),t("../common/Transform"));t("../common/Velocity"),t("../common/Position");p.gjkCalls=0,p.gjkIters=0,p.gjkMaxIters=0,a.prototype.getVertexCount=function(){return this.m_count},a.prototype.getVertex=function(t){return _&&u.assert(0<=t&&t<this.m_count),this.m_vertices[t]},a.prototype.getSupport=function(t){for(var i=0,e=f.dot(this.m_vertices[0],t),o=0;o<this.m_count;++o){var s=f.dot(this.m_vertices[o],t);s>e&&(i=o,e=s)}return i},a.prototype.getSupportVertex=function(t){return this.m_vertices[this.getSupport(t)]},a.prototype.set=function(t,i){_&&u.assert("function"==typeof t.computeDistanceProxy),t.computeDistanceProxy(this,i)},m.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.wA=f.clone(t.wA),this.wB=f.clone(t.wB),this.w=f.clone(t.w),this.a=t.a},h.prototype.print=function(){return 3==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y,this.m_v3.a,this.m_v3.wA.x,this.m_v3.wA.y,this.m_v3.wB.x,this.m_v3.wB.y].toString():2==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y].toString():1==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y].toString():"+"+this.m_count},h.prototype.readCache=function(t,i,e,o,s){_&&u.assert(t.count<=3),this.m_count=t.count;for(var n=0;n<this.m_count;++n){(c=this.m_v[n]).indexA=t.indexA[n],c.indexB=t.indexB[n];var r=i.getVertex(c.indexA),a=o.getVertex(c.indexB);c.wA=v.mul(e,r),c.wB=v.mul(s,a),c.w=f.sub(c.wB,c.wA),c.a=0}if(this.m_count>1){var m=t.metric,h=this.getMetric();(h<.5*m||2*m<h||h<d.EPSILON)&&(this.m_count=0)}if(0==this.m_count){var c;(c=this.m_v[0]).indexA=0,c.indexB=0;r=i.getVertex(0),a=o.getVertex(0);c.wA=v.mul(e,r),c.wB=v.mul(s,a),c.w=f.sub(c.wB,c.wA),c.a=1,this.m_count=1}},h.prototype.writeCache=function(t){t.metric=this.getMetric(),t.count=this.m_count;for(var i=0;i<this.m_count;++i)t.indexA[i]=this.m_v[i].indexA,t.indexB[i]=this.m_v[i].indexB},h.prototype.getSearchDirection=function(){switch(this.m_count){case 1:return f.neg(this.m_v1.w);case 2:var t=f.sub(this.m_v2.w,this.m_v1.w);return f.cross(t,f.neg(this.m_v1.w))>0?f.cross(1,t):f.cross(t,1);default:return _&&u.assert(!1),f.zero()}},h.prototype.getClosestPoint=function(){switch(this.m_count){case 0:return _&&u.assert(!1),f.zero();case 1:return f.clone(this.m_v1.w);case 2:return f.wAdd(this.m_v1.a,this.m_v1.w,this.m_v2.a,this.m_v2.w);case 3:return f.zero();default:return _&&u.assert(!1),f.zero()}},h.prototype.getWitnessPoints=function(t,i){switch(this.m_count){case 0:_&&u.assert(!1);break;case 1:c&&u.debug("case1",this.print()),t.set(this.m_v1.wA),i.set(this.m_v1.wB);break;case 2:c&&u.debug("case2",this.print()),t.wSet(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),i.wSet(this.m_v1.a,this.m_v1.wB,this.m_v2.a,this.m_v2.wB);break;case 3:c&&u.debug("case3",this.print()),t.wSet(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),t.wAdd(this.m_v3.a,this.m_v3.wA),i.set(t);break;default:_&&u.assert(!1)}},h.prototype.getMetric=function(){switch(this.m_count){case 0:return _&&u.assert(!1),0;case 1:return 0;case 2:return f.distance(this.m_v1.w,this.m_v2.w);case 3:return f.cross(f.sub(this.m_v2.w,this.m_v1.w),f.sub(this.m_v3.w,this.m_v1.w));default:return _&&u.assert(!1),0}},h.prototype.solve=function(){switch(this.m_count){case 1:break;case 2:this.solve2();break;case 3:this.solve3();break;default:_&&u.assert(!1)}},h.prototype.solve2=function(){var t=this.m_v1.w,i=this.m_v2.w,e=f.sub(i,t),o=-f.dot(t,e);if(o<=0)return this.m_v1.a=1,void(this.m_count=1);var s=f.dot(i,e);if(s<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);var n=1/(s+o);this.m_v1.a=s*n,this.m_v2.a=o*n,this.m_count=2},h.prototype.solve3=function(){var t=this.m_v1.w,i=this.m_v2.w,e=this.m_v3.w,o=f.sub(i,t),s=f.dot(t,o),n=f.dot(i,o),r=-s,a=f.sub(e,t),m=f.dot(t,a),h=f.dot(e,a),c=-m,_=f.sub(e,i),l=f.dot(i,_),u=f.dot(e,_),p=-l,d=f.cross(o,a),y=d*f.cross(i,e),v=d*f.cross(e,t),g=d*f.cross(t,i);if(r<=0&&c<=0)return this.m_v1.a=1,void(this.m_count=1);if(n>0&&r>0&&g<=0){var x=1/(n+r);return this.m_v1.a=n*x,this.m_v2.a=r*x,void(this.m_count=2)}if(h>0&&c>0&&v<=0){var b=1/(h+c);return this.m_v1.a=h*b,this.m_v3.a=c*b,this.m_count=2,void this.m_v2.set(this.m_v3)}if(n<=0&&p<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);if(h<=0&&u<=0)return this.m_v3.a=1,this.m_count=1,void this.m_v1.set(this.m_v3);if(u>0&&p>0&&y<=0){var A=1/(u+p);return this.m_v2.a=u*A,this.m_v3.a=p*A,this.m_count=2,void this.m_v1.set(this.m_v3)}var w=1/(y+v+g);this.m_v1.a=y*w,this.m_v2.a=v*w,this.m_v3.a=g*w,this.m_count=3},r.testOverlap=function(t,i,e,a,m,h){var c=new o;c.proxyA.set(t,i),c.proxyB.set(e,a),c.transformA=m,c.transformB=h,c.useRadii=!0;var _=new n,l=new s;return r(l,_,c),l.distance<10*d.EPSILON}},{"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../common/stats":26,"../util/Timer":50,"../util/common":51}],14:[function(t,i,e){function o(t){this.id=t,this.aabb=new l,this.userData=null,this.parent=null,this.child1=null,this.child2=null,this.height=-1,this.toString=function(){return this.id+": "+this.userData}}function s(){this.m_root=null,this.m_nodes={},this.m_lastProxyId=0,this.m_pool=new h({create:function(){return new o}})}if(void 0===n)var n=!1;if(void 0===r)var r=!1;var a=t("../Settings"),m=t("../util/common"),h=t("../util/Pool"),c=t("../common/Vec2"),_=t("../common/Math"),l=t("./AABB");i.exports=s,o.prototype.isLeaf=function(){return null==this.child1},s.prototype.getUserData=function(t){var i=this.m_nodes[t];return r&&m.assert(!!i),i.userData},s.prototype.getFatAABB=function(t){var i=this.m_nodes[t];return r&&m.assert(!!i),i.aabb},s.prototype.allocateNode=function(){var t=this.m_pool.allocate();return t.id=++this.m_lastProxyId,t.userData=null,t.parent=null,t.child1=null,t.child2=null,t.height=-1,this.m_nodes[t.id]=t,t},s.prototype.freeNode=function(t){this.m_pool.release(t),t.height=-1,delete this.m_nodes[t.id]},s.prototype.createProxy=function(t,i){r&&m.assert(l.isValid(t));var e=this.allocateNode();return e.aabb.set(t),l.extend(e.aabb,a.aabbExtension),e.userData=i,e.height=0,this.insertLeaf(e),e.id},s.prototype.destroyProxy=function(t){var i=this.m_nodes[t];r&&m.assert(!!i),r&&m.assert(i.isLeaf()),this.removeLeaf(i),this.freeNode(i)},s.prototype.moveProxy=function(t,i,e){r&&m.assert(l.isValid(i)),r&&m.assert(!e||c.isValid(e));var o=this.m_nodes[t];return r&&m.assert(!!o),r&&m.assert(o.isLeaf()),!o.aabb.contains(i)&&(this.removeLeaf(o),o.aabb.set(i),i=o.aabb,l.extend(i,a.aabbExtension),e.x<0?i.lowerBound.x+=e.x*a.aabbMultiplier:i.upperBound.x+=e.x*a.aabbMultiplier,e.y<0?i.lowerBound.y+=e.y*a.aabbMultiplier:i.upperBound.y+=e.y*a.aabbMultiplier,this.insertLeaf(o),!0)},s.prototype.insertLeaf=function(t){if(r&&m.assert(l.isValid(t.aabb)),null==this.m_root)return this.m_root=t,void(this.m_root.parent=null);for(var i=t.aabb,e=this.m_root;0==e.isLeaf();){var o=e.child1,s=e.child2,n=e.aabb.getPerimeter(),a=new l;a.combine(e.aabb,i);var h,c=a.getPerimeter(),u=2*c,p=2*(c-n);if(o.isLeaf()){(y=new l).combine(i,o.aabb),h=y.getPerimeter()+p}else{(y=new l).combine(i,o.aabb);var d=o.aabb.getPerimeter();h=y.getPerimeter()-d+p}var f;if(s.isLeaf()){(y=new l).combine(i,s.aabb),f=y.getPerimeter()+p}else{var y;(y=new l).combine(i,s.aabb);d=s.aabb.getPerimeter();f=y.getPerimeter()-d+p}if(u<h&&u<f)break;e=h<f?o:s}var v=e,g=v.parent,x=this.allocateNode();for(x.parent=g,x.userData=null,x.aabb.combine(i,v.aabb),x.height=v.height+1,null!=g?(g.child1==v?g.child1=x:g.child2=x,x.child1=v,x.child2=t,v.parent=x,t.parent=x):(x.child1=v,x.child2=t,v.parent=x,t.parent=x,this.m_root=x),e=t.parent;null!=e;){o=(e=this.balance(e)).child1,s=e.child2;r&&m.assert(null!=o),r&&m.assert(null!=s),e.height=1+_.max(o.height,s.height),e.aabb.combine(o.aabb,s.aabb),e=e.parent}},s.prototype.removeLeaf=function(t){if(t!=this.m_root){var i,e=t.parent,o=e.parent;if(i=e.child1==t?e.child2:e.child1,null!=o){o.child1==e?o.child1=i:o.child2=i,i.parent=o,this.freeNode(e);for(var s=o;null!=s;){var n=(s=this.balance(s)).child1,r=s.child2;s.aabb.combine(n.aabb,r.aabb),s.height=1+_.max(n.height,r.height),s=s.parent}}else this.m_root=i,i.parent=null,this.freeNode(e)}else this.m_root=null},s.prototype.balance=function(t){r&&m.assert(null!=t);var i=t;if(i.isLeaf()||i.height<2)return t;var e=i.child1,o=i.child2,s=o.height-e.height;if(s>1){var n=o.child1,a=o.child2;return o.child1=i,o.parent=i.parent,i.parent=o,null!=o.parent?o.parent.child1==t?o.parent.child1=o:o.parent.child2=o:this.m_root=o,n.height>a.height?(o.child2=n,i.child2=a,a.parent=i,i.aabb.combine(e.aabb,a.aabb),o.aabb.combine(i.aabb,n.aabb),i.height=1+_.max(e.height,a.height),o.height=1+_.max(i.height,n.height)):(o.child2=a,i.child2=n,n.parent=i,i.aabb.combine(e.aabb,n.aabb),o.aabb.combine(i.aabb,a.aabb),i.height=1+_.max(e.height,n.height),o.height=1+_.max(i.height,a.height)),o}if(s<-1){var h=e.child1,c=e.child2;return e.child1=i,e.parent=i.parent,i.parent=e,null!=e.parent?e.parent.child1==i?e.parent.child1=e:e.parent.child2=e:this.m_root=e,h.height>c.height?(e.child2=h,i.child1=c,c.parent=i,i.aabb.combine(o.aabb,c.aabb),e.aabb.combine(i.aabb,h.aabb),i.height=1+_.max(o.height,c.height),e.height=1+_.max(i.height,h.height)):(e.child2=c,i.child1=h,h.parent=i,i.aabb.combine(o.aabb,h.aabb),e.aabb.combine(i.aabb,c.aabb),i.height=1+_.max(o.height,h.height),e.height=1+_.max(i.height,c.height)),e}return i},s.prototype.getHeight=function(){return null==this.m_root?0:this.m_root.height},s.prototype.getAreaRatio=function(){if(null==this.m_root)return 0;for(var t,i=this.m_root.aabb.getPerimeter(),e=0,o=d.allocate().preorder();t=o.next();)t.height<0||(e+=t.aabb.getPerimeter());return d.release(o),e/i},s.prototype.computeHeight=function(t){var i;if((i=void 0!==t?this.m_nodes[t]:this.m_root).isLeaf())return 0;var e=ComputeHeight(i.child1),o=ComputeHeight(i.child2);return 1+_.max(e,o)},s.prototype.validateStructure=function(t){if(null!=t){t==this.m_root&&r&&m.assert(null==t.parent);var i=t.child1,e=t.child2;if(t.isLeaf())return r&&m.assert(null==i),r&&m.assert(null==e),void(r&&m.assert(0==t.height));r&&m.assert(i.parent==t),r&&m.assert(e.parent==t),this.validateStructure(i),this.validateStructure(e)}},s.prototype.validateMetrics=function(t){if(null!=t){var i=t.child1,e=t.child2;if(t.isLeaf())return r&&m.assert(null==i),r&&m.assert(null==e),void(r&&m.assert(0==t.height));var o=this.m_nodes[i].height,s=this.m_nodes[e].height,n=1+_.max(o,s);r&&m.assert(t.height==n);var a=new l;a.combine(i.aabb,e.aabb),r&&m.assert(l.areEqual(a,t.aabb)),this.validateMetrics(i),this.validateMetrics(e)}},s.prototype.validate=function(){ValidateStructure(this.m_root),ValidateMetrics(this.m_root),r&&m.assert(this.getHeight()==this.computeHeight())},s.prototype.getMaxBalance=function(){for(var t,i=0,e=d.allocate().preorder();t=e.next();)if(!(t.height<=1)){r&&m.assert(0==t.isLeaf());var o=_.abs(t.child2.height-t.child1.height);i=_.max(i,o)}return d.release(e),i},s.prototype.rebuildBottomUp=function(){for(var t,i=[],e=0,o=d.allocate().preorder();t=o.next();)t.height<0||(t.isLeaf()?(t.parent=null,i[e]=t,++e):this.freeNode(t));for(d.release(o);e>1;){for(var s=1/0,n=-1,r=-1,a=0;a<e;++a)for(var m=i[a].aabb,h=a+1;h<e;++h){var c=i[h].aabb,u=new l;u.combine(m,c);var p=u.getPerimeter();p<s&&(n=a,r=h,s=p)}var f=i[n],y=i[r],v=this.allocateNode();v.child1=f,v.child2=y,v.height=1+_.max(f.height,y.height),v.aabb.combine(f.aabb,y.aabb),v.parent=null,f.parent=v,y.parent=v,i[r]=i[e-1],i[n]=v,--e}this.m_root=i[0],this.validate()},s.prototype.shiftOrigin=function(t){for(var i,e=d.allocate().preorder();i=e.next();){var o=i.aabb;o.lowerBound.x-=t.x,o.lowerBound.y-=t.y,o.lowerBound.x-=t.x,o.lowerBound.y-=t.y}d.release(e)},s.prototype.query=function(t,i){r&&m.assert("function"==typeof i);var e=p.allocate();for(e.push(this.m_root);e.length>0;){var o=e.pop();if(null!=o&&l.testOverlap(o.aabb,t))if(o.isLeaf()){if(0==i(o.id))return}else e.push(o.child1),e.push(o.child2)}p.release(e)},s.prototype.rayCast=function(t,i){r&&m.assert("function"==typeof i);var e=t.p1,o=t.p2,s=c.sub(o,e);r&&m.assert(s.lengthSquared()>0),s.normalize();var n=c.cross(1,s),a=c.abs(n),h=t.maxFraction,d=new l,f=c.wAdd(1-h,e,h,o);d.combinePoints(e,f);var y=p.allocate(),v=u.allocate();for(y.push(this.m_root);y.length>0;){var g=y.pop();if(null!=g&&0!=l.testOverlap(g.aabb,d)){var x=g.aabb.getCenter(),b=g.aabb.getExtents();if(!(_.abs(c.dot(n,c.sub(e,x)))-c.dot(a,b)>0))if(g.isLeaf()){v.p1=c.clone(t.p1),v.p2=c.clone(t.p2),v.maxFraction=h;var A=i(v,g.id);if(0==A)return;A>0&&(h=A,f=c.wAdd(1-h,e,h,o),d.combinePoints(e,f))}else y.push(g.child1),y.push(g.child2)}}p.release(y),u.release(v)};var u=new h({create:function(){return{}},release:function(t){}}),p=new h({create:function(){return[]},release:function(t){t.length=0}}),d=new h({create:function(){return new function(){var t=[],i=[];return{preorder:function(e){return t.length=0,t.push(e),i.length=0,i.push(0),this},next:function(){for(;t.length>0;){var e=t.length-1,o=t[e];if(0===i[e])return i[e]=1,o;if(1===i[e]&&(i[e]=2,o.child1))return t.push(o.child1),i.push(1),o.child1;if(2===i[e]&&(i[e]=3,o.child2))return t.push(o.child2),i.push(1),o.child2;t.pop(),i.pop()}},close:function(){t.length=0}}}},release:function(t){t.close()}})},{"../Settings":7,"../common/Math":18,"../common/Vec2":23,"../util/Pool":49,"../util/common":51,"./AABB":11}],15:[function(t,i,e){function o(){this.state,this.t}function s(){this.m_proxyA=new g,this.m_proxyB=new g,this.m_sweepA,this.m_sweepB,this.m_type,this.m_localPoint=l.zero(),this.m_axis=l.zero()}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=function(t,i){var e=h.now();++c.toiCalls,t.state=o.e_unknown,t.t=i.tMax;var l=i.proxyA,u=i.proxyB,p=i.sweepA,g=i.sweepB;n&&m.debug("sweepA",p.localCenter.x,p.localCenter.y,p.c.x,p.c.y,p.a,p.alpha0,p.c0.x,p.c0.y,p.a0),n&&m.debug("sweepB",g.localCenter.x,g.localCenter.y,g.c.x,g.c.y,g.a,g.alpha0,g.c0.x,g.c0.y,g.a0),p.normalize(),g.normalize();var b=i.tMax,A=l.m_radius+u.m_radius,w=_.max(a.linearSlop,A-3*a.linearSlop),B=.25*a.linearSlop;r&&m.assert(w>B);var S=0,M=a.maxTOIIterations,C=0,I=new x,P=new y;for(P.proxyA=i.proxyA,P.proxyB=i.proxyB,P.useRadii=!1;;){var T=d.identity(),V=d.identity();p.getTransform(T,S),g.getTransform(V,S),n&&m.debug("xfA:",T.p.x,T.p.y,T.q.c,T.q.s),n&&m.debug("xfB:",V.p.x,V.p.y,V.q.c,V.q.s),P.transformA=T,P.transformB=V;var z=new v;if(f(z,I,P),n&&m.debug("distance:",z.distance),z.distance<=0){t.state=o.e_overlapped,t.t=0;break}if(z.distance<w+B){t.state=o.e_touching,t.t=S;break}var k=new s;k.initialize(I,l,p,u,g,S);for(var L=!1,q=b,F=0;;){var R=k.findMinSeparation(q);if(k.indexA,k.indexB,R>w+B){t.state=o.e_separated,t.t=b,L=!0;break}if(R>w-B){S=q;break}var E=k.evaluate(S);if(k.indexA,k.indexB,n&&m.debug("s1:",E,w,B,S),E<w-B){t.state=o.e_failed,t.t=S,L=!0;break}if(E<=w+B){t.state=o.e_touching,t.t=S,L=!0;break}for(var D=0,j=S,Y=q;;){var J;J=1&D?j+(w-E)*(Y-j)/(R-E):.5*(j+Y),++D,++c.toiRootIters;var O=k.evaluate(J);if(k.indexA,k.indexB,_.abs(O-w)<B){q=J;break}if(O>w?(j=J,E=O):(Y=J,R=O),50==D)break}if(c.toiMaxRootIters=_.max(c.toiMaxRootIters,D),++F==a.maxPolygonVertices)break}if(++C,++c.toiIters,L)break;if(C==M){t.state=o.e_failed,t.t=S;break}}c.toiMaxIters=_.max(c.toiMaxIters,C);var N=h.diff(e);c.toiMaxTime=_.max(c.toiMaxTime,N),c.toiTime+=N},i.exports.Input=function(){this.proxyA=new g,this.proxyB=new g,this.sweepA=new p,this.sweepB=new p,this.tMax},i.exports.Output=o;var a=t("../Settings"),m=t("../util/common"),h=t("../util/Timer"),c=t("../common/stats"),_=t("../common/Math"),l=t("../common/Vec2"),u=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),p=t("../common/Sweep"),d=t("../common/Transform"),f=(t("../common/Velocity"),t("../common/Position"),t("./Distance")),y=f.Input,v=f.Output,g=f.Proxy,x=f.Cache;o.e_unknown=0,o.e_failed=1,o.e_overlapped=2,o.e_touching=3,o.e_separated=4,c.toiTime=0,c.toiMaxTime=0,c.toiCalls=0,c.toiIters=0,c.toiMaxIters=0,c.toiRootIters=0,c.toiMaxRootIters=0;s.prototype.initialize=function(t,i,e,o,s,n){this.m_proxyA=i,this.m_proxyB=o;var a=t.count;r&&m.assert(0<a&&a<3),this.m_sweepA=e,this.m_sweepB=s;var h=d.identity(),c=d.identity();if(this.m_sweepA.getTransform(h,n),this.m_sweepB.getTransform(c,n),1==a){this.m_type=1;var _=this.m_proxyA.getVertex(t.indexA[0]),p=this.m_proxyB.getVertex(t.indexB[0]),f=d.mul(h,_),y=d.mul(c,p);this.m_axis.wSet(1,y,-1,f);return w=this.m_axis.normalize()}if(t.indexA[0]==t.indexA[1]){this.m_type=3;var v=o.getVertex(t.indexB[0]),g=o.getVertex(t.indexB[1]);this.m_axis=l.cross(l.sub(g,v),1),this.m_axis.normalize();var x=u.mul(c.q,this.m_axis);this.m_localPoint=l.mid(v,g);y=d.mul(c,this.m_localPoint),_=i.getVertex(t.indexA[0]),f=d.mul(h,_);return(w=l.dot(f,x)-l.dot(y,x))<0&&(this.m_axis=l.neg(this.m_axis),w=-w),w}this.m_type=2;var b=this.m_proxyA.getVertex(t.indexA[0]),A=this.m_proxyA.getVertex(t.indexA[1]);this.m_axis=l.cross(l.sub(A,b),1),this.m_axis.normalize();x=u.mul(h.q,this.m_axis);this.m_localPoint=l.mid(b,A);var w;f=d.mul(h,this.m_localPoint),p=this.m_proxyB.getVertex(t.indexB[0]),y=d.mul(c,p);return(w=l.dot(y,x)-l.dot(f,x))<0&&(this.m_axis=l.neg(this.m_axis),w=-w),w},s.prototype.compute=function(t,i){var e=d.identity(),o=d.identity();switch(this.m_sweepA.getTransform(e,i),this.m_sweepB.getTransform(o,i),this.m_type){case 1:if(t){var s=u.mulT(e.q,this.m_axis),n=u.mulT(o.q,l.neg(this.m_axis));this.indexA=this.m_proxyA.getSupport(s),this.indexB=this.m_proxyB.getSupport(n)}var a=this.m_proxyA.getVertex(this.indexA),h=this.m_proxyB.getVertex(this.indexB),c=d.mul(e,a),_=d.mul(o,h);return l.dot(_,this.m_axis)-l.dot(c,this.m_axis);case 2:var p=u.mul(e.q,this.m_axis);c=d.mul(e,this.m_localPoint);if(t){n=u.mulT(o.q,l.neg(p));this.indexA=-1,this.indexB=this.m_proxyB.getSupport(n)}h=this.m_proxyB.getVertex(this.indexB),_=d.mul(o,h);return l.dot(_,p)-l.dot(c,p);case 3:p=u.mul(o.q,this.m_axis),_=d.mul(o,this.m_localPoint);if(t){s=u.mulT(e.q,l.neg(p));this.indexB=-1,this.indexA=this.m_proxyA.getSupport(s)}a=this.m_proxyA.getVertex(this.indexA),c=d.mul(e,a);return l.dot(c,p)-l.dot(_,p);default:return r&&m.assert(!1),t&&(this.indexA=-1,this.indexB=-1),0}},s.prototype.findMinSeparation=function(t){return this.compute(!0,t)},s.prototype.evaluate=function(t){return this.compute(!1,t)}},{"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../common/stats":26,"../util/Timer":50,"../util/common":51,"./Distance":13}],16:[function(t,i,e){function o(t,i,e,o){"object"==typeof t&&null!==t?(this.ex=a.clone(t),this.ey=a.clone(i)):"number"==typeof t?(this.ex=a.neo(t,e),this.ey=a.neo(i,o)):(this.ex=a.zero(),this.ey=a.zero())}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=(t("./Math"),t("./Vec2"));o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&a.isValid(t.ex)&&a.isValid(t.ey)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Mat22!")},o.prototype.set=function(t,i,e,s){"number"==typeof t&&"number"==typeof i&&"number"==typeof e&&"number"==typeof s?(this.ex.set(t,e),this.ey.set(i,s)):"object"==typeof t&&"object"==typeof i?(this.ex.set(t),this.ey.set(i)):"object"==typeof t?(n&&o.assert(t),this.ex.set(t.ex),this.ey.set(t.ey)):n&&r.assert(!1)},o.prototype.setIdentity=function(){this.ex.x=1,this.ey.x=0,this.ex.y=0,this.ey.y=1},o.prototype.setZero=function(){this.ex.x=0,this.ey.x=0,this.ex.y=0,this.ey.y=0},o.prototype.getInverse=function(){var t=this.ex.x,i=this.ey.x,e=this.ex.y,s=this.ey.y,n=t*s-i*e;0!=n&&(n=1/n);var r=new o;return r.ex.x=n*s,r.ey.x=-n*i,r.ex.y=-n*e,r.ey.y=n*t,r},o.prototype.solve=function(t){n&&a.assert(t);var i=this.ex.x,e=this.ey.x,o=this.ex.y,s=this.ey.y,r=i*s-e*o;0!=r&&(r=1/r);var m=a.zero();return m.x=r*(s*t.x-e*t.y),m.y=r*(i*t.y-o*t.x),m},o.mul=function(t,i){if(i&&"x"in i&&"y"in i){n&&a.assert(i);var e=t.ex.x*i.x+t.ey.x*i.y,s=t.ex.y*i.x+t.ey.y*i.y;return a.neo(e,s)}if(i&&"ex"in i&&"ey"in i)return n&&o.assert(i),new o(a.mul(t,i.ex),a.mul(t,i.ey));n&&r.assert(!1)},o.mulT=function(t,i){if(i&&"x"in i&&"y"in i)return n&&a.assert(i),a.neo(a.dot(i,t.ex),a.dot(i,t.ey));if(i&&"ex"in i&&"ey"in i){n&&o.assert(i);return new o(a.neo(a.dot(t.ex,i.ex),a.dot(t.ey,i.ex)),a.neo(a.dot(t.ex,i.ey),a.dot(t.ey,i.ey)))}n&&r.assert(!1)},o.abs=function(t){return n&&o.assert(t),new o(a.abs(t.ex),a.abs(t.ey))},o.add=function(t,i){return n&&o.assert(t),n&&o.assert(i),new o(a.add(t.ex+i.ex),a.add(t.ey+i.ey))}},{"../util/common":51,"./Math":18,"./Vec2":23}],17:[function(t,i,e){function o(t,i,e){"object"==typeof t&&null!==t?(this.ex=m.clone(t),this.ey=m.clone(i),this.ez=m.clone(e)):(this.ex=m(),this.ey=m(),this.ez=m())}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=(t("./Math"),t("./Vec2")),m=t("./Vec3");o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&m.isValid(t.ex)&&m.isValid(t.ey)&&m.isValid(t.ez)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Mat33!")},o.prototype.setZero=function(){return this.ex.setZero(),this.ey.setZero(),this.ez.setZero(),this},o.prototype.solve33=function(t){var i=m.dot(this.ex,m.cross(this.ey,this.ez));0!=i&&(i=1/i);var e=new m;return e.x=i*m.dot(t,m.cross(this.ey,this.ez)),e.y=i*m.dot(this.ex,m.cross(t,this.ez)),e.z=i*m.dot(this.ex,m.cross(this.ey,t)),e},o.prototype.solve22=function(t){var i=this.ex.x,e=this.ey.x,o=this.ex.y,s=this.ey.y,n=i*s-e*o;0!=n&&(n=1/n);var r=a.zero();return r.x=n*(s*t.x-e*t.y),r.y=n*(i*t.y-o*t.x),r},o.prototype.getInverse22=function(t){var i=this.ex.x,e=this.ey.x,o=this.ex.y,s=this.ey.y,n=i*s-e*o;0!=n&&(n=1/n),t.ex.x=n*s,t.ey.x=-n*e,t.ex.z=0,t.ex.y=-n*o,t.ey.y=n*i,t.ey.z=0,t.ez.x=0,t.ez.y=0,t.ez.z=0},o.prototype.getSymInverse33=function(t){var i=m.dot(this.ex,m.cross(this.ey,this.ez));0!=i&&(i=1/i);var e=this.ex.x,o=this.ey.x,s=this.ez.x,n=this.ey.y,r=this.ez.y,a=this.ez.z;t.ex.x=i*(n*a-r*r),t.ex.y=i*(s*r-o*a),t.ex.z=i*(o*r-s*n),t.ey.x=t.ex.y,t.ey.y=i*(e*a-s*s),t.ey.z=i*(s*o-e*r),t.ez.x=t.ex.z,t.ez.y=t.ey.z,t.ez.z=i*(e*n-o*o)},o.mul=function(t,i){if(n&&o.assert(t),i&&"z"in i&&"y"in i&&"x"in i){n&&m.assert(i);var e=t.ex.x*i.x+t.ey.x*i.y+t.ez.x*i.z,s=t.ex.y*i.x+t.ey.y*i.y+t.ez.y*i.z,h=t.ex.z*i.x+t.ey.z*i.y+t.ez.z*i.z;return new m(e,s,h)}if(i&&"y"in i&&"x"in i){n&&a.assert(i);e=t.ex.x*i.x+t.ey.x*i.y,s=t.ex.y*i.x+t.ey.y*i.y;return a.neo(e,s)}n&&r.assert(!1)},o.add=function(t,i){return n&&o.assert(t),n&&o.assert(i),new m(t.x+i.x,t.y+i.y,t.z+i.z)}},{"../util/common":51,"./Math":18,"./Vec2":23,"./Vec3":24}],18:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;var n=t("../util/common"),r=t("../util/create"),a=Math,m=i.exports=r(a);m.EPSILON=1e-9,m.isFinite=function(t){return"number"==typeof t&&isFinite(t)&&!isNaN(t)},m.assert=function(t){if(s&&!m.isFinite(t))throw o&&n.debug(t),new Error("Invalid Number!")},m.invSqrt=function(t){return 1/a.sqrt(t)},m.nextPowerOfTwo=function(t){return t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,(t|=t>>16)+1},m.isPowerOfTwo=function(t){return t>0&&0==(t&t-1)},m.mod=function(t,i,e){return void 0===i?(e=1,i=0):void 0===e&&(e=i,i=0),e>i?(t=(t-i)%(e-i))+(t<0?e:i):(t=(t-e)%(i-e))+(t<=0?i:e)},m.clamp=function(t,i,e){return t<i?i:t>e?e:t},m.random=function(t,i){return void 0===t?(i=1,t=0):void 0===i&&(i=t,t=0),t==i?t:a.random()*(i-t)+t}},{"../util/common":51,"../util/create":52}],19:[function(t,i,e){function o(){this.c=r.zero(),this.a=0}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("./Vec2"),a=t("./Rot");o.prototype.getTransform=function(t,i){return t.q.set(this.a),t.p.set(r.sub(this.c,a.mul(t.q,i))),t}},{"./Rot":20,"./Vec2":23}],20:[function(t,i,e){function o(t){if(!(this instanceof o))return new o(t);"number"==typeof t?this.setAngle(t):"object"==typeof t?this.set(t):this.setIdentity()}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("./Vec2"),m=t("./Math");o.neo=function(t){var i=Object.create(o.prototype);return i.setAngle(t),i},o.clone=function(t){n&&o.assert(t);var i=Object.create(o.prototype);return i.s=t.s,i.c=t.c,i},o.identity=function(t){n&&o.assert(t);var i=Object.create(o.prototype);return i.s=0,i.c=1,i},o.isValid=function(t){return t&&m.isFinite(t.s)&&m.isFinite(t.c)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Rot!")},o.prototype.setIdentity=function(){this.s=0,this.c=1},o.prototype.set=function(t){"object"==typeof t?(n&&o.assert(t),this.s=t.s,this.c=t.c):(n&&m.assert(t),this.s=m.sin(t),this.c=m.cos(t))},o.prototype.setAngle=function(t){n&&m.assert(t),this.s=m.sin(t),this.c=m.cos(t)},o.prototype.getAngle=function(){return m.atan2(this.s,this.c)},o.prototype.getXAxis=function(){return a.neo(this.c,this.s)},o.prototype.getYAxis=function(){return a.neo(-this.s,this.c)},o.mul=function(t,i){if(n&&o.assert(t),"c"in i&&"s"in i){n&&o.assert(i);var e=o.identity();return e.s=t.s*i.c+t.c*i.s,e.c=t.c*i.c-t.s*i.s,e}if("x"in i&&"y"in i)return n&&a.assert(i),a.neo(t.c*i.x-t.s*i.y,t.s*i.x+t.c*i.y)},o.mulSub=function(t,i,e){var o=t.c*(i.x-e.x)-t.s*(i.y-e.y),s=t.s*(i.x-e.y)+t.c*(i.y-e.y);return a.neo(o,s)},o.mulT=function(t,i){if("c"in i&&"s"in i){n&&o.assert(i);var e=o.identity();return e.s=t.c*i.s-t.s*i.c,e.c=t.c*i.c+t.s*i.s,e}if("x"in i&&"y"in i)return n&&a.assert(i),a.neo(t.c*i.x+t.s*i.y,-t.s*i.x+t.c*i.y)}},{"../util/common":51,"./Math":18,"./Vec2":23}],21:[function(t,i,e){function o(t,i){n&&r.assert(void 0===t),n&&r.assert(void 0===i),this.localCenter=m.zero(),this.c=m.zero(),this.a=0,this.alpha0=0,this.c0=m.zero(),this.a0=0}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("./Math"),m=t("./Vec2"),h=t("./Rot"),c=t("./Transform");o.prototype.setTransform=function(t){var i=c.mul(t,this.localCenter);this.c.set(i),this.c0.set(i),this.a=t.q.getAngle(),this.a0=t.q.getAngle()},o.prototype.setLocalCenter=function(t,i){this.localCenter.set(t);var e=c.mul(i,this.localCenter);this.c.set(e),this.c0.set(e)},o.prototype.getTransform=function(t,i){i=void 0===i?0:i,t.q.setAngle((1-i)*this.a0+i*this.a),t.p.wSet(1-i,this.c0,i,this.c),t.p.sub(h.mul(t.q,this.localCenter))},o.prototype.advance=function(t){n&&r.assert(this.alpha0<1);var i=(t-this.alpha0)/(1-this.alpha0);this.c0.wSet(i,this.c,1-i,this.c0),this.a0=i*this.a+(1-i)*this.a0,this.alpha0=t},o.prototype.forward=function(){this.a0=this.a,this.c0.set(this.c)},o.prototype.normalize=function(){var t=a.mod(this.a0,-a.PI,+a.PI);this.a-=this.a0-t,this.a0=t},o.prototype.clone=function(){var t=new o;return t.localCenter.set(this.localCenter),t.alpha0=this.alpha0,t.a0=this.a0,t.a=this.a,t.c0.set(this.c0),t.c.set(this.c),t},o.prototype.set=function(t){this.localCenter.set(t.localCenter),this.alpha0=t.alpha0,this.a0=t.a0,this.a=t.a,this.c0.set(t.c0),this.c.set(t.c)}},{"../util/common":51,"./Math":18,"./Rot":20,"./Transform":22,"./Vec2":23}],22:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);this.p=a.zero(),this.q=m.identity(),void 0!==t&&this.p.set(t),void 0!==i&&this.q.set(i)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("./Vec2"),m=t("./Rot");o.clone=function(t){var i=Object.create(o.prototype);return i.p=a.clone(t.p),i.q=m.clone(t.q),i},o.neo=function(t,i){var e=Object.create(o.prototype);return e.p=a.clone(t),e.q=m.clone(i),e},o.identity=function(){var t=Object.create(o.prototype);return t.p=a.zero(),t.q=m.identity(),t},o.prototype.setIdentity=function(){this.p.setZero(),this.q.setIdentity()},o.prototype.set=function(t,i){o.isValid(t)?(this.p.set(t.p),this.q.set(t.q)):(this.p.set(t),this.q.set(i))},o.isValid=function(t){return t&&a.isValid(t.p)&&m.isValid(t.q)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Transform!")},o.mul=function(t,i){if(n&&o.assert(t),Array.isArray(i)){for(var e=[],s=0;s<i.length;s++)e[s]=o.mul(t,i[s]);return e}if("x"in i&&"y"in i){n&&a.assert(i);var r=t.q.c*i.x-t.q.s*i.y+t.p.x,h=t.q.s*i.x+t.q.c*i.y+t.p.y;return a.neo(r,h)}if("p"in i&&"q"in i){n&&o.assert(i);var c=o.identity();return c.q=m.mul(t.q,i.q),c.p=a.add(m.mul(t.q,i.p),t.p),c}},o.mulT=function(t,i){if(n&&o.assert(t),"x"in i&&"y"in i){n&&a.assert(i);var e=i.x-t.p.x,s=i.y-t.p.y,r=t.q.c*e+t.q.s*s,h=-t.q.s*e+t.q.c*s;return a.neo(r,h)}if("p"in i&&"q"in i){n&&o.assert(i);var c=o.identity();return c.q.set(m.mulT(t.q,i.q)),c.p.set(m.mulT(t.q,a.sub(i.p,t.p))),c}}},{"../util/common":51,"./Rot":20,"./Vec2":23}],23:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);void 0===t?(this.x=0,this.y=0):"object"==typeof t?(this.x=t.x,this.y=t.y):(this.x=t,this.y=i),n&&o.assert(this)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("./Math");o.zero=function(){var t=Object.create(o.prototype);return t.x=0,t.y=0,t},o.neo=function(t,i){var e=Object.create(o.prototype);return e.x=t,e.y=i,e},o.clone=function(t,i){return n&&o.assert(t),n&&r.assert(!i),o.neo(t.x,t.y)},o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&a.isFinite(t.x)&&a.isFinite(t.y)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Vec2!")},o.prototype.clone=function(t){return o.clone(this,t)},o.prototype.setZero=function(){return this.x=0,this.y=0,this},o.prototype.set=function(t,i){return"object"==typeof t?(n&&o.assert(t),this.x=t.x,this.y=t.y):(n&&a.assert(t),n&&a.assert(i),this.x=t,this.y=i),this},o.prototype.wSet=function(t,i,e,s){n&&a.assert(t),n&&o.assert(i);var r=t*i.x,m=t*i.y;return void 0===e&&void 0===s||(n&&a.assert(e),n&&o.assert(s),r+=e*s.x,m+=e*s.y),this.x=r,this.y=m,this},o.prototype.add=function(t){return n&&o.assert(t),this.x+=t.x,this.y+=t.y,this},o.prototype.wAdd=function(t,i,e,s){n&&a.assert(t),n&&o.assert(i);var r=t*i.x,m=t*i.y;return void 0===e&&void 0===s||(n&&a.assert(e),n&&o.assert(s),r+=e*s.x,m+=e*s.y),this.x+=r,this.y+=m,this},o.prototype.wSub=function(t,i,e,s){n&&a.assert(t),n&&o.assert(i);var r=t*i.x,m=t*i.y;return void 0===e&&void 0===s||(n&&a.assert(e),n&&o.assert(s),r+=e*s.x,m+=e*s.y),this.x-=r,this.y-=m,this},o.prototype.sub=function(t){return n&&o.assert(t),this.x-=t.x,this.y-=t.y,this},o.prototype.mul=function(t){return n&&a.assert(t),this.x*=t,this.y*=t,this},o.prototype.length=function(){return o.lengthOf(this)},o.prototype.lengthSquared=function(){return o.lengthSquared(this)},o.prototype.normalize=function(){var t=this.length();if(t<a.EPSILON)return 0;var i=1/t;return this.x*=i,this.y*=i,t},o.lengthOf=function(t){return n&&o.assert(t),a.sqrt(t.x*t.x+t.y*t.y)},o.lengthSquared=function(t){return n&&o.assert(t),t.x*t.x+t.y*t.y},o.distance=function(t,i){n&&o.assert(t),n&&o.assert(i);var e=t.x-i.x,s=t.y-i.y;return a.sqrt(e*e+s*s)},o.distanceSquared=function(t,i){n&&o.assert(t),n&&o.assert(i);var e=t.x-i.x,s=t.y-i.y;return e*e+s*s},o.areEqual=function(t,i){return n&&o.assert(t),n&&o.assert(i),t==i||"object"==typeof i&&null!==i&&t.x==i.x&&t.y==i.y},o.skew=function(t){return n&&o.assert(t),o.neo(-t.y,t.x)},o.dot=function(t,i){return n&&o.assert(t),n&&o.assert(i),t.x*i.x+t.y*i.y},o.cross=function(t,i){return"number"==typeof i?(n&&o.assert(t),n&&a.assert(i),o.neo(i*t.y,-i*t.x)):"number"==typeof t?(n&&a.assert(t),n&&o.assert(i),o.neo(-t*i.y,t*i.x)):(n&&o.assert(t),n&&o.assert(i),t.x*i.y-t.y*i.x)},o.addCross=function(t,i,e){return"number"==typeof e?(n&&o.assert(i),n&&a.assert(e),o.neo(e*i.y+t.x,-e*i.x+t.y)):"number"==typeof i?(n&&a.assert(i),n&&o.assert(e),o.neo(-i*e.y+t.x,i*e.x+t.y)):void(n&&r.assert(!1))},o.add=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(t.x+i.x,t.y+i.y)},o.wAdd=function(t,i,e,s){var n=o.zero();return n.wAdd(t,i,e,s),n},o.sub=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(t.x-i.x,t.y-i.y)},o.mul=function(t,i){return"object"==typeof t?(n&&o.assert(t),n&&a.assert(i),o.neo(t.x*i,t.y*i)):"object"==typeof i?(n&&a.assert(t),n&&o.assert(i),o.neo(t*i.x,t*i.y)):void 0},o.prototype.neg=function(){return this.x=-this.x,this.y=-this.y,this},o.neg=function(t){return n&&o.assert(t),o.neo(-t.x,-t.y)},o.abs=function(t){return n&&o.assert(t),o.neo(a.abs(t.x),a.abs(t.y))},o.mid=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(.5*(t.x+i.x),.5*(t.y+i.y))},o.upper=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(a.max(t.x,i.x),a.max(t.y,i.y))},o.lower=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(a.min(t.x,i.x),a.min(t.y,i.y))},o.prototype.clamp=function(t){var i=this.x*this.x+this.y*this.y;if(i>t*t){var e=a.invSqrt(i);this.x*=e*t,this.y*=e*t}return this},o.clamp=function(t,i){return(t=o.neo(t.x,t.y)).clamp(i),t}},{"../util/common":51,"./Math":18}],24:[function(t,i,e){function o(t,i,e){if(!(this instanceof o))return new o(t,i,e);void 0===t?(this.x=0,this.y=0,this.z=0):"object"==typeof t?(this.x=t.x,this.y=t.y,this.z=t.z):(this.x=t,this.y=i,this.z=e),n&&o.assert(this)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("./Math");o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&a.isFinite(t.x)&&a.isFinite(t.y)&&a.isFinite(t.z)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Vec3!")},o.prototype.setZero=function(){return this.x=0,this.y=0,this.z=0,this},o.prototype.set=function(t,i,e){return this.x=t,this.y=i,this.z=e,this},o.prototype.add=function(t){return this.x+=t.x,this.y+=t.y,this.z+=t.z,this},o.prototype.sub=function(t){return this.x-=t.x,this.y-=t.y,this.z-=t.z,this},o.prototype.mul=function(t){return this.x*=t,this.y*=t,this.z*=t,this},o.areEqual=function(t,i){return t==i||"object"==typeof i&&null!==i&&t.x==i.x&&t.y==i.y&&t.z==i.z},o.dot=function(t,i){return t.x*i.x+t.y*i.y+t.z*i.z},o.cross=function(t,i){return new o(t.y*i.z-t.z*i.y,t.z*i.x-t.x*i.z,t.x*i.y-t.y*i.x)},o.add=function(t,i){return new o(t.x+i.x,t.y+i.y,t.z+i.z)},o.sub=function(t,i){return new o(t.x-i.x,t.y-i.y,t.z-i.z)},o.mul=function(t,i){return new o(i*t.x,i*t.y,i*t.z)},o.prototype.neg=function(t){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this},o.neg=function(t){return new o(-t.x,-t.y,-t.z)}},{"../util/common":51,"./Math":18}],25:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;i.exports=function(){this.v=n.zero(),this.w=0};var n=t("./Vec2")},{"./Vec2":23}],26:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;e.toString=function(t){t="string"==typeof t?t:"\n";var i="";for(var e in this)"function"!=typeof this[e]&&"object"!=typeof this[e]&&(i+=e+": "+this[e]+t);return i}},{}],27:[function(t,i,e){e.internal={},e.Math=t("./common/Math"),e.Vec2=t("./common/Vec2"),e.Transform=t("./common/Transform"),e.Rot=t("./common/Rot"),e.AABB=t("./collision/AABB"),e.Shape=t("./Shape"),e.Fixture=t("./Fixture"),e.Body=t("./Body"),e.Contact=t("./Contact"),e.Joint=t("./Joint"),e.World=t("./World"),e.Circle=t("./shape/CircleShape"),e.Edge=t("./shape/EdgeShape"),e.Polygon=t("./shape/PolygonShape"),e.Chain=t("./shape/ChainShape"),e.Box=t("./shape/BoxShape"),t("./shape/CollideCircle"),t("./shape/CollideEdgeCircle"),e.internal.CollidePolygons=t("./shape/CollidePolygon"),t("./shape/CollideCirclePolygone"),t("./shape/CollideEdgePolygon"),e.DistanceJoint=t("./joint/DistanceJoint"),e.FrictionJoint=t("./joint/FrictionJoint"),e.GearJoint=t("./joint/GearJoint"),e.MotorJoint=t("./joint/MotorJoint"),e.MouseJoint=t("./joint/MouseJoint"),e.PrismaticJoint=t("./joint/PrismaticJoint"),e.PulleyJoint=t("./joint/PulleyJoint"),e.RevoluteJoint=t("./joint/RevoluteJoint"),e.RopeJoint=t("./joint/RopeJoint"),e.WeldJoint=t("./joint/WeldJoint"),e.WheelJoint=t("./joint/WheelJoint"),e.internal.Sweep=t("./common/Sweep"),e.internal.stats=t("./common/stats"),e.internal.Manifold=t("./Manifold"),e.internal.Distance=t("./collision/Distance"),e.internal.TimeOfImpact=t("./collision/TimeOfImpact"),e.internal.DynamicTree=t("./collision/DynamicTree"),e.internal.Settings=t("./Settings")},{"./Body":2,"./Contact":3,"./Fixture":4,"./Joint":5,"./Manifold":6,"./Settings":7,"./Shape":8,"./World":10,"./collision/AABB":11,"./collision/Distance":13,"./collision/DynamicTree":14,"./collision/TimeOfImpact":15,"./common/Math":18,"./common/Rot":20,"./common/Sweep":21,"./common/Transform":22,"./common/Vec2":23,"./common/stats":26,"./joint/DistanceJoint":28,"./joint/FrictionJoint":29,"./joint/GearJoint":30,"./joint/MotorJoint":31,"./joint/MouseJoint":32,"./joint/PrismaticJoint":33,"./joint/PulleyJoint":34,"./joint/RevoluteJoint":35,"./joint/RopeJoint":36,"./joint/WeldJoint":37,"./joint/WheelJoint":38,"./shape/BoxShape":39,"./shape/ChainShape":40,"./shape/CircleShape":41,"./shape/CollideCircle":42,"./shape/CollideCirclePolygone":43,"./shape/CollideEdgeCircle":44,"./shape/CollideEdgePolygon":45,"./shape/CollidePolygon":46,"./shape/EdgeShape":47,"./shape/PolygonShape":48}],28:[function(t,i,e){function o(t,i,e,s,n){if(!(this instanceof o))return new o(t,i,e,s,n);t=r(t,u),l.call(this,t,i,s),this.m_type=o.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(e),this.m_localAnchorB=t.localAnchorB||s.getLocalPoint(n),this.m_length=c.distance(n,e),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=0,this.m_gamma=0,this.m_bias=0,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/options"),a=t("../util/create"),m=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="distance-joint";var u={frequencyHz:0,dampingRatio:0};(o.prototype=a((o._super=l).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.setLength=function(t){this.m_length=t},o.prototype.getLength=function(){return this.m_length},o.prototype.setFrequency=function(t){this.m_frequencyHz=t},o.prototype.getFrequency=function(){return this.m_frequencyHz},o.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return c.mul(t*this.m_impulse,this.m_u)},o.prototype.getReactionTorque=function(t){return 0},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,l=this.m_bodyB.c_velocity.w,u=_.neo(e),p=_.neo(r);this.m_rA=_.mul(u,c.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=_.mul(p,c.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_u=c.sub(c.add(n,this.m_rB),c.add(i,this.m_rA));var d=this.m_u.length();d>m.linearSlop?this.m_u.mul(1/d):this.m_u.set(0,0);var f=c.cross(this.m_rA,this.m_u),y=c.cross(this.m_rB,this.m_u),v=this.m_invMassA+this.m_invIA*f*f+this.m_invMassB+this.m_invIB*y*y;if(this.m_mass=0!=v?1/v:0,this.m_frequencyHz>0){var g=d-this.m_length,x=2*h.PI*this.m_frequencyHz,b=2*this.m_mass*this.m_dampingRatio*x,A=this.m_mass*x*x,w=t.dt;this.m_gamma=w*(b+w*A),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=g*w*A*this.m_gamma,v+=this.m_gamma,this.m_mass=0!=v?1/v:0}else this.m_gamma=0,this.m_bias=0;if(t.warmStarting){this.m_impulse*=t.dtRatio;var B=c.mul(this.m_impulse,this.m_u);o.wSub(this.m_invMassA,B),s-=this.m_invIA*c.cross(this.m_rA,B),a.wAdd(this.m_invMassB,B),l+=this.m_invIB*c.cross(this.m_rB,B)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(a),this.m_bodyB.c_velocity.w=l},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=c.add(i,c.cross(e,this.m_rA)),r=c.add(o,c.cross(s,this.m_rB)),a=c.dot(this.m_u,r)-c.dot(this.m_u,n),m=-this.m_mass*(a+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=m;var h=c.mul(m,this.m_u);i.wSub(this.m_invMassA,h),e-=this.m_invIA*c.cross(this.m_rA,h),o.wAdd(this.m_invMassB,h),s+=this.m_invIB*c.cross(this.m_rB,h),this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v.set(o),this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){if(this.m_frequencyHz>0)return!0;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=_.neo(e),r=_.neo(s),a=_.mulSub(n,this.m_localAnchorA,this.m_localCenterA),l=_.mulSub(r,this.m_localAnchorB,this.m_localCenterB),u=c.sub(c.add(o,l),c.add(i,a)),p=u.normalize()-this.m_length;p=h.clamp(p,-m.maxLinearCorrection,m.maxLinearCorrection);var d=-this.m_mass*p,f=c.mul(d,u);return i.wSub(this.m_invMassA,f),e-=this.m_invIA*c.cross(a,f),o.wAdd(this.m_invMassB,f),s+=this.m_invIB*c.cross(l,f),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,h.abs(p)<m.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":52,"../util/options":53}],29:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=a(t,p),u.call(this,t,i,e),this.m_type=o.TYPE,s?(this.m_localAnchorA=i.getLocalPoint(s),this.m_localAnchorB=e.getLocalPoint(s)):(this.m_localAnchorA=c.zero(),this.m_localAnchorB=c.zero()),this.m_linearImpulse=c.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/options"),m=t("../util/create"),h=(t("../Settings"),t("../common/Math")),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22")),l=(t("../common/Mat33"),t("../common/Rot")),u=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="friction-joint";var p={maxForce:0,maxTorque:0};(o.prototype=m((o._super=u).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.setMaxForce=function(t){n&&r.assert(IsValid(t)&&t>=0),this.m_maxForce=t},o.prototype.getMaxForce=function(){return this.m_maxForce},o.prototype.setMaxTorque=function(t){n&&r.assert(IsValid(t)&&t>=0),this.m_maxTorque=t},o.prototype.getMaxTorque=function(){return this.m_maxTorque},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*this.m_linearImpulse},o.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,a=l.neo(i),m=l.neo(s);this.m_rA=l.mul(a,c.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=l.mul(m,c.sub(this.m_localAnchorB,this.m_localCenterB));var h=this.m_invMassA,u=this.m_invMassB,p=this.m_invIA,d=this.m_invIB,f=new _;if(f.ex.x=h+u+p*this.m_rA.y*this.m_rA.y+d*this.m_rB.y*this.m_rB.y,f.ex.y=-p*this.m_rA.x*this.m_rA.y-d*this.m_rB.x*this.m_rB.y,f.ey.x=f.ex.y,f.ey.y=h+u+p*this.m_rA.x*this.m_rA.x+d*this.m_rB.x*this.m_rB.x,this.m_linearMass=f.getInverse(),this.m_angularMass=p+d,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var y=c.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);e.wSub(h,y),o-=p*(c.cross(this.m_rA,y)+this.m_angularImpulse),n.wAdd(u,y),r+=d*(c.cross(this.m_rB,y)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,a=this.m_invIA,m=this.m_invIB,l=t.dt,u=s-e,p=-this.m_angularMass*u,d=this.m_angularImpulse,f=l*this.m_maxTorque;this.m_angularImpulse=h.clamp(this.m_angularImpulse+p,-f,f),e-=a*(p=this.m_angularImpulse-d),s+=m*p;u=c.sub(c.add(o,c.cross(s,this.m_rB)),c.add(i,c.cross(e,this.m_rA))),p=c.neg(_.mul(this.m_linearMass,u)),d=this.m_linearImpulse;this.m_linearImpulse.add(p);f=l*this.m_maxForce;this.m_linearImpulse.lengthSquared()>f*f&&(this.m_linearImpulse.normalize(),this.m_linearImpulse.mul(f)),p=c.sub(this.m_linearImpulse,d),i.wSub(n,p),e-=a*c.cross(this.m_rA,p),o.wAdd(r,p),s+=m*c.cross(this.m_rB,p),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],30:[function(t,i,e){function o(t,i,e,s,m,h){if(!(this instanceof o))return new o(t,i,e,s,m,h);t=a(t,d),l.call(this,t,i,e),this.m_type=o.TYPE,n&&r.assert(s.m_type==u.TYPE||s.m_type==p.TYPE),n&&r.assert(m.m_type==u.TYPE||m.m_type==p.TYPE),this.m_joint1=s,this.m_joint2=m,this.m_type1=this.m_joint1.getType(),this.m_type2=this.m_joint2.getType();var f,y;this.m_bodyC=this.m_joint1.getBodyA(),this.m_bodyA=this.m_joint1.getBodyB();var v=this.m_bodyA.m_xf,g=this.m_bodyA.m_sweep.a,x=this.m_bodyC.m_xf,b=this.m_bodyC.m_sweep.a;if(this.m_type1==u.TYPE){var A=s;this.m_localAnchorC=A.m_localAnchorA,this.m_localAnchorA=A.m_localAnchorB,this.m_referenceAngleA=A.m_referenceAngle,this.m_localAxisC=c.zero(),f=g-b-this.m_referenceAngleA}else{var w=s;this.m_localAnchorC=w.m_localAnchorA,this.m_localAnchorA=w.m_localAnchorB,this.m_referenceAngleA=w.m_referenceAngle,this.m_localAxisC=w.m_localXAxisA;var B=this.m_localAnchorC,S=_.mulT(x.q,c.add(_.mul(v.q,this.m_localAnchorA),c.sub(v.p,x.p)));f=c.dot(S,this.m_localAxisC)-c.dot(B,this.m_localAxisC)}this.m_bodyD=this.m_joint2.getBodyA(),this.m_bodyB=this.m_joint2.getBodyB();var M=this.m_bodyB.m_xf,C=this.m_bodyB.m_sweep.a,I=this.m_bodyD.m_xf,P=this.m_bodyD.m_sweep.a;if(this.m_type2==u.TYPE){A=m;this.m_localAnchorD=A.m_localAnchorA,this.m_localAnchorB=A.m_localAnchorB,this.m_referenceAngleB=A.m_referenceAngle,this.m_localAxisD=c.zero(),y=C-P-this.m_referenceAngleB}else{w=m;this.m_localAnchorD=w.m_localAnchorA,this.m_localAnchorB=w.m_localAnchorB,this.m_referenceAngleB=w.m_referenceAngle,this.m_localAxisD=w.m_localXAxisA;var T=this.m_localAnchorD,V=_.mulT(I.q,c.add(_.mul(M.q,this.m_localAnchorB),c.sub(M.p,I.p)));y=c.dot(V,this.m_localAxisD)-c.dot(T,this.m_localAxisD)}this.m_ratio=h||t.ratio,this.m_constant=f+this.m_ratio*y,this.m_impulse=0,this.m_lcA,this.m_lcB,this.m_lcC,this.m_lcD,this.m_mA,this.m_mB,this.m_mC,this.m_mD,this.m_iA,this.m_iB,this.m_iC,this.m_iD,this.m_JvAC,this.m_JvBD,this.m_JwA,this.m_JwB,this.m_JwC,this.m_JwD,this.m_mass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/options"),m=t("../util/create"),h=t("../Settings"),c=(t("../common/Math"),t("../common/Vec2")),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),u=t("./RevoluteJoint"),p=t("./PrismaticJoint");o.TYPE="gear-joint";var d={ratio:1};(o.prototype=m((o._super=l).prototype)).getJoint1=function(){return this.m_joint1},o.prototype.getJoint2=function(){return this.m_joint2},o.prototype.setRatio=function(t){n&&r.assert(IsValid(t)),this.m_ratio=t},o.prototype.setRatio=function(){return this.m_ratio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*(this.m_impulse*this.m_JvAC)},o.prototype.getReactionTorque=function(t){return t*(this.m_impulse*this.m_JwA)},o.prototype.initVelocityConstraints=function(t){this.m_lcA=this.m_bodyA.m_sweep.localCenter,this.m_lcB=this.m_bodyB.m_sweep.localCenter,this.m_lcC=this.m_bodyC.m_sweep.localCenter,this.m_lcD=this.m_bodyD.m_sweep.localCenter,this.m_mA=this.m_bodyA.m_invMass,this.m_mB=this.m_bodyB.m_invMass,this.m_mC=this.m_bodyC.m_invMass,this.m_mD=this.m_bodyD.m_invMass,this.m_iA=this.m_bodyA.m_invI,this.m_iB=this.m_bodyB.m_invI,this.m_iC=this.m_bodyC.m_invI,this.m_iD=this.m_bodyD.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,a=this.m_bodyC.c_position.a,m=this.m_bodyC.c_velocity.v,h=this.m_bodyC.c_velocity.w,l=this.m_bodyD.c_position.a,p=this.m_bodyD.c_velocity.v,d=this.m_bodyD.c_velocity.w,f=_.neo(i),y=_.neo(s),v=_.neo(a),g=_.neo(l);if(this.m_mass=0,this.m_type1==u.TYPE)this.m_JvAC=c.zero(),this.m_JwA=1,this.m_JwC=1,this.m_mass+=this.m_iA+this.m_iC;else{var x=_.mul(v,this.m_localAxisC),b=_.mulSub(v,this.m_localAnchorC,this.m_lcC),A=_.mulSub(f,this.m_localAnchorA,this.m_lcA);this.m_JvAC=x,this.m_JwC=c.cross(b,x),this.m_JwA=c.cross(A,x),this.m_mass+=this.m_mC+this.m_mA+this.m_iC*this.m_JwC*this.m_JwC+this.m_iA*this.m_JwA*this.m_JwA}if(this.m_type2==u.TYPE)this.m_JvBD=c.zero(),this.m_JwB=this.m_ratio,this.m_JwD=this.m_ratio,this.m_mass+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD);else{x=_.mul(g,this.m_localAxisD);var w=_.mulSub(g,this.m_localAnchorD,this.m_lcD),B=_.mulSub(y,this.m_localAnchorB,this.m_lcB);this.m_JvBD=c.mul(this.m_ratio,x),this.m_JwD=this.m_ratio*c.cross(w,x),this.m_JwB=this.m_ratio*c.cross(B,x),this.m_mass+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*this.m_JwD*this.m_JwD+this.m_iB*this.m_JwB*this.m_JwB}this.m_mass=this.m_mass>0?1/this.m_mass:0,t.warmStarting?(e.wAdd(this.m_mA*this.m_impulse,this.m_JvAC),o+=this.m_iA*this.m_impulse*this.m_JwA,n.wAdd(this.m_mB*this.m_impulse,this.m_JvBD),r+=this.m_iB*this.m_impulse*this.m_JwB,m.wSub(this.m_mC*this.m_impulse,this.m_JvAC),h-=this.m_iC*this.m_impulse*this.m_JwC,p.wSub(this.m_mD*this.m_impulse,this.m_JvBD),d-=this.m_iD*this.m_impulse*this.m_JwD):this.m_impulse=0,this.m_bodyA.c_velocity.v.set(e),this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v.set(n),this.m_bodyB.c_velocity.w=r,this.m_bodyC.c_velocity.v.set(m),this.m_bodyC.c_velocity.w=h,this.m_bodyD.c_velocity.v.set(p),this.m_bodyD.c_velocity.w=d},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_bodyC.c_velocity.v,r=this.m_bodyC.c_velocity.w,a=this.m_bodyD.c_velocity.v,m=this.m_bodyD.c_velocity.w,h=c.dot(this.m_JvAC,i)-c.dot(this.m_JvAC,n)+c.dot(this.m_JvBD,o)-c.dot(this.m_JvBD,a);h+=this.m_JwA*e-this.m_JwC*r+(this.m_JwB*s-this.m_JwD*m);var _=-this.m_mass*h;this.m_impulse+=_,i.wAdd(this.m_mA*_,this.m_JvAC),e+=this.m_iA*_*this.m_JwA,o.wAdd(this.m_mB*_,this.m_JvBD),s+=this.m_iB*_*this.m_JwB,n.wSub(this.m_mC*_,this.m_JvAC),r-=this.m_iC*_*this.m_JwC,a.wSub(this.m_mD*_,this.m_JvBD),m-=this.m_iD*_*this.m_JwD,this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v.set(o),this.m_bodyB.c_velocity.w=s,this.m_bodyC.c_velocity.v.set(n),this.m_bodyC.c_velocity.w=r,this.m_bodyD.c_velocity.v.set(a),this.m_bodyD.c_velocity.w=m},o.prototype.solvePositionConstraints=function(t){var i,e,o,s,n,r,a,m,l=this.m_bodyA.c_position.c,p=this.m_bodyA.c_position.a,d=this.m_bodyB.c_position.c,f=this.m_bodyB.c_position.a,y=this.m_bodyC.c_position.c,v=this.m_bodyC.c_position.a,g=this.m_bodyD.c_position.c,x=this.m_bodyD.c_position.a,b=_.neo(p),A=_.neo(f),w=_.neo(v),B=_.neo(x),S=0;if(this.m_type1==u.TYPE)o=c.zero(),n=1,a=1,S+=this.m_iA+this.m_iC,i=p-v-this.m_referenceAngleA;else{var M=_.mul(w,this.m_localAxisC),C=_.mulSub(w,this.m_localAnchorC,this.m_lcC),I=_.mulSub(b,this.m_localAnchorA,this.m_lcA);o=M,a=c.cross(C,M),n=c.cross(I,M),S+=this.m_mC+this.m_mA+this.m_iC*a*a+this.m_iA*n*n;var P=this.m_localAnchorC-this.m_lcC,T=_.mulT(w,c.add(I,c.sub(l,y)));i=Dot(T-P,this.m_localAxisC)}if(this.m_type2==u.TYPE)s=c.zero(),r=this.m_ratio,m=this.m_ratio,S+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD),e=f-x-this.m_referenceAngleB;else{M=_.mul(B,this.m_localAxisD);var V=_.mulSub(B,this.m_localAnchorD,this.m_lcD),z=_.mulSub(A,this.m_localAnchorB,this.m_lcB);s=c.mul(this.m_ratio,M),m=this.m_ratio*c.cross(V,M),r=this.m_ratio*c.cross(z,M),S+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*m*m+this.m_iB*r*r;var k=c.sub(this.m_localAnchorD,this.m_lcD),L=_.mulT(B,c.add(z,c.sub(d,g)));e=c.dot(L,this.m_localAxisD)-c.dot(k,this.m_localAxisD)}var q=i+this.m_ratio*e-this.m_constant,F=0;return S>0&&(F=-q/S),l.wAdd(this.m_mA*F,o),p+=this.m_iA*F*n,d.wAdd(this.m_mB*F,s),f+=this.m_iB*F*r,y.wAdd(this.m_mC*F,o),v-=this.m_iC*F*a,g.wAdd(this.m_mD*F,s),x-=this.m_iD*F*m,this.m_bodyA.c_position.c.set(l),this.m_bodyA.c_position.a=p,this.m_bodyB.c_position.c.set(d),this.m_bodyB.c_position.a=f,this.m_bodyC.c_position.c.set(y),this.m_bodyC.c_position.a=v,this.m_bodyD.c_position.c.set(g),this.m_bodyD.c_position.a=x,0<h.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53,"./PrismaticJoint":33,"./RevoluteJoint":35}],31:[function(t,i,e){function o(t,i,e){if(!(this instanceof o))return new o(t,i,e);t=a(t,p),u.call(this,t,i,e),this.m_type=o.TYPE;var s=e.getPosition();this.m_linearOffset=i.getLocalPoint(s);var n=i.getAngle(),r=e.getAngle();this.m_angularOffset=r-n,this.m_linearImpulse=c.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_correctionFactor=t.correctionFactor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_linearError,this.m_angularError,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/options"),m=t("../util/create"),h=(t("../Settings"),t("../common/Math")),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22")),l=(t("../common/Mat33"),t("../common/Rot")),u=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="motor-joint";var p={maxForce:1,maxTorque:1,correctionFactor:.3};(o.prototype=m((o._super=u).prototype)).setMaxForce=function(t){n&&r.assert(IsValid(t)&&t>=0),this.m_maxForce=t},o.prototype.getMaxForce=function(){return this.m_maxForce},o.prototype.setMaxTorque=function(t){n&&r.assert(IsValid(t)&&t>=0),this.m_maxTorque=t},o.prototype.getMaxTorque=function(){return this.m_maxTorque},o.prototype.setCorrectionFactor=function(t){n&&r.assert(IsValid(t)&&0<=t&&t<=1),this.m_correctionFactor=t},o.prototype.getCorrectionFactor=function(){return this.m_correctionFactor},o.prototype.setLinearOffset=function(t){t.x==this.m_linearOffset.x&&t.y==this.m_linearOffset.y||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_linearOffset=t)},o.prototype.getLinearOffset=function(){return this.m_linearOffset},o.prototype.setAngularOffset=function(t){t!=this.m_angularOffset&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_angularOffset=t)},o.prototype.getAngularOffset=function(){return this.m_angularOffset},o.prototype.getAnchorA=function(){return this.m_bodyA.getPosition()},o.prototype.getAnchorB=function(){return this.m_bodyB.getPosition()},o.prototype.getReactionForce=function(t){return t*this.m_linearImpulse},o.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,m=this.m_bodyB.c_velocity.w,h=l.neo(e),u=l.neo(r);this.m_rA=l.mul(h,c.neg(this.m_localCenterA)),this.m_rB=l.mul(u,c.neg(this.m_localCenterB));var p=this.m_invMassA,d=this.m_invMassB,f=this.m_invIA,y=this.m_invIB,v=new _;if(v.ex.x=p+d+f*this.m_rA.y*this.m_rA.y+y*this.m_rB.y*this.m_rB.y,v.ex.y=-f*this.m_rA.x*this.m_rA.y-y*this.m_rB.x*this.m_rB.y,v.ey.x=v.ex.y,v.ey.y=p+d+f*this.m_rA.x*this.m_rA.x+y*this.m_rB.x*this.m_rB.x,this.m_linearMass=v.getInverse(),this.m_angularMass=f+y,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),this.m_linearError=c.zero(),this.m_linearError.wAdd(1,n,1,this.m_rB),this.m_linearError.wSub(1,i,1,this.m_rA),this.m_linearError.sub(l.mul(h,this.m_linearOffset)),this.m_angularError=r-e-this.m_angularOffset,t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var g=c.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);o.wSub(p,g),s-=f*(c.cross(this.m_rA,g)+this.m_angularImpulse),a.wAdd(d,g),m+=y*(c.cross(this.m_rB,g)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=a,this.m_bodyB.c_velocity.w=m},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,a=this.m_invIA,m=this.m_invIB,l=t.dt,u=t.inv_dt,p=s-e+u*this.m_correctionFactor*this.m_angularError,d=-this.m_angularMass*p,f=this.m_angularImpulse,y=l*this.m_maxTorque;this.m_angularImpulse=h.clamp(this.m_angularImpulse+d,-y,y),e-=a*(d=this.m_angularImpulse-f),s+=m*d;(p=c.zero()).wAdd(1,o,1,c.cross(s,this.m_rB)),p.wSub(1,i,1,c.cross(e,this.m_rA)),p.wAdd(u*this.m_correctionFactor,this.m_linearError);d=c.neg(_.mul(this.m_linearMass,p)),f=c.clone(this.m_linearImpulse);this.m_linearImpulse.add(d);y=l*this.m_maxForce;this.m_linearImpulse.clamp(y),d=c.sub(this.m_linearImpulse,f),i.wSub(n,d),e-=a*c.cross(this.m_rA,d),o.wAdd(r,d),s+=m*c.cross(this.m_rB,d),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],32:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=a(t,d),p.call(this,t,i,e),this.m_type=o.TYPE,n&&r.assert(h.isFinite(t.maxForce)&&t.maxForce>=0),n&&r.assert(h.isFinite(t.frequencyHz)&&t.frequencyHz>=0),n&&r.assert(h.isFinite(t.dampingRatio)&&t.dampingRatio>=0),this.m_targetA=c.clone(s),this.m_localAnchorB=u.mulT(this.m_bodyB.getTransform(),this.m_targetA),this.m_maxForce=t.maxForce,this.m_impulse=c.zero(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_beta=0,this.m_gamma=0,this.m_rB=c.zero(),this.m_localCenterB=c.zero(),this.m_invMassB=0,this.m_invIB=0,this.mass=new _,this.m_C=c.zero()}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/options"),m=t("../util/create"),h=t("../common/Math"),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22")),l=(t("../common/Mat33"),t("../common/Rot")),u=(t("../common/Sweep"),t("../common/Transform")),p=(t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="mouse-joint";var d={maxForce:0,frequencyHz:5,dampingRatio:.7};(o.prototype=m((o._super=p).prototype)).setTarget=function(t){0==this.m_bodyB.isAwake()&&this.m_bodyB.setAwake(!0),this.m_targetA=c.clone(t)},o.prototype.getTarget=function(){return this.m_targetA},o.prototype.setMaxForce=function(t){this.m_maxForce=t},o.getMaxForce=function(){return this.m_maxForce},o.prototype.setFrequency=function(t){this.m_frequencyHz=t},o.prototype.getFrequency=function(){return this.m_frequencyHz},o.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return c.clone(this.m_targetA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return c.mul(t,this.m_impulse)},o.prototype.getReactionTorque=function(t){return 0*t},o.prototype.shiftOrigin=function(t){this.m_targetA.sub(t)},o.prototype.initVelocityConstraints=function(t){this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyB.c_position,e=this.m_bodyB.c_velocity,o=i.c,s=i.a,a=e.v,m=e.w,u=l.neo(s),p=this.m_bodyB.getMass(),d=2*h.PI*this.m_frequencyHz,f=2*p*this.m_dampingRatio*d,y=p*(d*d),v=t.dt;n&&r.assert(f+v*y>h.EPSILON),this.m_gamma=v*(f+v*y),0!=this.m_gamma&&(this.m_gamma=1/this.m_gamma),this.m_beta=v*y*this.m_gamma,this.m_rB=l.mul(u,c.sub(this.m_localAnchorB,this.m_localCenterB));var g=new _;g.ex.x=this.m_invMassB+this.m_invIB*this.m_rB.y*this.m_rB.y+this.m_gamma,g.ex.y=-this.m_invIB*this.m_rB.x*this.m_rB.y,g.ey.x=g.ex.y,g.ey.y=this.m_invMassB+this.m_invIB*this.m_rB.x*this.m_rB.x+this.m_gamma,this.m_mass=g.getInverse(),this.m_C.set(o),this.m_C.wAdd(1,this.m_rB,-1,this.m_targetA),this.m_C.mul(this.m_beta),m*=.98,t.warmStarting?(this.m_impulse.mul(t.dtRatio),a.wAdd(this.m_invMassB,this.m_impulse),m+=this.m_invIB*c.cross(this.m_rB,this.m_impulse)):this.m_impulse.setZero(),e.v.set(a),e.w=m},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyB.c_velocity,e=c.clone(i.v),o=i.w,s=c.cross(o,this.m_rB);s.add(e),s.wAdd(1,this.m_C,this.m_gamma,this.m_impulse),s.neg();var n=_.mul(this.m_mass,s),r=c.clone(this.m_impulse);this.m_impulse.add(n);var a=t.dt*this.m_maxForce;this.m_impulse.clamp(a),n=c.sub(this.m_impulse,r),e.wAdd(this.m_invMassB,n),o+=this.m_invIB*c.cross(this.m_rB,n),i.v.set(e),i.w=o},o.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],33:[function(t,i,e){function o(t,i,e,s,n){if(!(this instanceof o))return new o(t,i,e,s,n);t=a(t,v),f.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(s),this.m_localAnchorB=t.localAnchorB||e.getLocalPoint(s),this.m_localXAxisA=t.localAxisA||i.getLocalVector(n),this.m_localXAxisA.normalize(),this.m_localYAxisA=_.cross(1,this.m_localXAxisA),this.m_referenceAngle=e.getAngle()-i.getAngle(),this.m_impulse=l(),this.m_motorMass=0,this.m_motorImpulse=0,this.m_lowerTranslation=t.lowerTranslation,this.m_upperTranslation=t.upperTranslation,this.m_maxMotorForce=t.maxMotorForce,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_limitState=y,this.m_axis=_.zero(),this.m_perp=_.zero(),this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_axis,this.m_perp,this.m_s1,this.m_s2,this.m_a1,this.m_a2,this.m_K=new p,this.m_motorMass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/options"),m=t("../util/create"),h=t("../Settings"),c=t("../common/Math"),_=t("../common/Vec2"),l=t("../common/Vec3"),u=t("../common/Mat22"),p=t("../common/Mat33"),d=t("../common/Rot"),f=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),y=0;o.TYPE="prismatic-joint";var v={enableLimit:!1,lowerTranslation:0,upperTranslation:0,enableMotor:!1,maxMotorForce:0,motorSpeed:0};(o.prototype=m((o._super=f).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getLocalAxisA=function(){return this.m_localXAxisA},o.prototype.getReferenceAngle=function(){return this.m_referenceAngle},o.prototype.getJointTranslation=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_bodyB.getWorldPoint(this.m_localAnchorB),e=_.sub(i,t),o=this.m_bodyA.getWorldVector(this.m_localXAxisA);return _.dot(e,o)},o.prototype.getJointSpeed=function(){var t=this.m_bodyA,i=this.m_bodyB,e=Mul(t.m_xf.q,this.m_localAnchorA-t.m_sweep.localCenter),o=Mul(i.m_xf.q,this.m_localAnchorB-i.m_sweep.localCenter),s=t.m_sweep.c+e,n=i.m_sweep.c+o-s,r=Mul(t.m_xf.q,this.m_localXAxisA),a=t.m_linearVelocity,m=i.m_linearVelocity,h=t.m_angularVelocity,c=i.m_angularVelocity;return Dot(n,Cross(h,r))+Dot(r,m+Cross(c,o)-a-Cross(h,e))},o.prototype.isLimitEnabled=function(){return this.m_enableLimit},o.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},o.prototype.getLowerLimit=function(){return this.m_lowerTranslation},o.prototype.getUpperLimit=function(){return this.m_upperTranslation},o.prototype.setLimits=function(t,i){n&&r.assert(t<=i),t==this.m_lowerTranslation&&i==this.m_upperTranslation||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_lowerTranslation=t,this.m_upperTranslation=i,this.m_impulse.z=0)},o.prototype.isMotorEnabled=function(){return this.m_enableMotor},o.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},o.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},o.prototype.setMaxMotorForce=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorForce=t},o.prototype.getMotorSpeed=function(){return this.m_motorSpeed},o.prototype.getMotorForce=function(t){return t*this.m_motorImpulse},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*(this.m_impulse.x*this.m_perp+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis)},o.prototype.getReactionTorque=function(t){return t*this.m_impulse.y},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,m=this.m_bodyB.c_velocity.w,l=d.neo(e),u=d.neo(r),p=d.mul(l,_.sub(this.m_localAnchorA,this.m_localCenterA)),f=d.mul(u,_.sub(this.m_localAnchorB,this.m_localCenterB)),v=_.zero();v.wAdd(1,n,1,f),v.wSub(1,i,1,p);var g=this.m_invMassA,x=this.m_invMassB,b=this.m_invIA,A=this.m_invIB;this.m_axis=d.mul(l,this.m_localXAxisA),this.m_a1=_.cross(_.add(v,p),this.m_axis),this.m_a2=_.cross(f,this.m_axis),this.m_motorMass=g+x+b*this.m_a1*this.m_a1+A*this.m_a2*this.m_a2,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),this.m_perp=d.mul(l,this.m_localYAxisA),this.m_s1=_.cross(_.add(v,p),this.m_perp),this.m_s2=_.cross(f,this.m_perp);_.cross(p,this.m_perp);var w=g+x+b*this.m_s1*this.m_s1+A*this.m_s2*this.m_s2,B=b*this.m_s1+A*this.m_s2,S=b*this.m_s1*this.m_a1+A*this.m_s2*this.m_a2,M=b+A;0==M&&(M=1);var C=b*this.m_a1+A*this.m_a2,I=g+x+b*this.m_a1*this.m_a1+A*this.m_a2*this.m_a2;if(this.m_K.ex.set(w,B,S),this.m_K.ey.set(B,M,C),this.m_K.ez.set(S,C,I),this.m_enableLimit){var P=_.dot(this.m_axis,v);c.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*h.linearSlop?this.m_limitState=3:P<=this.m_lowerTranslation?1!=this.m_limitState&&(this.m_limitState=1,this.m_impulse.z=0):P>=this.m_upperTranslation?2!=this.m_limitState&&(this.m_limitState=2,this.m_impulse.z=0):(this.m_limitState=y,this.m_impulse.z=0)}else this.m_limitState=y,this.m_impulse.z=0;if(0==this.m_enableMotor&&(this.m_motorImpulse=0),t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var T=_.wAdd(this.m_impulse.x,this.m_perp,this.m_motorImpulse+this.m_impulse.z,this.m_axis),V=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,z=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2;o.wSub(g,T),s-=b*V,a.wAdd(x,T),m+=A*z}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(a),this.m_bodyB.c_velocity.w=m},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,a=this.m_invIA,m=this.m_invIB;if(this.m_enableMotor&&3!=this.m_limitState){var h=_.dot(this.m_axis,_.sub(o,i))+this.m_a2*s-this.m_a1*e,u=this.m_motorMass*(this.m_motorSpeed-h),p=this.m_motorImpulse,d=t.dt*this.m_maxMotorForce;this.m_motorImpulse=c.clamp(this.m_motorImpulse+u,-d,d),u=this.m_motorImpulse-p;var f=_.zero().wSet(u,this.m_axis),v=u*this.m_a1,g=u*this.m_a2;i.wSub(n,f),e-=a*v,o.wAdd(r,f),s+=m*g}var x=_.zero();if(x.x+=_.dot(this.m_perp,o)+this.m_s2*s,x.x-=_.dot(this.m_perp,i)+this.m_s1*e,x.y=s-e,this.m_enableLimit&&this.m_limitState!=y){var b=0;b+=_.dot(this.m_axis,o)+this.m_a2*s,b-=_.dot(this.m_axis,i)+this.m_a1*e;h=l(x.x,x.y,b);var A=l(this.m_impulse),w=this.m_K.solve33(l.neg(h));this.m_impulse.add(w),1==this.m_limitState?this.m_impulse.z=c.max(this.m_impulse.z,0):2==this.m_limitState&&(this.m_impulse.z=c.min(this.m_impulse.z,0));var B=_.wAdd(-1,x,-(this.m_impulse.z-A.z),_.neo(this.m_K.ez.x,this.m_K.ez.y)),S=_.add(this.m_K.solve22(B),_.neo(A.x,A.y));this.m_impulse.x=S.x,this.m_impulse.y=S.y,w=l.sub(this.m_impulse,A);f=_.wAdd(w.x,this.m_perp,w.z,this.m_axis),v=w.x*this.m_s1+w.y+w.z*this.m_a1,g=w.x*this.m_s2+w.y+w.z*this.m_a2;i.wSub(n,f),e-=a*v,o.wAdd(r,f),s+=m*g}else{w=this.m_K.solve22(_.neg(x));this.m_impulse.x+=w.x,this.m_impulse.y+=w.y;f=_.zero().wAdd(w.x,this.m_perp),v=w.x*this.m_s1+w.y,g=w.x*this.m_s2+w.y;i.wSub(n,f),e-=a*v,o.wAdd(r,f),s+=m*g}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=d.neo(e),r=d.neo(s),a=this.m_invMassA,m=this.m_invMassB,f=this.m_invIA,y=this.m_invIB,v=d.mul(n,_.sub(this.m_localAnchorA,this.m_localCenterA)),g=d.mul(r,_.sub(this.m_localAnchorB,this.m_localCenterB)),x=_.sub(_.add(o,g),_.add(i,v)),b=d.mul(n,this.m_localXAxisA),A=_.cross(_.add(x,v),b),w=_.cross(g,b),B=d.mul(n,this.m_localYAxisA),S=_.cross(_.add(x,v),B),M=_.cross(g,B),C=l(),I=_.zero();I.x=_.dot(B,x),I.y=s-e-this.m_referenceAngle;var P=c.abs(I.x),T=c.abs(I.y),V=h.linearSlop,z=h.maxLinearCorrection,k=!1,L=0;if(this.m_enableLimit){var q=_.dot(b,x);c.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*V?(L=c.clamp(q,-z,z),P=c.max(P,c.abs(q)),k=!0):q<=this.m_lowerTranslation?(L=c.clamp(q-this.m_lowerTranslation+V,-z,0),P=c.max(P,this.m_lowerTranslation-q),k=!0):q>=this.m_upperTranslation&&(L=c.clamp(q-this.m_upperTranslation-V,0,z),P=c.max(P,q-this.m_upperTranslation),k=!0)}if(k){var F=a+m+f*S*S+y*M*M,R=f*S+y*M,E=f*S*A+y*M*w;0==(J=f+y)&&(J=1);var D=f*A+y*w,j=a+m+f*A*A+y*w*w;(O=new p).ex.set(F,R,E),O.ey.set(R,J,D),O.ez.set(E,D,j);var Y=l();Y.x=I.x,Y.y=I.y,Y.z=L,C=O.solve33(l.neg(Y))}else{var J;F=a+m+f*S*S+y*M*M,R=f*S+y*M;0==(J=f+y)&&(J=1);var O;(O=new u).ex.set(F,R),O.ey.set(R,J);var N=O.solve(_.neg(I));C.x=N.x,C.y=N.y,C.z=0}var W=_.wAdd(C.x,B,C.z,b),X=C.x*S+C.y+C.z*A,H=C.x*M+C.y+C.z*w;return i.wSub(a,W),e-=f*X,o.wAdd(m,W),s+=y*H,this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c=o,this.m_bodyB.c_position.a=s,P<=h.linearSlop&&T<=h.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],34:[function(t,i,e){function o(t,i,e,s,m,h,l,u){if(!(this instanceof o))return new o(t,i,e,s,m,h,l,u);t=a(t,d),p.call(this,t,i,e),this.m_type=o.TYPE,this.m_groundAnchorA=s,this.m_groundAnchorB=m,this.m_localAnchorA=i.getLocalPoint(h),this.m_localAnchorB=e.getLocalPoint(l),this.m_lengthA=_.distance(h,s),this.m_lengthB=_.distance(l,m),this.m_ratio=t.ratio||u,n&&r.assert(u>c.EPSILON),this.m_constant=this.m_lengthA+this.m_ratio*this.m_lengthB,this.m_impulse=0,this.m_uA,this.m_uB,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/options"),m=t("../util/create"),h=t("../Settings"),c=t("../common/Math"),_=t("../common/Vec2"),l=t("../common/Vec3"),u=(t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),p=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="pulley-joint",o.MIN_PULLEY_LENGTH=2;var d={collideConnected:!0};(o.prototype=m((o._super=p).prototype)).getGroundAnchorA=function(){return this.m_groundAnchorA},o.prototype.getGroundAnchorB=function(){return this.m_groundAnchorB},o.prototype.getLengthA=function(){return this.m_lengthA},o.prototype.getLengthB=function(){return this.m_lengthB},o.prototype.setRatio=function(){return this.m_ratio},o.prototype.getCurrentLengthA=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_groundAnchorA;return _.distance(t,i)},o.prototype.getCurrentLengthB=function(){var t=this.m_bodyB.getWorldPoint(this.m_localAnchorB),i=this.m_groundAnchorB;return _.distance(t,i)},o.prototype.shiftOrigin=function(t){this.m_groundAnchorA-=t,this.m_groundAnchorB-=t},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return l.mul(t*this.m_impulse,this.m_uB)},o.prototype.getReactionTorque=function(t){return 0},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,m=this.m_bodyB.c_velocity.w,c=u.neo(e),l=u.neo(r);this.m_rA=u.mul(c,_.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=u.mul(l,_.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_uA=_.sub(_.add(i,this.m_rA),this.m_groundAnchorA),this.m_uB=_.sub(_.add(n,this.m_rB),this.m_groundAnchorB);var p=this.m_uA.length(),d=this.m_uB.length();p>10*h.linearSlop?this.m_uA.mul(1/p):this.m_uA.setZero(),d>10*h.linearSlop?this.m_uB.mul(1/d):this.m_uB.setZero();var f=_.cross(this.m_rA,this.m_uA),y=_.cross(this.m_rB,this.m_uB),v=this.m_invMassA+this.m_invIA*f*f,g=this.m_invMassB+this.m_invIB*y*y;if(this.m_mass=v+this.m_ratio*this.m_ratio*g,this.m_mass>0&&(this.m_mass=1/this.m_mass),t.warmStarting){this.m_impulse*=t.dtRatio;var x=_.mul(-this.m_impulse,this.m_uA),b=_.mul(-this.m_ratio*this.m_impulse,this.m_uB);o.wAdd(this.m_invMassA,x),s+=this.m_invIA*_.cross(this.m_rA,x),a.wAdd(this.m_invMassB,b),m+=this.m_invIB*_.cross(this.m_rB,b)}else this.m_impulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=a,this.m_bodyB.c_velocity.w=m},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=_.add(i,_.cross(e,this.m_rA)),r=_.add(o,_.cross(s,this.m_rB)),a=-_.dot(this.m_uA,n)-this.m_ratio*_.dot(this.m_uB,r),m=-this.m_mass*a;this.m_impulse+=m;var h=_.zero().wSet(-m,this.m_uA),c=_.zero().wSet(-this.m_ratio*m,this.m_uB);i.wAdd(this.m_invMassA,h),e+=this.m_invIA*_.cross(this.m_rA,h),o.wAdd(this.m_invMassB,c),s+=this.m_invIB*_.cross(this.m_rB,c),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=u.neo(e),r=u.neo(s),a=u.mul(n,_.sub(this.m_localAnchorA,this.m_localCenterA)),m=u.mul(r,_.sub(this.m_localAnchorB,this.m_localCenterB)),l=_.sub(_.add(i,this.m_rA),this.m_groundAnchorA),p=_.sub(_.add(o,this.m_rB),this.m_groundAnchorB),d=l.length(),f=p.length();d>10*h.linearSlop?l.mul(1/d):l.setZero(),f>10*h.linearSlop?p.mul(1/f):p.setZero();var y=_.cross(a,l),v=_.cross(m,p),g=this.m_invMassA+this.m_invIA*y*y,x=this.m_invMassB+this.m_invIB*v*v,b=g+this.m_ratio*this.m_ratio*x;b>0&&(b=1/b);var A=this.m_constant-d-this.m_ratio*f,w=c.abs(A),B=-b*A,S=_.zero().wSet(-B,l),M=_.zero().wSet(-this.m_ratio*B,p);return i.wAdd(this.m_invMassA,S),e+=this.m_invIA*_.cross(a,S),o.wAdd(this.m_invMassB,M),s+=this.m_invIB*_.cross(m,M),this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c=o,this.m_bodyB.c_position.a=s,w<h.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],35:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=a(t,v),f.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(s),this.m_localAnchorB=t.localAnchorB||e.getLocalPoint(s),this.m_referenceAngle=e.getAngle()-i.getAngle(),this.m_impulse=l(),this.m_motorImpulse=0,this.m_lowerAngle=t.lowerAngle,this.m_upperAngle=t.upperAngle,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new p,this.m_motorMass,this.m_limitState=y}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/options"),m=t("../util/create"),h=t("../Settings"),c=t("../common/Math"),_=t("../common/Vec2"),l=t("../common/Vec3"),u=t("../common/Mat22"),p=t("../common/Mat33"),d=t("../common/Rot"),f=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),y=0;o.TYPE="revolute-joint";var v={lowerAngle:0,upperAngle:0,maxMotorTorque:0,motorSpeed:0,enableLimit:!1,enableMotor:!1};(o.prototype=m((o._super=f).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getReferenceAngle=function(){return this.m_referenceAngle},o.prototype.getJointAngle=function(){var t=this.m_bodyA;return this.m_bodyB.m_sweep.a-t.m_sweep.a-this.m_referenceAngle},o.prototype.getJointSpeed=function(){var t=this.m_bodyA;return this.m_bodyB.m_angularVelocity-t.m_angularVelocity},o.prototype.isMotorEnabled=function(){return this.m_enableMotor},o.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},o.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},o.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},o.prototype.getMotorSpeed=function(){return this.m_motorSpeed},o.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},o.prototype.isLimitEnabled=function(){return this.m_enableLimit},o.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},o.prototype.getLowerLimit=function(){return this.m_lowerAngle},o.prototype.getUpperLimit=function(){return this.m_upperAngle},o.prototype.setLimits=function(t,i){n&&r.assert(t<=i),t==this.m_lowerAngle&&i==this.m_upperAngle||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_impulse.z=0,this.m_lowerAngle=t,this.m_upperAngle=i)},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*_.neo(this.m_impulse.x,this.m_impulse.y)},o.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,a=d.neo(i),m=d.neo(s);this.m_rA=d.mul(a,_.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=d.mul(m,_.sub(this.m_localAnchorB,this.m_localCenterB));var l=this.m_invMassA,u=this.m_invMassB,p=this.m_invIA,f=this.m_invIB,v=p+f==0;if(this.m_mass.ex.x=l+u+this.m_rA.y*this.m_rA.y*p+this.m_rB.y*this.m_rB.y*f,this.m_mass.ey.x=-this.m_rA.y*this.m_rA.x*p-this.m_rB.y*this.m_rB.x*f,this.m_mass.ez.x=-this.m_rA.y*p-this.m_rB.y*f,this.m_mass.ex.y=this.m_mass.ey.x,this.m_mass.ey.y=l+u+this.m_rA.x*this.m_rA.x*p+this.m_rB.x*this.m_rB.x*f,this.m_mass.ez.y=this.m_rA.x*p+this.m_rB.x*f,this.m_mass.ex.z=this.m_mass.ez.x,this.m_mass.ey.z=this.m_mass.ez.y,this.m_mass.ez.z=p+f,this.m_motorMass=p+f,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),(0==this.m_enableMotor||v)&&(this.m_motorImpulse=0),this.m_enableLimit&&0==v){var g=s-i-this.m_referenceAngle;c.abs(this.m_upperAngle-this.m_lowerAngle)<2*h.angularSlop?this.m_limitState=3:g<=this.m_lowerAngle?(1!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=1):g>=this.m_upperAngle?(2!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=2):(this.m_limitState=y,this.m_impulse.z=0)}else this.m_limitState=y;if(t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var x=_.neo(this.m_impulse.x,this.m_impulse.y);e.wSub(l,x),o-=p*(_.cross(this.m_rA,x)+this.m_motorImpulse+this.m_impulse.z),n.wAdd(u,x),r+=f*(_.cross(this.m_rB,x)+this.m_motorImpulse+this.m_impulse.z)}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,a=this.m_invIA,m=this.m_invIB,h=a+m==0;if(this.m_enableMotor&&3!=this.m_limitState&&0==h){var u=s-e-this.m_motorSpeed,p=-this.m_motorMass*u,d=this.m_motorImpulse,f=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=c.clamp(this.m_motorImpulse+p,-f,f),e-=a*(p=this.m_motorImpulse-d),s+=m*p}if(this.m_enableLimit&&this.m_limitState!=y&&0==h){var v=_.zero();v.wAdd(1,o,1,_.cross(s,this.m_rB)),v.wSub(1,i,1,_.cross(e,this.m_rA));var g=s-e;u=l(v.x,v.y,g),p=l.neg(this.m_mass.solve33(u));if(3==this.m_limitState)this.m_impulse.add(p);else if(1==this.m_limitState){if(this.m_impulse.z+p.z<0){var x=_.wAdd(-1,v,this.m_impulse.z,_.neo(this.m_mass.ez.x,this.m_mass.ez.y)),b=this.m_mass.solve22(x);p.x=b.x,p.y=b.y,p.z=-this.m_impulse.z,this.m_impulse.x+=b.x,this.m_impulse.y+=b.y,this.m_impulse.z=0}else this.m_impulse.add(p)}else if(2==this.m_limitState){if(this.m_impulse.z+p.z>0){x=_.wAdd(-1,v,this.m_impulse.z,_.neo(this.m_mass.ez.x,this.m_mass.ez.y)),b=this.m_mass.solve22(x);p.x=b.x,p.y=b.y,p.z=-this.m_impulse.z,this.m_impulse.x+=b.x,this.m_impulse.y+=b.y,this.m_impulse.z=0}else this.m_impulse.add(p)}var A=_.neo(p.x,p.y);i.wSub(n,A),e-=a*(_.cross(this.m_rA,A)+p.z),o.wAdd(r,A),s+=m*(_.cross(this.m_rB,A)+p.z)}else{(u=_.zero()).wAdd(1,o,1,_.cross(s,this.m_rB)),u.wSub(1,i,1,_.cross(e,this.m_rA));p=this.m_mass.solve22(_.neg(u));this.m_impulse.x+=p.x,this.m_impulse.y+=p.y,i.wSub(n,p),e-=a*_.cross(this.m_rA,p),o.wAdd(r,p),s+=m*_.cross(this.m_rB,p)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=d.neo(e),r=d.neo(s),a=0,m=0,l=this.m_invIA+this.m_invIB==0;if(this.m_enableLimit&&this.m_limitState!=y&&0==l){var p=s-e-this.m_referenceAngle,f=0;if(3==this.m_limitState){var v=c.clamp(p-this.m_lowerAngle,-h.maxAngularCorrection,h.maxAngularCorrection);f=-this.m_motorMass*v,a=c.abs(v)}else if(1==this.m_limitState){a=-(v=p-this.m_lowerAngle),v=c.clamp(v+h.angularSlop,-h.maxAngularCorrection,0),f=-this.m_motorMass*v}else if(2==this.m_limitState){a=v=p-this.m_upperAngle,v=c.clamp(v-h.angularSlop,0,h.maxAngularCorrection),f=-this.m_motorMass*v}e-=this.m_invIA*f,s+=this.m_invIB*f}n.set(e),r.set(s);var g=d.mul(n,_.sub(this.m_localAnchorA,this.m_localCenterA)),x=d.mul(r,_.sub(this.m_localAnchorB,this.m_localCenterB));(v=_.zero()).wAdd(1,o,1,x),v.wSub(1,i,1,g),m=v.length();var b=this.m_invMassA,A=this.m_invMassB,w=this.m_invIA,B=this.m_invIB,S=new u;S.ex.x=b+A+w*g.y*g.y+B*x.y*x.y,S.ex.y=-w*g.x*g.y-B*x.x*x.y,S.ey.x=S.ex.y,S.ey.y=b+A+w*g.x*g.x+B*x.x*x.x;var M=_.neg(S.solve(v));return i.wSub(b,M),e-=w*_.cross(g,M),o.wAdd(A,M),s+=B*_.cross(x,M),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,m<=h.linearSlop&&a<=h.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],36:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=r(t,p),l.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(s),this.m_localAnchorB=t.localAnchorB||e.getLocalPoint(s),this.m_maxLength=t.maxLength,this.m_mass=0,this.m_impulse=0,this.m_length=0,this.m_state=u,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/options"),a=t("../util/create"),m=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),u=0;o.TYPE="rope-joint";var p={maxLength:0};(o.prototype=a((o._super=l).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.setMaxLength=function(t){this.m_maxLength=t},o.prototype.getMaxLength=function(){return this.m_maxLength},o.prototype.getLimitState=function(){return this.m_state},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*this.m_impulse*this.m_u},o.prototype.getReactionTorque=function(t){return 0},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,l=_.neo(e),p=_.neo(r);this.m_rA=_.mulSub(l,this.m_localAnchorA,this.m_localCenterA),this.m_rB=_.mulSub(p,this.m_localAnchorB,this.m_localCenterB),this.m_u=c.zero(),this.m_u.wAdd(1,n,1,this.m_rB),this.m_u.wSub(1,i,1,this.m_rA),this.m_length=this.m_u.length();var d=this.m_length-this.m_maxLength;if(this.m_state=d>0?2:u,!(this.m_length>m.linearSlop))return this.m_u.setZero(),this.m_mass=0,void(this.m_impulse=0);this.m_u.mul(1/this.m_length);var f=c.cross(this.m_rA,this.m_u),y=c.cross(this.m_rB,this.m_u),v=this.m_invMassA+this.m_invIA*f*f+this.m_invMassB+this.m_invIB*y*y;if(this.m_mass=0!=v?1/v:0,t.warmStarting){this.m_impulse*=t.dtRatio;var g=c.mul(this.m_impulse,this.m_u);o.wSub(this.m_invMassA,g),s-=this.m_invIA*c.cross(this.m_rA,g),a.wAdd(this.m_invMassB,g),h+=this.m_invIB*c.cross(this.m_rB,g)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(a),this.m_bodyB.c_velocity.w=h},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=c.addCross(i,e,this.m_rA),r=c.addCross(o,s,this.m_rB),a=this.m_length-this.m_maxLength,m=c.dot(this.m_u,c.sub(r,n));a<0&&(m+=t.inv_dt*a);var _=-this.m_mass*m,l=this.m_impulse;this.m_impulse=h.min(0,this.m_impulse+_),_=this.m_impulse-l;var u=c.mul(_,this.m_u);i.wSub(this.m_invMassA,u),e-=this.m_invIA*c.cross(this.m_rA,u),o.wAdd(this.m_invMassB,u),s+=this.m_invIB*c.cross(this.m_rB,u),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=_.neo(e),r=_.neo(s),a=_.mulSub(n,this.m_localAnchorA,this.m_localCenterA),l=_.mulSub(r,this.m_localAnchorB,this.m_localCenterB),u=c.zero();u.wAdd(1,o,1,l),u.wSub(1,i,1,a);var p=u.normalize(),d=p-this.m_maxLength;d=h.clamp(d,0,m.maxLinearCorrection);var f=-this.m_mass*d,y=c.mul(f,u);return i.wSub(this.m_invMassA,y),e-=this.m_invIA*c.cross(a,y),o.wAdd(this.m_invMassB,y),s+=this.m_invIB*c.cross(l,y),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,p-this.m_maxLength<m.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":52,"../util/options":53}],37:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=r(t,d),p.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=i.getLocalPoint(s),this.m_localAnchorB=e.getLocalPoint(s),this.m_referenceAngle=e.getAngle()-i.getAngle(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=_(),this.m_bias=0,this.m_gamma=0,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new l}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/options"),a=t("../util/create"),m=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=t("../common/Vec3"),l=(t("../common/Mat22"),t("../common/Mat33")),u=t("../common/Rot"),p=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="weld-joint";var d={frequencyHz:0,dampingRatio:0};(o.prototype=a((o._super=p).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getReferenceAngle=function(){return this.m_referenceAngle},o.prototype.setFrequency=function(t){this.m_frequencyHz=t},o.prototype.getFrequency=function(){return this.m_frequencyHz},o.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*c.neo(this.m_impulse.x,this.m_impulse.y)},o.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,a=u.neo(i),m=u.neo(s);this.m_rA=u.mul(a,c.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=u.mul(m,c.sub(this.m_localAnchorB,this.m_localCenterB));var _=this.m_invMassA,p=this.m_invMassB,d=this.m_invIA,f=this.m_invIB,y=new l;if(y.ex.x=_+p+this.m_rA.y*this.m_rA.y*d+this.m_rB.y*this.m_rB.y*f,y.ey.x=-this.m_rA.y*this.m_rA.x*d-this.m_rB.y*this.m_rB.x*f,y.ez.x=-this.m_rA.y*d-this.m_rB.y*f,y.ex.y=y.ey.x,y.ey.y=_+p+this.m_rA.x*this.m_rA.x*d+this.m_rB.x*this.m_rB.x*f,y.ez.y=this.m_rA.x*d+this.m_rB.x*f,y.ex.z=y.ez.x,y.ey.z=y.ez.y,y.ez.z=d+f,this.m_frequencyHz>0){y.getInverse22(this.m_mass);var v=d+f,g=v>0?1/v:0,x=s-i-this.m_referenceAngle,b=2*h.PI*this.m_frequencyHz,A=2*g*this.m_dampingRatio*b,w=g*b*b,B=t.dt;this.m_gamma=B*(A+B*w),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=x*B*w*this.m_gamma,v+=this.m_gamma,this.m_mass.ez.z=0!=v?1/v:0}else 0==y.ez.z?(y.getInverse22(this.m_mass),this.m_gamma=0,this.m_bias=0):(y.getSymInverse33(this.m_mass),this.m_gamma=0,this.m_bias=0);if(t.warmStarting){this.m_impulse.mul(t.dtRatio);var S=c.neo(this.m_impulse.x,this.m_impulse.y);e.wSub(_,S),o-=d*(c.cross(this.m_rA,S)+this.m_impulse.z),n.wAdd(p,S),r+=f*(c.cross(this.m_rB,S)+this.m_impulse.z)}else this.m_impulse.setZero();this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,a=this.m_invIA,m=this.m_invIB;if(this.m_frequencyHz>0){var h=s-e,u=-this.m_mass.ez.z*(h+this.m_bias+this.m_gamma*this.m_impulse.z);this.m_impulse.z+=u,e-=a*u,s+=m*u;(f=c.zero()).wAdd(1,o,1,c.cross(s,this.m_rB)),f.wSub(1,i,1,c.cross(e,this.m_rA));var p=c.neg(l.mul(this.m_mass,f));this.m_impulse.x+=p.x,this.m_impulse.y+=p.y;var d=c.clone(p);i.wSub(n,d),e-=a*c.cross(this.m_rA,d),o.wAdd(r,d),s+=m*c.cross(this.m_rB,d)}else{var f;(f=c.zero()).wAdd(1,o,1,c.cross(s,this.m_rB)),f.wSub(1,i,1,c.cross(e,this.m_rA));h=s-e;var y=_(f.x,f.y,h),v=_.neg(l.mul(this.m_mass,y));this.m_impulse.add(v);d=c.neo(v.x,v.y);i.wSub(n,d),e-=a*(c.cross(this.m_rA,d)+v.z),o.wAdd(r,d),s+=m*(c.cross(this.m_rB,d)+v.z)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i,e,o=this.m_bodyA.c_position.c,s=this.m_bodyA.c_position.a,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,a=u.neo(s),p=u.neo(r),d=this.m_invMassA,f=this.m_invMassB,y=this.m_invIA,v=this.m_invIB,g=u.mul(a,c.sub(this.m_localAnchorA,this.m_localCenterA)),x=u.mul(p,c.sub(this.m_localAnchorB,this.m_localCenterB)),b=new l;if(b.ex.x=d+f+g.y*g.y*y+x.y*x.y*v,b.ey.x=-g.y*g.x*y-x.y*x.x*v,b.ez.x=-g.y*y-x.y*v,b.ex.y=b.ey.x,b.ey.y=d+f+g.x*g.x*y+x.x*x.x*v,b.ez.y=g.x*y+x.x*v,b.ex.z=b.ez.x,b.ey.z=b.ez.y,b.ez.z=y+v,this.m_frequencyHz>0){(w=c.zero()).wAdd(1,n,1,x),w.wSub(1,o,1,g),i=w.length(),e=0;var A=c.neg(b.solve22(w));o.wSub(d,A),s-=y*c.cross(g,A),n.wAdd(f,A),r+=v*c.cross(x,A)}else{var w;(w=c.zero()).wAdd(1,n,1,x),w.wSub(1,o,1,g);var B=r-s-this.m_referenceAngle;i=w.length(),e=h.abs(B);var S=_(w.x,w.y,B),M=_();if(b.ez.z>0)M=_.neg(b.solve33(S));else{var C=c.neg(b.solve22(w));M.set(C.x,C.y,0)}A=c.neo(M.x,M.y);o.wSub(d,A),s-=y*(c.cross(g,A)+M.z),n.wAdd(f,A),r+=v*(c.cross(x,A)+M.z)}return this.m_bodyA.c_position.c=o,this.m_bodyA.c_position.a=s,this.m_bodyB.c_position.c=n,this.m_bodyB.c_position.a=r,i<=m.linearSlop&&e<=m.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":52,"../util/options":53}],38:[function(t,i,e){function o(t,i,e,s,n){if(!(this instanceof o))return new o(t,i,e,s,n);t=r(t,u),l.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=i.getLocalPoint(s),this.m_localAnchorB=e.getLocalPoint(s),this.m_localXAxisA=i.getLocalVector(n||c.neo(1,0)),this.m_localYAxisA=c.cross(1,this.m_localXAxisA),this.m_mass=0,this.m_impulse=0,this.m_motorMass=0,this.m_motorImpulse=0,this.m_springMass=0,this.m_springImpulse=0,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableMotor=t.enableMotor,this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_bias=0,this.m_gamma=0,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_ax=c.zero(),this.m_ay=c.zero(),this.m_sAx,this.m_sBx,this.m_sAy,this.m_sBy}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/options"),a=t("../util/create"),m=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="wheel-joint";var u={enableMotor:!1,maxMotorTorque:0,motorSpeed:0,frequencyHz:2,dampingRatio:.7};(o.prototype=a((o._super=l).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getLocalAxisA=function(){return this.m_localXAxisA},o.prototype.getJointTranslation=function(){var t=this.m_bodyA,i=this.m_bodyB,e=t.getWorldPoint(this.m_localAnchorA),o=i.getWorldPoint(this.m_localAnchorB)-e,s=t.getWorldVector(this.m_localXAxisA);return Dot(o,s)},o.prototype.getJointSpeed=function(){var t=this.m_bodyA.m_angularVelocity;return this.m_bodyB.m_angularVelocity-t},o.prototype.isMotorEnabled=function(){return this.m_enableMotor},o.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},o.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},o.prototype.getMotorSpeed=function(){return this.m_motorSpeed},o.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},o.prototype.getMaxMotorTorque=function(){return this.m_maxMotorTorque},o.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},o.prototype.setSpringFrequencyHz=function(t){this.m_frequencyHz=t},o.prototype.getSpringFrequencyHz=function(){return this.m_frequencyHz},o.prototype.setSpringDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getSpringDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*(this.m_impulse*this.m_ay+this.m_springImpulse*this.m_ax)},o.prototype.getReactionTorque=function(t){return t*this.m_motorImpulse},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_invMassA,e=this.m_invMassB,o=this.m_invIA,s=this.m_invIB,n=this.m_bodyA.c_position.c,r=this.m_bodyA.c_position.a,a=this.m_bodyA.c_velocity.v,m=this.m_bodyA.c_velocity.w,l=this.m_bodyB.c_position.c,u=this.m_bodyB.c_position.a,p=this.m_bodyB.c_velocity.v,d=this.m_bodyB.c_velocity.w,f=_.neo(r),y=_.neo(u),v=_.mul(f,c.sub(this.m_localAnchorA,this.m_localCenterA)),g=_.mul(y,c.sub(this.m_localAnchorB,this.m_localCenterB));if((w=c.zero()).wAdd(1,l,1,g),w.wSub(1,n,1,v),this.m_ay=_.mul(f,this.m_localYAxisA),this.m_sAy=c.cross(c.add(w,v),this.m_ay),this.m_sBy=c.cross(g,this.m_ay),this.m_mass=i+e+o*this.m_sAy*this.m_sAy+s*this.m_sBy*this.m_sBy,this.m_mass>0&&(this.m_mass=1/this.m_mass),this.m_springMass=0,this.m_bias=0,this.m_gamma=0,this.m_frequencyHz>0){this.m_ax=_.mul(f,this.m_localXAxisA),this.m_sAx=c.cross(c.add(w,v),this.m_ax),this.m_sBx=c.cross(g,this.m_ax);var x=i+e+o*this.m_sAx*this.m_sAx+s*this.m_sBx*this.m_sBx;if(x>0){this.m_springMass=1/x;var b=c.dot(w,this.m_ax),A=2*h.PI*this.m_frequencyHz,w=2*this.m_springMass*this.m_dampingRatio*A,B=this.m_springMass*A*A,S=t.dt;this.m_gamma=S*(w+S*B),this.m_gamma>0&&(this.m_gamma=1/this.m_gamma),this.m_bias=b*S*B*this.m_gamma,this.m_springMass=x+this.m_gamma,this.m_springMass>0&&(this.m_springMass=1/this.m_springMass)}}else this.m_springImpulse=0;if(this.m_enableMotor?(this.m_motorMass=o+s,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass)):(this.m_motorMass=0,this.m_motorImpulse=0),t.warmStarting){this.m_impulse*=t.dtRatio,this.m_springImpulse*=t.dtRatio,this.m_motorImpulse*=t.dtRatio;var M=c.wAdd(this.m_impulse,this.m_ay,this.m_springImpulse,this.m_ax),C=this.m_impulse*this.m_sAy+this.m_springImpulse*this.m_sAx+this.m_motorImpulse,I=this.m_impulse*this.m_sBy+this.m_springImpulse*this.m_sBx+this.m_motorImpulse;a.wSub(this.m_invMassA,M),m-=this.m_invIA*C,p.wAdd(this.m_invMassB,M),d+=this.m_invIB*I}else this.m_impulse=0,this.m_springImpulse=0,this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(a),this.m_bodyA.c_velocity.w=m,this.m_bodyB.c_velocity.v.set(p),this.m_bodyB.c_velocity.w=d},o.prototype.solveVelocityConstraints=function(t){var i=this.m_invMassA,e=this.m_invMassB,o=this.m_invIA,s=this.m_invIB,n=this.m_bodyA.c_velocity.v,r=this.m_bodyA.c_velocity.w,a=this.m_bodyB.c_velocity.v,m=this.m_bodyB.c_velocity.w,_=c.dot(this.m_ax,a)-c.dot(this.m_ax,n)+this.m_sBx*m-this.m_sAx*r,l=-this.m_springMass*(_+this.m_bias+this.m_gamma*this.m_springImpulse);this.m_springImpulse+=l;var u=c.zero().wSet(l,this.m_ax),p=l*this.m_sAx,d=l*this.m_sBx;n.wSub(i,u),r-=o*p,a.wAdd(e,u);_=(m+=s*d)-r-this.m_motorSpeed,l=-this.m_motorMass*_;var f=this.m_motorImpulse,y=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=h.clamp(this.m_motorImpulse+l,-y,y),r-=o*(l=this.m_motorImpulse-f),m+=s*l;_=c.dot(this.m_ay,a)-c.dot(this.m_ay,n)+this.m_sBy*m-this.m_sAy*r,l=-this.m_mass*_;this.m_impulse+=l;u=c.zero().wSet(l,this.m_ay),p=l*this.m_sAy,d=l*this.m_sBy;n.wSub(i,u),r-=o*p,a.wAdd(e,u),m+=s*d,this.m_bodyA.c_velocity.v.set(n),this.m_bodyA.c_velocity.w=r,this.m_bodyB.c_velocity.v.set(a),this.m_bodyB.c_velocity.w=m},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=_.neo(e),r=_.neo(s),a=_.mul(n,c.sub(this.m_localAnchorA,this.m_localCenterA)),l=_.mul(r,c.sub(this.m_localAnchorB,this.m_localCenterB)),u=c.zero();u.wAdd(1,o,1,l),u.wSub(1,i,1,a);var p,d=_.mul(n,this.m_localYAxisA),f=c.cross(c.sub(u,a),d),y=c.cross(l,d),v=c.dot(u,d),g=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_sAy*this.m_sAy+this.m_invIB*this.m_sBy*this.m_sBy;p=0!=g?-v/g:0;var x=c.zero().wSet(p,d),b=p*f,A=p*y;return i.wSub(this.m_invMassA,x),e-=this.m_invIA*b,o.wAdd(this.m_invMassB,x),s+=this.m_invIB*A,this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,h.abs(v)<=m.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":52,"../util/options":53}],39:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);o._super.call(this),this._setAsBox(t,i,e,s)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;t("../util/common");var r=t("../util/create"),a=t("./PolygonShape");o.prototype=r((o._super=a).prototype),o.TYPE="polygon"},{"../util/common":51,"../util/create":52,"./PolygonShape":48}],40:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);o._super.call(this),this.m_type=o.TYPE,this.m_radius=c.polygonRadius,this.m_vertices=[],this.m_count=0,this.m_prevVertex=null,this.m_nextVertex=null,this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,t&&t.length&&(i?this._createLoop(t):this._createChain(t))}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/create"),m=(t("../util/options"),t("../common/Math"),t("../common/Transform")),h=(t("../common/Rot"),t("../common/Vec2")),c=(t("../collision/AABB"),t("../Settings")),_=t("../Shape"),l=t("./EdgeShape");o.prototype=a((o._super=_).prototype),o.TYPE="chain",o.prototype._createLoop=function(t){n&&r.assert(0==this.m_vertices.length&&0==this.m_count),n&&r.assert(t.length>=3);for(var i=1;i<t.length;++i){var e=t[i-1],o=t[i];n&&r.assert(h.distanceSquared(e,o)>c.linearSlopSquared)}this.m_vertices.length=0,this.m_count=t.length+1;for(i=0;i<t.length;++i)this.m_vertices[i]=t[i].clone();return this.m_vertices[t.length]=t[0].clone(),this.m_prevVertex=this.m_vertices[this.m_count-2],this.m_nextVertex=this.m_vertices[1],this.m_hasPrevVertex=!0,this.m_hasNextVertex=!0,this},o.prototype._createChain=function(t){n&&r.assert(0==this.m_vertices.length&&0==this.m_count),n&&r.assert(t.length>=2);for(var i=1;i<t.length;++i){var e=t[i-1],o=t[i];n&&r.assert(h.distanceSquared(e,o)>c.linearSlopSquared)}this.m_count=t.length;for(i=0;i<t.length;++i)this.m_vertices[i]=t[i].clone();return this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,this.m_prevVertex=null,this.m_nextVertex=null,this},o.prototype._setPrevVertex=function(t){this.m_prevVertex=t,this.m_hasPrevVertex=!0},o.prototype._setNextVertex=function(t){this.m_nextVertex=t,this.m_hasNextVertex=!0},o.prototype._clone=function(){var t=new o;return t.createChain(this.m_vertices),t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_prevVertex=this.m_prevVertex,t.m_nextVertex=this.m_nextVertex,t.m_hasPrevVertex=this.m_hasPrevVertex,t.m_hasNextVertex=this.m_hasNextVertex,t},o.prototype.getChildCount=function(){return this.m_count-1},o.prototype.getChildEdge=function(t,i){n&&r.assert(0<=i&&i<this.m_count-1),t.m_type=l.TYPE,t.m_radius=this.m_radius,t.m_vertex1=this.m_vertices[i],t.m_vertex2=this.m_vertices[i+1],i>0?(t.m_vertex0=this.m_vertices[i-1],t.m_hasVertex0=!0):(t.m_vertex0=this.m_prevVertex,t.m_hasVertex0=this.m_hasPrevVertex),i<this.m_count-2?(t.m_vertex3=this.m_vertices[i+2],t.m_hasVertex3=!0):(t.m_vertex3=this.m_nextVertex,t.m_hasVertex3=this.m_hasNextVertex)},o.prototype.getVertex=function(t){return n&&r.assert(0<=t&&t<=this.m_count),t<this.m_count?this.m_vertices[t]:this.m_vertices[0]},o.prototype.testPoint=function(t,i){return!1},o.prototype.rayCast=function(t,i,e,o){n&&r.assert(0<=o&&o<this.m_count);return new l(this.getVertex(o),this.getVertex(o+1)).rayCast(t,i,e,0)},o.prototype.computeAABB=function(t,i,e){n&&r.assert(0<=e&&e<this.m_count);var o=m.mul(i,this.getVertex(e)),s=m.mul(i,this.getVertex(e+1));t.combinePoints(o,s)},o.prototype.computeMass=function(t,i){t.mass=0,t.center=h.neo(),t.I=0},o.prototype.computeDistanceProxy=function(t,i){n&&r.assert(0<=i&&i<this.m_count),t.m_buffer[0]=this.getVertex(i),t.m_buffer[1]=this.getVertex(i+1),t.m_vertices=t.m_buffer,t.m_count=2,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"../util/options":53,"./EdgeShape":47}],41:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);o._super.call(this),this.m_type=o.TYPE,this.m_p=c.zero(),this.m_radius=1,"object"==typeof t&&c.isValid(t)?(this.m_p.set(t),"number"==typeof i&&(this.m_radius=i)):"number"==typeof t&&(this.m_radius=t)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/create"),m=(t("../util/options"),t("../common/Math")),h=(t("../common/Transform"),t("../common/Rot")),c=t("../common/Vec2"),_=(t("../collision/AABB"),t("../Settings"),t("../Shape"));o.prototype=a((o._super=_).prototype),o.TYPE="circle",o.prototype.getRadius=function(){return this.m_radius},o.prototype.getCenter=function(){return this.m_p},o.prototype.getSupportVertex=function(t){return this.m_p},o.prototype.getVertex=function(t){return n&&r.assert(0==t),this.m_p},o.prototype.getVertexCount=function(t){return 1},o.prototype._clone=function(){var t=new o;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_p=this.m_p.clone(),t},o.prototype.getChildCount=function(){return 1},o.prototype.testPoint=function(t,i){var e=c.add(t.p,h.mul(t.q,this.m_p)),o=c.sub(i,e);return c.dot(o,o)<=this.m_radius*this.m_radius},o.prototype.rayCast=function(t,i,e,o){var s=c.add(e.p,h.mul(e.q,this.m_p)),n=c.sub(i.p1,s),r=c.dot(n,n)-this.m_radius*this.m_radius,a=c.sub(i.p2,i.p1),_=c.dot(n,a),l=c.dot(a,a),u=_*_-l*r;if(u<0||l<m.EPSILON)return!1;var p=-(_+m.sqrt(u));return 0<=p&&p<=i.maxFraction*l&&(p/=l,t.fraction=p,t.normal=c.add(n,c.mul(p,a)),t.normal.normalize(),!0)},o.prototype.computeAABB=function(t,i,e){var o=c.add(i.p,h.mul(i.q,this.m_p));t.lowerBound.set(o.x-this.m_radius,o.y-this.m_radius),t.upperBound.set(o.x+this.m_radius,o.y+this.m_radius)},o.prototype.computeMass=function(t,i){t.mass=i*m.PI*this.m_radius*this.m_radius,t.center=this.m_p,t.I=t.mass*(.5*this.m_radius*this.m_radius+c.dot(this.m_p,this.m_p))},o.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_p),t.m_count=1,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"../util/options":53}],42:[function(t,i,e){function o(t,i,e,o,s){t.pointCount=0;var n=a.mul(e,i.m_p),r=a.mul(s,o.m_p),h=m.distanceSquared(r,n),_=i.m_radius+o.m_radius;h>_*_||(t.type=c.e_circles,t.localPoint.set(i.m_p),t.localNormal.setZero(),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;var r=t("../util/common"),a=(t("../util/create"),t("../common/Math"),t("../common/Transform")),m=t("../common/Vec2"),h=(t("../Settings"),t("../Shape"),t("../Contact")),c=t("../Manifold"),_=t("./CircleShape");h.addType(_.TYPE,_.TYPE,function(t,i,e,s,a,m,h){n&&r.assert(e.getType()==_.TYPE),n&&r.assert(m.getType()==_.TYPE),o(t,e.getShape(),i,m.getShape(),a)}),e.CollideCircles=o},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"./CircleShape":41}],43:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;var n=t("../util/common"),r=t("../common/Math"),a=t("../common/Transform"),m=(t("../common/Rot"),t("../common/Vec2")),h=(t("../collision/AABB"),t("../Settings"),t("../Manifold")),c=t("../Contact"),_=(t("../Shape"),t("./CircleShape")),l=t("./PolygonShape");c.addType(l.TYPE,_.TYPE,function(t,i,e,o,c,u,p){s&&n.assert(e.getType()==l.TYPE),s&&n.assert(u.getType()==_.TYPE),function(t,i,e,o,s){t.pointCount=0;for(var n=a.mul(s,o.m_p),c=a.mulT(e,n),_=0,l=-1/0,u=i.m_radius+o.m_radius,p=i.m_count,d=i.m_vertices,f=i.m_normals,y=0;y<p;++y){var v=m.dot(f[y],m.sub(c,d[y]));if(v>u)return;v>l&&(l=v,_=y)}var g=_,x=g+1<p?g+1:0,b=d[g],A=d[x];if(l<r.EPSILON)return t.pointCount=1,t.type=h.e_faceA,t.localNormal.set(f[_]),t.localPoint.wSet(.5,b,.5,A),t.points[0].localPoint=o.m_p,void(t.points[0].id.key=0);var w=m.dot(m.sub(c,b),m.sub(A,b)),B=m.dot(m.sub(c,A),m.sub(b,A));if(w<=0){if(m.distanceSquared(c,b)>u*u)return;t.pointCount=1,t.type=h.e_faceA,t.localNormal.wSet(1,c,-1,b),t.localNormal.normalize(),t.localPoint=b,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0}else if(B<=0){if(m.distanceSquared(c,A)>u*u)return;t.pointCount=1,t.type=h.e_faceA,t.localNormal.wSet(1,c,-1,A),t.localNormal.normalize(),t.localPoint.set(A),t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0}else{var S=m.mid(b,A),l=m.dot(c,f[g])-m.dot(S,f[g]);if(l>u)return;t.pointCount=1,t.type=h.e_faceA,t.localNormal.set(f[g]),t.localPoint.set(S),t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0}}(t,e.getShape(),i,u.getShape(),c)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"./CircleShape":41,"./PolygonShape":48}],44:[function(t,i,e){function o(t,i,e,o,s){t.pointCount=0;var h=a.mulT(e,a.mul(s,o.m_p)),_=i.m_vertex1,l=i.m_vertex2,u=m.sub(l,_),p=m.dot(u,m.sub(l,h)),d=m.dot(u,m.sub(h,_)),f=i.m_radius+o.m_radius;if(d<=0){var y=m.clone(_),v=m.sub(h,y);if(m.dot(v,v)>f*f)return;if(i.m_hasVertex0){var g=i.m_vertex0,x=_,b=m.sub(x,g);if(m.dot(b,m.sub(x,h))>0)return}return t.type=c.e_circles,t.localNormal.setZero(),t.localPoint.set(y),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0,t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=c.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=c.e_vertex)}if(p<=0){y=m.clone(l),v=m.sub(h,y);if(m.dot(v,v)>f*f)return;if(i.m_hasVertex3){var A=i.m_vertex3,w=l,B=m.sub(A,w);if(m.dot(B,m.sub(h,w))>0)return}return t.type=c.e_circles,t.localNormal.setZero(),t.localPoint.set(y),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0,t.points[0].id.cf.indexA=1,t.points[0].id.cf.typeA=c.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=c.e_vertex)}var S=m.dot(u,u);n&&r.assert(S>0);y=m.wAdd(p/S,_,d/S,l),v=m.sub(h,y);if(!(m.dot(v,v)>f*f)){var M=m.neo(-u.y,u.x);m.dot(M,m.sub(h,_))<0&&M.set(-M.x,-M.y),M.normalize(),t.type=c.e_faceA,t.localNormal=M,t.localPoint.set(_),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0,t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=c.e_face,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=c.e_vertex}}if(void 0===s)var s=!1;if(void 0===n)var n=!1;var r=t("../util/common"),a=(t("../util/create"),t("../common/Math"),t("../common/Transform")),m=t("../common/Vec2"),h=(t("../common/Rot"),t("../Settings"),t("../Shape"),t("../Contact")),c=t("../Manifold"),_=t("./EdgeShape"),l=t("./ChainShape"),u=t("./CircleShape");h.addType(_.TYPE,u.TYPE,function(t,i,e,s,a,m,h){n&&r.assert(e.getType()==_.TYPE),n&&r.assert(m.getType()==u.TYPE),o(t,e.getShape(),i,m.getShape(),a)}),h.addType(l.TYPE,u.TYPE,function(t,i,e,s,a,m,h){n&&r.assert(e.getType()==l.TYPE),n&&r.assert(m.getType()==u.TYPE);var c=e.getShape(),p=new _;c.getChildEdge(p,s),o(t,p,i,m.getShape(),a)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"./ChainShape":40,"./CircleShape":41,"./EdgeShape":47}],45:[function(t,i,e){function o(){this.type,this.index,this.separation}function s(t,i,e,o,s){n&&a.debug("CollideEdgePolygon");var r=h.mulT(e,s),u=h.mul(r,o.m_centroid),d=i.m_vertex0,f=i.m_vertex1,y=i.m_vertex2,S=i.m_vertex3,M=i.m_hasVertex0,C=i.m_hasVertex3,I=c.sub(y,f);I.normalize();var P=c.neo(I.y,-I.x),T=c.dot(P,c.sub(u,f)),V=0,z=0,k=!1,L=!1;if(M){var q=c.sub(f,d);q.normalize();var F=c.neo(q.y,-q.x);k=c.cross(q,I)>=0,V=c.dot(F,u)-c.dot(F,d)}if(C){var R=c.sub(S,y);R.normalize();var E=c.neo(R.y,-R.x);L=c.cross(I,R)>0,z=c.dot(E,u)-c.dot(E,y)}var D,j=c.zero(),Y=c.zero(),J=c.zero();M&&C?k&&L?(D=V>=0||T>=0||z>=0)?(j.set(P),Y.set(F),J.set(E)):(j.wSet(-1,P),Y.wSet(-1,P),J.wSet(-1,P)):k?(D=V>=0||T>=0&&z>=0)?(j.set(P),Y.set(F),J.set(P)):(j.wSet(-1,P),Y.wSet(-1,E),J.wSet(-1,P)):L?(D=z>=0||V>=0&&T>=0)?(j.set(P),Y.set(P),J.set(E)):(j.wSet(-1,P),Y.wSet(-1,P),J.wSet(-1,F)):(D=V>=0&&T>=0&&z>=0)?(j.set(P),Y.set(P),J.set(P)):(j.wSet(-1,P),Y.wSet(-1,E),J.wSet(-1,F)):M?k?(D=V>=0||T>=0)?(j.set(P),Y.set(F),J.wSet(-1,P)):(j.wSet(-1,P),Y.set(P),J.wSet(-1,P)):(D=V>=0&&T>=0)?(j.set(P),Y.set(P),J.wSet(-1,P)):(j.wSet(-1,P),Y.set(P),J.wSet(-1,F)):C?L?(D=T>=0||z>=0)?(j.set(P),Y.wSet(-1,P),J.set(E)):(j.wSet(-1,P),Y.wSet(-1,P),J.set(P)):(D=T>=0&&z>=0)?(j.set(P),Y.wSet(-1,P),J.set(P)):(j.wSet(-1,P),Y.wSet(-1,E),J.set(P)):(D=T>=0)?(j.set(P),Y.wSet(-1,P),J.wSet(-1,P)):(j.wSet(-1,P),Y.set(P),J.set(P)),w.count=o.m_count;for(var O=0;O<o.m_count;++O)w.vertices[O]=h.mul(r,o.m_vertices[O]),w.normals[O]=_.mul(r.q,o.m_normals[O]);var N=2*l.polygonRadius;t.pointCount=0,b.type=g,b.index=D?0:1,b.separation=1/0;for(O=0;O<w.count;++O){(X=c.dot(j,c.sub(w.vertices[O],f)))<b.separation&&(b.separation=X)}if(b.type!=v&&!(b.separation>N)){A.type=v,A.index=-1,A.separation=-1/0;var W=c.neo(-j.y,j.x);for(O=0;O<w.count;++O){var X,H=c.neg(w.normals[O]),Z=c.dot(H,c.sub(w.vertices[O],f)),K=c.dot(H,c.sub(w.vertices[O],y));if((X=m.min(Z,K))>N){A.type=x,A.index=O,A.separation=X;break}if(c.dot(H,W)>=0){if(c.dot(c.sub(H,J),j)<-l.angularSlop)continue}else if(c.dot(c.sub(H,Y),j)<-l.angularSlop)continue;X>A.separation&&(A.type=x,A.index=O,A.separation=X)}if(!(A.type!=v&&A.separation>N)){var G;G=A.type==v?b:A.separation>.98*b.separation+.001?A:b;var U=[new p.clipVertex,new p.clipVertex];if(G.type==g){t.type=p.e_faceA;var Q=0,$=c.dot(j,w.normals[0]);for(O=1;O<w.count;++O){var tt=c.dot(j,w.normals[O]);tt<$&&($=tt,Q=O)}var it=Q,et=it+1<w.count?it+1:0;U[0].v=w.vertices[it],U[0].id.cf.indexA=0,U[0].id.cf.indexB=it,U[0].id.cf.typeA=p.e_face,U[0].id.cf.typeB=p.e_vertex,U[1].v=w.vertices[et],U[1].id.cf.indexA=0,U[1].id.cf.indexB=et,U[1].id.cf.typeA=p.e_face,U[1].id.cf.typeB=p.e_vertex,D?(B.i1=0,B.i2=1,B.v1=f,B.v2=y,B.normal.set(P)):(B.i1=1,B.i2=0,B.v1=y,B.v2=f,B.normal.wSet(-1,P))}else t.type=p.e_faceB,U[0].v=f,U[0].id.cf.indexA=0,U[0].id.cf.indexB=G.index,U[0].id.cf.typeA=p.e_vertex,U[0].id.cf.typeB=p.e_face,U[1].v=y,U[1].id.cf.indexA=0,U[1].id.cf.indexB=G.index,U[1].id.cf.typeA=p.e_vertex,U[1].id.cf.typeB=p.e_face,B.i1=G.index,B.i2=B.i1+1<w.count?B.i1+1:0,B.v1=w.vertices[B.i1],B.v2=w.vertices[B.i2],B.normal.set(w.normals[B.i1]);B.sideNormal1.set(B.normal.y,-B.normal.x),B.sideNormal2.wSet(-1,B.sideNormal1),B.sideOffset1=c.dot(B.sideNormal1,B.v1),B.sideOffset2=c.dot(B.sideNormal2,B.v2);var ot=[new p.clipVertex,new p.clipVertex],st=[new p.clipVertex,new p.clipVertex];if(!(p.clipSegmentToLine(ot,U,B.sideNormal1,B.sideOffset1,B.i1)<l.maxManifoldPoints||p.clipSegmentToLine(st,ot,B.sideNormal2,B.sideOffset2,B.i2)<l.maxManifoldPoints)){G.type==g?(t.localNormal=c.clone(B.normal),t.localPoint=c.clone(B.v1)):(t.localNormal=c.clone(o.m_normals[B.i1]),t.localPoint=c.clone(o.m_vertices[B.i1]));var nt=0;for(O=0;O<l.maxManifoldPoints;++O){if(c.dot(B.normal,c.sub(st[O].v,B.v1))<=N){var rt=t.points[nt];G.type==g?(rt.localPoint=h.mulT(r,st[O].v),rt.id=st[O].id):(rt.localPoint=st[O].v,rt.id.cf.typeA=st[O].id.cf.typeB,rt.id.cf.typeB=st[O].id.cf.typeA,rt.id.cf.indexA=st[O].id.cf.indexB,rt.id.cf.indexB=st[O].id.cf.indexA),++nt}}t.pointCount=nt}}}}if(void 0===n)var n=!1;if(void 0===r)var r=!1;var a=t("../util/common"),m=(t("../util/create"),t("../common/Math")),h=t("../common/Transform"),c=t("../common/Vec2"),_=t("../common/Rot"),l=t("../Settings"),u=(t("../Shape"),t("../Contact")),p=t("../Manifold"),d=t("./EdgeShape"),f=t("./ChainShape"),y=t("./PolygonShape");u.addType(d.TYPE,y.TYPE,function(t,i,e,o,n,m,h){r&&a.assert(e.getType()==d.TYPE),r&&a.assert(m.getType()==y.TYPE),s(t,e.getShape(),i,m.getShape(),n)}),u.addType(f.TYPE,y.TYPE,function(t,i,e,o,n,m,h){r&&a.assert(e.getType()==f.TYPE),r&&a.assert(m.getType()==y.TYPE);var c=e.getShape(),_=new d;c.getChildEdge(_,o),s(t,_,i,m.getShape(),n)});var v=-1,g=1,x=2,b=new o,A=new o,w=new function(){this.vertices=[],this.normals=[],this.count=0},B=new function(){this.i1,this.i2,this.v1,this.v2,this.normal=c.zero(),this.sideNormal1=c.zero(),this.sideOffset1,this.sideNormal2=c.zero(),this.sideOffset2}},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"./ChainShape":40,"./EdgeShape":47,"./PolygonShape":48}],46:[function(t,i,e){function o(t,i,e,s){for(var n=t.m_count,r=e.m_count,a=t.m_normals,_=t.m_vertices,l=e.m_vertices,u=m.mulT(s,i),p=0,d=-1/0,f=0;f<n;++f){for(var y=h.mul(u.q,a[f]),v=m.mul(u,_[f]),g=1/0,x=0;x<r;++x){var b=c.dot(y,l[x])-c.dot(y,v);b<g&&(g=b)}g>d&&(d=g,p=f)}o._maxSeparation=d,o._bestIndex=p}function s(t,i,e,s,n){t.pointCount=0;var u=i.m_radius+s.m_radius;o(i,e,s,n);var p=o._bestIndex,d=o._maxSeparation;if(!(d>u)){o(s,n,i,e);var f=o._bestIndex,y=o._maxSeparation;if(!(y>u)){var v,g,x,b,A,w;y>d+.1*_.linearSlop?(v=s,g=i,x=n,b=e,A=f,t.type=l.e_faceB,w=1):(v=i,g=s,x=e,b=n,A=p,t.type=l.e_faceA,w=0);var B=[new l.clipVertex,new l.clipVertex];!function(t,i,e,o,s,n){var _=i.m_normals,u=s.m_count,p=s.m_vertices,d=s.m_normals;r&&a.assert(0<=o&&o<i.m_count);for(var f=h.mulT(n.q,h.mul(e.q,_[o])),y=0,v=1/0,g=0;g<u;++g){var x=c.dot(f,d[g]);x<v&&(v=x,y=g)}var b=y,A=b+1<u?b+1:0;t[0].v=m.mul(n,p[b]),t[0].id.cf.indexA=o,t[0].id.cf.indexB=b,t[0].id.cf.typeA=l.e_face,t[0].id.cf.typeB=l.e_vertex,t[1].v=m.mul(n,p[A]),t[1].id.cf.indexA=o,t[1].id.cf.indexB=A,t[1].id.cf.typeA=l.e_face,t[1].id.cf.typeB=l.e_vertex}(B,v,x,A,g,b);var S=v.m_count,M=v.m_vertices,C=A,I=A+1<S?A+1:0,P=M[C],T=M[I],V=c.sub(T,P);V.normalize();var z=c.cross(V,1),k=c.wAdd(.5,P,.5,T),L=h.mul(x.q,V),q=c.cross(L,1);P=m.mul(x,P),T=m.mul(x,T);var F=c.dot(q,P),R=-c.dot(L,P)+u,E=c.dot(L,T)+u,D=[new l.clipVertex,new l.clipVertex],j=[new l.clipVertex,new l.clipVertex];if(!(l.clipSegmentToLine(D,B,c.neg(L),R,C)<2||l.clipSegmentToLine(j,D,L,E,I)<2)){t.localNormal=z,t.localPoint=k;for(var Y=0,J=0;J<j.length;++J){if(c.dot(q,j[J].v)-F<=u){var O=t.points[Y];if(O.localPoint.set(m.mulT(b,j[J].v)),O.id=j[J].id,w){var N=O.id.cf,W=N.indexA,X=N.indexB,H=N.typeA,Z=N.typeB;N.indexA=X,N.indexB=W,N.typeA=Z,N.typeB=H}++Y}}t.pointCount=Y}}}}if(void 0===n)var n=!1;if(void 0===r)var r=!1;var a=t("../util/common"),m=(t("../common/Math"),t("../common/Transform")),h=t("../common/Rot"),c=t("../common/Vec2"),_=(t("../collision/AABB"),t("../Settings")),l=t("../Manifold"),u=t("../Contact"),p=(t("../Shape"),t("./PolygonShape"));i.exports=s,u.addType(p.TYPE,p.TYPE,function(t,i,e,o,n,m,h){r&&a.assert(e.getType()==p.TYPE),r&&a.assert(m.getType()==p.TYPE),s(t,e.getShape(),i,m.getShape(),n)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"./PolygonShape":48}],47:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);o._super.call(this),this.m_type=o.TYPE,this.m_radius=a.polygonRadius,this.m_vertex1=t?_.clone(t):_.zero(),this.m_vertex2=i?_.clone(i):_.zero(),this.m_vertex0=_.zero(),this.m_vertex3=_.zero(),this.m_hasVertex0=!1,this.m_hasVertex3=!1}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/create"),a=(t("../util/options"),t("../Settings")),m=t("../Shape"),h=(t("../common/Math"),t("../common/Transform")),c=t("../common/Rot"),_=t("../common/Vec2");t("../collision/AABB");o.prototype=r((o._super=m).prototype),o.TYPE="edge",o.prototype.setNext=function(t){return t?(this.m_vertex3.set(t),this.m_hasVertex3=!0):(this.m_vertex3.setZero(),this.m_hasVertex3=!1),this},o.prototype.setPrev=function(t){return t?(this.m_vertex0.set(t),this.m_hasVertex0=!0):(this.m_vertex0.setZero(),this.m_hasVertex0=!1),this},o.prototype._set=function(t,i){return this.m_vertex1.set(t),this.m_vertex2.set(i),this.m_hasVertex0=!1,this.m_hasVertex3=!1,this},o.prototype._clone=function(){var t=new o;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_vertex1.set(this.m_vertex1),t.m_vertex2.set(this.m_vertex2),t.m_vertex0.set(this.m_vertex0),t.m_vertex3.set(this.m_vertex3),t.m_hasVertex0=this.m_hasVertex0,t.m_hasVertex3=this.m_hasVertex3,t},o.prototype.getChildCount=function(){return 1},o.prototype.testPoint=function(t,i){return!1},o.prototype.rayCast=function(t,i,e,o){var s=c.mulT(e.q,_.sub(i.p1,e.p)),n=c.mulT(e.q,_.sub(i.p2,e.p)),r=_.sub(n,s),a=this.m_vertex1,m=this.m_vertex2,h=_.sub(m,a),l=_.neo(h.y,-h.x);l.normalize();var u=_.dot(l,_.sub(a,s)),p=_.dot(l,r);if(0==p)return!1;var d=u/p;if(d<0||i.maxFraction<d)return!1;var f=_.add(s,_.mul(d,r)),y=_.sub(m,a),v=_.dot(y,y);if(0==v)return!1;var g=_.dot(_.sub(f,a),y)/v;return!(g<0||1<g)&&(t.fraction=d,t.normal=u>0?c.mul(e.q,l).neg():c.mul(e.q,l),!0)},o.prototype.computeAABB=function(t,i,e){var o=h.mul(i,this.m_vertex1),s=h.mul(i,this.m_vertex2);t.combinePoints(o,s),t.extend(this.m_radius)},o.prototype.computeMass=function(t,i){t.mass=0,t.center.wSet(.5,this.m_vertex1,.5,this.m_vertex2),t.I=0},o.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_vertex1),t.m_vertices.push(this.m_vertex2),t.m_count=2,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/create":52,"../util/options":53}],48:[function(t,i,e){function o(t){if(!(this instanceof o))return new o(t);o._super.call(this),this.m_type=o.TYPE,this.m_radius=l.polygonRadius,this.m_centroid=_.zero(),this.m_vertices=[],this.m_normals=[],this.m_count=0,t&&t.length&&this._set(t)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),a=t("../util/create"),m=(t("../util/options"),t("../common/Math")),h=t("../common/Transform"),c=t("../common/Rot"),_=t("../common/Vec2"),l=(t("../collision/AABB"),t("../Settings")),u=t("../Shape");o.prototype=a((o._super=u).prototype),o.TYPE="polygon",o.prototype.getVertex=function(t){return n&&r.assert(0<=t&&t<this.m_count),this.m_vertices[t]},o.prototype._clone=function(){var t=new o;t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_count=this.m_count,t.m_centroid.set(this.m_centroid);for(var i=0;i<this.m_count;i++)t.m_vertices.push(this.m_vertices[i].clone());for(i=0;i<this.m_normals.length;i++)t.m_normals.push(this.m_normals[i].clone());return t},o.prototype.getChildCount=function(){return 1},o.prototype._set=function(t){if(n&&r.assert(3<=t.length&&t.length<=l.maxPolygonVertices),t.length<3)this._setAsBox(1,1);else{for(var i=m.min(t.length,l.maxPolygonVertices),e=[],o=0,s=0;s<i;++s){for(var a=t[s],h=!0,c=0;c<o;++c)if(_.distanceSquared(a,e[c])<.25*l.linearSlopSquared){h=!1;break}h&&(e[o++]=a)}if((i=o)<3)return n&&r.assert(!1),void this._setAsBox(1,1);var u=0,p=e[0].x;for(s=1;s<i;++s){var d=e[s].x;(d>p||d==p&&e[s].y<e[u].y)&&(u=s,p=d)}for(var f=[],y=0,v=u;;){f[y]=v;var g=0;for(c=1;c<i;++c)if(g!=v){var x=_.sub(e[g],e[f[y]]),b=(a=_.sub(e[c],e[f[y]]),_.cross(x,a));b<0&&(g=c),0==b&&a.lengthSquared()>x.lengthSquared()&&(g=c)}else g=c;if(++y,v=g,g==u)break}if(y<3)return n&&r.assert(!1),void this._setAsBox(1,1);this.m_count=y;for(s=0;s<y;++s)this.m_vertices[s]=e[f[s]];for(s=0;s<y;++s){var A=s,w=s+1<y?s+1:0,B=_.sub(this.m_vertices[w],this.m_vertices[A]);n&&r.assert(B.lengthSquared()>m.EPSILON*m.EPSILON),this.m_normals[s]=_.cross(B,1),this.m_normals[s].normalize()}this.m_centroid=function(t,i){n&&r.assert(i>=3);for(var e=_.zero(),o=0,s=_.zero(),a=0;a<i;++a){var h=s,c=t[a],l=a+1<i?t[a+1]:t[0],u=_.sub(c,h),p=_.sub(l,h),d=.5*_.cross(u,p);o+=d,e.wAdd(d*(1/3),h),e.wAdd(d*(1/3),c),e.wAdd(d*(1/3),l)}return n&&r.assert(o>m.EPSILON),e.mul(1/o),e}(this.m_vertices,y)}},o.prototype._setAsBox=function(t,i,e,o){if(this.m_vertices[0]=_.neo(-t,-i),this.m_vertices[1]=_.neo(t,-i),this.m_vertices[2]=_.neo(t,i),this.m_vertices[3]=_.neo(-t,i),this.m_normals[0]=_.neo(0,-1),this.m_normals[1]=_.neo(1,0),this.m_normals[2]=_.neo(0,1),this.m_normals[3]=_.neo(-1,0),this.m_count=4,_.isValid(e)){o=o||0,this.m_centroid.set(e);var s=h.identity();s.p.set(e),s.q.set(o);for(var n=0;n<this.m_count;++n)this.m_vertices[n]=h.mul(s,this.m_vertices[n]),this.m_normals[n]=c.mul(s.q,this.m_normals[n])}},o.prototype.testPoint=function(t,i){for(var e=c.mulT(t.q,_.sub(i,t.p)),o=0;o<this.m_count;++o){if(_.dot(this.m_normals[o],_.sub(e,this.m_vertices[o]))>0)return!1}return!0},o.prototype.rayCast=function(t,i,e,o){for(var s=c.mulT(e.q,_.sub(i.p1,e.p)),a=c.mulT(e.q,_.sub(i.p2,e.p)),m=_.sub(a,s),h=0,l=i.maxFraction,u=-1,p=0;p<this.m_count;++p){var d=_.dot(this.m_normals[p],_.sub(this.m_vertices[p],s)),f=_.dot(this.m_normals[p],m);if(0==f){if(d<0)return!1}else f<0&&d<h*f?(h=d/f,u=p):f>0&&d<l*f&&(l=d/f);if(l<h)return!1}return n&&r.assert(0<=h&&h<=i.maxFraction),u>=0&&(t.fraction=h,t.normal=c.mul(e.q,this.m_normals[u]),!0)},o.prototype.computeAABB=function(t,i,e){for(var o=1/0,s=1/0,n=-1/0,r=-1/0,a=0;a<this.m_count;++a){var c=h.mul(i,this.m_vertices[a]);o=m.min(o,c.x),n=m.max(n,c.x),s=m.min(s,c.y),r=m.max(r,c.y)}t.lowerBound.set(o,s),t.upperBound.set(n,r),t.extend(this.m_radius)},o.prototype.computeMass=function(t,i){n&&r.assert(this.m_count>=3);for(var e=_.zero(),o=0,s=0,a=_.zero(),h=0;h<this.m_count;++h)a.add(this.m_vertices[h]);a.mul(1/this.m_count);for(h=0;h<this.m_count;++h){var c=_.sub(this.m_vertices[h],a),l=h+1<this.m_count?_.sub(this.m_vertices[h+1],a):_.sub(this.m_vertices[0],a),u=_.cross(c,l),p=.5*u;o+=p,e.wAdd(p*(1/3),c,p*(1/3),l);var d=c.x,f=c.y,y=l.x,v=l.y;s+=1/3*.25*u*(d*d+y*d+y*y+(f*f+v*f+v*v))}t.mass=i*o,n&&r.assert(o>m.EPSILON),e.mul(1/o),t.center.wSet(1,e,1,a),t.I=i*s,t.I+=t.mass*(_.dot(t.center,t.center)-_.dot(e,e))},o.prototype.validate=function(){for(var t=0;t<this.m_count;++t)for(var i=t,e=t<this.m_count-1?i+1:0,o=this.m_vertices[i],s=_.sub(this.m_vertices[e],o),n=0;n<this.m_count;++n)if(n!=i&&n!=e){var r=_.sub(this.m_vertices[n],o);if(_.cross(s,r)<0)return!1}return!0},o.prototype.computeDistanceProxy=function(t){t.m_vertices=this.m_vertices,t.m_count=this.m_count,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"../util/options":53}],49:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;i.exports=function(t){var i=[],e=t.max||1/0,o=t.create,s=t.allocate,n=t.release,r=t.discard,a=0,m=0,h=0,c=0;this.max=function(t){return"number"==typeof t?(e=t,this):e},this.size=function(){return i.length},this.allocate=function(){var t;return i.length>0?t=i.shift():(a++,t="function"==typeof o?o():{}),m++,"function"==typeof s&&s(t),t},this.release=function(t){i.length<e?(h++,"function"==typeof n&&n(t),i.push(t)):(c++,"function"==typeof r&&(t=r(t)))},this.toString=function(){return" +"+a+" >"+m+" <"+h+" -"+c+" ="+i.length+"/"+e}}},{}],50:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;i.exports.now=function(){return Date.now()},i.exports.diff=function(t){return Date.now()-t}},{}],51:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;e.debug=function(){o&&console.log.apply(console,arguments)},e.assert=function(t,i,e){if(s&&!t)throw e&&console.log(e),new Error(i)}},{}],52:[function(t,i,e){function o(){}"function"==typeof Object.create?i.exports=function(t,i){return Object.create.call(Object,t,i)}:i.exports=function(t,i){if(i)throw Error("Second argument is not supported!");if("object"!=typeof t||null===t)throw Error("Invalid prototype!");return o.prototype=t,new o}},{}],53:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;Object.prototype.propertyIsEnumerable;i.exports=function(t,i){null!==t&&void 0!==t||(t={});for(var e in i)i.hasOwnProperty(e)&&void 0===t[e]&&(t[e]=i[e]);if("function"==typeof Object.getOwnPropertySymbols)for(var o=Object.getOwnPropertySymbols(i),s=0;s<o.length;s++){var n=o[s];i.propertyIsEnumerable(n)&&void 0===t[e]&&(t[n]=i[n])}return t}},{}],54:[function(t,i,e){function o(t){return t}function s(t){if("function"==typeof t)return t;if("string"!=typeof t)return o;var i=n[t];if(i)return i;var e=/^(\w+)(-(in|out|in-out|out-in))?(\((.*)\))?$/i.exec(t);if(!e||!e.length)return o;var s=a[e[1]],m=r[e[3]],h=e[5];
// TODO: It can be a memory leak with different `params`.
return i=s&&s.fn?s.fn:s&&s.fc?s.fc.apply(s.fc,h&&h.replace(/\s+/,"").split(",")):o,m&&(i=m.fn(i)),n[t]=i,i}var n={},r={},a={};s.add=function(t){for(var i=(t.name||t.mode).split(/\s+/),e=0;e<i.length;e++){var o=i[e];o&&((t.name?a:r)[o]=t)}},s.add({mode:"in",fn:function(t){return t}}),s.add({mode:"out",fn:function(t){return function(i){return 1-t(1-i)}}}),s.add({mode:"in-out",fn:function(t){return function(i){return i<.5?t(2*i)/2:1-t(2*(1-i))/2}}}),s.add({mode:"out-in",fn:function(t){return function(i){return i<.5?1-t(2*(1-i))/2:t(2*i)/2}}}),s.add({name:"linear",fn:function(t){return t}}),s.add({name:"quad",fn:function(t){return t*t}}),s.add({name:"cubic",fn:function(t){return t*t*t}}),s.add({name:"quart",fn:function(t){return t*t*t*t}}),s.add({name:"quint",fn:function(t){return t*t*t*t*t}}),s.add({name:"sin sine",fn:function(t){return 1-Math.cos(t*Math.PI/2)}}),s.add({name:"exp expo",fn:function(t){return 0==t?0:Math.pow(2,10*(t-1))}}),s.add({name:"circle circ",fn:function(t){return 1-Math.sqrt(1-t*t)}}),s.add({name:"bounce",fn:function(t){return t<1/2.75?7.5625*t*t:t<2/2.75?7.5625*(t-=1.5/2.75)*t+.75:t<2.5/2.75?7.5625*(t-=2.25/2.75)*t+.9375:7.5625*(t-=2.625/2.75)*t+.984375}}),s.add({name:"poly",fc:function(t){return function(i){return Math.pow(i,t)}}}),s.add({name:"elastic",fc:function(t,i){i=i||.45,t=t||1;var e=i/(2*Math.PI)*Math.asin(1/t);return function(o){return 1+t*Math.pow(2,-10*o)*Math.sin((o-e)*(2*Math.PI)/i)}}}),s.add({name:"back",fc:function(t){return t=void 0!==t?t:1.70158,function(i){return i*i*((t+1)*i-t)}}}),i.exports=s},{}],55:[function(t,i,e){function o(t,i){if(this instanceof o){var e=t.viewport().ratio||1;t.on("viewport",function(t){e=t.ratio||e}),this.x=0,this.y=0,this.toString=function(){return(0|this.x)+"x"+(0|this.y)},this.locate=function(t){!function(t,i,e){
// pageX/Y if available?
i.touches&&i.touches.length?(e.x=i.touches[0].clientX,e.y=i.touches[0].clientY):(e.x=i.clientX,e.y=i.clientY);var o=t.getBoundingClientRect();e.x-=o.left,e.y-=o.top,e.x-=0|t.clientLeft,e.y-=0|t.clientTop}(i,t,this),this.x*=e,this.y*=e},this.lookup=function(i,e){this.type=i,this.root=t,this.event=null,e.length=0,this.collect=e,this.root.visit(this.visitor,this)},this.publish=function(i,e,o){if(this.type=i,this.root=t,this.event=e,this.collect=!1,this.timeStamp=Date.now(),o){for(;o.length&&!this.visitor.end(o.shift(),this););o.length=0}else this.root.visit(this.visitor,this)},this.visitor={reverse:!0,visible:!0,start:function(t,i){return!t._flag(i.type)},end:function(t,i){
// mouse: event/collect, type, root
n.raw=i.event,n.type=i.type,n.timeStamp=i.timeStamp,n.abs.x=i.x,n.abs.y=i.y;var e=t.listeners(i.type);if(e&&(t.matrix().inverse().map(i,n),(t===i.root||t.hitTest(n))&&(i.collect&&i.collect.push(t),i.event))){for(var o=!1,s=0;s<e.length;s++)o=!!e[s].call(t,n)||o;return o}}}}}function s(t,i,e){Object.defineProperty(t,i,{value:e})}t("../core")._load(function(t,i){o.subscribe(t,i)}),
// TODO: capture mouse
o.CLICK="click",o.START="touchstart mousedown",o.MOVE="touchmove mousemove",o.END="touchend mouseup",o.CANCEL="touchcancel mousecancel",o.subscribe=function(t,i){function e(i){i.preventDefault(),t.mouse.locate(i),
// DEBUG && console.log('Mouse Start: ' + event.type + ' ' + mouse);
t.mouse.publish(i.type,i),t.mouse.lookup("click",a),t.mouse.lookup("mousecancel",m)}function s(i){i.preventDefault(),t.mouse.locate(i),t.mouse.publish(i.type,i)}function n(i){i.preventDefault(),
// up/end location is not available, last one is used instead
// DEBUG && console.log('Mouse End: ' + event.type + ' ' + mouse);
t.mouse.publish(i.type,i),a.length&&
// DEBUG && console.log('Mouse Click: ' + clicklist.length);
t.mouse.publish("click",i,a),m.length=0}function r(i){m.length&&
// DEBUG && console.log('Mouse Cancel: ' + event.type);
t.mouse.publish("mousecancel",i,m),a.length=0}if(!t.mouse){t.mouse=new o(t,i),
// `click` events are synthesized from start/end events on same nodes
// `mousecancel` events are synthesized on blur or mouseup outside element
i.addEventListener("touchstart",e),i.addEventListener("touchend",n),i.addEventListener("touchmove",s),i.addEventListener("touchcancel",r),i.addEventListener("mousedown",e),i.addEventListener("mouseup",n),i.addEventListener("mousemove",s),document.addEventListener("mouseup",r),window.addEventListener("blur",r);var a=[],m=[]}};
// TODO: define per mouse object with get-only x and y
var n={},r={};s(n,"clone",function(t){return t=t||{},t.x=this.x,t.y=this.y,t}),s(n,"toString",function(){return(0|this.x)+"x"+(0|this.y)+" ("+this.abs+")"}),s(n,"abs",r),s(r,"clone",function(t){return t=t||{},t.x=this.x,t.y=this.y,t}),s(r,"toString",function(){return(0|this.x)+"x"+(0|this.y)}),i.exports=o},{"../core":60}],56:[function(t,i,e){function o(t,i,e){this._end={},this._duration=i||400,this._delay=e||0,this._owner=t,this._time=0}function s(t,i,e,o){"number"==typeof t.pin(e)?i[e]=o:"number"==typeof t.pin(e+"X")&&"number"==typeof t.pin(e+"Y")&&(i[e+"X"]=o,i[e+"Y"]=o)}var n=t("./easing"),r=t("../core"),a=t("../pin");r.prototype.tween=function(t,i,e){if("number"!=typeof t?(e=t,i=0,t=0):"number"!=typeof i&&(e=i,i=0),!this._tweens){this._tweens=[];var s=0;this.tick(function(t,i,e){if(this._tweens.length){
// ignore old elapsed
var o=s!=e;if(s=i,o)return!0;var n=this._tweens[0],r=n.tick(this,t,i,e);if(r&&n===this._tweens[0]&&this._tweens.shift(),"function"==typeof r)try{r.call(this)}catch(t){console.log(t)}return"object"==typeof r&&this._tweens.unshift(r),!0}},!0)}this.touch(),e||(this._tweens.length=0);var n=new o(this,t,i);return this._tweens.push(n),n},o.prototype.tick=function(t,i,e,o){if(this._time+=i,!(this._time<this._delay)){var s=this._time-this._delay;if(!this._start){this._start={};for(var n in this._end)this._start[n]=this._owner.pin(n)}var r,a;s<this._duration?(r=s/this._duration,a=!1):(r=1,a=!0),"function"==typeof this._easing&&(r=this._easing(r));var m=1-r;for(var n in this._end)this._owner.pin(n,this._start[n]*m+this._end[n]*r);return a?this._next||this._done||!0:void 0}},o.prototype.tween=function(t,i){return this._next=new o(this._owner,t,i)},o.prototype.duration=function(t){return this._duration=t,this},o.prototype.delay=function(t){return this._delay=t,this},o.prototype.ease=function(t){return this._easing=n(t),this},o.prototype.done=function(t){return this._done=t,this},o.prototype.hide=function(){return this.done(function(){this.hide()}),this},o.prototype.remove=function(){return this.done(function(){this.remove()}),this},o.prototype.pin=function(t,i){if("object"==typeof t)for(var e in t)s(this._owner,this._end,e,t[e]);else void 0!==i&&s(this._owner,this._end,t,i);return this},a._add_shortcuts(o),/**
 * @deprecated Use .done(fn) instead.
 */
o.prototype.then=function(t){return this.done(t),this},/**
 * @deprecated NOOP
 */
o.prototype.clear=function(t){return this},i.exports=o},{"../core":60,"../pin":68,"./easing":54}],57:[function(t,i,e){function o(){o._super.call(this),this.label("Anim"),this._textures=[],this._fps=s.Anim.FPS,this._ft=1e3/this._fps,this._time=-1,this._repeat=0,this._index=0,this._frames=[];var t=0;this.tick(function(i,e,o){if(!(this._time<0||this._frames.length<=1)){
// ignore old elapsed
var s=t!=o;if(t=e,s)return!0;if(this._time+=i,this._time<this._ft)return!0;var n=this._time/this._ft|0;return this._time-=n*this._ft,this.moveFrame(n),!(this._repeat>0&&(this._repeat-=n)<=0)||(this.stop(),this._callback&&this._callback(),!1)}},!1)}var s=t("./core");t("./pin"),t("./loop");var n=t("./util/create"),r=t("./util/math");s.anim=function(t,i){var e=new o;return e.frames(t).gotoFrame(0),i&&e.fps(i),e},o.prototype=n((o._super=s).prototype),
// TODO: replace with atlas fps or texture time
s.Anim={FPS:15},o.prototype.fps=function(t){return void 0===t?this._fps:(this._fps=t>0?t:s.Anim.FPS,this._ft=1e3/this._fps,this)},/**
 * @deprecated Use frames
 */
o.prototype.setFrames=function(t,i,e){return this.frames(t,i,e)},o.prototype.frames=function(t){return this._index=0,this._frames=s.texture(t).array(),this.touch(),this},o.prototype.length=function(){return this._frames?this._frames.length:0},o.prototype.gotoFrame=function(t,i){return this._index=0|r.rotate(t,this._frames.length),i=i||!this._textures[0],this._textures[0]=this._frames[this._index],i&&(this.pin("width",this._textures[0].width),this.pin("height",this._textures[0].height)),this.touch(),this},o.prototype.moveFrame=function(t){return this.gotoFrame(this._index+t)},o.prototype.repeat=function(t,i){return this._repeat=t*this._frames.length-1,this._callback=i,this.play(),this},o.prototype.play=function(t){return void 0!==t?(this.gotoFrame(t),this._time=0):this._time<0&&(this._time=0),this.touch(),this},o.prototype.stop=function(t){return this._time=-1,void 0!==t&&this.gotoFrame(t),this}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74,"./util/math":78}],58:[function(t,i,e){function o(t){function i(t){if(!t||c.fn(t.draw))return t;t=m({},t),c.fn(a)&&(t=a(t)),1!=h&&(t.x*=h,t.y*=h,t.width*=h,t.height*=h,t.top*=h,t.bottom*=h,t.left*=h,t.right*=h),0!=l&&(t.x+=l,t.y+=l,t.width-=2*l,t.height-=2*l,t.top-=l,t.bottom-=l,t.left-=l,t.right-=l);var i=r.pipe();return i.top=t.top,i.bottom=t.bottom,i.left=t.left,i.right=t.right,i.src(t.x,t.y,t.width,t.height),i}function e(t){if(u){if(c.fn(u))return u(t);if(c.hash(u))return u[t]}if(d){for(var i=null,e=0,o=0;o<d.length;o++)_.startsWith(d[o].name,t)&&(0===e?i=d[o]:1===e?i=[i,d[o]]:i.push(d[o]),e++);return 0===e&&c.fn(p)&&(i=function(i){return p(t+(i||""))}),i}}o._super.call(this);var r=this;n(t,"filter"),n(t,"cutouts"),n(t,"sprites"),n(t,"factory");var a=t.map||t.filter,h=t.ppu||t.ratio||1,l=t.trim||0,u=t.textures,p=t.factory,d=t.cutouts||t.sprites;this.select=function(t){if(!t)
// TODO: if `textures` is texture def, map or fn?
return new s(this.pipe());var o=e(t);return o?new s(o,e,i):void 0}}function s(t,i,e){function o(t,s){return t?c.fn(t.draw)?t:c.hash(t)&&c.number(t.width)&&c.number(t.height)&&c.fn(e)?e(t):c.hash(t)&&c.defined(s)?o(t[s]):c.fn(t)?o(t(s)):c.array(t)?o(t[0]):c.string(t)&&c.fn(i)?o(i(t)):void 0:p}this.one=function(i){return o(t,i)},this.array=function(i){var e=c.array(i)?i:[];if(c.array(t))for(var s=0;s<t.length;s++)e[s]=o(t[s]);else e[0]=o(t);return e}}function n(t,i,e){i in t&&console.log(e?e.replace("%name",i):"'"+i+"' field of texture atlas is deprecated.")}var r=t("./core"),a=t("./texture"),m=t("./util/extend"),h=t("./util/create"),c=t("./util/is"),_=t("./util/string"),l={},u=[];
// TODO: print subquery not found error
// TODO: index textures
r.atlas=function(t){var i=c.fn(t.draw)?t:new o(t);t.name&&(l[t.name]=i),u.push(i),n(t,"imagePath"),n(t,"imageRatio");var e=t.imagePath,s=t.imageRatio||1;return c.string(t.image)?e=t.image:c.hash(t.image)&&(e=t.image.src||t.image.url,s=t.image.ratio||s),e&&r.preload(function(t){e=r.resolve(e);r.config("image-loader")(e,function(e){i.src(e,s),t()},function(i){t()})}),i},o.prototype=h((o._super=a).prototype);var p=new a;p.x=p.y=p.width=p.height=0,p.pipe=p.src=p.dest=function(){return this},p.draw=function(){};var d=new s(p);r.texture=function(t){if(!c.string(t))return new s(t);var i,e,o=null;for((e=t.indexOf(":"))>0&&t.length>e+1&&(o=(i=l[t.slice(0,e)])&&i.select(t.slice(e+1))),!o&&(i=l[t])&&(o=i.select()),e=0;!o&&e<u.length;e++)o=u[e].select(t);return o||(console.error("Texture not found: "+t),o=d),o},i.exports=o},{"./core":60,"./texture":71,"./util/create":74,"./util/extend":76,"./util/is":77,"./util/string":81}],59:[function(t,i,e){var o=t("./core"),s=t("./texture");o.canvas=function(t,i,e){"string"==typeof t?"object"==typeof i||("function"==typeof i&&(e=i),i={}):("function"==typeof t&&(e=t),i={},t="2d");var o=document.createElement("canvas"),n=o.getContext(t,i),r=new s(o);return r.context=function(){return n},r.size=function(t,i,e){return e=e||1,o.width=t*e,o.height=i*e,this.src(o,e),this},r.canvas=function(t){return"function"==typeof t?t.call(this,n):void 0===t&&"function"==typeof e&&e.call(this,n),this},"function"==typeof e&&e.call(r,n),r}},{"./core":60,"./texture":71}],60:[function(t,i,e){function o(t){if(!(this instanceof o))return r.fn(t)?o.app.apply(o,arguments):r.object(t)?o.atlas.apply(o,arguments):t;s.create++;for(var i=0;i<m.length;i++)m[i].call(this)}var s=t("./util/stats"),n=t("./util/extend"),r=t("./util/is"),a=t("./util/await");s.create=0;var m=[];o._init=function(t){m.push(t)};var h=[];o._load=function(t){h.push(t)};var c={};o.config=function(){if(1===arguments.length&&r.string(arguments[0]))return c[arguments[0]];1===arguments.length&&r.object(arguments[0])&&n(c,arguments[0]),2===arguments.length&&r.string(arguments[0])&&(arguments[0],arguments[1])};var _=[],l=[],u=!1,p=!1;o.app=function(t,i){if(u){o.config("app-loader")(function(i,e){for(var o=0;o<h.length;o++)h[o].call(this,i,e);t(i,e),l.push(i),i.start()},i)}else _.push(arguments)};var d=a();o.preload=function(t){if("string"==typeof t){var i=o.resolve(t);/\.js($|\?|\#)/.test(i)&&(t=function(t){!function(t,i){var e=document.createElement("script");e.addEventListener("load",function(){i()}),e.addEventListener("error",function(e){i(e||"Error loading script: "+t)}),e.src=t,e.id="preload-"+Date.now(),document.body.appendChild(e)}(i,t)})}"function"==typeof t&&
// if (!_started) {
// _preload_queue.push(load);
// return;
// }
t(d())},o.start=function(t){o.config(t),
// DEBUG && console.log('Preloading...');
// _started = true;
// while (_preload_queue.length) {
// var load = _preload_queue.shift();
// load(loading());
// }
d.then(function(){for(u=!0;_.length;){var t=_.shift();o.app.apply(o,t)}})},o.pause=function(){if(!p){p=!0;for(var t=l.length-1;t>=0;t--)l[t].pause()}},o.resume=function(){if(p){p=!1;for(var t=l.length-1;t>=0;t--)l[t].resume()}},o.create=function(){return new o},o.resolve=function(){if("undefined"==typeof window||"undefined"==typeof document)return function(t){return t};var t=document.getElementsByTagName("script");return function(i){if(/^\.\//.test(i)){var e=function(){
// HTML5
if(document.currentScript)return document.currentScript.src;
// IE>=10
var i;try{var e=new Error;if(!e.stack)throw e;i=e.stack}catch(e){i=e.stack}if("string"==typeof i)
// Uses the last line, where the call started
for(var o=(i=i.split("\n")).length;o--;){var s=i[o].match(/(\w+\:\/\/[^/]*?\/.+?)(:\d+)(:\d+)?/);if(s)return s[1]}
// IE<11
if(t.length&&"readyState"in t[0])for(o=t.length;o--;)if("interactive"===t[o].readyState)return t[o].src;return location.href}();i=e.substring(0,e.lastIndexOf("/")+1)+i.substring(2)}return i}}(),i.exports=o},{"./util/await":73,"./util/extend":76,"./util/is":77,"./util/stats":80}],61:[function(t,i,e){t("./util/event")(t("./core").prototype,function(t,i,e){t._flag(i,e)})},{"./core":60,"./util/event":75}],62:[function(t,i,e){function o(){o._super.call(this),this.label("Image"),this._textures=[],this._image=null}var s=t("./core");t("./pin"),t("./loop");var n=t("./util/repeat"),r=t("./util/create");i.exports=o,s.image=function(t){var i=new o;return t&&i.image(t),i},/**
 * @deprecated Use image
 */
(o.prototype=r((o._super=s).prototype)).setImage=function(t,i,e){return this.image(t,i,e)},o.prototype.image=function(t){return this._image=s.texture(t).one(),this.pin("width",this._image?this._image.width:0),this.pin("height",this._image?this._image.height:0),this._textures[0]=this._image.pipe(),this._textures.length=1,this},o.prototype.tile=function(t){return this._repeat(!1,t),this},o.prototype.stretch=function(t){return this._repeat(!0,t),this},o.prototype._repeat=function(t,i){function e(t,i,e,s,n,r,a,m,h){var c=o._textures.length>t?o._textures[t]:o._textures[t]=o._image.pipe();c.src(i,e,s,n),c.dest(r,a,m,h)}var o=this;this.untick(this._repeatTicker),this.tick(this._repeatTicker=function(){if(this._mo_stretch!=this._pin._ts_transform){this._mo_stretch=this._pin._ts_transform;var o=this.pin("width"),s=this.pin("height");this._textures.length=n(this._image,o,s,t,i,e)}})}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74,"./util/repeat":79}],63:[function(t,i,e){i.exports=t("./core"),i.exports.Matrix=t("./matrix"),i.exports.Texture=t("./texture"),t("./atlas"),t("./tree"),t("./event"),t("./pin"),t("./loop"),t("./root")},{"./atlas":58,"./core":60,"./event":61,"./loop":66,"./matrix":67,"./pin":68,"./root":69,"./texture":71,"./tree":72}],64:[function(t,i,e){var o=t("./core");t("./pin"),t("./loop");t("./util/create");o.row=function(t){return o.create().row(t).label("Row")},o.prototype.row=function(t){return this.sequence("row",t),this},o.column=function(t){return o.create().column(t).label("Row")},o.prototype.column=function(t){return this.sequence("column",t),this},o.sequence=function(t,i){return o.create().sequence(t,i).label("Sequence")},o.prototype.sequence=function(t,i){return this._padding=this._padding||0,this._spacing=this._spacing||0,this.untick(this._layoutTiker),this.tick(this._layoutTiker=function(){if(this._mo_seq!=this._ts_touch){this._mo_seq=this._ts_touch;var e=this._mo_seqAlign!=this._ts_children;this._mo_seqAlign=this._ts_children;for(var o,s=0,n=0,r=this.first(!0),a=!0;o=r;){r=o.next(!0),o.matrix(!0);var m=o.pin("boxWidth"),h=o.pin("boxHeight");"column"==t?(!a&&(n+=this._spacing),o.pin("offsetY")!=n&&o.pin("offsetY",n),s=Math.max(s,m),n+=h,e&&o.pin("alignX",i)):"row"==t&&(!a&&(s+=this._spacing),o.pin("offsetX")!=s&&o.pin("offsetX",s),s+=m,n=Math.max(n,h),e&&o.pin("alignY",i)),a=!1}s+=2*this._padding,n+=2*this._padding,this.pin("width")!=s&&this.pin("width",s),this.pin("height")!=n&&this.pin("height",n)}}),this},o.box=function(){return o.create().box().label("Box")},o.prototype.box=function(){return this._padding=this._padding||0,this.untick(this._layoutTiker),this.tick(this._layoutTiker=function(){if(this._mo_box!=this._ts_touch){this._mo_box=this._ts_touch;for(var t,i=0,e=0,o=this.first(!0);t=o;){o=t.next(!0),t.matrix(!0);var s=t.pin("boxWidth"),n=t.pin("boxHeight");i=Math.max(i,s),e=Math.max(e,n)}i+=2*this._padding,e+=2*this._padding,this.pin("width")!=i&&this.pin("width",i),this.pin("height")!=e&&this.pin("height",e)}}),this},o.layer=function(){return o.create().layer().label("Layer")},o.prototype.layer=function(){return this.untick(this._layoutTiker),this.tick(this._layoutTiker=function(){var t=this.parent();if(t){var i=t.pin("width");this.pin("width")!=i&&this.pin("width",i);var e=t.pin("height");this.pin("height")!=e&&this.pin("height",e)}},!0),this},
// TODO: move padding to pin
o.prototype.padding=function(t){return this._padding=t,this},o.prototype.spacing=function(t){return this._spacing=t,this}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74}],65:[function(t,i,e){var o=t("../core");o._supported=function(){var t=document.createElement("canvas");return!(!t.getContext||!t.getContext("2d"))}(),window.addEventListener("load",function(){o._supported&&o.start()},!1),o.config({"app-loader":function(t,i){function e(){r.setTransform(1,0,0,1,0,0),r.clearRect(0,0,m,h),d.render(r)}function s(){a?(
// screen.availWidth/Height?
m=window.innerWidth>0?window.innerWidth:screen.width,h=window.innerHeight>0?window.innerHeight:screen.height,n.style.width=m+"px",n.style.height=h+"px"):(m=n.clientWidth,h=n.clientHeight),m*=c,h*=c,n.width===m&&n.height===h||(n.width=m,n.height=h,d.viewport(m,h,c),e())}var n=(i=i||{}).canvas,r=null,a=!1,m=0,h=0,c=1;if("string"==typeof n&&(n=document.getElementById(n)),n||(n=document.getElementById("cutjs")||document.getElementById("stage")),!n){a=!0,(n=document.createElement("canvas")).style.position="absolute",n.style.top="0",n.style.left="0";var _=document.body;_.insertBefore(n,_.firstChild)}r=n.getContext("2d");var l=window.devicePixelRatio||1,u=r.webkitBackingStorePixelRatio||r.mozBackingStorePixelRatio||r.msBackingStorePixelRatio||r.oBackingStorePixelRatio||r.backingStorePixelRatio||1;c=l/u;var p=window.requestAnimationFrame||window.msRequestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.oRequestAnimationFrame||function(t){return window.setTimeout(t,1e3/60)},d=o.root(p,e);d.background=function(t){return n.style.backgroundColor=t,this},t(d,n),s(),window.addEventListener("resize",s,!1),window.addEventListener("orientationchange",s,!1)},"image-loader":function(t,i,e){var o=new Image;o.onload=function(){i(o)},o.onerror=e,o.src=t}})},{"../core":60}],66:[function(t,i,e){var o=t("./core");t("./pin");var s=t("./util/stats");o.prototype._textures=null,o.prototype._alpha=1,o.prototype.render=function(t){if(this._visible){s.node++;var i=this.matrix();t.setTransform(i.a,i.b,i.c,i.d,i.e,i.f),
// move this elsewhere!
this._alpha=this._pin._alpha*(this._parent?this._parent._alpha:1);var e=this._pin._textureAlpha*this._alpha;if(t.globalAlpha!=e&&(t.globalAlpha=e),null!==this._textures)for(var o=0,n=this._textures.length;o<n;o++)this._textures[o].draw(t);t.globalAlpha!=this._alpha&&(t.globalAlpha=this._alpha);for(var r,a=this._first;r=a;)a=r._next,r.render(t)}},o.prototype._tickBefore=null,o.prototype._tickAfter=null,o.prototype.MAX_ELAPSE=1/0,o.prototype._tick=function(t,i,e){if(this._visible){t>this.MAX_ELAPSE&&(t=this.MAX_ELAPSE);var o=!1;if(null!==this._tickBefore)for(var n=0;n<this._tickBefore.length;n++){s.tick++;o=!0===this._tickBefore[n].call(this,t,i,e)||o}for(var r,a=this._first;r=a;)a=r._next,r._flag("_tick")&&(o=!0===r._tick(t,i,e)||o);if(null!==this._tickAfter)for(n=0;n<this._tickAfter.length;n++){s.tick++;o=!0===this._tickAfter[n].call(this,t,i,e)||o}return o}},o.prototype.tick=function(t,i){"function"==typeof t&&(i?(null===this._tickBefore&&(this._tickBefore=[]),this._tickBefore.push(t)):(null===this._tickAfter&&(this._tickAfter=[]),this._tickAfter.push(t)),this._flag("_tick",null!==this._tickAfter&&this._tickAfter.length>0||null!==this._tickBefore&&this._tickBefore.length>0))},o.prototype.untick=function(t){if("function"==typeof t){var i;null!==this._tickBefore&&(i=this._tickBefore.indexOf(t))>=0&&this._tickBefore.splice(i,1),null!==this._tickAfter&&(i=this._tickAfter.indexOf(t))>=0&&this._tickAfter.splice(i,1)}},o.prototype.timeout=function(t,i){this.setTimeout(t,i)},o.prototype.setTimeout=function(t,i){function e(o){if(!((i-=o)<0))return!0;this.untick(e),t.call(this)}return this.tick(e),e},o.prototype.clearTimeout=function(t){this.untick(t)}},{"./core":60,"./pin":68,"./util/stats":80}],67:[function(t,i,e){function o(t,i,e,o,s,n){this.reset(t,i,e,o,s,n)}o.prototype.toString=function(){return"["+this.a+", "+this.b+", "+this.c+", "+this.d+", "+this.e+", "+this.f+"]"},o.prototype.clone=function(){return new o(this.a,this.b,this.c,this.d,this.e,this.f)},o.prototype.reset=function(t,i,e,o,s,n){return this._dirty=!0,"object"==typeof t?(this.a=t.a,this.d=t.d,this.b=t.b,this.c=t.c,this.e=t.e,this.f=t.f):(this.a=t||1,this.d=o||1,this.b=i||0,this.c=e||0,this.e=s||0,this.f=n||0),this},o.prototype.identity=function(){return this._dirty=!0,this.a=1,this.b=0,this.c=0,this.d=1,this.e=0,this.f=0,this},o.prototype.rotate=function(t){if(!t)return this;this._dirty=!0;var i=t?Math.cos(t):1,e=t?Math.sin(t):0,o=i*this.a-e*this.b,s=i*this.b+e*this.a,n=i*this.c-e*this.d,r=i*this.d+e*this.c,a=i*this.e-e*this.f,m=i*this.f+e*this.e;return this.a=o,this.b=s,this.c=n,this.d=r,this.e=a,this.f=m,this},o.prototype.translate=function(t,i){return t||i?(this._dirty=!0,this.e+=t,this.f+=i,this):this},o.prototype.scale=function(t,i){return t-1||i-1?(this._dirty=!0,this.a*=t,this.b*=i,this.c*=t,this.d*=i,this.e*=t,this.f*=i,this):this},o.prototype.skew=function(t,i){if(!t&&!i)return this;this._dirty=!0;var e=this.a+this.b*t,o=this.b+this.a*i,s=this.c+this.d*t,n=this.d+this.c*i,r=this.e+this.f*t,a=this.f+this.e*i;return this.a=e,this.b=o,this.c=s,this.d=n,this.e=r,this.f=a,this},o.prototype.concat=function(t){this._dirty=!0;var i=this.a*t.a+this.b*t.c,e=this.b*t.d+this.a*t.b,o=this.c*t.a+this.d*t.c,s=this.d*t.d+this.c*t.b,n=this.e*t.a+t.e+this.f*t.c,r=this.f*t.d+t.f+this.e*t.b;return this.a=i,this.b=e,this.c=o,this.d=s,this.e=n,this.f=r,this},o.prototype.inverse=o.prototype.reverse=function(){if(this._dirty){this._dirty=!1,this.inversed=this.inversed||new o;var t=this.a*this.d-this.b*this.c;this.inversed.a=this.d/t,this.inversed.b=-this.b/t,this.inversed.c=-this.c/t,this.inversed.d=this.a/t,this.inversed.e=(this.c*this.f-this.e*this.d)/t,this.inversed.f=(this.e*this.b-this.a*this.f)/t}return this.inversed},o.prototype.map=function(t,i){return i=i||{},i.x=this.a*t.x+this.c*t.y+this.e,i.y=this.b*t.x+this.d*t.y+this.f,i},o.prototype.mapX=function(t,i){return"object"==typeof t&&(i=t.y,t=t.x),this.a*t+this.c*i+this.e},o.prototype.mapY=function(t,i){return"object"==typeof t&&(i=t.y,t=t.x),this.b*t+this.d*i+this.f},i.exports=o},{}],68:[function(t,i,e){function o(t){this._owner=t,this._parent=null,
// relative to parent
this._relativeMatrix=new r,
// relative to stage
this._absoluteMatrix=new r,this.reset()}function s(t,i,e,o){var s="number"==typeof i,n="number"==typeof e,r="string"==typeof o;t._ts_transform=++a,s&&(t._scaleX=i/t._width_,t._width=t._width_),n&&(t._scaleY=e/t._height_,t._height=t._height_),s&&n&&r&&("out"==o||"out-crop"==o?t._scaleX=t._scaleY=Math.max(t._scaleX,t._scaleY):"in"!=o&&"in-pad"!=o||(t._scaleX=t._scaleY=Math.min(t._scaleX,t._scaleY)),"out-crop"!=o&&"in-pad"!=o||(t._width=i/t._scaleX,t._height=e/t._scaleY))}var n=t("./core"),r=t("./matrix"),a=0;n._init(function(){this._pin=new o(this)}),n.prototype.matrix=function(t){return!0===t?this._pin.relativeMatrix():this._pin.absoluteMatrix()},n.prototype.pin=function(t,i){return"object"==typeof t?(this._pin.set(t),this):"string"==typeof t?void 0===i?this._pin.get(t):(this._pin.set(t,i),this):void 0===t?this._pin:void 0},o.prototype.reset=function(){this._textureAlpha=1,this._alpha=1,this._width=0,this._height=0,this._scaleX=1,this._scaleY=1,this._skewX=0,this._skewY=0,this._rotation=0,
// scale/skew/rotate center
this._pivoted=!1,this._pivotX=null,this._pivotY=null,
// self pin point
this._handled=!1,this._handleX=0,this._handleY=0,
// parent pin point
this._aligned=!1,this._alignX=0,this._alignY=0,
// as seen by parent px
this._offsetX=0,this._offsetY=0,this._boxX=0,this._boxY=0,this._boxWidth=this._width,this._boxHeight=this._height,
// TODO: also set for owner
this._ts_translate=++a,this._ts_transform=++a,this._ts_matrix=++a},o.prototype._update=function(){
// if handled and transformed then be translated
return this._parent=this._owner._parent&&this._owner._parent._pin,this._handled&&this._mo_handle!=this._ts_transform&&(this._mo_handle=this._ts_transform,this._ts_translate=++a),this._aligned&&this._parent&&this._mo_align!=this._parent._ts_transform&&(this._mo_align=this._parent._ts_transform,this._ts_translate=++a),this},o.prototype.toString=function(){return this._owner+" ("+(this._parent?this._parent._owner:null)+")"},
// TODO: ts fields require refactoring
o.prototype.absoluteMatrix=function(){this._update();var t=Math.max(this._ts_transform,this._ts_translate,this._parent?this._parent._ts_matrix:0);if(this._mo_abs==t)return this._absoluteMatrix;this._mo_abs=t;var i=this._absoluteMatrix;return i.reset(this.relativeMatrix()),this._parent&&i.concat(this._parent._absoluteMatrix),this._ts_matrix=++a,i},o.prototype.relativeMatrix=function(){this._update();var t=Math.max(this._ts_transform,this._ts_translate,this._parent?this._parent._ts_transform:0);if(this._mo_rel==t)return this._relativeMatrix;this._mo_rel=t;var i=this._relativeMatrix;
// calculate effective box
if(i.identity(),this._pivoted&&i.translate(-this._pivotX*this._width,-this._pivotY*this._height),i.scale(this._scaleX,this._scaleY),i.skew(this._skewX,this._skewY),i.rotate(this._rotation),this._pivoted&&i.translate(this._pivotX*this._width,this._pivotY*this._height),this._pivoted)
// origin
this._boxX=0,this._boxY=0,this._boxWidth=this._width,this._boxHeight=this._height;else{
// aabb
var e,o;i.a>0&&i.c>0||i.a<0&&i.c<0?(e=0,o=i.a*this._width+i.c*this._height):(e=i.a*this._width,o=i.c*this._height),e>o?(this._boxX=o,this._boxWidth=e-o):(this._boxX=e,this._boxWidth=o-e),i.b>0&&i.d>0||i.b<0&&i.d<0?(e=0,o=i.b*this._width+i.d*this._height):(e=i.b*this._width,o=i.d*this._height),e>o?(this._boxY=o,this._boxHeight=e-o):(this._boxY=e,this._boxHeight=o-e)}return this._x=this._offsetX,this._y=this._offsetY,this._x-=this._boxX+this._handleX*this._boxWidth,this._y-=this._boxY+this._handleY*this._boxHeight,this._aligned&&this._parent&&(this._parent.relativeMatrix(),this._x+=this._alignX*this._parent._width,this._y+=this._alignY*this._parent._height),i.translate(this._x,this._y),this._relativeMatrix},o.prototype.get=function(t){if("function"==typeof m[t])return m[t](this)},
// TODO: Use defineProperty instead? What about multi-field pinning?
o.prototype.set=function(t,i){if("string"==typeof t)"function"==typeof h[t]&&void 0!==i&&h[t](this,i);else if("object"==typeof t)for(i in t)"function"==typeof h[i]&&void 0!==t[i]&&h[i](this,t[i],t);return this._owner&&(this._owner._ts_pin=++a,this._owner.touch()),this};var m={alpha:function(t){return t._alpha},textureAlpha:function(t){return t._textureAlpha},width:function(t){return t._width},height:function(t){return t._height},boxWidth:function(t){return t._boxWidth},boxHeight:function(t){return t._boxHeight},
// scale : function(pin) {
// },
scaleX:function(t){return t._scaleX},scaleY:function(t){return t._scaleY},
// skew : function(pin) {
// },
skewX:function(t){return t._skewX},skewY:function(t){return t._skewY},rotation:function(t){return t._rotation},
// pivot : function(pin) {
// },
pivotX:function(t){return t._pivotX},pivotY:function(t){return t._pivotY},
// offset : function(pin) {
// },
offsetX:function(t){return t._offsetX},offsetY:function(t){return t._offsetY},
// align : function(pin) {
// },
alignX:function(t){return t._alignX},alignY:function(t){return t._alignY},
// handle : function(pin) {
// },
handleX:function(t){return t._handleX},handleY:function(t){return t._handleY}},h={alpha:function(t,i){t._alpha=i},textureAlpha:function(t,i){t._textureAlpha=i},width:function(t,i){t._width_=i,t._width=i,t._ts_transform=++a},height:function(t,i){t._height_=i,t._height=i,t._ts_transform=++a},scale:function(t,i){t._scaleX=i,t._scaleY=i,t._ts_transform=++a},scaleX:function(t,i){t._scaleX=i,t._ts_transform=++a},scaleY:function(t,i){t._scaleY=i,t._ts_transform=++a},skew:function(t,i){t._skewX=i,t._skewY=i,t._ts_transform=++a},skewX:function(t,i){t._skewX=i,t._ts_transform=++a},skewY:function(t,i){t._skewY=i,t._ts_transform=++a},rotation:function(t,i){t._rotation=i,t._ts_transform=++a},pivot:function(t,i){t._pivotX=i,t._pivotY=i,t._pivoted=!0,t._ts_transform=++a},pivotX:function(t,i){t._pivotX=i,t._pivoted=!0,t._ts_transform=++a},pivotY:function(t,i){t._pivotY=i,t._pivoted=!0,t._ts_transform=++a},offset:function(t,i){t._offsetX=i,t._offsetY=i,t._ts_translate=++a},offsetX:function(t,i){t._offsetX=i,t._ts_translate=++a},offsetY:function(t,i){t._offsetY=i,t._ts_translate=++a},align:function(t,i){this.alignX(t,i),this.alignY(t,i)},alignX:function(t,i){t._alignX=i,t._aligned=!0,t._ts_translate=++a,this.handleX(t,i)},alignY:function(t,i){t._alignY=i,t._aligned=!0,t._ts_translate=++a,this.handleY(t,i)},handle:function(t,i){this.handleX(t,i),this.handleY(t,i)},handleX:function(t,i){t._handleX=i,t._handled=!0,t._ts_translate=++a},handleY:function(t,i){t._handleY=i,t._handled=!0,t._ts_translate=++a},resizeMode:function(t,i,e){e&&("in"==i?i="in-pad":"out"==i&&(i="out-crop"),s(t,e.resizeWidth,e.resizeHeight,i))},resizeWidth:function(t,i,e){e&&e.resizeMode||s(t,i,null)},resizeHeight:function(t,i,e){e&&e.resizeMode||s(t,null,i)},scaleMode:function(t,i,e){e&&s(t,e.scaleWidth,e.scaleHeight,i)},scaleWidth:function(t,i,e){e&&e.scaleMode||s(t,i,null)},scaleHeight:function(t,i,e){e&&e.scaleMode||s(t,null,i)},matrix:function(t,i){this.scaleX(t,i.a),this.skewX(t,i.c/i.d),this.skewY(t,i.b/i.a),this.scaleY(t,i.d),this.offsetX(t,i.e),this.offsetY(t,i.f),this.rotation(t,0)}};n.prototype.scaleTo=function(t,i,e){return"object"==typeof t&&(e=i,i=t.y,t=t.x),s(this._pin,t,i,e),this},
// Used by Tween class
o._add_shortcuts=function(t){t.prototype.size=function(t,i){return this.pin("width",t),this.pin("height",i),this},t.prototype.width=function(t){return void 0===t?this.pin("width"):(this.pin("width",t),this)},t.prototype.height=function(t){return void 0===t?this.pin("height"):(this.pin("height",t),this)},t.prototype.offset=function(t,i){return"object"==typeof t&&(i=t.y,t=t.x),this.pin("offsetX",t),this.pin("offsetY",i),this},t.prototype.rotate=function(t){return this.pin("rotation",t),this},t.prototype.skew=function(t,i){return"object"==typeof t?(i=t.y,t=t.x):void 0===i&&(i=t),this.pin("skewX",t),this.pin("skewY",i),this},t.prototype.scale=function(t,i){return"object"==typeof t?(i=t.y,t=t.x):void 0===i&&(i=t),this.pin("scaleX",t),this.pin("scaleY",i),this},t.prototype.alpha=function(t,i){return this.pin("alpha",t),void 0!==i&&this.pin("textureAlpha",i),this}},o._add_shortcuts(n),i.exports=o},{"./core":60,"./matrix":67}],69:[function(t,i,e){function o(t,i){o._super.call(this),this.label("Root");var e=!0,s=this,r=0,a=function(o){if(!0!==e){n.tick=n.node=n.draw=0;var m=r||o,h=o-m;r=o;var c=s._tick(h,o,m);s._mo_touch!=s._ts_touch?(s._mo_touch=s._ts_touch,i(s),t(a)):c?t(a):e=!0,n.fps=h?1e3/h:0}};this.start=function(){return this.resume()},this.resume=function(){return e&&(this.publish("resume"),e=!1,t(a)),this},this.pause=function(){return e||this.publish("pause"),e=!0,this},this.touch_root=this.touch,this.touch=function(){return this.resume(),this.touch_root()}}var s=t("./core");t("./pin"),t("./loop");var n=t("./util/stats"),r=t("./util/create"),a=t("./util/extend");o.prototype=r((o._super=s).prototype),s.root=function(t,i){return new o(t,i)},o.prototype.background=function(t){
// to be implemented by loaders
return this},o.prototype.viewport=function(t,i,e){if(void 0===t)return a({},this._viewport);this._viewport={width:t,height:i,ratio:e||1},this.viewbox();var o=a({},this._viewport);return this.visit({start:function(t){if(!t._flag("viewport"))return!0;t.publish("viewport",[o])}}),this},
// TODO: static/fixed viewbox
o.prototype.viewbox=function(t,i,e){"number"==typeof t&&"number"==typeof i&&(this._viewbox={width:t,height:i,mode:/^(in|out|in-pad|out-crop)$/.test(e)?e:"in-pad"});var o=this._viewbox,s=this._viewport;return s&&o?(this.pin({width:o.width,height:o.height}),this.scaleTo(s.width,s.height,o.mode)):s&&this.pin({width:s.width,height:s.height}),this}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74,"./util/extend":76,"./util/stats":80}],70:[function(t,i,e){function o(){o._super.call(this),this.label("String"),this._textures=[]}var s=t("./core");t("./pin"),t("./loop");var n=t("./util/create"),r=t("./util/is");s.string=function(t){return(new o).frames(t)},/**
 * @deprecated Use frames
 */
(o.prototype=n((o._super=s).prototype)).setFont=function(t,i,e){return this.frames(t,i,e)},o.prototype.frames=function(t){return this._textures=[],"string"==typeof t?(t=s.texture(t),this._item=function(i){return t.one(i)}):"object"==typeof t?this._item=function(i){return t[i]}:"function"==typeof t&&(this._item=t),this},/**
 * @deprecated Use value
 */
o.prototype.setValue=function(t,i,e){return this.value(t,i,e)},o.prototype.value=function(t){if(void 0===t)return this._value;if(this._value===t)return this;this._value=t,null===t?t="":"string"==typeof t||r.array(t)||(t=t.toString()),this._spacing=this._spacing||0;for(var i=0,e=0,o=0;o<t.length;o++){var s=this._textures[o]=this._item(t[o]);i+=o>0?this._spacing:0,s.dest(i,0),i+=s.width,e=Math.max(e,s.height)}return this.pin("width",i),this.pin("height",e),this._textures.length=t.length,this}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74,"./util/is":77}],71:[function(t,i,e){function o(t,i){"object"==typeof t&&this.src(t,i)}var s=t("./util/stats"),n=t("./util/math");o.prototype.pipe=function(){return new o(this)},/**
 * Signatures: (image), (x, y, w, h), (w, h)
 */
o.prototype.src=function(t,i,e,o){if("object"==typeof t){var s=t,n=i||1;this._image=s,this._sx=this._dx=0,this._sy=this._dy=0,this._sw=this._dw=s.width/n,this._sh=this._dh=s.height/n,this.width=s.width/n,this.height=s.height/n,this.ratio=n}else void 0===e?(e=t,o=i):(this._sx=t,this._sy=i),this._sw=this._dw=e,this._sh=this._dh=o,this.width=e,this.height=o;return this},/**
 * Signatures: (x, y, w, h), (x, y)
 */
o.prototype.dest=function(t,i,e,o){return this._dx=t,this._dy=i,this._dx=t,this._dy=i,void 0!==e&&(this._dw=e,this._dh=o,this.width=e,this.height=o),this},o.prototype.draw=function(t,i,e,o,r,a,m,h,c){var _=this._image;if(null!==_&&"object"==typeof _){var l=this._sx,u=this._sy,p=this._sw,d=this._sh,f=this._dx,y=this._dy,v=this._dw,g=this._dh;void 0!==a?(i=n.limit(i,0,this._sw),o=n.limit(o,0,this._sw-i),l+=i,u+=e=n.limit(e,0,this._sh),p=o,d=r=n.limit(r,0,this._sh-e),f=a,y=m,v=h,g=c):void 0!==o?(f=i,y=e,v=o,g=r):void 0!==i&&(v=i,g=e);var x=this.ratio||1;l*=x,u*=x,p*=x,d*=x;try{"function"==typeof _.draw?_.draw(t,l,u,p,d,f,y,v,g):(s.draw++,t.drawImage(_,l,u,p,d,f,y,v,g))}catch(t){_._draw_failed||(console.log("Unable to draw: ",_),console.log(t),_._draw_failed=!0)}}},i.exports=o},{"./util/math":78,"./util/stats":80}],72:[function(t,i,e){function o(t,i){a(i),a(t),i.remove(),t._last&&(t._last._next=i,i._prev=t._last),i._parent=t,t._last=i,t._first||(t._first=i),i._parent._flag(i,!0),i._ts_parent=++c,t._ts_children=++c,t.touch()}function s(t,i){a(i),a(t),i.remove(),t._first&&(t._first._prev=i,i._next=t._first),i._parent=t,t._first=i,t._last||(t._last=i),i._parent._flag(i,!0),i._ts_parent=++c,t._ts_children=++c,t.touch()}function n(t,i){a(t),a(i),t.remove();var e=i._parent,o=i._prev;i._prev=t,o&&(o._next=t)||e&&(e._first=t),t._parent=e,t._prev=o,t._next=i,t._parent._flag(t,!0),t._ts_parent=++c,t.touch()}function r(t,i){a(t),a(i),t.remove();var e=i._parent,o=i._next;i._next=t,o&&(o._prev=t)||e&&(e._last=t),t._parent=e,t._prev=i,t._next=o,t._parent._flag(t,!0),t._ts_parent=++c,t.touch()}function a(t){if(t&&t instanceof m)return t;throw"Invalid node: "+t}var m=t("./core"),h=t("./util/is"),c=0;
// TODO: do not clear next/prev/parent on remove
m.prototype._label="",m.prototype._visible=!0,m.prototype._parent=null,m.prototype._next=null,m.prototype._prev=null,m.prototype._first=null,m.prototype._last=null,m.prototype._attrs=null,m.prototype._flags=null,m.prototype.toString=function(){return"["+this._label+"]"},/**
 * @deprecated Use label()
 */
m.prototype.id=function(t){return this.label(t)},m.prototype.label=function(t){return void 0===t?this._label:(this._label=t,this)},m.prototype.attr=function(t,i){return void 0===i?null!==this._attrs?this._attrs[t]:void 0:((null!==this._attrs?this._attrs:this._attrs={})[t]=i,this)},m.prototype.visible=function(t){return void 0===t?this._visible:(this._visible=t,this._parent&&(this._parent._ts_children=++c),this._ts_pin=++c,this.touch(),this)},m.prototype.hide=function(){return this.visible(!1)},m.prototype.show=function(){return this.visible(!0)},m.prototype.parent=function(){return this._parent},m.prototype.next=function(t){for(var i=this._next;i&&t&&!i._visible;)i=i._next;return i},m.prototype.prev=function(t){for(var i=this._prev;i&&t&&!i._visible;)i=i._prev;return i},m.prototype.first=function(t){for(var i=this._first;i&&t&&!i._visible;)i=i._next;return i},m.prototype.last=function(t){for(var i=this._last;i&&t&&!i._visible;)i=i._prev;return i},m.prototype.visit=function(t,i){var e=t.reverse,o=t.visible;if(!t.start||!t.start(this,i)){for(var s,n=e?this.last(o):this.first(o);s=n;)if(n=e?s.prev(o):s.next(o),s.visit(t,i))return!0;return t.end&&t.end(this,i)}},m.prototype.append=function(t,i){if(h.array(t))for(var e=0;e<t.length;e++)o(this,t[e]);else if(void 0!==i)// deprecated
for(e=0;e<arguments.length;e++)o(this,arguments[e]);else void 0!==t&&o(this,t);return this},m.prototype.prepend=function(t,i){if(h.array(t))for(var e=t.length-1;e>=0;e--)s(this,t[e]);else if(void 0!==i)// deprecated
for(e=arguments.length-1;e>=0;e--)s(this,arguments[e]);else void 0!==t&&s(this,t);return this},m.prototype.appendTo=function(t){return o(t,this),this},m.prototype.prependTo=function(t){return s(t,this),this},m.prototype.insertNext=function(t,i){if(h.array(t))for(var e=0;e<t.length;e++)r(t[e],this);else if(void 0!==i)// deprecated
for(e=0;e<arguments.length;e++)r(arguments[e],this);else void 0!==t&&r(t,this);return this},m.prototype.insertPrev=function(t,i){if(h.array(t))for(var e=t.length-1;e>=0;e--)n(t[e],this);else if(void 0!==i)// deprecated
for(e=arguments.length-1;e>=0;e--)n(arguments[e],this);else void 0!==t&&n(t,this);return this},m.prototype.insertAfter=function(t){return r(this,t),this},m.prototype.insertBefore=function(t){return n(this,t),this},m.prototype.remove=function(t,i){if(void 0!==t){if(h.array(t))for(var e=0;e<t.length;e++)a(t[e]).remove();else if(void 0!==i)for(e=0;e<arguments.length;e++)a(arguments[e]).remove();else a(t).remove();return this}
// this._parent.touch();
return this._prev&&(this._prev._next=this._next),this._next&&(this._next._prev=this._prev),this._parent&&(this._parent._first===this&&(this._parent._first=this._next),this._parent._last===this&&(this._parent._last=this._prev),this._parent._flag(this,!1),this._parent._ts_children=++c,this._parent.touch()),this._prev=this._next=this._parent=null,this._ts_parent=++c,this},m.prototype.empty=function(){for(var t,i=this._first;t=i;)i=t._next,t._prev=t._next=t._parent=null,this._flag(t,!1);return this._first=this._last=null,this._ts_children=++c,this.touch(),this},m.prototype.touch=function(){return this._ts_touch=++c,this._parent&&this._parent.touch(),this},/**
 * Deep flags used for optimizing event distribution.
 */
m.prototype._flag=function(t,i){if(void 0===i)return null!==this._flags&&this._flags[t]||0;if("string"==typeof t&&(i?(this._flags=this._flags||{},!this._flags[t]&&this._parent&&this._parent._flag(t,!0),this._flags[t]=(this._flags[t]||0)+1):this._flags&&this._flags[t]>0&&(1==this._flags[t]&&this._parent&&this._parent._flag(t,!1),this._flags[t]=this._flags[t]-1)),"object"==typeof t&&t._flags)for(var e in t._flags)t._flags[e]>0&&this._flag(e,i);return this},/**
 * @private
 */
m.prototype.hitTest=function(t){return!!this.attr("spy")||t.x>=0&&t.x<=this._pin._width&&t.y>=0&&t.y<=this._pin._height},i.exports=m},{"./core":60,"./util/is":77}],73:[function(t,i,e){i.exports=function(){function t(t,o){return i+=o="number"==typeof o&&o>=1?o:1,function(){t&&t.apply(this,arguments),o>0&&(o--,i--,function(){if(0===i)for(;e.length;)setTimeout(e.shift(),0)}())}}var i=0,e=[];return t.then=function(t){0===i?setTimeout(t,0):e.push(t)},t}},{}],74:[function(t,i,e){function o(){}"function"==typeof Object.create?i.exports=function(t,i){return Object.create.call(Object,t,i)}:i.exports=function(t,i){if(i)throw Error("Second argument is not supported!");if("object"!=typeof t||null===t)throw Error("Invalid prototype!");return o.prototype=t,new o}},{}],75:[function(t,i,e){i.exports=function(t,i){t._listeners=null,t.on=t.listen=function(t,e){if(!t||!t.length||"function"!=typeof e)return this;null===this._listeners&&(this._listeners={});if(t=("string"!=typeof t&&"function"==typeof t.join?t.join(" "):t).match(/\S+/g))for(var o=0;o<t.length;o++){var s=t[o];this._listeners[s]=this._listeners[s]||[],this._listeners[s].push(e),"function"==typeof i&&i(this,s,!0)}return this},t.off=function(t,e){if(!t||!t.length||"function"!=typeof e)return this;if(null===this._listeners)return this;if(t=("string"!=typeof t&&"function"==typeof t.join?t.join(" "):t).match(/\S+/g))for(var o=0;o<t.length;o++){var s,n=t[o],r=this._listeners[n];r&&(s=r.indexOf(e))>=0&&(r.splice(s,1),r.length||delete this._listeners[n],"function"==typeof i&&i(this,n,!1))}return this},t.listeners=function(t){return this._listeners&&this._listeners[t]},t.publish=function(t,i){var e=this.listeners(t);if(!e||!e.length)return 0;for(var o=0;o<e.length;o++)e[o].apply(this,i);return e.length},t.trigger=function(t,i){return this.publish(t,i),this}}},{}],76:[function(t,i,e){i.exports=function(t){for(var i=1;i<arguments.length;i++){var e=arguments[i];for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])}return t}},{}],77:[function(t,i,e){/**
 * ! is the definitive JavaScript type testing library
 * 
 * @copyright 2013-2014 Enrico Marino / Jordan Harband
 * @license MIT
 */
var o=Object.prototype,s=o.hasOwnProperty,n=o.toString,r=/^[A-Fa-f0-9]+$/,a=i.exports={};a.a=a.an=a.type=function(t,i){return typeof t===i},a.defined=function(t){return void 0!==t},a.empty=function(t){var i,e=n.call(t);if("[object Array]"===e||"[object Arguments]"===e||"[object String]"===e)return 0===t.length;if("[object Object]"===e){for(i in t)if(s.call(t,i))return!1;return!0}return!t},a.equal=function(t,i){if(t===i)return!0;var e,o=n.call(t);if(o!==n.call(i))return!1;if("[object Object]"===o){for(e in t)if(!(a.equal(t[e],i[e])&&e in i))return!1;for(e in i)if(!(a.equal(t[e],i[e])&&e in t))return!1;return!0}if("[object Array]"===o){if((e=t.length)!==i.length)return!1;for(;--e;)if(!a.equal(t[e],i[e]))return!1;return!0}return"[object Function]"===o?t.prototype===i.prototype:"[object Date]"===o&&t.getTime()===i.getTime()},a.instance=function(t,i){return t instanceof i},a.nil=function(t){return null===t},a.undef=function(t){return void 0===t},a.array=function(t){return"[object Array]"===n.call(t)},a.emptyarray=function(t){return a.array(t)&&0===t.length},a.arraylike=function(t){return!!t&&!a.boolean(t)&&s.call(t,"length")&&isFinite(t.length)&&a.number(t.length)&&t.length>=0},a.boolean=function(t){return"[object Boolean]"===n.call(t)},a.element=function(t){return void 0!==t&&"undefined"!=typeof HTMLElement&&t instanceof HTMLElement&&1===t.nodeType},a.fn=function(t){return"[object Function]"===n.call(t)},a.number=function(t){return"[object Number]"===n.call(t)},a.nan=function(t){return!a.number(t)||t!=t},a.object=function(t){return"[object Object]"===n.call(t)},a.hash=function(t){return a.object(t)&&t.constructor===Object&&!t.nodeType&&!t.setInterval},a.regexp=function(t){return"[object RegExp]"===n.call(t)},a.string=function(t){return"[object String]"===n.call(t)},a.hex=function(t){return a.string(t)&&(!t.length||r.test(t))}},{}],78:[function(t,i,e){var o=t("./create"),s=Math;i.exports=o(Math),i.exports.random=function(t,i){return void 0===t?(i=1,t=0):void 0===i&&(i=t,t=0),t==i?t:s.random()*(i-t)+t},i.exports.rotate=function(t,i,e){return void 0===i?(e=1,i=0):void 0===e&&(e=i,i=0),e>i?(t=(t-i)%(e-i))+(t<0?e:i):(t=(t-e)%(i-e))+(t<=0?i:e)},i.exports.limit=function(t,i,e){return t<i?i:t>e?e:t},i.exports.length=function(t,i){return s.sqrt(t*t+i*i)}},{"./create":74}],79:[function(t,i,e){i.exports=function(t,i,e,o,s,n){var r=t.width,a=t.height,m=t.left,h=t.right,c=t.top,_=t.bottom;r=r-(m="number"==typeof m&&m==m?m:0)-(h="number"==typeof h&&h==h?h:0),a=a-(c="number"==typeof c&&c==c?c:0)-(_="number"==typeof _&&_==_?_:0),s||(i=Math.max(i-m-h,0),e=Math.max(e-c-_,0));var l=0;if(c>0&&m>0&&n(l++,0,0,m,c,0,0,m,c),_>0&&m>0&&n(l++,0,a+c,m,_,0,e+c,m,_),c>0&&h>0&&n(l++,r+m,0,h,c,i+m,0,h,c),_>0&&h>0&&n(l++,r+m,a+c,h,_,i+m,e+c,h,_),o)c>0&&n(l++,m,0,r,c,m,0,i,c),_>0&&n(l++,m,a+c,r,_,m,e+c,i,_),m>0&&n(l++,0,c,m,a,0,c,m,e),h>0&&n(l++,r+m,c,h,a,i+m,c,h,e),
// center
n(l++,m,c,r,a,m,c,i,e);else for(// tile
var u,p=m,d=i;d>0;){u=Math.min(r,d),d-=r;for(var f,y=c,v=e;v>0;)f=Math.min(a,v),v-=a,n(l++,m,c,u,f,p,y,u,f),d<=0&&(m&&n(l++,0,c,m,f,0,y,m,f),h&&n(l++,r+m,c,h,f,p+u,y,h,f)),y+=f;c&&n(l++,m,0,u,c,p,0,u,c),_&&n(l++,m,a+c,u,_,p,y,u,_),p+=u}return l}},{}],80:[function(t,i,e){i.exports={}},{}],81:[function(t,i,e){i.exports.startsWith=function(t,i){return"string"==typeof t&&"string"==typeof i&&t.substring(0,i.length)==i}},{}],82:[function(t,i,e){i.exports=t("../lib/"),i.exports.internal={},t("../lib/canvas"),i.exports.internal.Image=t("../lib/image"),t("../lib/anim"),t("../lib/str"),t("../lib/layout"),t("../lib/addon/tween"),i.exports.Mouse=t("../lib/addon/mouse"),i.exports.Math=t("../lib/util/math"),i.exports._extend=t("../lib/util/extend"),i.exports._create=t("../lib/util/create"),t("../lib/loader/web")},{"../lib/":63,"../lib/addon/mouse":55,"../lib/addon/tween":56,"../lib/anim":57,"../lib/canvas":59,"../lib/image":62,"../lib/layout":64,"../lib/loader/web":65,"../lib/str":70,"../lib/util/create":74,"../lib/util/extend":76,"../lib/util/math":78}]},{},[1])(1)});