/*
 * Planck.js v0.1.38
 * 
 * Copyright (c) 2016-2018 Ali Shakiba http://shakiba.me/planck.js
 * Copyright (c) 2006-2013 Erin Catto  http://www.gphysics.com
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 */
!function(t){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=t();else if("function"==typeof define&&define.amd)define([],t);else{var i;"undefined"!=typeof window?i=window:"undefined"!=typeof global?i=global:"undefined"!=typeof self&&(i=self),i.planck=t()}}(function(){return function t(i,e,o){function s(r,m){if(!e[r]){if(!i[r]){var a="function"==typeof require&&require;if(!m&&a)return a(r,!0);if(n)return n(r,!0);var h=new Error("Cannot find module '"+r+"'");throw h.code="MODULE_NOT_FOUND",h}var c=e[r]={exports:{}};i[r][0].call(c.exports,function(t){var e=i[r][1][t];return s(e||t)},c,c.exports,t,i,e,o)}return e[r].exports}for(var n="function"==typeof require&&require,r=0;r<o.length;r++)s(o[r]);return s}({1:[function(t,i,e){e.internal={},e.Math=t("./common/Math"),e.Vec2=t("./common/Vec2"),e.Transform=t("./common/Transform"),e.Rot=t("./common/Rot"),e.AABB=t("./collision/AABB"),e.Shape=t("./Shape"),e.Fixture=t("./Fixture"),e.Body=t("./Body"),e.Contact=t("./Contact"),e.Joint=t("./Joint"),e.World=t("./World"),e.Circle=t("./shape/CircleShape"),e.Edge=t("./shape/EdgeShape"),e.Polygon=t("./shape/PolygonShape"),e.Chain=t("./shape/ChainShape"),e.Box=t("./shape/BoxShape"),t("./shape/CollideCircle"),t("./shape/CollideEdgeCircle"),e.internal.CollidePolygons=t("./shape/CollidePolygon"),t("./shape/CollideCirclePolygone"),t("./shape/CollideEdgePolygon"),e.DistanceJoint=t("./joint/DistanceJoint"),e.FrictionJoint=t("./joint/FrictionJoint"),e.GearJoint=t("./joint/GearJoint"),e.MotorJoint=t("./joint/MotorJoint"),e.MouseJoint=t("./joint/MouseJoint"),e.PrismaticJoint=t("./joint/PrismaticJoint"),e.PulleyJoint=t("./joint/PulleyJoint"),e.RevoluteJoint=t("./joint/RevoluteJoint"),e.RopeJoint=t("./joint/RopeJoint"),e.WeldJoint=t("./joint/WeldJoint"),e.WheelJoint=t("./joint/WheelJoint"),e.internal.Sweep=t("./common/Sweep"),e.internal.stats=t("./common/stats"),e.internal.Manifold=t("./Manifold"),e.internal.Distance=t("./collision/Distance"),e.internal.TimeOfImpact=t("./collision/TimeOfImpact"),e.internal.DynamicTree=t("./collision/DynamicTree"),e.internal.Settings=t("./Settings")},{"./Body":2,"./Contact":3,"./Fixture":4,"./Joint":5,"./Manifold":6,"./Settings":7,"./Shape":8,"./World":10,"./collision/AABB":11,"./collision/Distance":13,"./collision/DynamicTree":14,"./collision/TimeOfImpact":15,"./common/Math":18,"./common/Rot":20,"./common/Sweep":21,"./common/Transform":22,"./common/Vec2":23,"./common/stats":26,"./joint/DistanceJoint":27,"./joint/FrictionJoint":28,"./joint/GearJoint":29,"./joint/MotorJoint":30,"./joint/MouseJoint":31,"./joint/PrismaticJoint":32,"./joint/PulleyJoint":33,"./joint/RevoluteJoint":34,"./joint/RopeJoint":35,"./joint/WeldJoint":36,"./joint/WheelJoint":37,"./shape/BoxShape":38,"./shape/ChainShape":39,"./shape/CircleShape":40,"./shape/CollideCircle":41,"./shape/CollideCirclePolygone":42,"./shape/CollideEdgeCircle":43,"./shape/CollideEdgePolygon":44,"./shape/CollidePolygon":45,"./shape/EdgeShape":46,"./shape/PolygonShape":47}],2:[function(t,i,e){function o(t,i){i=a(i,g),r&&m.assert(h.isValid(i.position)),r&&m.assert(h.isValid(i.linearVelocity)),r&&m.assert(_.isFinite(i.angle)),r&&m.assert(_.isFinite(i.angularVelocity)),r&&m.assert(_.isFinite(i.angularDamping)&&i.angularDamping>=0),r&&m.assert(_.isFinite(i.linearDamping)&&i.linearDamping>=0),this.m_world=t,this.m_awakeFlag=i.awake,this.m_autoSleepFlag=i.allowSleep,this.m_bulletFlag=i.bullet,this.m_fixedRotationFlag=i.fixedRotation,this.m_activeFlag=i.active,this.m_islandFlag=!1,this.m_toiFlag=!1,this.m_userData=i.userData,this.m_type=i.type,this.m_type==x?(this.m_mass=1,this.m_invMass=1):(this.m_mass=0,this.m_invMass=0),this.m_I=0,this.m_invI=0,this.m_xf=u.identity(),this.m_xf.p=h.clone(i.position),this.m_xf.q.setAngle(i.angle),this.m_sweep=new l,this.m_sweep.setTransform(this.m_xf),this.c_velocity=new p,this.c_position=new d,this.m_force=h.zero(),this.m_torque=0,this.m_linearVelocity=h.clone(i.linearVelocity),this.m_angularVelocity=i.angularVelocity,this.m_linearDamping=i.linearDamping,this.m_angularDamping=i.angularDamping,this.m_gravityScale=i.gravityScale,this.m_sleepTime=0,this.m_jointList=null,this.m_contactList=null,this.m_fixtureList=null,this.m_prev=null,this.m_next=null}function s(){this.mass=0,this.center=h.zero(),this.I=0}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=o;var m=t("./util/common"),a=t("./util/options"),h=t("./common/Vec2"),c=t("./common/Rot"),_=t("./common/Math"),l=t("./common/Sweep"),u=t("./common/Transform"),p=t("./common/Velocity"),d=t("./common/Position"),y=t("./Fixture"),v=(t("./Shape"),t("./World"),o.STATIC="static"),f=o.KINEMATIC="kinematic",x=o.DYNAMIC="dynamic",g={type:v,position:h.zero(),angle:0,linearVelocity:h.zero(),angularVelocity:0,linearDamping:0,angularDamping:0,fixedRotation:!1,bullet:!1,gravityScale:1,allowSleep:!0,awake:!0,active:!0,userData:null};o.prototype.isWorldLocked=function(){return!(!this.m_world||!this.m_world.isLocked())},o.prototype.getWorld=function(){return this.m_world},o.prototype.getNext=function(){return this.m_next},o.prototype.setUserData=function(t){this.m_userData=t},o.prototype.getUserData=function(){return this.m_userData},o.prototype.getFixtureList=function(){return this.m_fixtureList},o.prototype.getJointList=function(){return this.m_jointList},o.prototype.getContactList=function(){return this.m_contactList},o.prototype.isStatic=function(){return this.m_type==v},o.prototype.isDynamic=function(){return this.m_type==x},o.prototype.isKinematic=function(){return this.m_type==f},o.prototype.setStatic=function(){return this.setType(v),this},o.prototype.setDynamic=function(){return this.setType(x),this},o.prototype.setKinematic=function(){return this.setType(f),this},o.prototype.getType=function(){return this.m_type},o.prototype.setType=function(t){if(r&&m.assert(t===v||t===f||t===x),r&&m.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()&&this.m_type!=t){this.m_type=t,this.resetMassData(),this.m_type==v&&(this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_sweep.forward(),this.synchronizeFixtures()),this.setAwake(!0),this.m_force.setZero(),this.m_torque=0;for(var i=this.m_contactList;i;){var e=i;i=i.next,this.m_world.destroyContact(e.contact)}this.m_contactList=null;for(var o=this.m_world.m_broadPhase,s=this.m_fixtureList;s;s=s.m_next)for(var n=s.m_proxyCount,a=0;a<n;++a)o.touchProxy(s.m_proxies[a].proxyId)}},o.prototype.isBullet=function(){return this.m_bulletFlag},o.prototype.setBullet=function(t){this.m_bulletFlag=!!t},o.prototype.isSleepingAllowed=function(){return this.m_autoSleepFlag},o.prototype.setSleepingAllowed=function(t){this.m_autoSleepFlag=!!t,0==this.m_autoSleepFlag&&this.setAwake(!0)},o.prototype.isAwake=function(){return this.m_awakeFlag},o.prototype.setAwake=function(t){t?0==this.m_awakeFlag&&(this.m_awakeFlag=!0,this.m_sleepTime=0):(this.m_awakeFlag=!1,this.m_sleepTime=0,this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_force.setZero(),this.m_torque=0)},o.prototype.isActive=function(){return this.m_activeFlag},o.prototype.setActive=function(t){if(r&&m.assert(0==this.isWorldLocked()),t!=this.m_activeFlag)if(this.m_activeFlag=!!t,this.m_activeFlag)for(var i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.createProxies(i,this.m_xf);else{for(i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.destroyProxies(i);for(var o=this.m_contactList;o;){var s=o;o=o.next,this.m_world.destroyContact(s.contact)}this.m_contactList=null}},o.prototype.isFixedRotation=function(){return this.m_fixedRotationFlag},o.prototype.setFixedRotation=function(t){this.m_fixedRotationFlag!=t&&(this.m_fixedRotationFlag=!!t,this.m_angularVelocity=0,this.resetMassData())},o.prototype.getTransform=function(){return this.m_xf},o.prototype.setTransform=function(t,i){if(r&&m.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()){this.m_xf.set(t,i),this.m_sweep.setTransform(this.m_xf);for(var e=this.m_world.m_broadPhase,o=this.m_fixtureList;o;o=o.m_next)o.synchronize(e,this.m_xf,this.m_xf)}},o.prototype.synchronizeTransform=function(){this.m_sweep.getTransform(this.m_xf,1)},o.prototype.synchronizeFixtures=function(){var t=u.identity();this.m_sweep.getTransform(t,0);for(var i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.synchronize(i,t,this.m_xf)},o.prototype.advance=function(t){this.m_sweep.advance(t),this.m_sweep.c.set(this.m_sweep.c0),this.m_sweep.a=this.m_sweep.a0,this.m_sweep.getTransform(this.m_xf,1)},o.prototype.getPosition=function(){return this.m_xf.p},o.prototype.setPosition=function(t){this.setTransform(t,this.m_sweep.a)},o.prototype.getAngle=function(){return this.m_sweep.a},o.prototype.setAngle=function(t){this.setTransform(this.m_xf.p,t)},o.prototype.getWorldCenter=function(){return this.m_sweep.c},o.prototype.getLocalCenter=function(){return this.m_sweep.localCenter},o.prototype.getLinearVelocity=function(){return this.m_linearVelocity},o.prototype.getLinearVelocityFromWorldPoint=function(t){var i=h.sub(t,this.m_sweep.c);return h.add(this.m_linearVelocity,h.cross(this.m_angularVelocity,i))},o.prototype.getLinearVelocityFromLocalPoint=function(t){return this.getLinearVelocityFromWorldPoint(this.getWorldPoint(t))},o.prototype.setLinearVelocity=function(t){this.m_type!=v&&(h.dot(t,t)>0&&this.setAwake(!0),this.m_linearVelocity.set(t))},o.prototype.getAngularVelocity=function(){return this.m_angularVelocity},o.prototype.setAngularVelocity=function(t){this.m_type!=v&&(t*t>0&&this.setAwake(!0),this.m_angularVelocity=t)},o.prototype.getLinearDamping=function(){return this.m_linearDamping},o.prototype.setLinearDamping=function(t){this.m_linearDamping=t},o.prototype.getAngularDamping=function(){return this.m_angularDamping},o.prototype.setAngularDamping=function(t){this.m_angularDamping=t},o.prototype.getGravityScale=function(){return this.m_gravityScale},o.prototype.setGravityScale=function(t){this.m_gravityScale=t},o.prototype.getMass=function(){return this.m_mass},o.prototype.getInertia=function(){return this.m_I+this.m_mass*h.dot(this.m_sweep.localCenter,this.m_sweep.localCenter)},o.prototype.getMassData=function(t){t.mass=this.m_mass,t.I=this.getInertia(),t.center.set(this.m_sweep.localCenter)},o.prototype.resetMassData=function(){if(this.m_mass=0,this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_sweep.localCenter.setZero(),this.isStatic()||this.isKinematic())return this.m_sweep.c0.set(this.m_xf.p),this.m_sweep.c.set(this.m_xf.p),void(this.m_sweep.a0=this.m_sweep.a);r&&m.assert(this.isDynamic());for(var t=h.zero(),i=this.m_fixtureList;i;i=i.m_next)if(0!=i.m_density){var e=new s;i.getMassData(e),this.m_mass+=e.mass,t.wAdd(e.mass,e.center),this.m_I+=e.I}this.m_mass>0?(this.m_invMass=1/this.m_mass,t.mul(this.m_invMass)):(this.m_mass=1,this.m_invMass=1),this.m_I>0&&0==this.m_fixedRotationFlag?(this.m_I-=this.m_mass*h.dot(t,t),r&&m.assert(this.m_I>0),this.m_invI=1/this.m_I):(this.m_I=0,this.m_invI=0);var o=h.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t,this.m_xf),this.m_linearVelocity.add(h.cross(this.m_angularVelocity,h.sub(this.m_sweep.c,o)))},o.prototype.setMassData=function(t){if(r&&m.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()&&this.m_type==x){this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_mass=t.mass,this.m_mass<=0&&(this.m_mass=1),this.m_invMass=1/this.m_mass,t.I>0&&0==this.m_fixedRotationFlag&&(this.m_I=t.I-this.m_mass*h.dot(t.center,t.center),r&&m.assert(this.m_I>0),this.m_invI=1/this.m_I);var i=h.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t.center,this.m_xf),this.m_linearVelocity.add(h.cross(this.m_angularVelocity,h.sub(this.m_sweep.c,i)))}},o.prototype.applyForce=function(t,i,e){this.m_type==x&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_force.add(t),this.m_torque+=h.cross(h.sub(i,this.m_sweep.c),t)))},o.prototype.applyForceToCenter=function(t,i){this.m_type==x&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&this.m_force.add(t))},o.prototype.applyTorque=function(t,i){this.m_type==x&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_torque+=t))},o.prototype.applyLinearImpulse=function(t,i,e){this.m_type==x&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_linearVelocity.wAdd(this.m_invMass,t),this.m_angularVelocity+=this.m_invI*h.cross(h.sub(i,this.m_sweep.c),t)))},o.prototype.applyAngularImpulse=function(t,i){this.m_type==x&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_angularVelocity+=this.m_invI*t))},o.prototype.shouldCollide=function(t){if(this.m_type!=x&&t.m_type!=x)return!1;for(var i=this.m_jointList;i;i=i.next)if(i.other==t&&0==i.joint.m_collideConnected)return!1;return!0},o.prototype.createFixture=function(t,i){if(r&&m.assert(0==this.isWorldLocked()),1==this.isWorldLocked())return null;var e=new y(this,t,i);if(this.m_activeFlag){var o=this.m_world.m_broadPhase;e.createProxies(o,this.m_xf)}return e.m_next=this.m_fixtureList,this.m_fixtureList=e,e.m_density>0&&this.resetMassData(),this.m_world.m_newFixture=!0,e},o.prototype.destroyFixture=function(t){if(r&&m.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()){r&&m.assert(t.m_body==this);var i=!1;if(this.m_fixtureList===t)this.m_fixtureList=t.m_next,i=!0;else for(var e=this.m_fixtureList;null!=e;){if(e.m_next===t){e.m_next=t.m_next,i=!0;break}e=e.m_next}r&&m.assert(i);for(var o=this.m_contactList;o;){var s=o.contact;o=o.next;var n=s.getFixtureA(),a=s.getFixtureB();t!=n&&t!=a||this.m_world.destroyContact(s)}if(this.m_activeFlag){var h=this.m_world.m_broadPhase;t.destroyProxies(h)}t.m_body=null,t.m_next=null,this.m_world.publish("remove-fixture",t),this.resetMassData()}},o.prototype.getWorldPoint=function(t){return u.mul(this.m_xf,t)},o.prototype.getWorldVector=function(t){return c.mul(this.m_xf.q,t)},o.prototype.getLocalPoint=function(t){return u.mulT(this.m_xf,t)},o.prototype.getLocalVector=function(t){return c.mulT(this.m_xf.q,t)}},{"./Fixture":4,"./Shape":8,"./World":10,"./common/Math":18,"./common/Position":19,"./common/Rot":20,"./common/Sweep":21,"./common/Transform":22,"./common/Vec2":23,"./common/Velocity":25,"./util/common":50,"./util/options":52}],3:[function(t,i,e){function o(t){this.contact=t,this.prev,this.next,this.other}function s(t,i,e,s,m){this.m_nodeA=new o(this),this.m_nodeB=new o(this),this.m_fixtureA=t,this.m_fixtureB=e,this.m_indexA=i,this.m_indexB=s,this.m_evaluateFcn=m,this.m_manifold=new y,this.m_prev=null,this.m_next=null,this.m_toi=1,this.m_toiCount=0,this.m_toiFlag=!1,this.m_friction=n(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction),this.m_restitution=r(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution),this.m_tangentSpeed=0,this.m_enabledFlag=!0,this.m_islandFlag=!1,this.m_touchingFlag=!1,this.m_filterFlag=!1,this.m_bulletHitFlag=!1,this.v_points=[],this.v_normal=_.zero(),this.v_normalMass=new u,this.v_K=new u,this.v_pointCount,this.v_tangentSpeed,this.v_friction,this.v_restitution,this.v_invMassA,this.v_invMassB,this.v_invIA,this.v_invIB,this.p_localPoints=[],this.p_localNormal=_.zero(),this.p_localPoint=_.zero(),this.p_localCenterA=_.zero(),this.p_localCenterB=_.zero(),this.p_type,this.p_radiusA,this.p_radiusB,this.p_pointCount,this.p_invMassA,this.p_invMassB,this.p_invIA,this.p_invIB}function n(t,i){return c.sqrt(t*i)}function r(t,i){return t>i?t:i}if(void 0===m)var m=!1;if(void 0===a)var a=!1;var h=t("./util/common"),c=t("./common/Math"),_=t("./common/Vec2"),l=t("./common/Transform"),u=t("./common/Mat22"),p=t("./common/Rot"),d=t("./Settings"),y=t("./Manifold"),v=t("./collision/Distance");i.exports=s,s.prototype.initConstraint=function(t){var i=this.m_fixtureA,e=this.m_fixtureB,o=i.getShape(),s=e.getShape(),n=i.getBody(),r=e.getBody(),c=this.getManifold(),l=c.pointCount;a&&h.assert(l>0),this.v_invMassA=n.m_invMass,this.v_invMassB=r.m_invMass,this.v_invIA=n.m_invI,this.v_invIB=r.m_invI,this.v_friction=this.m_friction,this.v_restitution=this.m_restitution,this.v_tangentSpeed=this.m_tangentSpeed,this.v_pointCount=l,m&&h.debug("pc",this.v_pointCount,l),this.v_K.setZero(),this.v_normalMass.setZero(),this.p_invMassA=n.m_invMass,this.p_invMassB=r.m_invMass,this.p_invIA=n.m_invI,this.p_invIB=r.m_invI,this.p_localCenterA=_.clone(n.m_sweep.localCenter),this.p_localCenterB=_.clone(r.m_sweep.localCenter),this.p_radiusA=o.m_radius,this.p_radiusB=s.m_radius,this.p_type=c.type,this.p_localNormal=_.clone(c.localNormal),this.p_localPoint=_.clone(c.localPoint),this.p_pointCount=l;for(var u=0;u<l;++u){var p=c.points[u],d=this.v_points[u]=new function(){this.rA=_.zero(),this.rB=_.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.normalMass=0,this.tangentMass=0,this.velocityBias=0};t.warmStarting?(d.normalImpulse=t.dtRatio*p.normalImpulse,d.tangentImpulse=t.dtRatio*p.tangentImpulse):(d.normalImpulse=0,d.tangentImpulse=0),d.rA.setZero(),d.rB.setZero(),d.normalMass=0,d.tangentMass=0,d.velocityBias=0,this.p_localPoints[u]=_.clone(p.localPoint)}},s.prototype.getManifold=function(){return this.m_manifold},s.prototype.getWorldManifold=function(t){var i=this.m_fixtureA.getBody(),e=this.m_fixtureB.getBody(),o=this.m_fixtureA.getShape(),s=this.m_fixtureB.getShape();return this.m_manifold.getWorldManifold(t,i.getTransform(),o.m_radius,e.getTransform(),s.m_radius)},s.prototype.setEnabled=function(t){this.m_enabledFlag=!!t},s.prototype.isEnabled=function(){return this.m_enabledFlag},s.prototype.isTouching=function(){return this.m_touchingFlag},s.prototype.getNext=function(){return this.m_next},s.prototype.getFixtureA=function(){return this.m_fixtureA},s.prototype.getFixtureB=function(){return this.m_fixtureB},s.prototype.getChildIndexA=function(){return this.m_indexA},s.prototype.getChildIndexB=function(){return this.m_indexB},s.prototype.flagForFiltering=function(){this.m_filterFlag=!0},s.prototype.setFriction=function(t){this.m_friction=t},s.prototype.getFriction=function(){return this.m_friction},s.prototype.resetFriction=function(){this.m_friction=n(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction)},s.prototype.setRestitution=function(t){this.m_restitution=t},s.prototype.getRestitution=function(){return this.m_restitution},s.prototype.resetRestitution=function(){this.m_restitution=r(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution)},s.prototype.setTangentSpeed=function(t){this.m_tangentSpeed=t},s.prototype.getTangentSpeed=function(){return this.m_tangentSpeed},s.prototype.evaluate=function(t,i,e){this.m_evaluateFcn(t,i,this.m_fixtureA,this.m_indexA,e,this.m_fixtureB,this.m_indexB)},s.prototype.update=function(t){this.m_enabledFlag=!0;var i=!1,e=this.m_touchingFlag,o=this.m_fixtureA.isSensor(),s=this.m_fixtureB.isSensor(),n=o||s,r=this.m_fixtureA.getBody(),m=this.m_fixtureB.getBody(),a=r.getTransform(),h=m.getTransform();if(n){var c=this.m_fixtureA.getShape(),_=this.m_fixtureB.getShape();i=v.testOverlap(c,this.m_indexA,_,this.m_indexB,a,h),this.m_manifold.pointCount=0}else{var l=this.m_manifold;this.m_manifold=new y,this.evaluate(this.m_manifold,a,h),i=this.m_manifold.pointCount>0;for(var u=0;u<this.m_manifold.pointCount;++u){var p=this.m_manifold.points[u];p.normalImpulse=0,p.tangentImpulse=0;for(var d=0;d<l.pointCount;++d){var f=l.points[d];if(f.id.key==p.id.key){p.normalImpulse=f.normalImpulse,p.tangentImpulse=f.tangentImpulse;break}}}i!=e&&(r.setAwake(!0),m.setAwake(!0))}this.m_touchingFlag=i,0==e&&1==i&&t&&t.beginContact(this),1==e&&0==i&&t&&t.endContact(this),0==n&&i&&t&&t.preSolve(this,l)},s.prototype.solvePositionConstraint=function(t){return this._solvePositionConstraint(t,!1)},s.prototype.solvePositionConstraintTOI=function(t,i,e){return this._solvePositionConstraint(t,!0,i,e)},s.prototype._solvePositionConstraint=function(t,i,e,o){var s=this.m_fixtureA,n=this.m_fixtureB,r=s.getBody(),m=n.getBody(),a=(r.c_velocity,m.c_velocity,r.c_position),h=m.c_position,u=_.clone(this.p_localCenterA),v=_.clone(this.p_localCenterB),f=0,x=0;i&&r!=e&&r!=o||(f=this.p_invMassA,x=this.p_invIA);var g=0,A=0;i&&m!=e&&m!=o||(g=this.p_invMassB,A=this.p_invIB);for(var b=_.clone(a.c),B=a.a,w=_.clone(h.c),S=h.a,C=0,M=0;M<this.p_pointCount;++M){var I=l.identity(),P=l.identity();I.q.set(B),P.q.set(S),I.p=_.sub(b,p.mul(I.q,u)),P.p=_.sub(w,p.mul(P.q,v));var T,V,z;switch(this.p_type){case y.e_circles:var L=l.mul(I,this.p_localPoint),F=l.mul(P,this.p_localPoints[0]);(T=_.sub(F,L)).normalize(),V=_.wAdd(.5,L,.5,F),z=_.dot(_.sub(F,L),T)-this.p_radiusA-this.p_radiusB;break;case y.e_faceA:T=p.mul(I.q,this.p_localNormal);var q=l.mul(I,this.p_localPoint),k=l.mul(P,this.p_localPoints[M]);z=_.dot(_.sub(k,q),T)-this.p_radiusA-this.p_radiusB,V=k;break;case y.e_faceB:T=p.mul(P.q,this.p_localNormal);q=l.mul(P,this.p_localPoint),k=l.mul(I,this.p_localPoints[M]);z=_.dot(_.sub(k,q),T)-this.p_radiusA-this.p_radiusB,V=k,T.mul(-1)}var D=_.sub(V,b),R=_.sub(V,w);C=c.min(C,z);var E=i?d.toiBaugarte:d.baumgarte,j=d.linearSlop,J=d.maxLinearCorrection,O=c.clamp(E*(z+j),-J,0),N=_.cross(D,T),Y=_.cross(R,T),W=f+g+x*N*N+A*Y*Y,H=W>0?-O/W:0,Z=_.mul(H,T);b.wSub(f,Z),B-=x*_.cross(D,Z),w.wAdd(g,Z),S+=A*_.cross(R,Z)}return a.c.set(b),a.a=B,h.c.set(w),h.a=S,C},s.prototype.initVelocityConstraint=function(t){var i=this.m_fixtureA,e=this.m_fixtureB,o=i.getBody(),s=e.getBody(),n=o.c_velocity,r=s.c_velocity,c=o.c_position,u=s.c_position,y=this.p_radiusA,v=this.p_radiusB,f=this.getManifold(),x=this.v_invMassA,g=this.v_invMassB,A=this.v_invIA,b=this.v_invIB,B=_.clone(this.p_localCenterA),w=_.clone(this.p_localCenterB),S=_.clone(c.c),C=c.a,M=_.clone(n.v),I=n.w,P=_.clone(u.c),T=u.a,V=_.clone(r.v),z=r.w;a&&h.assert(f.pointCount>0);var L=l.identity(),F=l.identity();L.q.set(C),F.q.set(T),L.p.wSet(1,S,-1,p.mul(L.q,B)),F.p.wSet(1,P,-1,p.mul(F.q,w));var q=f.getWorldManifold(null,L,y,F,v);this.v_normal.set(q.normal);for(var k=0;k<this.v_pointCount;++k){var D=this.v_points[k];D.rA.set(_.sub(q.points[k],S)),D.rB.set(_.sub(q.points[k],P)),m&&h.debug("vcp.rA",q.points[k].x,q.points[k].y,S.x,S.y,D.rA.x,D.rA.y);var R=_.cross(D.rA,this.v_normal),E=_.cross(D.rB,this.v_normal),j=x+g+A*R*R+b*E*E;D.normalMass=j>0?1/j:0;var J=_.cross(this.v_normal,1),O=_.cross(D.rA,J),N=_.cross(D.rB,J),Y=x+g+A*O*O+b*N*N;D.tangentMass=Y>0?1/Y:0,D.velocityBias=0;var W=_.dot(this.v_normal,V)+_.dot(this.v_normal,_.cross(z,D.rB))-_.dot(this.v_normal,M)-_.dot(this.v_normal,_.cross(I,D.rA));W<-d.velocityThreshold&&(D.velocityBias=-this.v_restitution*W)}if(2==this.v_pointCount&&t.blockSolve){var H=this.v_points[0],Z=this.v_points[1],K=_.cross(H.rA,this.v_normal),G=_.cross(H.rB,this.v_normal),U=_.cross(Z.rA,this.v_normal),X=_.cross(Z.rB,this.v_normal),Q=x+g+A*K*K+b*G*G,$=x+g+A*U*U+b*X*X,tt=x+g+A*K*U+b*G*X;m&&h.debug("k1x2: ",Q,$,tt,x,g,A,K,U,b,G,X),Q*Q<1e3*(Q*$-tt*tt)?(this.v_K.ex.set(Q,tt),this.v_K.ey.set(tt,$),this.v_normalMass.set(this.v_K.getInverse())):this.v_pointCount=1}c.c.set(S),c.a=C,n.v.set(M),n.w=I,u.c.set(P),u.a=T,r.v.set(V),r.w=z},s.prototype.warmStartConstraint=function(t){for(var i=this.m_fixtureA,e=this.m_fixtureB,o=i.getBody(),s=e.getBody(),n=o.c_velocity,r=s.c_velocity,a=(o.c_position,s.c_position,this.v_invMassA),c=this.v_invIA,l=this.v_invMassB,u=this.v_invIB,p=_.clone(n.v),d=n.w,y=_.clone(r.v),v=r.w,f=this.v_normal,x=_.cross(f,1),g=0;g<this.v_pointCount;++g){var A=this.v_points[g],b=_.wAdd(A.normalImpulse,f,A.tangentImpulse,x);m&&h.debug(c,u,A.rA.x,A.rA.y,A.rB.x,A.rB.y,b.x,b.y),d-=c*_.cross(A.rA,b),p.wSub(a,b),v+=u*_.cross(A.rB,b),y.wAdd(l,b)}n.v.set(p),n.w=d,r.v.set(y),r.w=v},s.prototype.storeConstraintImpulses=function(t){for(var i=this.m_manifold,e=0;e<this.v_pointCount;++e)i.points[e].normalImpulse=this.v_points[e].normalImpulse,i.points[e].tangentImpulse=this.v_points[e].tangentImpulse},s.prototype.solveVelocityConstraint=function(t){var i=this.m_fixtureA.m_body,e=this.m_fixtureB.m_body,o=i.c_velocity,s=(i.c_position,e.c_velocity),n=(e.c_position,this.v_invMassA),r=this.v_invIA,m=this.v_invMassB,l=this.v_invIB,p=_.clone(o.v),d=o.w,y=_.clone(s.v),v=s.w,f=this.v_normal,x=_.cross(f,1),g=this.v_friction;a&&h.assert(1==this.v_pointCount||2==this.v_pointCount);for(var A=0;A<this.v_pointCount;++A){var b=this.v_points[A];(I=_.zero()).wAdd(1,y,1,_.cross(v,b.rB)),I.wSub(1,p,1,_.cross(d,b.rA));var B=_.dot(I,x)-this.v_tangentSpeed,w=b.tangentMass*-B,S=g*b.normalImpulse;w=(P=c.clamp(b.tangentImpulse+w,-S,S))-b.tangentImpulse,b.tangentImpulse=P;var C=_.mul(w,x);p.wSub(n,C),d-=r*_.cross(b.rA,C),y.wAdd(m,C),v+=l*_.cross(b.rB,C)}if(1==this.v_pointCount||0==t.blockSolve)for(var M=0;M<this.v_pointCount;++M){var I;b=this.v_points[M];(I=_.zero()).wAdd(1,y,1,_.cross(v,b.rB)),I.wSub(1,p,1,_.cross(d,b.rA));var P,T=_.dot(I,f);w=-b.normalMass*(T-b.velocityBias);w=(P=c.max(b.normalImpulse+w,0))-b.normalImpulse,b.normalImpulse=P;C=_.mul(w,f);p.wSub(n,C),d-=r*_.cross(b.rA,C),y.wAdd(m,C),v+=l*_.cross(b.rB,C)}else{var V=this.v_points[0],z=this.v_points[1],L=_.neo(V.normalImpulse,z.normalImpulse);a&&h.assert(L.x>=0&&L.y>=0);var F=_.zero().add(y).add(_.cross(v,V.rB)).sub(p).sub(_.cross(d,V.rA)),q=_.zero().add(y).add(_.cross(v,z.rB)).sub(p).sub(_.cross(d,z.rA)),k=_.dot(F,f),D=_.dot(q,f),R=_.neo(k-V.velocityBias,D-z.velocityBias);R.sub(u.mul(this.v_K,L));for(;;){var E=_.neg(u.mul(this.v_normalMass,R));if(E.x>=0&&E.y>=0){var j=_.sub(E,L),J=_.mul(j.x,f),O=_.mul(j.y,f);p.wSub(n,J,n,O),d-=r*(_.cross(V.rA,J)+_.cross(z.rA,O)),y.wAdd(m,J,m,O),v+=l*(_.cross(V.rB,J)+_.cross(z.rB,O)),V.normalImpulse=E.x,z.normalImpulse=E.y;break}if(E.x=-V.normalMass*R.x,E.y=0,k=0,D=this.v_K.ex.y*E.x+R.y,E.x>=0&&D>=0){j=_.sub(E,L),J=_.mul(j.x,f),O=_.mul(j.y,f);p.wSub(n,J,n,O),d-=r*(_.cross(V.rA,J)+_.cross(z.rA,O)),y.wAdd(m,J,m,O),v+=l*(_.cross(V.rB,J)+_.cross(z.rB,O)),V.normalImpulse=E.x,z.normalImpulse=E.y;break}if(E.x=0,E.y=-z.normalMass*R.y,k=this.v_K.ey.x*E.y+R.x,D=0,E.y>=0&&k>=0){j=_.sub(E,L),J=_.mul(j.x,f),O=_.mul(j.y,f);p.wSub(n,J,n,O),d-=r*(_.cross(V.rA,J)+_.cross(z.rA,O)),y.wAdd(m,J,m,O),v+=l*(_.cross(V.rB,J)+_.cross(z.rB,O)),V.normalImpulse=E.x,z.normalImpulse=E.y;break}if(E.x=0,E.y=0,k=R.x,D=R.y,k>=0&&D>=0){j=_.sub(E,L),J=_.mul(j.x,f),O=_.mul(j.y,f);p.wSub(n,J,n,O),d-=r*(_.cross(V.rA,J)+_.cross(z.rA,O)),y.wAdd(m,J,m,O),v+=l*(_.cross(V.rB,J)+_.cross(z.rB,O)),V.normalImpulse=E.x,z.normalImpulse=E.y;break}break}}o.v.set(p),o.w=d,s.v.set(y),s.w=v};var f=[];s.addType=function(t,i,e){f[t]=f[t]||{},f[t][i]=e},s.create=function(t,i,e,o){var n,r,m=t.getType(),a=e.getType();if(r=f[m]&&f[m][a])n=new s(t,i,e,o,r);else{if(!(r=f[a]&&f[a][m]))return null;n=new s(e,o,t,i,r)}t=n.getFixtureA(),e=n.getFixtureB(),i=n.getChildIndexA(),o=n.getChildIndexB();var h=t.getBody(),c=e.getBody();return n.m_nodeA.contact=n,n.m_nodeA.other=c,n.m_nodeA.prev=null,n.m_nodeA.next=h.m_contactList,null!=h.m_contactList&&(h.m_contactList.prev=n.m_nodeA),h.m_contactList=n.m_nodeA,n.m_nodeB.contact=n,n.m_nodeB.other=h,n.m_nodeB.prev=null,n.m_nodeB.next=c.m_contactList,null!=c.m_contactList&&(c.m_contactList.prev=n.m_nodeB),c.m_contactList=n.m_nodeB,0==t.isSensor()&&0==e.isSensor()&&(h.setAwake(!0),c.setAwake(!0)),n},s.destroy=function(t,i){var e=t.m_fixtureA,o=t.m_fixtureB,s=e.getBody(),n=o.getBody();t.isTouching()&&i.endContact(t),t.m_nodeA.prev&&(t.m_nodeA.prev.next=t.m_nodeA.next),t.m_nodeA.next&&(t.m_nodeA.next.prev=t.m_nodeA.prev),t.m_nodeA==s.m_contactList&&(s.m_contactList=t.m_nodeA.next),t.m_nodeB.prev&&(t.m_nodeB.prev.next=t.m_nodeB.next),t.m_nodeB.next&&(t.m_nodeB.next.prev=t.m_nodeB.prev),t.m_nodeB==n.m_contactList&&(n.m_contactList=t.m_nodeB.next),t.m_manifold.pointCount>0&&0==e.isSensor()&&0==o.isSensor()&&(s.setAwake(!0),n.setAwake(!0));var r=e.getType(),m=o.getType(),a=f[r][m].destroyFcn;"function"==typeof a&&a(t)}},{"./Manifold":6,"./Settings":7,"./collision/Distance":13,"./common/Mat22":16,"./common/Math":18,"./common/Rot":20,"./common/Transform":22,"./common/Vec2":23,"./util/common":50}],4:[function(t,i,e){function o(t,i){this.aabb=new c,this.fixture=t,this.childIndex=i,this.proxyId}function s(t,i,e){i.shape?(e=i,i=i.shape):"number"==typeof e&&(e={density:e}),e=a(e,_),this.m_body=t,this.m_friction=e.friction,this.m_restitution=e.restitution,this.m_density=e.density,this.m_isSensor=e.isSensor,this.m_filterGroupIndex=e.filterGroupIndex,this.m_filterCategoryBits=e.filterCategoryBits,this.m_filterMaskBits=e.filterMaskBits,this.m_shape=i,this.m_next=null,this.m_proxies=[],this.m_proxyCount=0;for(var s=this.m_shape.getChildCount(),n=0;n<s;++n)this.m_proxies[n]=new o(this,n);this.m_userData=e.userData}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=s;var m=t("./util/common"),a=t("./util/options"),h=t("./common/Vec2"),c=t("./collision/AABB"),_={userData:null,friction:.2,restitution:0,density:0,isSensor:!1,filterGroupIndex:0,filterCategoryBits:1,filterMaskBits:65535};s.prototype.getType=function(){return this.m_shape.getType()},s.prototype.getShape=function(){return this.m_shape},s.prototype.isSensor=function(){return this.m_isSensor},s.prototype.setSensor=function(t){t!=this.m_isSensor&&(this.m_body.setAwake(!0),this.m_isSensor=t)},s.prototype.getUserData=function(){return this.m_userData},s.prototype.setUserData=function(t){this.m_userData=t},s.prototype.getBody=function(){return this.m_body},s.prototype.getNext=function(){return this.m_next},s.prototype.getDensity=function(){return this.m_density},s.prototype.setDensity=function(t){r&&m.assert(Math.isFinite(t)&&t>=0),this.m_density=t},s.prototype.getFriction=function(){return this.m_friction},s.prototype.setFriction=function(t){this.m_friction=t},s.prototype.getRestitution=function(){return this.m_restitution},s.prototype.setRestitution=function(t){this.m_restitution=t},s.prototype.testPoint=function(t){return this.m_shape.testPoint(this.m_body.getTransform(),t)},s.prototype.rayCast=function(t,i,e){return this.m_shape.rayCast(t,i,this.m_body.getTransform(),e)},s.prototype.getMassData=function(t){this.m_shape.computeMass(t,this.m_density)},s.prototype.getAABB=function(t){return r&&m.assert(0<=t&&t<this.m_proxyCount),this.m_proxies[t].aabb},s.prototype.createProxies=function(t,i){r&&m.assert(0==this.m_proxyCount),this.m_proxyCount=this.m_shape.getChildCount();for(var e=0;e<this.m_proxyCount;++e){var o=this.m_proxies[e];this.m_shape.computeAABB(o.aabb,i,e),o.proxyId=t.createProxy(o.aabb,o)}},s.prototype.destroyProxies=function(t){for(var i=0;i<this.m_proxyCount;++i){var e=this.m_proxies[i];t.destroyProxy(e.proxyId),e.proxyId=null}this.m_proxyCount=0},s.prototype.synchronize=function(t,i,e){for(var o=0;o<this.m_proxyCount;++o){var s=this.m_proxies[o],n=new c,r=new c;this.m_shape.computeAABB(n,i,s.childIndex),this.m_shape.computeAABB(r,e,s.childIndex),s.aabb.combine(n,r);var m=h.sub(e.p,i.p);t.moveProxy(s.proxyId,s.aabb,m)}},s.prototype.setFilterData=function(t){this.m_filterGroupIndex=t.groupIndex,this.m_filterCategoryBits=t.categoryBits,this.m_filterMaskBits=t.maskBits,this.refilter()},s.prototype.getFilterGroupIndex=function(){return this.m_filterGroupIndex},s.prototype.getFilterCategoryBits=function(){return this.m_filterCategoryBits},s.prototype.getFilterMaskBits=function(){return this.m_filterMaskBits},s.prototype.refilter=function(){if(null!=this.m_body){for(var t=this.m_body.getContactList();t;){var i=t.contact,e=i.getFixtureA(),o=i.getFixtureB();e!=this&&o!=this||i.flagForFiltering(),t=t.next}var s=this.m_body.getWorld();if(null!=s)for(var n=s.m_broadPhase,r=0;r<this.m_proxyCount;++r)n.touchProxy(this.m_proxies[r].proxyId)}},s.prototype.shouldCollide=function(t){if(t.m_filterGroupIndex==this.m_filterGroupIndex&&0!=t.m_filterGroupIndex)return t.m_filterGroupIndex>0;return 0!=(t.m_filterMaskBits&this.m_filterCategoryBits)&&0!=(t.m_filterCategoryBits&this.m_filterMaskBits)}},{"./collision/AABB":11,"./common/Vec2":23,"./util/common":50,"./util/options":52}],5:[function(t,i,e){function o(){this.other=null,this.joint=null,this.prev=null,this.next=null}function s(t,i,e){i=t.bodyA||i,e=t.bodyB||e,r&&m.assert(i),r&&m.assert(e),r&&m.assert(i!=e),this.m_type="unknown-joint",this.m_bodyA=i,this.m_bodyB=e,this.m_index=0,this.m_collideConnected=!!t.collideConnected,this.m_prev=null,this.m_next=null,this.m_edgeA=new o,this.m_edgeB=new o,this.m_islandFlag=!1,this.m_userData=t.userData}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=s;var m=t("./util/common");s.prototype.isActive=function(){return this.m_bodyA.isActive()&&this.m_bodyB.isActive()},s.prototype.getType=function(){return this.m_type},s.prototype.getBodyA=function(){return this.m_bodyA},s.prototype.getBodyB=function(){return this.m_bodyB},s.prototype.getNext=function(){return this.m_next},s.prototype.getUserData=function(){return this.m_userData},s.prototype.setUserData=function(t){this.m_userData=t},s.prototype.getCollideConnected=function(){return this.m_collideConnected},s.prototype.getAnchorA=function(){},s.prototype.getAnchorB=function(){},s.prototype.getReactionForce=function(t){},s.prototype.getReactionTorque=function(t){},s.prototype.shiftOrigin=function(t){},s.prototype.initVelocityConstraints=function(t){},s.prototype.solveVelocityConstraints=function(t){},s.prototype.solvePositionConstraints=function(t){}},{"./util/common":50}],6:[function(t,i,e){function o(){this.type,this.localNormal=_.zero(),this.localPoint=_.zero(),this.points=[new s,new s],this.pointCount=0}function s(){this.localPoint=_.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.id=new n}function n(){this.cf=new r,this.key}function r(){this.indexA,this.indexB,this.typeA,this.typeB}function m(){this.v=_.zero(),this.id=new n}if(void 0===a)var a=!1;if(void 0===h)var h=!1;var c=t("./util/common"),_=t("./common/Vec2"),l=t("./common/Transform"),u=t("./common/Math"),p=t("./common/Rot");i.exports=o,i.exports.clipSegmentToLine=function(t,i,e,o,s){var n=0,m=_.dot(e,i[0].v)-o,a=_.dot(e,i[1].v)-o;if(m<=0&&t[n++].set(i[0]),a<=0&&t[n++].set(i[1]),m*a<0){var h=m/(m-a);t[n].v.wSet(1-h,i[0].v,h,i[1].v),t[n].id.cf.indexA=s,t[n].id.cf.indexB=i[0].id.cf.indexB,t[n].id.cf.typeA=r.e_vertex,t[n].id.cf.typeB=r.e_face,++n}return n},i.exports.clipVertex=m,i.exports.getPointStates=function(t,i,e,o){for(var s=0;s<e.pointCount;++s){var n=e.points[s].id;t[s]=d.removeState;for(var r=0;r<o.pointCount;++r)if(o.points[r].id.key==n.key){t[s]=d.persistState;break}}for(s=0;s<o.pointCount;++s)for(n=o.points[s].id,i[s]=d.addState,r=0;r<e.pointCount;++r)if(e.points[r].id.key==n.key){i[s]=d.persistState;break}},i.exports.PointState=d,o.e_circles=0,o.e_faceA=1,o.e_faceB=2,o.e_vertex=0,o.e_face=1,n.prototype.set=function(t){this.key=t.key,this.cf.set(t.cf)},r.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.typeA=t.typeA,this.typeB=t.typeB},o.prototype.getWorldManifold=function(t,i,e,s,n){if(0!=this.pointCount){var r=(t=t||new function(){this.normal,this.points=[],this.separations=[]}).normal,m=t.points,h=t.separations;switch(this.type){case o.e_circles:r=_.neo(1,0);var d=l.mul(i,this.localPoint),y=l.mul(s,this.points[0].localPoint),v=_.sub(y,d);_.lengthSquared(v)>u.EPSILON*u.EPSILON&&(r.set(v),r.normalize()),m[0]=_.mid(d,y),h[0]=-n-e,m.length=1,h.length=1;break;case o.e_faceA:r=p.mul(i.q,this.localNormal);var f=l.mul(i,this.localPoint);a&&c.debug("faceA",this.localPoint.x,this.localPoint.y,this.localNormal.x,this.localNormal.y,r.x,r.y);for(var x=0;x<this.pointCount;++x){var g=l.mul(s,this.points[x].localPoint),A=_.clone(g).wAdd(e-_.dot(_.sub(g,f),r),r),b=_.clone(g).wSub(n,r);m[x]=_.mid(A,b),h[x]=_.dot(_.sub(b,A),r),a&&c.debug(x,this.points[x].localPoint.x,this.points[x].localPoint.y,f.x,f.y,i.p.x,i.p.y,i.q.c,i.q.s,s.p.x,s.p.y,s.q.c,s.q.s,e,n,g.x,g.y,A.x,A.y,b.x,b.y,h[x],m[x].x,m[x].y)}m.length=this.pointCount,h.length=this.pointCount;break;case o.e_faceB:r=p.mul(s.q,this.localNormal);for(f=l.mul(s,this.localPoint),x=0;x<this.pointCount;++x){g=l.mul(i,this.points[x].localPoint),b=_.zero().wSet(1,g,n-_.dot(_.sub(g,f),r),r),A=_.zero().wSet(1,g,-e,r);m[x]=_.mid(A,b),h[x]=_.dot(_.sub(A,b),r)}m.length=this.pointCount,h.length=this.pointCount,r.mul(-1)}return t.normal=r,t.points=m,t.separations=h,t}};var d={nullState:0,addState:1,persistState:2,removeState:3};m.prototype.set=function(t){this.v.set(t.v),this.id.set(t.id)}},{"./common/Math":18,"./common/Rot":20,"./common/Transform":22,"./common/Vec2":23,"./util/common":50}],7:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;var n=e;n.maxManifoldPoints=2,n.maxPolygonVertices=12,n.aabbExtension=.1,n.aabbMultiplier=2,n.linearSlop=.005,n.linearSlopSquared=n.linearSlop*n.linearSlop,n.angularSlop=2/180*Math.PI,n.polygonRadius=2*n.linearSlop,n.maxSubSteps=8,n.maxTOIContacts=32,n.maxTOIIterations=20,n.maxDistnceIterations=20,n.velocityThreshold=1,n.maxLinearCorrection=.2,n.maxAngularCorrection=8/180*Math.PI,n.maxTranslation=2,n.maxTranslationSquared=n.maxTranslation*n.maxTranslation,n.maxRotation=.5*Math.PI,n.maxRotationSquared=n.maxRotation*n.maxRotation,n.baumgarte=.2,n.toiBaugarte=.75,n.timeToSleep=.5,n.linearSleepTolerance=.01,n.linearSleepToleranceSqr=Math.pow(n.linearSleepTolerance,2),n.angularSleepTolerance=2/180*Math.PI,n.angularSleepToleranceSqr=Math.pow(n.angularSleepTolerance,2)},{}],8:[function(t,i,e){function o(){this.m_type,this.m_radius}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;t("./common/Math");o.isValid=function(t){return!!t},o.prototype.getRadius=function(){return this.m_radius},o.prototype.getType=function(){return this.m_type},o.prototype._clone=function(){},o.prototype.getChildCount=function(){},o.prototype.testPoint=function(t,i){},o.prototype.rayCast=function(t,i,e,o){},o.prototype.computeAABB=function(t,i,e){},o.prototype.computeMass=function(t,i){},o.prototype.computeDistanceProxy=function(t){}},{"./common/Math":18}],9:[function(t,i,e){function o(t){this.dt=0,this.inv_dt=0,this.velocityIterations=0,this.positionIterations=0,this.warmStarting=!1,this.blockSolve=!0,this.inv_dt0=0,this.dtRatio=1}function s(t){this.m_world=t,this.m_profile=new function(){this.solveInit,this.solveVelocity,this.solvePosition},this.m_stack=[],this.m_bodies=[],this.m_contacts=[],this.m_joints=[]}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=s,i.exports.TimeStep=o;var m=t("./Settings"),a=t("./util/common"),h=t("./util/Timer"),c=t("./common/Vec2"),_=t("./common/Math"),l=t("./Body"),u=t("./Contact"),p=t("./Joint"),d=t("./collision/TimeOfImpact"),y=d.Input,v=d.Output,f=t("./collision/Distance");f.Input,f.Output,f.Proxy,f.Cache;o.prototype.reset=function(t){this.dt>0&&(this.inv_dt0=this.inv_dt),this.dt=t,this.inv_dt=0==t?0:1/t,this.dtRatio=t*this.inv_dt0},s.prototype.clear=function(){this.m_stack.length=0,this.m_bodies.length=0,this.m_contacts.length=0,this.m_joints.length=0},s.prototype.addBody=function(t){r&&a.assert(t instanceof l,"Not a Body!",t),this.m_bodies.push(t)},s.prototype.addContact=function(t){r&&a.assert(t instanceof u,"Not a Contact!",t),this.m_contacts.push(t)},s.prototype.addJoint=function(t){r&&a.assert(t instanceof p,"Not a Joint!",t),this.m_joints.push(t)},s.prototype.solveWorld=function(t){var i=this.m_world,e=this.m_profile;e.solveInit=0,e.solveVelocity=0,e.solvePosition=0;for(var o=i.m_bodyList;o;o=o.m_next)o.m_islandFlag=!1;for(var s=i.m_contactList;s;s=s.m_next)s.m_islandFlag=!1;for(var n=i.m_jointList;n;n=n.m_next)n.m_islandFlag=!1;for(var m=this.m_stack,h=i.m_bodyList;h;h=h.m_next)if(0,!h.m_islandFlag&&0!=h.isAwake()&&0!=h.isActive()&&!h.isStatic()){for(this.clear(),m.push(h),h.m_islandFlag=!0;m.length>0;){o=m.pop();if(r&&a.assert(1==o.isActive()),this.addBody(o),o.setAwake(!0),!o.isStatic()){for(var c=o.m_contactList;c;c=c.next){var _=c.contact;if(!_.m_islandFlag&&(0!=_.isEnabled()&&0!=_.isTouching())){var l=_.m_fixtureA.m_isSensor,u=_.m_fixtureB.m_isSensor;if(!l&&!u){this.addContact(_),_.m_islandFlag=!0;(d=c.other).m_islandFlag||(m.push(d),d.m_islandFlag=!0)}}}for(var p=o.m_jointList;p;p=p.next)if(1!=p.joint.m_islandFlag){var d;0!=(d=p.other).isActive()&&(this.addJoint(p.joint),p.joint.m_islandFlag=!0,d.m_islandFlag||(m.push(d),d.m_islandFlag=!0))}}}this.solveIsland(t);for(var y=0;y<this.m_bodies.length;++y){(o=this.m_bodies[y]).isStatic()&&(o.m_islandFlag=!1)}}},s.prototype.solveIsland=function(t){for(var i=this.m_world,e=this.m_profile,o=i.m_gravity,s=i.m_allowSleep,r=h.now(),l=t.dt,u=0;u<this.m_bodies.length;++u){var p=this.m_bodies[u],d=c.clone(p.m_sweep.c),y=p.m_sweep.a,v=c.clone(p.m_linearVelocity),f=p.m_angularVelocity;p.m_sweep.c0.set(p.m_sweep.c),p.m_sweep.a0=p.m_sweep.a,n&&a.debug("P: ",y,d.x,d.y,f,v.x,v.y),p.isDynamic()&&(v.wAdd(l*p.m_gravityScale,o),v.wAdd(l*p.m_invMass,p.m_force),f+=l*p.m_invI*p.m_torque,n&&a.debug("N: "+l,p.m_gravityScale,o.x,o.y,p.m_invMass,p.m_force.x,p.m_force.y),v.mul(1/(1+l*p.m_linearDamping)),f*=1/(1+l*p.m_angularDamping)),a.debug("A: ",y,d.x,d.y,f,v.x,v.y),p.c_position.c=d,p.c_position.a=y,p.c_velocity.v=v,p.c_velocity.w=f}r=h.now();for(u=0;u<this.m_contacts.length;++u){this.m_contacts[u].initConstraint(t)}n&&this.printBodies("M: ");for(u=0;u<this.m_contacts.length;++u){this.m_contacts[u].initVelocityConstraint(t)}if(n&&this.printBodies("R: "),t.warmStarting)for(u=0;u<this.m_contacts.length;++u){this.m_contacts[u].warmStartConstraint(t)}n&&this.printBodies("Q: ");for(u=0;u<this.m_joints.length;++u){this.m_joints[u].initVelocityConstraints(t)}n&&this.printBodies("E: "),e.solveInit=h.diff(r),r=h.now();for(u=0;u<t.velocityIterations;++u){n&&a.debug("--",u);for(var x=0;x<this.m_joints.length;++x){this.m_joints[x].solveVelocityConstraints(t)}for(x=0;x<this.m_contacts.length;++x){this.m_contacts[x].solveVelocityConstraint(t)}}n&&this.printBodies("D: ");for(u=0;u<this.m_contacts.length;++u){this.m_contacts[u].storeConstraintImpulses(t)}e.solveVelocity=h.diff(r),n&&this.printBodies("C: ");for(u=0;u<this.m_bodies.length;++u){p=this.m_bodies[u],d=c.clone(p.c_position.c),y=p.c_position.a,v=c.clone(p.c_velocity.v),f=p.c_velocity.w;var g=c.mul(l,v);if(c.lengthSquared(g)>m.maxTranslationSquared){var A=m.maxTranslation/g.length();v.mul(A)}var b=l*f;if(b*b>m.maxRotationSquared){f*=A=m.maxRotation/_.abs(b)}d.wAdd(l,v),y+=l*f,p.c_position.c.set(d),p.c_position.a=y,p.c_velocity.v.set(v),p.c_velocity.w=f}n&&this.printBodies("B: "),r=h.now();var B=!1;for(u=0;u<t.positionIterations;++u){var w=0;for(x=0;x<this.m_contacts.length;++x){var S=this.m_contacts[x].solvePositionConstraint(t);w=_.min(w,S)}var C=w>=-3*m.linearSlop,M=!0;for(x=0;x<this.m_joints.length;++x){var I=this.m_joints[x].solvePositionConstraints(t);M=M&&I}if(C&&M){B=!0;break}}n&&this.printBodies("L: ");for(u=0;u<this.m_bodies.length;++u){(p=this.m_bodies[u]).m_sweep.c.set(p.c_position.c),p.m_sweep.a=p.c_position.a,p.m_linearVelocity.set(p.c_velocity.v),p.m_angularVelocity=p.c_velocity.w,p.synchronizeTransform()}if(e.solvePosition=h.diff(r),this.postSolveIsland(),s){var P=1/0,T=m.linearSleepToleranceSqr,V=m.angularSleepToleranceSqr;for(u=0;u<this.m_bodies.length;++u){(p=this.m_bodies[u]).isStatic()||(0==p.m_autoSleepFlag||p.m_angularVelocity*p.m_angularVelocity>V||c.lengthSquared(p.m_linearVelocity)>T?(p.m_sleepTime=0,P=0):(p.m_sleepTime+=l,P=_.min(P,p.m_sleepTime)))}if(P>=m.timeToSleep&&B)for(u=0;u<this.m_bodies.length;++u){(p=this.m_bodies[u]).setAwake(!1)}}},s.prototype.printBodies=function(t){for(var i=0;i<this.m_bodies.length;++i){var e=this.m_bodies[i];a.debug(t,e.c_position.a,e.c_position.c.x,e.c_position.c.y,e.c_velocity.w,e.c_velocity.v.x,e.c_velocity.v.y)}};var x=new o;s.prototype.solveWorldTOI=function(t){n&&a.debug("TOI++++++World");var i=this.m_world;this.m_profile;if(n&&a.debug("Z:",i.m_stepComplete),i.m_stepComplete){for(var e=i.m_bodyList;e;e=e.m_next)e.m_islandFlag=!1,e.m_sweep.alpha0=0,n&&a.debug("b.alpha0:",e.m_sweep.alpha0);for(var o=i.m_contactList;o;o=o.m_next)o.m_toiFlag=!1,o.m_islandFlag=!1,o.m_toiCount=0,o.m_toi=1}if(n)for(o=i.m_contactList;o;o=o.m_next)n&&a.debug("X:",o.m_toiFlag);for(;;){n&&a.debug(";;");var s=null,h=1;for(o=i.m_contactList;o;o=o.m_next)if(n&&a.debug("alpha0::",o.getFixtureA().getBody().m_sweep.alpha0,o.getFixtureB().getBody().m_sweep.alpha0),0!=o.isEnabled()&&(n&&a.debug("toiCount:",o.m_toiCount,m.maxSubSteps),!(o.m_toiCount>m.maxSubSteps))){n&&a.debug("toiFlag:",o.m_toiFlag);var c=1;if(o.m_toiFlag)c=o.m_toi;else{var l=o.getFixtureA(),u=o.getFixtureB();if(n&&a.debug("sensor:",l.isSensor(),u.isSensor()),l.isSensor()||u.isSensor())continue;var p=l.getBody(),f=u.getBody();r&&a.assert(p.isDynamic()||f.isDynamic());var g=p.isAwake()&&!p.isStatic(),A=f.isAwake()&&!f.isStatic();if(n&&a.debug("awakestatic:",p.isAwake(),p.isStatic()),n&&a.debug("awakestatic:",f.isAwake(),f.isStatic()),n&&a.debug("active:",g,A),0==g&&0==A)continue;n&&a.debug("alpha:",c,p.m_sweep.alpha0,f.m_sweep.alpha0);var b=p.isBullet()||!p.isDynamic(),B=f.isBullet()||!f.isDynamic();if(n&&a.debug("collide:",b,B),0==b&&0==B)continue;var w=p.m_sweep.alpha0;p.m_sweep.alpha0<f.m_sweep.alpha0?(w=f.m_sweep.alpha0,p.m_sweep.advance(w)):f.m_sweep.alpha0<p.m_sweep.alpha0&&(w=p.m_sweep.alpha0,f.m_sweep.advance(w)),n&&a.debug("alpha0:",w,p.m_sweep.alpha0,f.m_sweep.alpha0),r&&a.assert(w<1);var S=o.getChildIndexA(),C=o.getChildIndexB(),M=p.m_sweep,I=f.m_sweep;n&&a.debug("sweepA",M.localCenter.x,M.localCenter.y,M.c.x,M.c.y,M.a,M.alpha0,M.c0.x,M.c0.y,M.a0),n&&a.debug("sweepB",I.localCenter.x,I.localCenter.y,I.c.x,I.c.y,I.a,I.alpha0,I.c0.x,I.c0.y,I.a0);var P=new y;P.proxyA.set(l.getShape(),S),P.proxyB.set(u.getShape(),C),P.sweepA.set(p.m_sweep),P.sweepB.set(f.m_sweep),P.tMax=1;var T=new v;d(T,P);var V=T.t;n&&a.debug("state:",T.state,v.e_touching),c=T.state==v.e_touching?_.min(w+(1-w)*V,1):1,o.m_toi=c,o.m_toiFlag=!0}n&&a.debug("minAlpha:",h,c),c<h&&(s=o,h=c)}if(n&&a.debug("minContact:",null==s,1-10*_.EPSILON<h,h),null==s||1-10*_.EPSILON<h){i.m_stepComplete=!0;break}l=s.getFixtureA(),u=s.getFixtureB(),p=l.getBody(),f=u.getBody();var z=p.m_sweep.clone(),L=f.m_sweep.clone();if(p.advance(h),f.advance(h),s.update(i),s.m_toiFlag=!1,++s.m_toiCount,0!=s.isEnabled()&&0!=s.isTouching()){p.setAwake(!0),f.setAwake(!0),this.clear(),this.addBody(p),this.addBody(f),this.addContact(s),p.m_islandFlag=!0,f.m_islandFlag=!0,s.m_islandFlag=!0;for(var F=[p,f],q=0;q<F.length;++q){if((O=F[q]).isDynamic())for(var k=O.m_contactList;k;k=k.next){var D=k.contact;if(!D.m_islandFlag){var R=k.other;if(!R.isDynamic()||O.isBullet()||R.isBullet()){var E=D.m_fixtureA.m_isSensor,j=D.m_fixtureB.m_isSensor;if(!E&&!j){var J=R.m_sweep.clone();0==R.m_islandFlag&&R.advance(h),D.update(i),0!=D.isEnabled()&&0!=D.isTouching()?(D.m_islandFlag=!0,this.addContact(D),R.m_islandFlag||(R.m_islandFlag=!0,R.isStatic()||R.setAwake(!0),this.addBody(R))):(R.m_sweep.set(J),R.synchronizeTransform())}}}}}x.reset((1-h)*t.dt),x.dtRatio=1,x.positionIterations=20,x.velocityIterations=t.velocityIterations,x.warmStarting=!1,this.solveIslandTOI(x,p,f);for(q=0;q<this.m_bodies.length;++q){var O;if((O=this.m_bodies[q]).m_islandFlag=!1,O.isDynamic()){O.synchronizeFixtures();for(k=O.m_contactList;k;k=k.next)k.contact.m_toiFlag=!1,k.contact.m_islandFlag=!1}}if(i.findNewContacts(),i.m_subStepping){i.m_stepComplete=!1;break}}else s.setEnabled(!1),p.m_sweep.set(z),f.m_sweep.set(L),p.synchronizeTransform(),f.synchronizeTransform()}if(n)for(e=i.m_bodyList;e;e=e.m_next){o=e.m_sweep.c;var N=e.m_sweep.a,Y=e.m_linearVelocity,W=e.m_angularVelocity;n&&a.debug("== ",N,o.x,o.y,W,Y.x,Y.y)}},s.prototype.solveIslandTOI=function(t,i,e){n&&a.debug("TOI++++++Island");this.m_world,this.m_profile;for(var o=0;o<this.m_bodies.length;++o){(u=this.m_bodies[o]).c_position.c.set(u.m_sweep.c),u.c_position.a=u.m_sweep.a,u.c_velocity.v.set(u.m_linearVelocity),u.c_velocity.w=u.m_angularVelocity}for(o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initConstraint(t)}for(o=0;o<t.positionIterations;++o){for(var s=0,r=0;r<this.m_contacts.length;++r){var h=this.m_contacts[r].solvePositionConstraintTOI(t,i,e);s=_.min(s,h)}if(s>=-1.5*m.linearSlop)break}i.m_sweep.c0.set(i.c_position.c),i.m_sweep.a0=i.c_position.a,e.m_sweep.c0.set(e.c_position.c),e.m_sweep.a0=e.c_position.a;for(o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initVelocityConstraint(t)}for(o=0;o<t.velocityIterations;++o)for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].solveVelocityConstraint(t)}var l=t.dt;for(o=0;o<this.m_bodies.length;++o){var u=this.m_bodies[o],p=c.clone(u.c_position.c),d=u.c_position.a,y=c.clone(u.c_velocity.v),v=u.c_velocity.w,f=c.mul(l,y);if(c.dot(f,f)>m.maxTranslationSquared){var x=m.maxTranslation/f.length();y.mul(x)}var g=l*v;if(g*g>m.maxRotationSquared){v*=x=m.maxRotation/_.abs(g)}p.wAdd(l,y),d+=l*v,u.c_position.c=p,u.c_position.a=d,u.c_velocity.v=y,u.c_velocity.w=v,u.m_sweep.c=p,u.m_sweep.a=d,u.m_linearVelocity=y,u.m_angularVelocity=v,u.synchronizeTransform()}this.postSolveIsland(),n&&a.debug("TOI------Island")},s.prototype.postSolveIsland=function(){for(var t=new function(){this.normalImpulses=[],this.tangentImpulses=[]},i=0;i<this.m_contacts.length;++i){for(var e=this.m_contacts[i],o=0;o<e.v_points.length;++o)t.normalImpulses.push(e.v_points[o].normalImpulse),t.tangentImpulses.push(e.v_points[o].tangentImpulse);this.m_world.postSolve(e,t)}}},{"./Body":2,"./Contact":3,"./Joint":5,"./Settings":7,"./collision/Distance":13,"./collision/TimeOfImpact":15,"./common/Math":18,"./common/Vec2":23,"./util/Timer":49,"./util/common":50}],10:[function(t,i,e){function o(t){if(!(this instanceof o))return new o(t);t&&a.isValid(t)&&(t={gravity:t}),t=r(t,u),this.m_solver=new c(this),this.m_broadPhase=new h,this.m_contactList=null,this.m_contactCount=0,this.m_bodyList=null,this.m_bodyCount=0,this.m_jointList=null,this.m_jointCount=0,this.m_stepComplete=!0,this.m_allowSleep=t.allowSleep,this.m_gravity=a.clone(t.gravity),this.m_clearForces=!0,this.m_newFixture=!1,this.m_locked=!1,this.m_warmStarting=t.warmStarting,this.m_continuousPhysics=t.continuousPhysics,this.m_subStepping=t.subStepping,this.m_blockSolve=t.blockSolve,this.m_velocityIterations=t.velocityIterations,this.m_positionIterations=t.positionIterations,this.m_t=0,this.m_stepCount=0,this.addPair=this.createContact.bind(this)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("./util/options"),m=t("./util/common"),a=(t("./util/Timer"),t("./common/Vec2")),h=t("./collision/BroadPhase"),c=t("./Solver"),_=t("./Body"),l=t("./Contact"),u={gravity:a.zero(),allowSleep:!0,warmStarting:!0,continuousPhysics:!0,subStepping:!1,blockSolve:!0,velocityIterations:8,positionIterations:3};o.prototype.getBodyList=function(){return this.m_bodyList},o.prototype.getJointList=function(){return this.m_jointList},o.prototype.getContactList=function(){return this.m_contactList},o.prototype.getBodyCount=function(){return this.m_bodyCount},o.prototype.getJointCount=function(){return this.m_jointCount},o.prototype.getContactCount=function(){return this.m_contactCount},o.prototype.setGravity=function(t){this.m_gravity=t},o.prototype.getGravity=function(){return this.m_gravity},o.prototype.isLocked=function(){return this.m_locked},o.prototype.setAllowSleeping=function(t){if(t!=this.m_allowSleep&&(this.m_allowSleep=t,0==this.m_allowSleep))for(var i=this.m_bodyList;i;i=i.m_next)i.setAwake(!0)},o.prototype.getAllowSleeping=function(){return this.m_allowSleep},o.prototype.setWarmStarting=function(t){this.m_warmStarting=t},o.prototype.getWarmStarting=function(){return this.m_warmStarting},o.prototype.setContinuousPhysics=function(t){this.m_continuousPhysics=t},o.prototype.getContinuousPhysics=function(){return this.m_continuousPhysics},o.prototype.setSubStepping=function(t){this.m_subStepping=t},o.prototype.getSubStepping=function(){return this.m_subStepping},o.prototype.setAutoClearForces=function(t){this.m_clearForces=t},o.prototype.getAutoClearForces=function(){return this.m_clearForces},o.prototype.clearForces=function(){for(var t=this.m_bodyList;t;t=t.getNext())t.m_force.setZero(),t.m_torque=0},o.prototype.queryAABB=function(t,i){n&&m.assert("function"==typeof i);var e=this.m_broadPhase;this.m_broadPhase.query(t,function(t){var o=e.getUserData(t);return i(o.fixture)})},o.prototype.rayCast=function(t,i,e){n&&m.assert("function"==typeof e);var o=this.m_broadPhase;this.m_broadPhase.rayCast({maxFraction:1,p1:t,p2:i},function(t,i){var s=o.getUserData(i),n=s.fixture,r=s.childIndex,m={};if(n.rayCast(m,t,r)){var h=m.fraction,c=a.add(a.mul(1-h,t.p1),a.mul(h,t.p2));return e(n,c,m.normal,h)}return t.maxFraction})},o.prototype.getProxyCount=function(){return this.m_broadPhase.getProxyCount()},o.prototype.getTreeHeight=function(){return this.m_broadPhase.getTreeHeight()},o.prototype.getTreeBalance=function(){return this.m_broadPhase.getTreeBalance()},o.prototype.getTreeQuality=function(){return this.m_broadPhase.getTreeQuality()},o.prototype.shiftOrigin=function(t){if(n&&m.assert(0==this.m_locked),!this.m_locked){for(var i=this.m_bodyList;i;i=i.m_next)i.m_xf.p.sub(t),i.m_sweep.c0.sub(t),i.m_sweep.c.sub(t);for(var e=this.m_jointList;e;e=e.m_next)e.shiftOrigin(t);this.m_broadPhase.shiftOrigin(t)}},o.prototype.createBody=function(t,i){if(n&&m.assert(0==this.isLocked()),this.isLocked())return null;t&&a.isValid(t)&&(t={position:t,angle:i});var e=new _(this,t);return e.m_prev=null,e.m_next=this.m_bodyList,this.m_bodyList&&(this.m_bodyList.m_prev=e),this.m_bodyList=e,++this.m_bodyCount,e},o.prototype.createDynamicBody=function(t,i){return t?a.isValid(t)&&(t={position:t,angle:i}):t={},t.type="dynamic",this.createBody(t)},o.prototype.createKinematicBody=function(t,i){return t?a.isValid(t)&&(t={position:t,angle:i}):t={},t.type="kinematic",this.createBody(t)},o.prototype.destroyBody=function(t){if(n&&m.assert(this.m_bodyCount>0),n&&m.assert(0==this.isLocked()),!this.isLocked()){if(t.m_destroyed)return!1;for(var i=t.m_jointList;i;){var e=i;i=i.next,this.publish("remove-joint",e.joint),this.destroyJoint(e.joint),t.m_jointList=i}t.m_jointList=null;for(var o=t.m_contactList;o;){var s=o;o=o.next,this.destroyContact(s.contact),t.m_contactList=o}t.m_contactList=null;for(var r=t.m_fixtureList;r;){var a=r;r=r.m_next,this.publish("remove-fixture",a),a.destroyProxies(this.m_broadPhase),t.m_fixtureList=r}return t.m_fixtureList=null,t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_bodyList&&(this.m_bodyList=t.m_next),t.m_destroyed=!0,--this.m_bodyCount,!0}},o.prototype.createJoint=function(t){if(n&&m.assert(!!t.m_bodyA),n&&m.assert(!!t.m_bodyB),n&&m.assert(0==this.isLocked()),this.isLocked())return null;if(t.m_prev=null,t.m_next=this.m_jointList,this.m_jointList&&(this.m_jointList.m_prev=t),this.m_jointList=t,++this.m_jointCount,t.m_edgeA.joint=t,t.m_edgeA.other=t.m_bodyB,t.m_edgeA.prev=null,t.m_edgeA.next=t.m_bodyA.m_jointList,t.m_bodyA.m_jointList&&(t.m_bodyA.m_jointList.prev=t.m_edgeA),t.m_bodyA.m_jointList=t.m_edgeA,t.m_edgeB.joint=t,t.m_edgeB.other=t.m_bodyA,t.m_edgeB.prev=null,t.m_edgeB.next=t.m_bodyB.m_jointList,t.m_bodyB.m_jointList&&(t.m_bodyB.m_jointList.prev=t.m_edgeB),t.m_bodyB.m_jointList=t.m_edgeB,0==t.m_collideConnected)for(var i=t.m_bodyB.getContactList();i;i=i.next)i.other==t.m_bodyA&&i.contact.flagForFiltering();return t},o.prototype.destroyJoint=function(t){if(n&&m.assert(0==this.isLocked()),!this.isLocked()){t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_jointList&&(this.m_jointList=t.m_next);var i=t.m_bodyA,e=t.m_bodyB;if(i.setAwake(!0),e.setAwake(!0),t.m_edgeA.prev&&(t.m_edgeA.prev.next=t.m_edgeA.next),t.m_edgeA.next&&(t.m_edgeA.next.prev=t.m_edgeA.prev),t.m_edgeA==i.m_jointList&&(i.m_jointList=t.m_edgeA.next),t.m_edgeA.prev=null,t.m_edgeA.next=null,t.m_edgeB.prev&&(t.m_edgeB.prev.next=t.m_edgeB.next),t.m_edgeB.next&&(t.m_edgeB.next.prev=t.m_edgeB.prev),t.m_edgeB==e.m_jointList&&(e.m_jointList=t.m_edgeB.next),t.m_edgeB.prev=null,t.m_edgeB.next=null,n&&m.assert(this.m_jointCount>0),--this.m_jointCount,0==t.m_collideConnected)for(var o=e.getContactList();o;)o.other==i&&o.contact.flagForFiltering(),o=o.next;this.publish("remove-joint",t)}};var p=new c.TimeStep;o.prototype.step=function(t,i,e){if((0|i)!==i&&(i=0),i=i||this.m_velocityIterations,e=e||this.m_positionIterations,this.m_stepCount++,this.m_newFixture&&(this.findNewContacts(),this.m_newFixture=!1),this.m_locked=!0,p.reset(t),p.velocityIterations=i,p.positionIterations=e,p.warmStarting=this.m_warmStarting,p.blockSolve=this.m_blockSolve,this.updateContacts(),this.m_stepComplete&&t>0){this.m_solver.solveWorld(p);for(var o=this.m_bodyList;o;o=o.getNext())0!=o.m_islandFlag&&(o.isStatic()||o.synchronizeFixtures());this.findNewContacts()}this.m_continuousPhysics&&t>0&&this.m_solver.solveWorldTOI(p),this.m_clearForces&&this.clearForces(),this.m_locked=!1},o.prototype.findNewContacts=function(){this.m_broadPhase.updatePairs(this.addPair)},o.prototype.createContact=function(t,i){var e=t.fixture,o=i.fixture,s=t.childIndex,n=i.childIndex,r=e.getBody(),m=o.getBody();if(r!=m){for(var a=m.getContactList();a;){if(a.other==r){var h=a.contact.getFixtureA(),c=a.contact.getFixtureB(),_=a.contact.getChildIndexA(),u=a.contact.getChildIndexB();if(h==e&&c==o&&_==s&&u==n)return;if(h==o&&c==e&&_==n&&u==s)return}a=a.next}if(0!=m.shouldCollide(r)&&0!=o.shouldCollide(e)){var p=l.create(e,s,o,n);null!=p&&(p.m_prev=null,null!=this.m_contactList&&(p.m_next=this.m_contactList,this.m_contactList.m_prev=p),this.m_contactList=p,++this.m_contactCount)}}},o.prototype.updateContacts=function(){for(var t,i=this.m_contactList;t=i;){i=t.getNext();var e=t.getFixtureA(),o=t.getFixtureB(),s=t.getChildIndexA(),n=t.getChildIndexB(),r=e.getBody(),m=o.getBody();if(t.m_filterFlag){if(0==m.shouldCollide(r)){this.destroyContact(t);continue}if(0==o.shouldCollide(e)){this.destroyContact(t);continue}t.m_filterFlag=!1}var a=r.isAwake()&&!r.isStatic(),h=m.isAwake()&&!m.isStatic();if(0!=a||0!=h){var c=e.m_proxies[s].proxyId,_=o.m_proxies[n].proxyId;0!=this.m_broadPhase.testOverlap(c,_)?t.update(this):this.destroyContact(t)}}},o.prototype.destroyContact=function(t){l.destroy(t,this),t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_contactList&&(this.m_contactList=t.m_next),--this.m_contactCount},o.prototype._listeners=null,o.prototype.on=function(t,i){return"string"!=typeof t||"function"!=typeof i?this:(this._listeners||(this._listeners={}),this._listeners[t]||(this._listeners[t]=[]),this._listeners[t].push(i),this)},o.prototype.off=function(t,i){if("string"!=typeof t||"function"!=typeof i)return this;var e=this._listeners&&this._listeners[t];if(!e||!e.length)return this;var o=e.indexOf(i);return o>=0&&e.splice(o,1),this},o.prototype.publish=function(t,i,e,o){var s=this._listeners&&this._listeners[t];if(!s||!s.length)return 0;for(var n=0;n<s.length;n++)s[n].call(this,i,e,o);return s.length},o.prototype.beginContact=function(t){this.publish("begin-contact",t)},o.prototype.endContact=function(t){this.publish("end-contact",t)},o.prototype.preSolve=function(t,i){this.publish("pre-solve",t,i)},o.prototype.postSolve=function(t,i){this.publish("post-solve",t,i)}},{"./Body":2,"./Contact":3,"./Solver":9,"./collision/BroadPhase":12,"./common/Vec2":23,"./util/Timer":49,"./util/common":50,"./util/options":52}],11:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);this.lowerBound=m.zero(),this.upperBound=m.zero(),"object"==typeof t&&this.lowerBound.set(t),"object"==typeof i&&this.upperBound.set(i)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;t("../Settings");var r=t("../common/Math"),m=t("../common/Vec2");i.exports=o,o.prototype.isValid=function(){return o.isValid(this)},o.isValid=function(t){var i=m.sub(t.upperBound,t.lowerBound);return i.x>=0&&i.y>=0&&m.isValid(t.lowerBound)&&m.isValid(t.upperBound)},o.prototype.getCenter=function(){return m.neo(.5*(this.lowerBound.x+this.upperBound.x),.5*(this.lowerBound.y+this.upperBound.y))},o.prototype.getExtents=function(){return m.neo(.5*(this.upperBound.x-this.lowerBound.x),.5*(this.upperBound.y-this.lowerBound.y))},o.prototype.getPerimeter=function(){return 2*(this.upperBound.x-this.lowerBound.x+this.upperBound.y-this.lowerBound.y)},o.prototype.combine=function(t,i){i=i||this,this.lowerBound.set(r.min(t.lowerBound.x,i.lowerBound.x),r.min(t.lowerBound.y,i.lowerBound.y)),this.upperBound.set(r.max(t.upperBound.x,i.upperBound.x),r.max(t.upperBound.y,i.upperBound.y))},o.prototype.combinePoints=function(t,i){this.lowerBound.set(r.min(t.x,i.x),r.min(t.y,i.y)),this.upperBound.set(r.max(t.x,i.x),r.max(t.y,i.y))},o.prototype.set=function(t){this.lowerBound.set(t.lowerBound.x,t.lowerBound.y),this.upperBound.set(t.upperBound.x,t.upperBound.y)},o.prototype.contains=function(t){var i=!0;return i=i&&this.lowerBound.x<=t.lowerBound.x,i=i&&this.lowerBound.y<=t.lowerBound.y,i=i&&t.upperBound.x<=this.upperBound.x,i=i&&t.upperBound.y<=this.upperBound.y},o.prototype.extend=function(t){o.extend(this,t)},o.extend=function(t,i){t.lowerBound.x-=i,t.lowerBound.y-=i,t.upperBound.x+=i,t.upperBound.y+=i},o.testOverlap=function(t,i){var e=i.lowerBound.x-t.upperBound.x,o=t.lowerBound.x-i.upperBound.x,s=i.lowerBound.y-t.upperBound.y,n=t.lowerBound.y-i.upperBound.y;return!(e>0||s>0||o>0||n>0)},o.areEqual=function(t,i){return m.areEqual(t.lowerBound,i.lowerBound)&&m.areEqual(t.upperBound,i.upperBound)},o.diff=function(t,i){var e=r.max(0,r.min(t.upperBound.x,i.upperBound.x)-r.max(i.lowerBound.x,t.lowerBound.x)),o=r.max(0,r.min(t.upperBound.y,i.upperBound.y)-r.max(i.lowerBound.y,t.lowerBound.y));return(t.upperBound.x-t.lowerBound.x)*(t.upperBound.y-t.lowerBound.y)+(i.upperBound.x-i.lowerBound.x)*(i.upperBound.y-i.lowerBound.y)-e*o},o.prototype.rayCast=function(t,i){for(var e=-1/0,o=1/0,s=i.p1,n=m.sub(i.p2,i.p1),a=m.abs(n),h=m.zero(),c="x";null!==c;c="x"===c?"y":null)if(a.x<r.EPSILON){if(s[c]<this.lowerBound[c]||this.upperBound[c]<s[c])return!1}else{var _=1/n[c],l=(this.lowerBound[c]-s[c])*_,u=(this.upperBound[c]-s[c])*_,p=-1;if(l>u){var d=l;l=u,u=d,p=1}if(l>e&&(h.setZero(),h[c]=p,e=l),o=r.min(o,u),e>o)return!1}return!(e<0||i.maxFraction<e)&&(t.fraction=e,t.normal=h,!0)},o.prototype.toString=function(){return JSON.stringify(this)}},{"../Settings":7,"../common/Math":18,"../common/Vec2":23}],12:[function(t,i,e){function o(){this.m_tree=new h,this.m_proxyCount=0,this.m_moveBuffer=[],this.queryCallback=this.queryCallback.bind(this)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;t("../Settings");var r=t("../util/common"),m=t("../common/Math"),a=t("./AABB"),h=t("./DynamicTree");i.exports=o,o.prototype.getUserData=function(t){return this.m_tree.getUserData(t)},o.prototype.testOverlap=function(t,i){var e=this.m_tree.getFatAABB(t),o=this.m_tree.getFatAABB(i);return a.testOverlap(e,o)},o.prototype.getFatAABB=function(t){return this.m_tree.getFatAABB(t)},o.prototype.getProxyCount=function(){return this.m_proxyCount},o.prototype.getTreeHeight=function(){return this.m_tree.getHeight()},o.prototype.getTreeBalance=function(){return this.m_tree.getMaxBalance()},o.prototype.getTreeQuality=function(){return this.m_tree.getAreaRatio()},o.prototype.query=function(t,i){this.m_tree.query(t,i)},o.prototype.rayCast=function(t,i){this.m_tree.rayCast(t,i)},o.prototype.shiftOrigin=function(t){this.m_tree.shiftOrigin(t)},o.prototype.createProxy=function(t,i){n&&r.assert(a.isValid(t));var e=this.m_tree.createProxy(t,i);return this.m_proxyCount++,this.bufferMove(e),e},o.prototype.destroyProxy=function(t){this.unbufferMove(t),this.m_proxyCount--,this.m_tree.destroyProxy(t)},o.prototype.moveProxy=function(t,i,e){n&&r.assert(a.isValid(i));this.m_tree.moveProxy(t,i,e)&&this.bufferMove(t)},o.prototype.touchProxy=function(t){this.bufferMove(t)},o.prototype.bufferMove=function(t){this.m_moveBuffer.push(t)},o.prototype.unbufferMove=function(t){for(var i=0;i<this.m_moveBuffer.length;++i)this.m_moveBuffer[i]==t&&(this.m_moveBuffer[i]=null)},o.prototype.updatePairs=function(t){for(n&&r.assert("function"==typeof t),this.m_callback=t;this.m_moveBuffer.length>0;)if(this.m_queryProxyId=this.m_moveBuffer.pop(),null!==this.m_queryProxyId){var i=this.m_tree.getFatAABB(this.m_queryProxyId);this.m_tree.query(i,this.queryCallback)}},o.prototype.queryCallback=function(t){if(t==this.m_queryProxyId)return!0;var i=m.min(t,this.m_queryProxyId),e=m.max(t,this.m_queryProxyId),o=this.m_tree.getUserData(i),s=this.m_tree.getUserData(e);return this.m_callback(o,s),!0}},{"../Settings":7,"../common/Math":18,"../util/common":50,"./AABB":11,"./DynamicTree":14}],13:[function(t,i,e){function o(){this.proxyA=new m,this.proxyB=new m,this.transformA=null,this.transformB=null,this.useRadii=!1}function s(){this.pointA=y.zero(),this.pointB=y.zero(),this.distance,this.iterations}function n(){this.metric=0,this.indexA=[],this.indexB=[],this.count=0}function r(t,i,e){++p.gjkCalls;var o=e.proxyA,s=e.proxyB,n=e.transformA,r=e.transformB;c&&u.debug("cahce:",i.metric,i.count),c&&u.debug("proxyA:",o.m_count),c&&u.debug("proxyB:",s.m_count),c&&u.debug("xfA:",n.p.x,n.p.y,n.q.c,n.q.s),c&&u.debug("xfB:",r.p.x,r.p.y,r.q.c,r.q.s);var m=new h;m.readCache(i,o,n,s,r),c&&u.debug("cache",m.print());for(var a=m.m_v,_=l.maxDistnceIterations,x=[],g=[],A=0,b=0;b<_;){A=m.m_count;for(var B=0;B<A;++B)x[B]=a[B].indexA,g[B]=a[B].indexB;if(m.solve(),3==m.m_count)break;(T=m.getClosestPoint()).lengthSquared();var w=m.getSearchDirection();if(w.lengthSquared()<d.EPSILON*d.EPSILON)break;var S=a[m.m_count];S.indexA=o.getSupport(v.mulT(n.q,y.neg(w))),S.wA=f.mul(n,o.getVertex(S.indexA)),S.indexB=s.getSupport(v.mulT(r.q,w)),S.wB=f.mul(r,s.getVertex(S.indexB)),S.w=y.sub(S.wB,S.wA),++b,++p.gjkIters;var C=!1;for(B=0;B<A;++B)if(S.indexA==x[B]&&S.indexB==g[B]){C=!0;break}if(C)break;++m.m_count}if(p.gjkMaxIters=d.max(p.gjkMaxIters,b),m.getWitnessPoints(t.pointA,t.pointB),t.distance=y.distance(t.pointA,t.pointB),t.iterations=b,c&&u.debug("Distance:",t.distance,t.pointA.x,t.pointA.y,t.pointB.x,t.pointB.y),m.writeCache(i),e.useRadii){var M=o.m_radius,I=s.m_radius;if(t.distance>M+I&&t.distance>d.EPSILON){t.distance-=M+I;var P=y.sub(t.pointB,t.pointA);P.normalize(),t.pointA.wAdd(M,P),t.pointB.wSub(I,P)}else{var T=y.mid(t.pointA,t.pointB);t.pointA.set(T),t.pointB.set(T),t.distance=0}}}function m(){this.m_buffer=[],this.m_vertices=[],this.m_count=0,this.m_radius=0}function a(){this.indexA,this.indexB,this.wA=y.zero(),this.wB=y.zero(),this.w=y.zero(),this.a}function h(){this.m_v1=new a,this.m_v2=new a,this.m_v3=new a,this.m_v=[this.m_v1,this.m_v2,this.m_v3],this.m_count}if(void 0===c)var c=!1;if(void 0===_)var _=!1;i.exports=r,i.exports.Input=o,i.exports.Output=s,i.exports.Proxy=m,i.exports.Cache=n;var l=t("../Settings"),u=t("../util/common"),p=(t("../util/Timer"),t("../common/stats")),d=t("../common/Math"),y=t("../common/Vec2"),v=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),f=(t("../common/Sweep"),t("../common/Transform"));t("../common/Velocity"),t("../common/Position");p.gjkCalls=0,p.gjkIters=0,p.gjkMaxIters=0,m.prototype.getVertexCount=function(){return this.m_count},m.prototype.getVertex=function(t){return _&&u.assert(0<=t&&t<this.m_count),this.m_vertices[t]},m.prototype.getSupport=function(t){for(var i=0,e=y.dot(this.m_vertices[0],t),o=0;o<this.m_count;++o){var s=y.dot(this.m_vertices[o],t);s>e&&(i=o,e=s)}return i},m.prototype.getSupportVertex=function(t){return this.m_vertices[this.getSupport(t)]},m.prototype.set=function(t,i){_&&u.assert("function"==typeof t.computeDistanceProxy),t.computeDistanceProxy(this,i)},a.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.wA=y.clone(t.wA),this.wB=y.clone(t.wB),this.w=y.clone(t.w),this.a=t.a},h.prototype.print=function(){return 3==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y,this.m_v3.a,this.m_v3.wA.x,this.m_v3.wA.y,this.m_v3.wB.x,this.m_v3.wB.y].toString():2==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y].toString():1==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y].toString():"+"+this.m_count},h.prototype.readCache=function(t,i,e,o,s){_&&u.assert(t.count<=3),this.m_count=t.count;for(var n=0;n<this.m_count;++n){(c=this.m_v[n]).indexA=t.indexA[n],c.indexB=t.indexB[n];var r=i.getVertex(c.indexA),m=o.getVertex(c.indexB);c.wA=f.mul(e,r),c.wB=f.mul(s,m),c.w=y.sub(c.wB,c.wA),c.a=0}if(this.m_count>1){var a=t.metric,h=this.getMetric();(h<.5*a||2*a<h||h<d.EPSILON)&&(this.m_count=0)}if(0==this.m_count){var c;(c=this.m_v[0]).indexA=0,c.indexB=0;r=i.getVertex(0),m=o.getVertex(0);c.wA=f.mul(e,r),c.wB=f.mul(s,m),c.w=y.sub(c.wB,c.wA),c.a=1,this.m_count=1}},h.prototype.writeCache=function(t){t.metric=this.getMetric(),t.count=this.m_count;for(var i=0;i<this.m_count;++i)t.indexA[i]=this.m_v[i].indexA,t.indexB[i]=this.m_v[i].indexB},h.prototype.getSearchDirection=function(){switch(this.m_count){case 1:return y.neg(this.m_v1.w);case 2:var t=y.sub(this.m_v2.w,this.m_v1.w);return y.cross(t,y.neg(this.m_v1.w))>0?y.cross(1,t):y.cross(t,1);default:return _&&u.assert(!1),y.zero()}},h.prototype.getClosestPoint=function(){switch(this.m_count){case 0:return _&&u.assert(!1),y.zero();case 1:return y.clone(this.m_v1.w);case 2:return y.wAdd(this.m_v1.a,this.m_v1.w,this.m_v2.a,this.m_v2.w);case 3:return y.zero();default:return _&&u.assert(!1),y.zero()}},h.prototype.getWitnessPoints=function(t,i){switch(this.m_count){case 0:_&&u.assert(!1);break;case 1:c&&u.debug("case1",this.print()),t.set(this.m_v1.wA),i.set(this.m_v1.wB);break;case 2:c&&u.debug("case2",this.print()),t.wSet(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),i.wSet(this.m_v1.a,this.m_v1.wB,this.m_v2.a,this.m_v2.wB);break;case 3:c&&u.debug("case3",this.print()),t.wSet(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),t.wAdd(this.m_v3.a,this.m_v3.wA),i.set(t);break;default:_&&u.assert(!1)}},h.prototype.getMetric=function(){switch(this.m_count){case 0:return _&&u.assert(!1),0;case 1:return 0;case 2:return y.distance(this.m_v1.w,this.m_v2.w);case 3:return y.cross(y.sub(this.m_v2.w,this.m_v1.w),y.sub(this.m_v3.w,this.m_v1.w));default:return _&&u.assert(!1),0}},h.prototype.solve=function(){switch(this.m_count){case 1:break;case 2:this.solve2();break;case 3:this.solve3();break;default:_&&u.assert(!1)}},h.prototype.solve2=function(){var t=this.m_v1.w,i=this.m_v2.w,e=y.sub(i,t),o=-y.dot(t,e);if(o<=0)return this.m_v1.a=1,void(this.m_count=1);var s=y.dot(i,e);if(s<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);var n=1/(s+o);this.m_v1.a=s*n,this.m_v2.a=o*n,this.m_count=2},h.prototype.solve3=function(){var t=this.m_v1.w,i=this.m_v2.w,e=this.m_v3.w,o=y.sub(i,t),s=y.dot(t,o),n=y.dot(i,o),r=-s,m=y.sub(e,t),a=y.dot(t,m),h=y.dot(e,m),c=-a,_=y.sub(e,i),l=y.dot(i,_),u=y.dot(e,_),p=-l,d=y.cross(o,m),v=d*y.cross(i,e),f=d*y.cross(e,t),x=d*y.cross(t,i);if(r<=0&&c<=0)return this.m_v1.a=1,void(this.m_count=1);if(n>0&&r>0&&x<=0){var g=1/(n+r);return this.m_v1.a=n*g,this.m_v2.a=r*g,void(this.m_count=2)}if(h>0&&c>0&&f<=0){var A=1/(h+c);return this.m_v1.a=h*A,this.m_v3.a=c*A,this.m_count=2,void this.m_v2.set(this.m_v3)}if(n<=0&&p<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);if(h<=0&&u<=0)return this.m_v3.a=1,this.m_count=1,void this.m_v1.set(this.m_v3);if(u>0&&p>0&&v<=0){var b=1/(u+p);return this.m_v2.a=u*b,this.m_v3.a=p*b,this.m_count=2,void this.m_v1.set(this.m_v3)}var B=1/(v+f+x);this.m_v1.a=v*B,this.m_v2.a=f*B,this.m_v3.a=x*B,this.m_count=3},r.testOverlap=function(t,i,e,m,a,h){var c=new o;c.proxyA.set(t,i),c.proxyB.set(e,m),c.transformA=a,c.transformB=h,c.useRadii=!0;var _=new n,l=new s;return r(l,_,c),l.distance<10*d.EPSILON}},{"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../common/stats":26,"../util/Timer":49,"../util/common":50}],14:[function(t,i,e){function o(t){this.id=t,this.aabb=new l,this.userData=null,this.parent=null,this.child1=null,this.child2=null,this.height=-1,this.toString=function(){return this.id+": "+this.userData}}function s(){this.m_root=null,this.m_nodes={},this.m_lastProxyId=0,this.m_pool=new h({create:function(){return new o}})}if(void 0===n)var n=!1;if(void 0===r)var r=!1;var m=t("../Settings"),a=t("../util/common"),h=t("../util/Pool"),c=t("../common/Vec2"),_=t("../common/Math"),l=t("./AABB");i.exports=s,o.prototype.isLeaf=function(){return null==this.child1},s.prototype.getUserData=function(t){var i=this.m_nodes[t];return r&&a.assert(!!i),i.userData},s.prototype.getFatAABB=function(t){var i=this.m_nodes[t];return r&&a.assert(!!i),i.aabb},s.prototype.allocateNode=function(){var t=this.m_pool.allocate();return t.id=++this.m_lastProxyId,t.userData=null,t.parent=null,t.child1=null,t.child2=null,t.height=-1,this.m_nodes[t.id]=t,t},s.prototype.freeNode=function(t){this.m_pool.release(t),t.height=-1,delete this.m_nodes[t.id]},s.prototype.createProxy=function(t,i){r&&a.assert(l.isValid(t));var e=this.allocateNode();return e.aabb.set(t),l.extend(e.aabb,m.aabbExtension),e.userData=i,e.height=0,this.insertLeaf(e),e.id},s.prototype.destroyProxy=function(t){var i=this.m_nodes[t];r&&a.assert(!!i),r&&a.assert(i.isLeaf()),this.removeLeaf(i),this.freeNode(i)},s.prototype.moveProxy=function(t,i,e){r&&a.assert(l.isValid(i)),r&&a.assert(!e||c.isValid(e));var o=this.m_nodes[t];return r&&a.assert(!!o),r&&a.assert(o.isLeaf()),!o.aabb.contains(i)&&(this.removeLeaf(o),o.aabb.set(i),i=o.aabb,l.extend(i,m.aabbExtension),e.x<0?i.lowerBound.x+=e.x*m.aabbMultiplier:i.upperBound.x+=e.x*m.aabbMultiplier,e.y<0?i.lowerBound.y+=e.y*m.aabbMultiplier:i.upperBound.y+=e.y*m.aabbMultiplier,this.insertLeaf(o),!0)},s.prototype.insertLeaf=function(t){if(r&&a.assert(l.isValid(t.aabb)),null==this.m_root)return this.m_root=t,void(this.m_root.parent=null);for(var i=t.aabb,e=this.m_root;0==e.isLeaf();){var o=e.child1,s=e.child2,n=e.aabb.getPerimeter(),m=new l;m.combine(e.aabb,i);var h,c=m.getPerimeter(),u=2*c,p=2*(c-n);if(o.isLeaf()){(v=new l).combine(i,o.aabb),h=v.getPerimeter()+p}else{(v=new l).combine(i,o.aabb);var d=o.aabb.getPerimeter();h=v.getPerimeter()-d+p}var y;if(s.isLeaf()){(v=new l).combine(i,s.aabb),y=v.getPerimeter()+p}else{var v;(v=new l).combine(i,s.aabb);d=s.aabb.getPerimeter();y=v.getPerimeter()-d+p}if(u<h&&u<y)break;e=h<y?o:s}var f=e,x=f.parent,g=this.allocateNode();for(g.parent=x,g.userData=null,g.aabb.combine(i,f.aabb),g.height=f.height+1,null!=x?(x.child1==f?x.child1=g:x.child2=g,g.child1=f,g.child2=t,f.parent=g,t.parent=g):(g.child1=f,g.child2=t,f.parent=g,t.parent=g,this.m_root=g),e=t.parent;null!=e;){o=(e=this.balance(e)).child1,s=e.child2;r&&a.assert(null!=o),r&&a.assert(null!=s),e.height=1+_.max(o.height,s.height),e.aabb.combine(o.aabb,s.aabb),e=e.parent}},s.prototype.removeLeaf=function(t){if(t!=this.m_root){var i,e=t.parent,o=e.parent;if(i=e.child1==t?e.child2:e.child1,null!=o){o.child1==e?o.child1=i:o.child2=i,i.parent=o,this.freeNode(e);for(var s=o;null!=s;){var n=(s=this.balance(s)).child1,r=s.child2;s.aabb.combine(n.aabb,r.aabb),s.height=1+_.max(n.height,r.height),s=s.parent}}else this.m_root=i,i.parent=null,this.freeNode(e)}else this.m_root=null},s.prototype.balance=function(t){r&&a.assert(null!=t);var i=t;if(i.isLeaf()||i.height<2)return t;var e=i.child1,o=i.child2,s=o.height-e.height;if(s>1){var n=o.child1,m=o.child2;return o.child1=i,o.parent=i.parent,i.parent=o,null!=o.parent?o.parent.child1==t?o.parent.child1=o:o.parent.child2=o:this.m_root=o,n.height>m.height?(o.child2=n,i.child2=m,m.parent=i,i.aabb.combine(e.aabb,m.aabb),o.aabb.combine(i.aabb,n.aabb),i.height=1+_.max(e.height,m.height),o.height=1+_.max(i.height,n.height)):(o.child2=m,i.child2=n,n.parent=i,i.aabb.combine(e.aabb,n.aabb),o.aabb.combine(i.aabb,m.aabb),i.height=1+_.max(e.height,n.height),o.height=1+_.max(i.height,m.height)),o}if(s<-1){var h=e.child1,c=e.child2;return e.child1=i,e.parent=i.parent,i.parent=e,null!=e.parent?e.parent.child1==i?e.parent.child1=e:e.parent.child2=e:this.m_root=e,h.height>c.height?(e.child2=h,i.child1=c,c.parent=i,i.aabb.combine(o.aabb,c.aabb),e.aabb.combine(i.aabb,h.aabb),i.height=1+_.max(o.height,c.height),e.height=1+_.max(i.height,h.height)):(e.child2=c,i.child1=h,h.parent=i,i.aabb.combine(o.aabb,h.aabb),e.aabb.combine(i.aabb,c.aabb),i.height=1+_.max(o.height,h.height),e.height=1+_.max(i.height,c.height)),e}return i},s.prototype.getHeight=function(){return null==this.m_root?0:this.m_root.height},s.prototype.getAreaRatio=function(){if(null==this.m_root)return 0;for(var t,i=this.m_root.aabb.getPerimeter(),e=0,o=d.allocate().preorder();t=o.next();)t.height<0||(e+=t.aabb.getPerimeter());return d.release(o),e/i},s.prototype.computeHeight=function(t){var i;if((i=void 0!==t?this.m_nodes[t]:this.m_root).isLeaf())return 0;var e=ComputeHeight(i.child1),o=ComputeHeight(i.child2);return 1+_.max(e,o)},s.prototype.validateStructure=function(t){if(null!=t){t==this.m_root&&r&&a.assert(null==t.parent);var i=t.child1,e=t.child2;if(t.isLeaf())return r&&a.assert(null==i),r&&a.assert(null==e),void(r&&a.assert(0==t.height));r&&a.assert(i.parent==t),r&&a.assert(e.parent==t),this.validateStructure(i),this.validateStructure(e)}},s.prototype.validateMetrics=function(t){if(null!=t){var i=t.child1,e=t.child2;if(t.isLeaf())return r&&a.assert(null==i),r&&a.assert(null==e),void(r&&a.assert(0==t.height));var o=this.m_nodes[i].height,s=this.m_nodes[e].height,n=1+_.max(o,s);r&&a.assert(t.height==n);var m=new l;m.combine(i.aabb,e.aabb),r&&a.assert(l.areEqual(m,t.aabb)),this.validateMetrics(i),this.validateMetrics(e)}},s.prototype.validate=function(){ValidateStructure(this.m_root),ValidateMetrics(this.m_root),r&&a.assert(this.getHeight()==this.computeHeight())},s.prototype.getMaxBalance=function(){for(var t,i=0,e=d.allocate().preorder();t=e.next();)if(!(t.height<=1)){r&&a.assert(0==t.isLeaf());var o=_.abs(t.child2.height-t.child1.height);i=_.max(i,o)}return d.release(e),i},s.prototype.rebuildBottomUp=function(){for(var t,i=[],e=0,o=d.allocate().preorder();t=o.next();)t.height<0||(t.isLeaf()?(t.parent=null,i[e]=t,++e):this.freeNode(t));for(d.release(o);e>1;){for(var s=1/0,n=-1,r=-1,m=0;m<e;++m)for(var a=i[m].aabb,h=m+1;h<e;++h){var c=i[h].aabb,u=new l;u.combine(a,c);var p=u.getPerimeter();p<s&&(n=m,r=h,s=p)}var y=i[n],v=i[r],f=this.allocateNode();f.child1=y,f.child2=v,f.height=1+_.max(y.height,v.height),f.aabb.combine(y.aabb,v.aabb),f.parent=null,y.parent=f,v.parent=f,i[r]=i[e-1],i[n]=f,--e}this.m_root=i[0],this.validate()},s.prototype.shiftOrigin=function(t){for(var i,e=d.allocate().preorder();i=e.next();){var o=i.aabb;o.lowerBound.x-=t.x,o.lowerBound.y-=t.y,o.lowerBound.x-=t.x,o.lowerBound.y-=t.y}d.release(e)},s.prototype.query=function(t,i){r&&a.assert("function"==typeof i);var e=p.allocate();for(e.push(this.m_root);e.length>0;){var o=e.pop();if(null!=o&&l.testOverlap(o.aabb,t))if(o.isLeaf()){if(0==i(o.id))return}else e.push(o.child1),e.push(o.child2)}p.release(e)},s.prototype.rayCast=function(t,i){r&&a.assert("function"==typeof i);var e=t.p1,o=t.p2,s=c.sub(o,e);r&&a.assert(s.lengthSquared()>0),s.normalize();var n=c.cross(1,s),m=c.abs(n),h=t.maxFraction,d=new l,y=c.wAdd(1-h,e,h,o);d.combinePoints(e,y);var v=p.allocate(),f=u.allocate();for(v.push(this.m_root);v.length>0;){var x=v.pop();if(null!=x&&0!=l.testOverlap(x.aabb,d)){var g=x.aabb.getCenter(),A=x.aabb.getExtents();if(!(_.abs(c.dot(n,c.sub(e,g)))-c.dot(m,A)>0))if(x.isLeaf()){f.p1=c.clone(t.p1),f.p2=c.clone(t.p2),f.maxFraction=h;var b=i(f,x.id);if(0==b)return;b>0&&(h=b,y=c.wAdd(1-h,e,h,o),d.combinePoints(e,y))}else v.push(x.child1),v.push(x.child2)}}p.release(v),u.release(f)};var u=new h({create:function(){return{}},release:function(t){}}),p=new h({create:function(){return[]},release:function(t){t.length=0}}),d=new h({create:function(){return new function(){var t=[],i=[];return{preorder:function(e){return t.length=0,t.push(e),i.length=0,i.push(0),this},next:function(){for(;t.length>0;){var e=t.length-1,o=t[e];if(0===i[e])return i[e]=1,o;if(1===i[e]&&(i[e]=2,o.child1))return t.push(o.child1),i.push(1),o.child1;if(2===i[e]&&(i[e]=3,o.child2))return t.push(o.child2),i.push(1),o.child2;t.pop(),i.pop()}},close:function(){t.length=0}}}},release:function(t){t.close()}})},{"../Settings":7,"../common/Math":18,"../common/Vec2":23,"../util/Pool":48,"../util/common":50,"./AABB":11}],15:[function(t,i,e){function o(){this.state,this.t}function s(){this.m_proxyA=new x,this.m_proxyB=new x,this.m_sweepA,this.m_sweepB,this.m_type,this.m_localPoint=l.zero(),this.m_axis=l.zero()}if(void 0===n)var n=!1;if(void 0===r)var r=!1;i.exports=function(t,i){var e=h.now();++c.toiCalls,t.state=o.e_unknown,t.t=i.tMax;var l=i.proxyA,u=i.proxyB,p=i.sweepA,x=i.sweepB;n&&a.debug("sweepA",p.localCenter.x,p.localCenter.y,p.c.x,p.c.y,p.a,p.alpha0,p.c0.x,p.c0.y,p.a0),n&&a.debug("sweepB",x.localCenter.x,x.localCenter.y,x.c.x,x.c.y,x.a,x.alpha0,x.c0.x,x.c0.y,x.a0),p.normalize(),x.normalize();var A=i.tMax,b=l.m_radius+u.m_radius,B=_.max(m.linearSlop,b-3*m.linearSlop),w=.25*m.linearSlop;r&&a.assert(B>w);var S=0,C=m.maxTOIIterations,M=0,I=new g,P=new v;for(P.proxyA=i.proxyA,P.proxyB=i.proxyB,P.useRadii=!1;;){var T=d.identity(),V=d.identity();p.getTransform(T,S),x.getTransform(V,S),n&&a.debug("xfA:",T.p.x,T.p.y,T.q.c,T.q.s),n&&a.debug("xfB:",V.p.x,V.p.y,V.q.c,V.q.s),P.transformA=T,P.transformB=V;var z=new f;if(y(z,I,P),n&&a.debug("distance:",z.distance),z.distance<=0){t.state=o.e_overlapped,t.t=0;break}if(z.distance<B+w){t.state=o.e_touching,t.t=S;break}var L=new s;L.initialize(I,l,p,u,x,S);for(var F=!1,q=A,k=0;;){var D=L.findMinSeparation(q);if(L.indexA,L.indexB,D>B+w){t.state=o.e_separated,t.t=A,F=!0;break}if(D>B-w){S=q;break}var R=L.evaluate(S);if(L.indexA,L.indexB,n&&a.debug("s1:",R,B,w,S),R<B-w){t.state=o.e_failed,t.t=S,F=!0;break}if(R<=B+w){t.state=o.e_touching,t.t=S,F=!0;break}for(var E=0,j=S,J=q;;){var O;O=1&E?j+(B-R)*(J-j)/(D-R):.5*(j+J),++E,++c.toiRootIters;var N=L.evaluate(O);if(L.indexA,L.indexB,_.abs(N-B)<w){q=O;break}if(N>B?(j=O,R=N):(J=O,D=N),50==E)break}if(c.toiMaxRootIters=_.max(c.toiMaxRootIters,E),++k==m.maxPolygonVertices)break}if(++M,++c.toiIters,F)break;if(M==C){t.state=o.e_failed,t.t=S;break}}c.toiMaxIters=_.max(c.toiMaxIters,M);var Y=h.diff(e);c.toiMaxTime=_.max(c.toiMaxTime,Y),c.toiTime+=Y},i.exports.Input=function(){this.proxyA=new x,this.proxyB=new x,this.sweepA=new p,this.sweepB=new p,this.tMax},i.exports.Output=o;var m=t("../Settings"),a=t("../util/common"),h=t("../util/Timer"),c=t("../common/stats"),_=t("../common/Math"),l=t("../common/Vec2"),u=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),p=t("../common/Sweep"),d=t("../common/Transform"),y=(t("../common/Velocity"),t("../common/Position"),t("./Distance")),v=y.Input,f=y.Output,x=y.Proxy,g=y.Cache;o.e_unknown=0,o.e_failed=1,o.e_overlapped=2,o.e_touching=3,o.e_separated=4,c.toiTime=0,c.toiMaxTime=0,c.toiCalls=0,c.toiIters=0,c.toiMaxIters=0,c.toiRootIters=0,c.toiMaxRootIters=0;s.prototype.initialize=function(t,i,e,o,s,n){this.m_proxyA=i,this.m_proxyB=o;var m=t.count;r&&a.assert(0<m&&m<3),this.m_sweepA=e,this.m_sweepB=s;var h=d.identity(),c=d.identity();if(this.m_sweepA.getTransform(h,n),this.m_sweepB.getTransform(c,n),1==m){this.m_type=1;var _=this.m_proxyA.getVertex(t.indexA[0]),p=this.m_proxyB.getVertex(t.indexB[0]),y=d.mul(h,_),v=d.mul(c,p);this.m_axis.wSet(1,v,-1,y);return B=this.m_axis.normalize()}if(t.indexA[0]==t.indexA[1]){this.m_type=3;var f=o.getVertex(t.indexB[0]),x=o.getVertex(t.indexB[1]);this.m_axis=l.cross(l.sub(x,f),1),this.m_axis.normalize();var g=u.mul(c.q,this.m_axis);this.m_localPoint=l.mid(f,x);v=d.mul(c,this.m_localPoint),_=i.getVertex(t.indexA[0]),y=d.mul(h,_);return(B=l.dot(y,g)-l.dot(v,g))<0&&(this.m_axis=l.neg(this.m_axis),B=-B),B}this.m_type=2;var A=this.m_proxyA.getVertex(t.indexA[0]),b=this.m_proxyA.getVertex(t.indexA[1]);this.m_axis=l.cross(l.sub(b,A),1),this.m_axis.normalize();g=u.mul(h.q,this.m_axis);this.m_localPoint=l.mid(A,b);var B;y=d.mul(h,this.m_localPoint),p=this.m_proxyB.getVertex(t.indexB[0]),v=d.mul(c,p);return(B=l.dot(v,g)-l.dot(y,g))<0&&(this.m_axis=l.neg(this.m_axis),B=-B),B},s.prototype.compute=function(t,i){var e=d.identity(),o=d.identity();switch(this.m_sweepA.getTransform(e,i),this.m_sweepB.getTransform(o,i),this.m_type){case 1:if(t){var s=u.mulT(e.q,this.m_axis),n=u.mulT(o.q,l.neg(this.m_axis));this.indexA=this.m_proxyA.getSupport(s),this.indexB=this.m_proxyB.getSupport(n)}var m=this.m_proxyA.getVertex(this.indexA),h=this.m_proxyB.getVertex(this.indexB),c=d.mul(e,m),_=d.mul(o,h);return l.dot(_,this.m_axis)-l.dot(c,this.m_axis);case 2:var p=u.mul(e.q,this.m_axis);c=d.mul(e,this.m_localPoint);if(t){n=u.mulT(o.q,l.neg(p));this.indexA=-1,this.indexB=this.m_proxyB.getSupport(n)}h=this.m_proxyB.getVertex(this.indexB),_=d.mul(o,h);return l.dot(_,p)-l.dot(c,p);case 3:p=u.mul(o.q,this.m_axis),_=d.mul(o,this.m_localPoint);if(t){s=u.mulT(e.q,l.neg(p));this.indexB=-1,this.indexA=this.m_proxyA.getSupport(s)}m=this.m_proxyA.getVertex(this.indexA),c=d.mul(e,m);return l.dot(c,p)-l.dot(_,p);default:return r&&a.assert(!1),t&&(this.indexA=-1,this.indexB=-1),0}},s.prototype.findMinSeparation=function(t){return this.compute(!0,t)},s.prototype.evaluate=function(t){return this.compute(!1,t)}},{"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../common/stats":26,"../util/Timer":49,"../util/common":50,"./Distance":13}],16:[function(t,i,e){function o(t,i,e,o){"object"==typeof t&&null!==t?(this.ex=m.clone(t),this.ey=m.clone(i)):"number"==typeof t?(this.ex=m.neo(t,e),this.ey=m.neo(i,o)):(this.ex=m.zero(),this.ey=m.zero())}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=(t("./Math"),t("./Vec2"));o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&m.isValid(t.ex)&&m.isValid(t.ey)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Mat22!")},o.prototype.set=function(t,i,e,s){"number"==typeof t&&"number"==typeof i&&"number"==typeof e&&"number"==typeof s?(this.ex.set(t,e),this.ey.set(i,s)):"object"==typeof t&&"object"==typeof i?(this.ex.set(t),this.ey.set(i)):"object"==typeof t?(n&&o.assert(t),this.ex.set(t.ex),this.ey.set(t.ey)):n&&r.assert(!1)},o.prototype.setIdentity=function(){this.ex.x=1,this.ey.x=0,this.ex.y=0,this.ey.y=1},o.prototype.setZero=function(){this.ex.x=0,this.ey.x=0,this.ex.y=0,this.ey.y=0},o.prototype.getInverse=function(){var t=this.ex.x,i=this.ey.x,e=this.ex.y,s=this.ey.y,n=t*s-i*e;0!=n&&(n=1/n);var r=new o;return r.ex.x=n*s,r.ey.x=-n*i,r.ex.y=-n*e,r.ey.y=n*t,r},o.prototype.solve=function(t){n&&m.assert(t);var i=this.ex.x,e=this.ey.x,o=this.ex.y,s=this.ey.y,r=i*s-e*o;0!=r&&(r=1/r);var a=m.zero();return a.x=r*(s*t.x-e*t.y),a.y=r*(i*t.y-o*t.x),a},o.mul=function(t,i){if(i&&"x"in i&&"y"in i){n&&m.assert(i);var e=t.ex.x*i.x+t.ey.x*i.y,s=t.ex.y*i.x+t.ey.y*i.y;return m.neo(e,s)}if(i&&"ex"in i&&"ey"in i)return n&&o.assert(i),new o(m.mul(t,i.ex),m.mul(t,i.ey));n&&r.assert(!1)},o.mulT=function(t,i){if(i&&"x"in i&&"y"in i)return n&&m.assert(i),m.neo(m.dot(i,t.ex),m.dot(i,t.ey));if(i&&"ex"in i&&"ey"in i){n&&o.assert(i);return new o(m.neo(m.dot(t.ex,i.ex),m.dot(t.ey,i.ex)),m.neo(m.dot(t.ex,i.ey),m.dot(t.ey,i.ey)))}n&&r.assert(!1)},o.abs=function(t){return n&&o.assert(t),new o(m.abs(t.ex),m.abs(t.ey))},o.add=function(t,i){return n&&o.assert(t),n&&o.assert(i),new o(m.add(t.ex+i.ex),m.add(t.ey+i.ey))}},{"../util/common":50,"./Math":18,"./Vec2":23}],17:[function(t,i,e){function o(t,i,e){"object"==typeof t&&null!==t?(this.ex=a.clone(t),this.ey=a.clone(i),this.ez=a.clone(e)):(this.ex=a(),this.ey=a(),this.ez=a())}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=(t("./Math"),t("./Vec2")),a=t("./Vec3");o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&a.isValid(t.ex)&&a.isValid(t.ey)&&a.isValid(t.ez)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Mat33!")},o.prototype.setZero=function(){return this.ex.setZero(),this.ey.setZero(),this.ez.setZero(),this},o.prototype.solve33=function(t){var i=a.dot(this.ex,a.cross(this.ey,this.ez));0!=i&&(i=1/i);var e=new a;return e.x=i*a.dot(t,a.cross(this.ey,this.ez)),e.y=i*a.dot(this.ex,a.cross(t,this.ez)),e.z=i*a.dot(this.ex,a.cross(this.ey,t)),e},o.prototype.solve22=function(t){var i=this.ex.x,e=this.ey.x,o=this.ex.y,s=this.ey.y,n=i*s-e*o;0!=n&&(n=1/n);var r=m.zero();return r.x=n*(s*t.x-e*t.y),r.y=n*(i*t.y-o*t.x),r},o.prototype.getInverse22=function(t){var i=this.ex.x,e=this.ey.x,o=this.ex.y,s=this.ey.y,n=i*s-e*o;0!=n&&(n=1/n),t.ex.x=n*s,t.ey.x=-n*e,t.ex.z=0,t.ex.y=-n*o,t.ey.y=n*i,t.ey.z=0,t.ez.x=0,t.ez.y=0,t.ez.z=0},o.prototype.getSymInverse33=function(t){var i=a.dot(this.ex,a.cross(this.ey,this.ez));0!=i&&(i=1/i);var e=this.ex.x,o=this.ey.x,s=this.ez.x,n=this.ey.y,r=this.ez.y,m=this.ez.z;t.ex.x=i*(n*m-r*r),t.ex.y=i*(s*r-o*m),t.ex.z=i*(o*r-s*n),t.ey.x=t.ex.y,t.ey.y=i*(e*m-s*s),t.ey.z=i*(s*o-e*r),t.ez.x=t.ex.z,t.ez.y=t.ey.z,t.ez.z=i*(e*n-o*o)},o.mul=function(t,i){if(n&&o.assert(t),i&&"z"in i&&"y"in i&&"x"in i){n&&a.assert(i);var e=t.ex.x*i.x+t.ey.x*i.y+t.ez.x*i.z,s=t.ex.y*i.x+t.ey.y*i.y+t.ez.y*i.z,h=t.ex.z*i.x+t.ey.z*i.y+t.ez.z*i.z;return new a(e,s,h)}if(i&&"y"in i&&"x"in i){n&&m.assert(i);e=t.ex.x*i.x+t.ey.x*i.y,s=t.ex.y*i.x+t.ey.y*i.y;return m.neo(e,s)}n&&r.assert(!1)},o.add=function(t,i){return n&&o.assert(t),n&&o.assert(i),new a(t.x+i.x,t.y+i.y,t.z+i.z)}},{"../util/common":50,"./Math":18,"./Vec2":23,"./Vec3":24}],18:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;var n=t("../util/common"),r=t("../util/create"),m=Math,a=i.exports=r(m);a.EPSILON=1e-9,a.isFinite=function(t){return"number"==typeof t&&isFinite(t)&&!isNaN(t)},a.assert=function(t){if(s&&!a.isFinite(t))throw o&&n.debug(t),new Error("Invalid Number!")},a.invSqrt=function(t){return 1/m.sqrt(t)},a.nextPowerOfTwo=function(t){return t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,(t|=t>>16)+1},a.isPowerOfTwo=function(t){return t>0&&0==(t&t-1)},a.mod=function(t,i,e){return void 0===i?(e=1,i=0):void 0===e&&(e=i,i=0),e>i?(t=(t-i)%(e-i))+(t<0?e:i):(t=(t-e)%(i-e))+(t<=0?i:e)},a.clamp=function(t,i,e){return t<i?i:t>e?e:t},a.random=function(t,i){return void 0===t?(i=1,t=0):void 0===i&&(i=t,t=0),t==i?t:m.random()*(i-t)+t}},{"../util/common":50,"../util/create":51}],19:[function(t,i,e){function o(){this.c=r.zero(),this.a=0}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("./Vec2"),m=t("./Rot");o.prototype.getTransform=function(t,i){return t.q.set(this.a),t.p.set(r.sub(this.c,m.mul(t.q,i))),t}},{"./Rot":20,"./Vec2":23}],20:[function(t,i,e){function o(t){if(!(this instanceof o))return new o(t);"number"==typeof t?this.setAngle(t):"object"==typeof t?this.set(t):this.setIdentity()}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("./Vec2"),a=t("./Math");o.neo=function(t){var i=Object.create(o.prototype);return i.setAngle(t),i},o.clone=function(t){n&&o.assert(t);var i=Object.create(o.prototype);return i.s=t.s,i.c=t.c,i},o.identity=function(t){n&&o.assert(t);var i=Object.create(o.prototype);return i.s=0,i.c=1,i},o.isValid=function(t){return t&&a.isFinite(t.s)&&a.isFinite(t.c)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Rot!")},o.prototype.setIdentity=function(){this.s=0,this.c=1},o.prototype.set=function(t){"object"==typeof t?(n&&o.assert(t),this.s=t.s,this.c=t.c):(n&&a.assert(t),this.s=a.sin(t),this.c=a.cos(t))},o.prototype.setAngle=function(t){n&&a.assert(t),this.s=a.sin(t),this.c=a.cos(t)},o.prototype.getAngle=function(){return a.atan2(this.s,this.c)},o.prototype.getXAxis=function(){return m.neo(this.c,this.s)},o.prototype.getYAxis=function(){return m.neo(-this.s,this.c)},o.mul=function(t,i){if(n&&o.assert(t),"c"in i&&"s"in i){n&&o.assert(i);var e=o.identity();return e.s=t.s*i.c+t.c*i.s,e.c=t.c*i.c-t.s*i.s,e}if("x"in i&&"y"in i)return n&&m.assert(i),m.neo(t.c*i.x-t.s*i.y,t.s*i.x+t.c*i.y)},o.mulSub=function(t,i,e){var o=t.c*(i.x-e.x)-t.s*(i.y-e.y),s=t.s*(i.x-e.y)+t.c*(i.y-e.y);return m.neo(o,s)},o.mulT=function(t,i){if("c"in i&&"s"in i){n&&o.assert(i);var e=o.identity();return e.s=t.c*i.s-t.s*i.c,e.c=t.c*i.c+t.s*i.s,e}if("x"in i&&"y"in i)return n&&m.assert(i),m.neo(t.c*i.x+t.s*i.y,-t.s*i.x+t.c*i.y)}},{"../util/common":50,"./Math":18,"./Vec2":23}],21:[function(t,i,e){function o(t,i){n&&r.assert(void 0===t),n&&r.assert(void 0===i),this.localCenter=a.zero(),this.c=a.zero(),this.a=0,this.alpha0=0,this.c0=a.zero(),this.a0=0}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("./Math"),a=t("./Vec2"),h=t("./Rot"),c=t("./Transform");o.prototype.setTransform=function(t){var i=c.mul(t,this.localCenter);this.c.set(i),this.c0.set(i),this.a=t.q.getAngle(),this.a0=t.q.getAngle()},o.prototype.setLocalCenter=function(t,i){this.localCenter.set(t);var e=c.mul(i,this.localCenter);this.c.set(e),this.c0.set(e)},o.prototype.getTransform=function(t,i){i=void 0===i?0:i,t.q.setAngle((1-i)*this.a0+i*this.a),t.p.wSet(1-i,this.c0,i,this.c),t.p.sub(h.mul(t.q,this.localCenter))},o.prototype.advance=function(t){n&&r.assert(this.alpha0<1);var i=(t-this.alpha0)/(1-this.alpha0);this.c0.wSet(i,this.c,1-i,this.c0),this.a0=i*this.a+(1-i)*this.a0,this.alpha0=t},o.prototype.forward=function(){this.a0=this.a,this.c0.set(this.c)},o.prototype.normalize=function(){var t=m.mod(this.a0,-m.PI,+m.PI);this.a-=this.a0-t,this.a0=t},o.prototype.clone=function(){var t=new o;return t.localCenter.set(this.localCenter),t.alpha0=this.alpha0,t.a0=this.a0,t.a=this.a,t.c0.set(this.c0),t.c.set(this.c),t},o.prototype.set=function(t){this.localCenter.set(t.localCenter),this.alpha0=t.alpha0,this.a0=t.a0,this.a=t.a,this.c0.set(t.c0),this.c.set(t.c)}},{"../util/common":50,"./Math":18,"./Rot":20,"./Transform":22,"./Vec2":23}],22:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);this.p=m.zero(),this.q=a.identity(),void 0!==t&&this.p.set(t),void 0!==i&&this.q.set(i)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("./Vec2"),a=t("./Rot");o.clone=function(t){var i=Object.create(o.prototype);return i.p=m.clone(t.p),i.q=a.clone(t.q),i},o.neo=function(t,i){var e=Object.create(o.prototype);return e.p=m.clone(t),e.q=a.clone(i),e},o.identity=function(){var t=Object.create(o.prototype);return t.p=m.zero(),t.q=a.identity(),t},o.prototype.setIdentity=function(){this.p.setZero(),this.q.setIdentity()},o.prototype.set=function(t,i){o.isValid(t)?(this.p.set(t.p),this.q.set(t.q)):(this.p.set(t),this.q.set(i))},o.isValid=function(t){return t&&m.isValid(t.p)&&a.isValid(t.q)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Transform!")},o.mul=function(t,i){if(n&&o.assert(t),Array.isArray(i)){for(var e=[],s=0;s<i.length;s++)e[s]=o.mul(t,i[s]);return e}if("x"in i&&"y"in i){n&&m.assert(i);var r=t.q.c*i.x-t.q.s*i.y+t.p.x,h=t.q.s*i.x+t.q.c*i.y+t.p.y;return m.neo(r,h)}if("p"in i&&"q"in i){n&&o.assert(i);var c=o.identity();return c.q=a.mul(t.q,i.q),c.p=m.add(a.mul(t.q,i.p),t.p),c}},o.mulT=function(t,i){if(n&&o.assert(t),"x"in i&&"y"in i){n&&m.assert(i);var e=i.x-t.p.x,s=i.y-t.p.y,r=t.q.c*e+t.q.s*s,h=-t.q.s*e+t.q.c*s;return m.neo(r,h)}if("p"in i&&"q"in i){n&&o.assert(i);var c=o.identity();return c.q.set(a.mulT(t.q,i.q)),c.p.set(a.mulT(t.q,m.sub(i.p,t.p))),c}}},{"../util/common":50,"./Rot":20,"./Vec2":23}],23:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);void 0===t?(this.x=0,this.y=0):"object"==typeof t?(this.x=t.x,this.y=t.y):(this.x=t,this.y=i),n&&o.assert(this)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("./Math");o.zero=function(){var t=Object.create(o.prototype);return t.x=0,t.y=0,t},o.neo=function(t,i){var e=Object.create(o.prototype);return e.x=t,e.y=i,e},o.clone=function(t,i){return n&&o.assert(t),n&&r.assert(!i),o.neo(t.x,t.y)},o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&m.isFinite(t.x)&&m.isFinite(t.y)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Vec2!")},o.prototype.clone=function(t){return o.clone(this,t)},o.prototype.setZero=function(){return this.x=0,this.y=0,this},o.prototype.set=function(t,i){return"object"==typeof t?(n&&o.assert(t),this.x=t.x,this.y=t.y):(n&&m.assert(t),n&&m.assert(i),this.x=t,this.y=i),this},o.prototype.wSet=function(t,i,e,s){n&&m.assert(t),n&&o.assert(i);var r=t*i.x,a=t*i.y;return void 0===e&&void 0===s||(n&&m.assert(e),n&&o.assert(s),r+=e*s.x,a+=e*s.y),this.x=r,this.y=a,this},o.prototype.add=function(t){return n&&o.assert(t),this.x+=t.x,this.y+=t.y,this},o.prototype.wAdd=function(t,i,e,s){n&&m.assert(t),n&&o.assert(i);var r=t*i.x,a=t*i.y;return void 0===e&&void 0===s||(n&&m.assert(e),n&&o.assert(s),r+=e*s.x,a+=e*s.y),this.x+=r,this.y+=a,this},o.prototype.wSub=function(t,i,e,s){n&&m.assert(t),n&&o.assert(i);var r=t*i.x,a=t*i.y;return void 0===e&&void 0===s||(n&&m.assert(e),n&&o.assert(s),r+=e*s.x,a+=e*s.y),this.x-=r,this.y-=a,this},o.prototype.sub=function(t){return n&&o.assert(t),this.x-=t.x,this.y-=t.y,this},o.prototype.mul=function(t){return n&&m.assert(t),this.x*=t,this.y*=t,this},o.prototype.length=function(){return o.lengthOf(this)},o.prototype.lengthSquared=function(){return o.lengthSquared(this)},o.prototype.normalize=function(){var t=this.length();if(t<m.EPSILON)return 0;var i=1/t;return this.x*=i,this.y*=i,t},o.lengthOf=function(t){return n&&o.assert(t),m.sqrt(t.x*t.x+t.y*t.y)},o.lengthSquared=function(t){return n&&o.assert(t),t.x*t.x+t.y*t.y},o.distance=function(t,i){n&&o.assert(t),n&&o.assert(i);var e=t.x-i.x,s=t.y-i.y;return m.sqrt(e*e+s*s)},o.distanceSquared=function(t,i){n&&o.assert(t),n&&o.assert(i);var e=t.x-i.x,s=t.y-i.y;return e*e+s*s},o.areEqual=function(t,i){return n&&o.assert(t),n&&o.assert(i),t==i||"object"==typeof i&&null!==i&&t.x==i.x&&t.y==i.y},o.skew=function(t){return n&&o.assert(t),o.neo(-t.y,t.x)},o.dot=function(t,i){return n&&o.assert(t),n&&o.assert(i),t.x*i.x+t.y*i.y},o.cross=function(t,i){return"number"==typeof i?(n&&o.assert(t),n&&m.assert(i),o.neo(i*t.y,-i*t.x)):"number"==typeof t?(n&&m.assert(t),n&&o.assert(i),o.neo(-t*i.y,t*i.x)):(n&&o.assert(t),n&&o.assert(i),t.x*i.y-t.y*i.x)},o.addCross=function(t,i,e){return"number"==typeof e?(n&&o.assert(i),n&&m.assert(e),o.neo(e*i.y+t.x,-e*i.x+t.y)):"number"==typeof i?(n&&m.assert(i),n&&o.assert(e),o.neo(-i*e.y+t.x,i*e.x+t.y)):void(n&&r.assert(!1))},o.add=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(t.x+i.x,t.y+i.y)},o.wAdd=function(t,i,e,s){var n=o.zero();return n.wAdd(t,i,e,s),n},o.sub=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(t.x-i.x,t.y-i.y)},o.mul=function(t,i){return"object"==typeof t?(n&&o.assert(t),n&&m.assert(i),o.neo(t.x*i,t.y*i)):"object"==typeof i?(n&&m.assert(t),n&&o.assert(i),o.neo(t*i.x,t*i.y)):void 0},o.prototype.neg=function(){return this.x=-this.x,this.y=-this.y,this},o.neg=function(t){return n&&o.assert(t),o.neo(-t.x,-t.y)},o.abs=function(t){return n&&o.assert(t),o.neo(m.abs(t.x),m.abs(t.y))},o.mid=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(.5*(t.x+i.x),.5*(t.y+i.y))},o.upper=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(m.max(t.x,i.x),m.max(t.y,i.y))},o.lower=function(t,i){return n&&o.assert(t),n&&o.assert(i),o.neo(m.min(t.x,i.x),m.min(t.y,i.y))},o.prototype.clamp=function(t){var i=this.x*this.x+this.y*this.y;if(i>t*t){var e=m.invSqrt(i);this.x*=e*t,this.y*=e*t}return this},o.clamp=function(t,i){return(t=o.neo(t.x,t.y)).clamp(i),t}},{"../util/common":50,"./Math":18}],24:[function(t,i,e){function o(t,i,e){if(!(this instanceof o))return new o(t,i,e);void 0===t?(this.x=0,this.y=0,this.z=0):"object"==typeof t?(this.x=t.x,this.y=t.y,this.z=t.z):(this.x=t,this.y=i,this.z=e),n&&o.assert(this)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("./Math");o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&m.isFinite(t.x)&&m.isFinite(t.y)&&m.isFinite(t.z)},o.assert=function(t){if(n&&!o.isValid(t))throw s&&r.debug(t),new Error("Invalid Vec3!")},o.prototype.setZero=function(){return this.x=0,this.y=0,this.z=0,this},o.prototype.set=function(t,i,e){return this.x=t,this.y=i,this.z=e,this},o.prototype.add=function(t){return this.x+=t.x,this.y+=t.y,this.z+=t.z,this},o.prototype.sub=function(t){return this.x-=t.x,this.y-=t.y,this.z-=t.z,this},o.prototype.mul=function(t){return this.x*=t,this.y*=t,this.z*=t,this},o.areEqual=function(t,i){return t==i||"object"==typeof i&&null!==i&&t.x==i.x&&t.y==i.y&&t.z==i.z},o.dot=function(t,i){return t.x*i.x+t.y*i.y+t.z*i.z},o.cross=function(t,i){return new o(t.y*i.z-t.z*i.y,t.z*i.x-t.x*i.z,t.x*i.y-t.y*i.x)},o.add=function(t,i){return new o(t.x+i.x,t.y+i.y,t.z+i.z)},o.sub=function(t,i){return new o(t.x-i.x,t.y-i.y,t.z-i.z)},o.mul=function(t,i){return new o(i*t.x,i*t.y,i*t.z)},o.prototype.neg=function(t){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this},o.neg=function(t){return new o(-t.x,-t.y,-t.z)}},{"../util/common":50,"./Math":18}],25:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;i.exports=function(){this.v=n.zero(),this.w=0};var n=t("./Vec2")},{"./Vec2":23}],26:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;e.toString=function(t){t="string"==typeof t?t:"\n";var i="";for(var e in this)"function"!=typeof this[e]&&"object"!=typeof this[e]&&(i+=e+": "+this[e]+t);return i}},{}],27:[function(t,i,e){function o(t,i,e,s,n){if(!(this instanceof o))return new o(t,i,e,s,n);t=r(t,u),l.call(this,t,i,s),this.m_type=o.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(e),this.m_localAnchorB=t.localAnchorB||s.getLocalPoint(n),this.m_length=c.distance(n,e),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=0,this.m_gamma=0,this.m_bias=0,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/options"),m=t("../util/create"),a=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="distance-joint";var u={frequencyHz:0,dampingRatio:0};(o.prototype=m((o._super=l).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.setLength=function(t){this.m_length=t},o.prototype.getLength=function(){return this.m_length},o.prototype.setFrequency=function(t){this.m_frequencyHz=t},o.prototype.getFrequency=function(){return this.m_frequencyHz},o.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return c.mul(t*this.m_impulse,this.m_u)},o.prototype.getReactionTorque=function(t){return 0},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,m=this.m_bodyB.c_velocity.v,l=this.m_bodyB.c_velocity.w,u=_.neo(e),p=_.neo(r);this.m_rA=_.mul(u,c.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=_.mul(p,c.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_u=c.sub(c.add(n,this.m_rB),c.add(i,this.m_rA));var d=this.m_u.length();d>a.linearSlop?this.m_u.mul(1/d):this.m_u.set(0,0);var y=c.cross(this.m_rA,this.m_u),v=c.cross(this.m_rB,this.m_u),f=this.m_invMassA+this.m_invIA*y*y+this.m_invMassB+this.m_invIB*v*v;if(this.m_mass=0!=f?1/f:0,this.m_frequencyHz>0){var x=d-this.m_length,g=2*h.PI*this.m_frequencyHz,A=2*this.m_mass*this.m_dampingRatio*g,b=this.m_mass*g*g,B=t.dt;this.m_gamma=B*(A+B*b),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=x*B*b*this.m_gamma,f+=this.m_gamma,this.m_mass=0!=f?1/f:0}else this.m_gamma=0,this.m_bias=0;if(t.warmStarting){this.m_impulse*=t.dtRatio;var w=c.mul(this.m_impulse,this.m_u);o.wSub(this.m_invMassA,w),s-=this.m_invIA*c.cross(this.m_rA,w),m.wAdd(this.m_invMassB,w),l+=this.m_invIB*c.cross(this.m_rB,w)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(m),this.m_bodyB.c_velocity.w=l},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=c.add(i,c.cross(e,this.m_rA)),r=c.add(o,c.cross(s,this.m_rB)),m=c.dot(this.m_u,r)-c.dot(this.m_u,n),a=-this.m_mass*(m+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=a;var h=c.mul(a,this.m_u);i.wSub(this.m_invMassA,h),e-=this.m_invIA*c.cross(this.m_rA,h),o.wAdd(this.m_invMassB,h),s+=this.m_invIB*c.cross(this.m_rB,h),this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v.set(o),this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){if(this.m_frequencyHz>0)return!0;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=_.neo(e),r=_.neo(s),m=_.mulSub(n,this.m_localAnchorA,this.m_localCenterA),l=_.mulSub(r,this.m_localAnchorB,this.m_localCenterB),u=c.sub(c.add(o,l),c.add(i,m)),p=u.normalize()-this.m_length;p=h.clamp(p,-a.maxLinearCorrection,a.maxLinearCorrection);var d=-this.m_mass*p,y=c.mul(d,u);return i.wSub(this.m_invMassA,y),e-=this.m_invIA*c.cross(m,y),o.wAdd(this.m_invMassB,y),s+=this.m_invIB*c.cross(l,y),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,h.abs(p)<a.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":51,"../util/options":52}],28:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=m(t,p),u.call(this,t,i,e),this.m_type=o.TYPE,s?(this.m_localAnchorA=i.getLocalPoint(s),this.m_localAnchorB=e.getLocalPoint(s)):(this.m_localAnchorA=c.zero(),this.m_localAnchorB=c.zero()),this.m_linearImpulse=c.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/options"),a=t("../util/create"),h=(t("../Settings"),t("../common/Math")),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22")),l=(t("../common/Mat33"),t("../common/Rot")),u=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="friction-joint";var p={maxForce:0,maxTorque:0};(o.prototype=a((o._super=u).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.setMaxForce=function(t){n&&r.assert(IsValid(t)&&t>=0),this.m_maxForce=t},o.prototype.getMaxForce=function(){return this.m_maxForce},o.prototype.setMaxTorque=function(t){n&&r.assert(IsValid(t)&&t>=0),this.m_maxTorque=t},o.prototype.getMaxTorque=function(){return this.m_maxTorque},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*this.m_linearImpulse},o.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,m=l.neo(i),a=l.neo(s);this.m_rA=l.mul(m,c.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=l.mul(a,c.sub(this.m_localAnchorB,this.m_localCenterB));var h=this.m_invMassA,u=this.m_invMassB,p=this.m_invIA,d=this.m_invIB,y=new _;if(y.ex.x=h+u+p*this.m_rA.y*this.m_rA.y+d*this.m_rB.y*this.m_rB.y,y.ex.y=-p*this.m_rA.x*this.m_rA.y-d*this.m_rB.x*this.m_rB.y,y.ey.x=y.ex.y,y.ey.y=h+u+p*this.m_rA.x*this.m_rA.x+d*this.m_rB.x*this.m_rB.x,this.m_linearMass=y.getInverse(),this.m_angularMass=p+d,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var v=c.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);e.wSub(h,v),o-=p*(c.cross(this.m_rA,v)+this.m_angularImpulse),n.wAdd(u,v),r+=d*(c.cross(this.m_rB,v)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,m=this.m_invIA,a=this.m_invIB,l=t.dt,u=s-e,p=-this.m_angularMass*u,d=this.m_angularImpulse,y=l*this.m_maxTorque;this.m_angularImpulse=h.clamp(this.m_angularImpulse+p,-y,y),e-=m*(p=this.m_angularImpulse-d),s+=a*p;u=c.sub(c.add(o,c.cross(s,this.m_rB)),c.add(i,c.cross(e,this.m_rA))),p=c.neg(_.mul(this.m_linearMass,u)),d=this.m_linearImpulse;this.m_linearImpulse.add(p);y=l*this.m_maxForce;this.m_linearImpulse.lengthSquared()>y*y&&(this.m_linearImpulse.normalize(),this.m_linearImpulse.mul(y)),p=c.sub(this.m_linearImpulse,d),i.wSub(n,p),e-=m*c.cross(this.m_rA,p),o.wAdd(r,p),s+=a*c.cross(this.m_rB,p),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],29:[function(t,i,e){function o(t,i,e,s,a,h){if(!(this instanceof o))return new o(t,i,e,s,a,h);t=m(t,d),l.call(this,t,i,e),this.m_type=o.TYPE,n&&r.assert(s.m_type==u.TYPE||s.m_type==p.TYPE),n&&r.assert(a.m_type==u.TYPE||a.m_type==p.TYPE),this.m_joint1=s,this.m_joint2=a,this.m_type1=this.m_joint1.getType(),this.m_type2=this.m_joint2.getType();var y,v;this.m_bodyC=this.m_joint1.getBodyA(),this.m_bodyA=this.m_joint1.getBodyB();var f=this.m_bodyA.m_xf,x=this.m_bodyA.m_sweep.a,g=this.m_bodyC.m_xf,A=this.m_bodyC.m_sweep.a;if(this.m_type1==u.TYPE){var b=s;this.m_localAnchorC=b.m_localAnchorA,this.m_localAnchorA=b.m_localAnchorB,this.m_referenceAngleA=b.m_referenceAngle,this.m_localAxisC=c.zero(),y=x-A-this.m_referenceAngleA}else{var B=s;this.m_localAnchorC=B.m_localAnchorA,this.m_localAnchorA=B.m_localAnchorB,this.m_referenceAngleA=B.m_referenceAngle,this.m_localAxisC=B.m_localXAxisA;var w=this.m_localAnchorC,S=_.mulT(g.q,c.add(_.mul(f.q,this.m_localAnchorA),c.sub(f.p,g.p)));y=c.dot(S,this.m_localAxisC)-c.dot(w,this.m_localAxisC)}this.m_bodyD=this.m_joint2.getBodyA(),this.m_bodyB=this.m_joint2.getBodyB();var C=this.m_bodyB.m_xf,M=this.m_bodyB.m_sweep.a,I=this.m_bodyD.m_xf,P=this.m_bodyD.m_sweep.a;if(this.m_type2==u.TYPE){b=a;this.m_localAnchorD=b.m_localAnchorA,this.m_localAnchorB=b.m_localAnchorB,this.m_referenceAngleB=b.m_referenceAngle,this.m_localAxisD=c.zero(),v=M-P-this.m_referenceAngleB}else{B=a;this.m_localAnchorD=B.m_localAnchorA,this.m_localAnchorB=B.m_localAnchorB,this.m_referenceAngleB=B.m_referenceAngle,this.m_localAxisD=B.m_localXAxisA;var T=this.m_localAnchorD,V=_.mulT(I.q,c.add(_.mul(C.q,this.m_localAnchorB),c.sub(C.p,I.p)));v=c.dot(V,this.m_localAxisD)-c.dot(T,this.m_localAxisD)}this.m_ratio=h||t.ratio,this.m_constant=y+this.m_ratio*v,this.m_impulse=0,this.m_lcA,this.m_lcB,this.m_lcC,this.m_lcD,this.m_mA,this.m_mB,this.m_mC,this.m_mD,this.m_iA,this.m_iB,this.m_iC,this.m_iD,this.m_JvAC,this.m_JvBD,this.m_JwA,this.m_JwB,this.m_JwC,this.m_JwD,this.m_mass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/options"),a=t("../util/create"),h=t("../Settings"),c=(t("../common/Math"),t("../common/Vec2")),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),u=t("./RevoluteJoint"),p=t("./PrismaticJoint");o.TYPE="gear-joint";var d={ratio:1};(o.prototype=a((o._super=l).prototype)).getJoint1=function(){return this.m_joint1},o.prototype.getJoint2=function(){return this.m_joint2},o.prototype.setRatio=function(t){n&&r.assert(IsValid(t)),this.m_ratio=t},o.prototype.setRatio=function(){return this.m_ratio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*(this.m_impulse*this.m_JvAC)},o.prototype.getReactionTorque=function(t){return t*(this.m_impulse*this.m_JwA)},o.prototype.initVelocityConstraints=function(t){this.m_lcA=this.m_bodyA.m_sweep.localCenter,this.m_lcB=this.m_bodyB.m_sweep.localCenter,this.m_lcC=this.m_bodyC.m_sweep.localCenter,this.m_lcD=this.m_bodyD.m_sweep.localCenter,this.m_mA=this.m_bodyA.m_invMass,this.m_mB=this.m_bodyB.m_invMass,this.m_mC=this.m_bodyC.m_invMass,this.m_mD=this.m_bodyD.m_invMass,this.m_iA=this.m_bodyA.m_invI,this.m_iB=this.m_bodyB.m_invI,this.m_iC=this.m_bodyC.m_invI,this.m_iD=this.m_bodyD.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,m=this.m_bodyC.c_position.a,a=this.m_bodyC.c_velocity.v,h=this.m_bodyC.c_velocity.w,l=this.m_bodyD.c_position.a,p=this.m_bodyD.c_velocity.v,d=this.m_bodyD.c_velocity.w,y=_.neo(i),v=_.neo(s),f=_.neo(m),x=_.neo(l);if(this.m_mass=0,this.m_type1==u.TYPE)this.m_JvAC=c.zero(),this.m_JwA=1,this.m_JwC=1,this.m_mass+=this.m_iA+this.m_iC;else{var g=_.mul(f,this.m_localAxisC),A=_.mulSub(f,this.m_localAnchorC,this.m_lcC),b=_.mulSub(y,this.m_localAnchorA,this.m_lcA);this.m_JvAC=g,this.m_JwC=c.cross(A,g),this.m_JwA=c.cross(b,g),this.m_mass+=this.m_mC+this.m_mA+this.m_iC*this.m_JwC*this.m_JwC+this.m_iA*this.m_JwA*this.m_JwA}if(this.m_type2==u.TYPE)this.m_JvBD=c.zero(),this.m_JwB=this.m_ratio,this.m_JwD=this.m_ratio,this.m_mass+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD);else{g=_.mul(x,this.m_localAxisD);var B=_.mulSub(x,this.m_localAnchorD,this.m_lcD),w=_.mulSub(v,this.m_localAnchorB,this.m_lcB);this.m_JvBD=c.mul(this.m_ratio,g),this.m_JwD=this.m_ratio*c.cross(B,g),this.m_JwB=this.m_ratio*c.cross(w,g),this.m_mass+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*this.m_JwD*this.m_JwD+this.m_iB*this.m_JwB*this.m_JwB}this.m_mass=this.m_mass>0?1/this.m_mass:0,t.warmStarting?(e.wAdd(this.m_mA*this.m_impulse,this.m_JvAC),o+=this.m_iA*this.m_impulse*this.m_JwA,n.wAdd(this.m_mB*this.m_impulse,this.m_JvBD),r+=this.m_iB*this.m_impulse*this.m_JwB,a.wSub(this.m_mC*this.m_impulse,this.m_JvAC),h-=this.m_iC*this.m_impulse*this.m_JwC,p.wSub(this.m_mD*this.m_impulse,this.m_JvBD),d-=this.m_iD*this.m_impulse*this.m_JwD):this.m_impulse=0,this.m_bodyA.c_velocity.v.set(e),this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v.set(n),this.m_bodyB.c_velocity.w=r,this.m_bodyC.c_velocity.v.set(a),this.m_bodyC.c_velocity.w=h,this.m_bodyD.c_velocity.v.set(p),this.m_bodyD.c_velocity.w=d},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_bodyC.c_velocity.v,r=this.m_bodyC.c_velocity.w,m=this.m_bodyD.c_velocity.v,a=this.m_bodyD.c_velocity.w,h=c.dot(this.m_JvAC,i)-c.dot(this.m_JvAC,n)+c.dot(this.m_JvBD,o)-c.dot(this.m_JvBD,m);h+=this.m_JwA*e-this.m_JwC*r+(this.m_JwB*s-this.m_JwD*a);var _=-this.m_mass*h;this.m_impulse+=_,i.wAdd(this.m_mA*_,this.m_JvAC),e+=this.m_iA*_*this.m_JwA,o.wAdd(this.m_mB*_,this.m_JvBD),s+=this.m_iB*_*this.m_JwB,n.wSub(this.m_mC*_,this.m_JvAC),r-=this.m_iC*_*this.m_JwC,m.wSub(this.m_mD*_,this.m_JvBD),a-=this.m_iD*_*this.m_JwD,this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v.set(o),this.m_bodyB.c_velocity.w=s,this.m_bodyC.c_velocity.v.set(n),this.m_bodyC.c_velocity.w=r,this.m_bodyD.c_velocity.v.set(m),this.m_bodyD.c_velocity.w=a},o.prototype.solvePositionConstraints=function(t){var i,e,o,s,n,r,m,a,l=this.m_bodyA.c_position.c,p=this.m_bodyA.c_position.a,d=this.m_bodyB.c_position.c,y=this.m_bodyB.c_position.a,v=this.m_bodyC.c_position.c,f=this.m_bodyC.c_position.a,x=this.m_bodyD.c_position.c,g=this.m_bodyD.c_position.a,A=_.neo(p),b=_.neo(y),B=_.neo(f),w=_.neo(g),S=0;if(this.m_type1==u.TYPE)o=c.zero(),n=1,m=1,S+=this.m_iA+this.m_iC,i=p-f-this.m_referenceAngleA;else{var C=_.mul(B,this.m_localAxisC),M=_.mulSub(B,this.m_localAnchorC,this.m_lcC),I=_.mulSub(A,this.m_localAnchorA,this.m_lcA);o=C,m=c.cross(M,C),n=c.cross(I,C),S+=this.m_mC+this.m_mA+this.m_iC*m*m+this.m_iA*n*n;var P=this.m_localAnchorC-this.m_lcC,T=_.mulT(B,c.add(I,c.sub(l,v)));i=Dot(T-P,this.m_localAxisC)}if(this.m_type2==u.TYPE)s=c.zero(),r=this.m_ratio,a=this.m_ratio,S+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD),e=y-g-this.m_referenceAngleB;else{C=_.mul(w,this.m_localAxisD);var V=_.mulSub(w,this.m_localAnchorD,this.m_lcD),z=_.mulSub(b,this.m_localAnchorB,this.m_lcB);s=c.mul(this.m_ratio,C),a=this.m_ratio*c.cross(V,C),r=this.m_ratio*c.cross(z,C),S+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*a*a+this.m_iB*r*r;var L=c.sub(this.m_localAnchorD,this.m_lcD),F=_.mulT(w,c.add(z,c.sub(d,x)));e=c.dot(F,this.m_localAxisD)-c.dot(L,this.m_localAxisD)}var q=i+this.m_ratio*e-this.m_constant,k=0;return S>0&&(k=-q/S),l.wAdd(this.m_mA*k,o),p+=this.m_iA*k*n,d.wAdd(this.m_mB*k,s),y+=this.m_iB*k*r,v.wAdd(this.m_mC*k,o),f-=this.m_iC*k*m,x.wAdd(this.m_mD*k,s),g-=this.m_iD*k*a,this.m_bodyA.c_position.c.set(l),this.m_bodyA.c_position.a=p,this.m_bodyB.c_position.c.set(d),this.m_bodyB.c_position.a=y,this.m_bodyC.c_position.c.set(v),this.m_bodyC.c_position.a=f,this.m_bodyD.c_position.c.set(x),this.m_bodyD.c_position.a=g,0<h.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52,"./PrismaticJoint":32,"./RevoluteJoint":34}],30:[function(t,i,e){function o(t,i,e){if(!(this instanceof o))return new o(t,i,e);t=m(t,p),u.call(this,t,i,e),this.m_type=o.TYPE;var s=e.getPosition();this.m_linearOffset=i.getLocalPoint(s);var n=i.getAngle(),r=e.getAngle();this.m_angularOffset=r-n,this.m_linearImpulse=c.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_correctionFactor=t.correctionFactor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_linearError,this.m_angularError,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/options"),a=t("../util/create"),h=(t("../Settings"),t("../common/Math")),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22")),l=(t("../common/Mat33"),t("../common/Rot")),u=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="motor-joint";var p={maxForce:1,maxTorque:1,correctionFactor:.3};(o.prototype=a((o._super=u).prototype)).setMaxForce=function(t){n&&r.assert(IsValid(t)&&t>=0),this.m_maxForce=t},o.prototype.getMaxForce=function(){return this.m_maxForce},o.prototype.setMaxTorque=function(t){n&&r.assert(IsValid(t)&&t>=0),this.m_maxTorque=t},o.prototype.getMaxTorque=function(){return this.m_maxTorque},o.prototype.setCorrectionFactor=function(t){n&&r.assert(IsValid(t)&&0<=t&&t<=1),this.m_correctionFactor=t},o.prototype.getCorrectionFactor=function(){return this.m_correctionFactor},o.prototype.setLinearOffset=function(t){t.x==this.m_linearOffset.x&&t.y==this.m_linearOffset.y||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_linearOffset=t)},o.prototype.getLinearOffset=function(){return this.m_linearOffset},o.prototype.setAngularOffset=function(t){t!=this.m_angularOffset&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_angularOffset=t)},o.prototype.getAngularOffset=function(){return this.m_angularOffset},o.prototype.getAnchorA=function(){return this.m_bodyA.getPosition()},o.prototype.getAnchorB=function(){return this.m_bodyB.getPosition()},o.prototype.getReactionForce=function(t){return t*this.m_linearImpulse},o.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,m=this.m_bodyB.c_velocity.v,a=this.m_bodyB.c_velocity.w,h=l.neo(e),u=l.neo(r);this.m_rA=l.mul(h,c.neg(this.m_localCenterA)),this.m_rB=l.mul(u,c.neg(this.m_localCenterB));var p=this.m_invMassA,d=this.m_invMassB,y=this.m_invIA,v=this.m_invIB,f=new _;if(f.ex.x=p+d+y*this.m_rA.y*this.m_rA.y+v*this.m_rB.y*this.m_rB.y,f.ex.y=-y*this.m_rA.x*this.m_rA.y-v*this.m_rB.x*this.m_rB.y,f.ey.x=f.ex.y,f.ey.y=p+d+y*this.m_rA.x*this.m_rA.x+v*this.m_rB.x*this.m_rB.x,this.m_linearMass=f.getInverse(),this.m_angularMass=y+v,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),this.m_linearError=c.zero(),this.m_linearError.wAdd(1,n,1,this.m_rB),this.m_linearError.wSub(1,i,1,this.m_rA),this.m_linearError.sub(l.mul(h,this.m_linearOffset)),this.m_angularError=r-e-this.m_angularOffset,t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var x=c.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);o.wSub(p,x),s-=y*(c.cross(this.m_rA,x)+this.m_angularImpulse),m.wAdd(d,x),a+=v*(c.cross(this.m_rB,x)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=m,this.m_bodyB.c_velocity.w=a},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,m=this.m_invIA,a=this.m_invIB,l=t.dt,u=t.inv_dt,p=s-e+u*this.m_correctionFactor*this.m_angularError,d=-this.m_angularMass*p,y=this.m_angularImpulse,v=l*this.m_maxTorque;this.m_angularImpulse=h.clamp(this.m_angularImpulse+d,-v,v),e-=m*(d=this.m_angularImpulse-y),s+=a*d;(p=c.zero()).wAdd(1,o,1,c.cross(s,this.m_rB)),p.wSub(1,i,1,c.cross(e,this.m_rA)),p.wAdd(u*this.m_correctionFactor,this.m_linearError);d=c.neg(_.mul(this.m_linearMass,p)),y=c.clone(this.m_linearImpulse);this.m_linearImpulse.add(d);v=l*this.m_maxForce;this.m_linearImpulse.clamp(v),d=c.sub(this.m_linearImpulse,y),i.wSub(n,d),e-=m*c.cross(this.m_rA,d),o.wAdd(r,d),s+=a*c.cross(this.m_rB,d),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],31:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=m(t,d),p.call(this,t,i,e),this.m_type=o.TYPE,n&&r.assert(h.isFinite(t.maxForce)&&t.maxForce>=0),n&&r.assert(h.isFinite(t.frequencyHz)&&t.frequencyHz>=0),n&&r.assert(h.isFinite(t.dampingRatio)&&t.dampingRatio>=0),this.m_targetA=c.clone(s),this.m_localAnchorB=u.mulT(this.m_bodyB.getTransform(),this.m_targetA),this.m_maxForce=t.maxForce,this.m_impulse=c.zero(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_beta=0,this.m_gamma=0,this.m_rB=c.zero(),this.m_localCenterB=c.zero(),this.m_invMassB=0,this.m_invIB=0,this.mass=new _,this.m_C=c.zero()}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/options"),a=t("../util/create"),h=t("../common/Math"),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22")),l=(t("../common/Mat33"),t("../common/Rot")),u=(t("../common/Sweep"),t("../common/Transform")),p=(t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="mouse-joint";var d={maxForce:0,frequencyHz:5,dampingRatio:.7};(o.prototype=a((o._super=p).prototype)).setTarget=function(t){0==this.m_bodyB.isAwake()&&this.m_bodyB.setAwake(!0),this.m_targetA=c.clone(t)},o.prototype.getTarget=function(){return this.m_targetA},o.prototype.setMaxForce=function(t){this.m_maxForce=t},o.getMaxForce=function(){return this.m_maxForce},o.prototype.setFrequency=function(t){this.m_frequencyHz=t},o.prototype.getFrequency=function(){return this.m_frequencyHz},o.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return c.clone(this.m_targetA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return c.mul(t,this.m_impulse)},o.prototype.getReactionTorque=function(t){return 0*t},o.prototype.shiftOrigin=function(t){this.m_targetA.sub(t)},o.prototype.initVelocityConstraints=function(t){this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyB.c_position,e=this.m_bodyB.c_velocity,o=i.c,s=i.a,m=e.v,a=e.w,u=l.neo(s),p=this.m_bodyB.getMass(),d=2*h.PI*this.m_frequencyHz,y=2*p*this.m_dampingRatio*d,v=p*(d*d),f=t.dt;n&&r.assert(y+f*v>h.EPSILON),this.m_gamma=f*(y+f*v),0!=this.m_gamma&&(this.m_gamma=1/this.m_gamma),this.m_beta=f*v*this.m_gamma,this.m_rB=l.mul(u,c.sub(this.m_localAnchorB,this.m_localCenterB));var x=new _;x.ex.x=this.m_invMassB+this.m_invIB*this.m_rB.y*this.m_rB.y+this.m_gamma,x.ex.y=-this.m_invIB*this.m_rB.x*this.m_rB.y,x.ey.x=x.ex.y,x.ey.y=this.m_invMassB+this.m_invIB*this.m_rB.x*this.m_rB.x+this.m_gamma,this.m_mass=x.getInverse(),this.m_C.set(o),this.m_C.wAdd(1,this.m_rB,-1,this.m_targetA),this.m_C.mul(this.m_beta),a*=.98,t.warmStarting?(this.m_impulse.mul(t.dtRatio),m.wAdd(this.m_invMassB,this.m_impulse),a+=this.m_invIB*c.cross(this.m_rB,this.m_impulse)):this.m_impulse.setZero(),e.v.set(m),e.w=a},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyB.c_velocity,e=c.clone(i.v),o=i.w,s=c.cross(o,this.m_rB);s.add(e),s.wAdd(1,this.m_C,this.m_gamma,this.m_impulse),s.neg();var n=_.mul(this.m_mass,s),r=c.clone(this.m_impulse);this.m_impulse.add(n);var m=t.dt*this.m_maxForce;this.m_impulse.clamp(m),n=c.sub(this.m_impulse,r),e.wAdd(this.m_invMassB,n),o+=this.m_invIB*c.cross(this.m_rB,n),i.v.set(e),i.w=o},o.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],32:[function(t,i,e){function o(t,i,e,s,n){if(!(this instanceof o))return new o(t,i,e,s,n);t=m(t,f),y.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(s),this.m_localAnchorB=t.localAnchorB||e.getLocalPoint(s),this.m_localXAxisA=t.localAxisA||i.getLocalVector(n),this.m_localXAxisA.normalize(),this.m_localYAxisA=_.cross(1,this.m_localXAxisA),this.m_referenceAngle=e.getAngle()-i.getAngle(),this.m_impulse=l(),this.m_motorMass=0,this.m_motorImpulse=0,this.m_lowerTranslation=t.lowerTranslation,this.m_upperTranslation=t.upperTranslation,this.m_maxMotorForce=t.maxMotorForce,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_limitState=v,this.m_axis=_.zero(),this.m_perp=_.zero(),this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_axis,this.m_perp,this.m_s1,this.m_s2,this.m_a1,this.m_a2,this.m_K=new p,this.m_motorMass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/options"),a=t("../util/create"),h=t("../Settings"),c=t("../common/Math"),_=t("../common/Vec2"),l=t("../common/Vec3"),u=t("../common/Mat22"),p=t("../common/Mat33"),d=t("../common/Rot"),y=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),v=0;o.TYPE="prismatic-joint";var f={enableLimit:!1,lowerTranslation:0,upperTranslation:0,enableMotor:!1,maxMotorForce:0,motorSpeed:0};(o.prototype=a((o._super=y).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getLocalAxisA=function(){return this.m_localXAxisA},o.prototype.getReferenceAngle=function(){return this.m_referenceAngle},o.prototype.getJointTranslation=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_bodyB.getWorldPoint(this.m_localAnchorB),e=_.sub(i,t),o=this.m_bodyA.getWorldVector(this.m_localXAxisA);return _.dot(e,o)},o.prototype.getJointSpeed=function(){var t=this.m_bodyA,i=this.m_bodyB,e=Mul(t.m_xf.q,this.m_localAnchorA-t.m_sweep.localCenter),o=Mul(i.m_xf.q,this.m_localAnchorB-i.m_sweep.localCenter),s=t.m_sweep.c+e,n=i.m_sweep.c+o-s,r=Mul(t.m_xf.q,this.m_localXAxisA),m=t.m_linearVelocity,a=i.m_linearVelocity,h=t.m_angularVelocity,c=i.m_angularVelocity;return Dot(n,Cross(h,r))+Dot(r,a+Cross(c,o)-m-Cross(h,e))},o.prototype.isLimitEnabled=function(){return this.m_enableLimit},o.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},o.prototype.getLowerLimit=function(){return this.m_lowerTranslation},o.prototype.getUpperLimit=function(){return this.m_upperTranslation},o.prototype.setLimits=function(t,i){n&&r.assert(t<=i),t==this.m_lowerTranslation&&i==this.m_upperTranslation||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_lowerTranslation=t,this.m_upperTranslation=i,this.m_impulse.z=0)},o.prototype.isMotorEnabled=function(){return this.m_enableMotor},o.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},o.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},o.prototype.setMaxMotorForce=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorForce=t},o.prototype.getMotorSpeed=function(){return this.m_motorSpeed},o.prototype.getMotorForce=function(t){return t*this.m_motorImpulse},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*(this.m_impulse.x*this.m_perp+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis)},o.prototype.getReactionTorque=function(t){return t*this.m_impulse.y},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,m=this.m_bodyB.c_velocity.v,a=this.m_bodyB.c_velocity.w,l=d.neo(e),u=d.neo(r),p=d.mul(l,_.sub(this.m_localAnchorA,this.m_localCenterA)),y=d.mul(u,_.sub(this.m_localAnchorB,this.m_localCenterB)),f=_.zero();f.wAdd(1,n,1,y),f.wSub(1,i,1,p);var x=this.m_invMassA,g=this.m_invMassB,A=this.m_invIA,b=this.m_invIB;this.m_axis=d.mul(l,this.m_localXAxisA),this.m_a1=_.cross(_.add(f,p),this.m_axis),this.m_a2=_.cross(y,this.m_axis),this.m_motorMass=x+g+A*this.m_a1*this.m_a1+b*this.m_a2*this.m_a2,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),this.m_perp=d.mul(l,this.m_localYAxisA),this.m_s1=_.cross(_.add(f,p),this.m_perp),this.m_s2=_.cross(y,this.m_perp);_.cross(p,this.m_perp);var B=x+g+A*this.m_s1*this.m_s1+b*this.m_s2*this.m_s2,w=A*this.m_s1+b*this.m_s2,S=A*this.m_s1*this.m_a1+b*this.m_s2*this.m_a2,C=A+b;0==C&&(C=1);var M=A*this.m_a1+b*this.m_a2,I=x+g+A*this.m_a1*this.m_a1+b*this.m_a2*this.m_a2;if(this.m_K.ex.set(B,w,S),this.m_K.ey.set(w,C,M),this.m_K.ez.set(S,M,I),this.m_enableLimit){var P=_.dot(this.m_axis,f);c.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*h.linearSlop?this.m_limitState=3:P<=this.m_lowerTranslation?1!=this.m_limitState&&(this.m_limitState=1,this.m_impulse.z=0):P>=this.m_upperTranslation?2!=this.m_limitState&&(this.m_limitState=2,this.m_impulse.z=0):(this.m_limitState=v,this.m_impulse.z=0)}else this.m_limitState=v,this.m_impulse.z=0;if(0==this.m_enableMotor&&(this.m_motorImpulse=0),t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var T=_.wAdd(this.m_impulse.x,this.m_perp,this.m_motorImpulse+this.m_impulse.z,this.m_axis),V=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,z=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2;o.wSub(x,T),s-=A*V,m.wAdd(g,T),a+=b*z}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(m),this.m_bodyB.c_velocity.w=a},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,m=this.m_invIA,a=this.m_invIB;if(this.m_enableMotor&&3!=this.m_limitState){var h=_.dot(this.m_axis,_.sub(o,i))+this.m_a2*s-this.m_a1*e,u=this.m_motorMass*(this.m_motorSpeed-h),p=this.m_motorImpulse,d=t.dt*this.m_maxMotorForce;this.m_motorImpulse=c.clamp(this.m_motorImpulse+u,-d,d),u=this.m_motorImpulse-p;var y=_.zero().wSet(u,this.m_axis),f=u*this.m_a1,x=u*this.m_a2;i.wSub(n,y),e-=m*f,o.wAdd(r,y),s+=a*x}var g=_.zero();if(g.x+=_.dot(this.m_perp,o)+this.m_s2*s,g.x-=_.dot(this.m_perp,i)+this.m_s1*e,g.y=s-e,this.m_enableLimit&&this.m_limitState!=v){var A=0;A+=_.dot(this.m_axis,o)+this.m_a2*s,A-=_.dot(this.m_axis,i)+this.m_a1*e;h=l(g.x,g.y,A);var b=l(this.m_impulse),B=this.m_K.solve33(l.neg(h));this.m_impulse.add(B),1==this.m_limitState?this.m_impulse.z=c.max(this.m_impulse.z,0):2==this.m_limitState&&(this.m_impulse.z=c.min(this.m_impulse.z,0));var w=_.wAdd(-1,g,-(this.m_impulse.z-b.z),_.neo(this.m_K.ez.x,this.m_K.ez.y)),S=_.add(this.m_K.solve22(w),_.neo(b.x,b.y));this.m_impulse.x=S.x,this.m_impulse.y=S.y,B=l.sub(this.m_impulse,b);y=_.wAdd(B.x,this.m_perp,B.z,this.m_axis),f=B.x*this.m_s1+B.y+B.z*this.m_a1,x=B.x*this.m_s2+B.y+B.z*this.m_a2;i.wSub(n,y),e-=m*f,o.wAdd(r,y),s+=a*x}else{B=this.m_K.solve22(_.neg(g));this.m_impulse.x+=B.x,this.m_impulse.y+=B.y;y=_.zero().wAdd(B.x,this.m_perp),f=B.x*this.m_s1+B.y,x=B.x*this.m_s2+B.y;i.wSub(n,y),e-=m*f,o.wAdd(r,y),s+=a*x}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=d.neo(e),r=d.neo(s),m=this.m_invMassA,a=this.m_invMassB,y=this.m_invIA,v=this.m_invIB,f=d.mul(n,_.sub(this.m_localAnchorA,this.m_localCenterA)),x=d.mul(r,_.sub(this.m_localAnchorB,this.m_localCenterB)),g=_.sub(_.add(o,x),_.add(i,f)),A=d.mul(n,this.m_localXAxisA),b=_.cross(_.add(g,f),A),B=_.cross(x,A),w=d.mul(n,this.m_localYAxisA),S=_.cross(_.add(g,f),w),C=_.cross(x,w),M=l(),I=_.zero();I.x=_.dot(w,g),I.y=s-e-this.m_referenceAngle;var P=c.abs(I.x),T=c.abs(I.y),V=h.linearSlop,z=h.maxLinearCorrection,L=!1,F=0;if(this.m_enableLimit){var q=_.dot(A,g);c.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*V?(F=c.clamp(q,-z,z),P=c.max(P,c.abs(q)),L=!0):q<=this.m_lowerTranslation?(F=c.clamp(q-this.m_lowerTranslation+V,-z,0),P=c.max(P,this.m_lowerTranslation-q),L=!0):q>=this.m_upperTranslation&&(F=c.clamp(q-this.m_upperTranslation-V,0,z),P=c.max(P,q-this.m_upperTranslation),L=!0)}if(L){var k=m+a+y*S*S+v*C*C,D=y*S+v*C,R=y*S*b+v*C*B;0==(O=y+v)&&(O=1);var E=y*b+v*B,j=m+a+y*b*b+v*B*B;(N=new p).ex.set(k,D,R),N.ey.set(D,O,E),N.ez.set(R,E,j);var J=l();J.x=I.x,J.y=I.y,J.z=F,M=N.solve33(l.neg(J))}else{var O;k=m+a+y*S*S+v*C*C,D=y*S+v*C;0==(O=y+v)&&(O=1);var N;(N=new u).ex.set(k,D),N.ey.set(D,O);var Y=N.solve(_.neg(I));M.x=Y.x,M.y=Y.y,M.z=0}var W=_.wAdd(M.x,w,M.z,A),H=M.x*S+M.y+M.z*b,Z=M.x*C+M.y+M.z*B;return i.wSub(m,W),e-=y*H,o.wAdd(a,W),s+=v*Z,this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c=o,this.m_bodyB.c_position.a=s,P<=h.linearSlop&&T<=h.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],33:[function(t,i,e){function o(t,i,e,s,a,h,l,u){if(!(this instanceof o))return new o(t,i,e,s,a,h,l,u);t=m(t,d),p.call(this,t,i,e),this.m_type=o.TYPE,this.m_groundAnchorA=s,this.m_groundAnchorB=a,this.m_localAnchorA=i.getLocalPoint(h),this.m_localAnchorB=e.getLocalPoint(l),this.m_lengthA=_.distance(h,s),this.m_lengthB=_.distance(l,a),this.m_ratio=t.ratio||u,n&&r.assert(u>c.EPSILON),this.m_constant=this.m_lengthA+this.m_ratio*this.m_lengthB,this.m_impulse=0,this.m_uA,this.m_uB,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/options"),a=t("../util/create"),h=t("../Settings"),c=t("../common/Math"),_=t("../common/Vec2"),l=t("../common/Vec3"),u=(t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),p=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="pulley-joint",o.MIN_PULLEY_LENGTH=2;var d={collideConnected:!0};(o.prototype=a((o._super=p).prototype)).getGroundAnchorA=function(){return this.m_groundAnchorA},o.prototype.getGroundAnchorB=function(){return this.m_groundAnchorB},o.prototype.getLengthA=function(){return this.m_lengthA},o.prototype.getLengthB=function(){return this.m_lengthB},o.prototype.setRatio=function(){return this.m_ratio},o.prototype.getCurrentLengthA=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_groundAnchorA;return _.distance(t,i)},o.prototype.getCurrentLengthB=function(){var t=this.m_bodyB.getWorldPoint(this.m_localAnchorB),i=this.m_groundAnchorB;return _.distance(t,i)},o.prototype.shiftOrigin=function(t){this.m_groundAnchorA-=t,this.m_groundAnchorB-=t},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return l.mul(t*this.m_impulse,this.m_uB)},o.prototype.getReactionTorque=function(t){return 0},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,m=this.m_bodyB.c_velocity.v,a=this.m_bodyB.c_velocity.w,c=u.neo(e),l=u.neo(r);this.m_rA=u.mul(c,_.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=u.mul(l,_.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_uA=_.sub(_.add(i,this.m_rA),this.m_groundAnchorA),this.m_uB=_.sub(_.add(n,this.m_rB),this.m_groundAnchorB);var p=this.m_uA.length(),d=this.m_uB.length();p>10*h.linearSlop?this.m_uA.mul(1/p):this.m_uA.setZero(),d>10*h.linearSlop?this.m_uB.mul(1/d):this.m_uB.setZero();var y=_.cross(this.m_rA,this.m_uA),v=_.cross(this.m_rB,this.m_uB),f=this.m_invMassA+this.m_invIA*y*y,x=this.m_invMassB+this.m_invIB*v*v;if(this.m_mass=f+this.m_ratio*this.m_ratio*x,this.m_mass>0&&(this.m_mass=1/this.m_mass),t.warmStarting){this.m_impulse*=t.dtRatio;var g=_.mul(-this.m_impulse,this.m_uA),A=_.mul(-this.m_ratio*this.m_impulse,this.m_uB);o.wAdd(this.m_invMassA,g),s+=this.m_invIA*_.cross(this.m_rA,g),m.wAdd(this.m_invMassB,A),a+=this.m_invIB*_.cross(this.m_rB,A)}else this.m_impulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=m,this.m_bodyB.c_velocity.w=a},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=_.add(i,_.cross(e,this.m_rA)),r=_.add(o,_.cross(s,this.m_rB)),m=-_.dot(this.m_uA,n)-this.m_ratio*_.dot(this.m_uB,r),a=-this.m_mass*m;this.m_impulse+=a;var h=_.zero().wSet(-a,this.m_uA),c=_.zero().wSet(-this.m_ratio*a,this.m_uB);i.wAdd(this.m_invMassA,h),e+=this.m_invIA*_.cross(this.m_rA,h),o.wAdd(this.m_invMassB,c),s+=this.m_invIB*_.cross(this.m_rB,c),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=u.neo(e),r=u.neo(s),m=u.mul(n,_.sub(this.m_localAnchorA,this.m_localCenterA)),a=u.mul(r,_.sub(this.m_localAnchorB,this.m_localCenterB)),l=_.sub(_.add(i,this.m_rA),this.m_groundAnchorA),p=_.sub(_.add(o,this.m_rB),this.m_groundAnchorB),d=l.length(),y=p.length();d>10*h.linearSlop?l.mul(1/d):l.setZero(),y>10*h.linearSlop?p.mul(1/y):p.setZero();var v=_.cross(m,l),f=_.cross(a,p),x=this.m_invMassA+this.m_invIA*v*v,g=this.m_invMassB+this.m_invIB*f*f,A=x+this.m_ratio*this.m_ratio*g;A>0&&(A=1/A);var b=this.m_constant-d-this.m_ratio*y,B=c.abs(b),w=-A*b,S=_.zero().wSet(-w,l),C=_.zero().wSet(-this.m_ratio*w,p);return i.wAdd(this.m_invMassA,S),e+=this.m_invIA*_.cross(m,S),o.wAdd(this.m_invMassB,C),s+=this.m_invIB*_.cross(a,C),this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c=o,this.m_bodyB.c_position.a=s,B<h.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],34:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=m(t,f),y.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(s),this.m_localAnchorB=t.localAnchorB||e.getLocalPoint(s),this.m_referenceAngle=e.getAngle()-i.getAngle(),this.m_impulse=l(),this.m_motorImpulse=0,this.m_lowerAngle=t.lowerAngle,this.m_upperAngle=t.upperAngle,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new p,this.m_motorMass,this.m_limitState=v}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/options"),a=t("../util/create"),h=t("../Settings"),c=t("../common/Math"),_=t("../common/Vec2"),l=t("../common/Vec3"),u=t("../common/Mat22"),p=t("../common/Mat33"),d=t("../common/Rot"),y=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),v=0;o.TYPE="revolute-joint";var f={lowerAngle:0,upperAngle:0,maxMotorTorque:0,motorSpeed:0,enableLimit:!1,enableMotor:!1};(o.prototype=a((o._super=y).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getReferenceAngle=function(){return this.m_referenceAngle},o.prototype.getJointAngle=function(){var t=this.m_bodyA;return this.m_bodyB.m_sweep.a-t.m_sweep.a-this.m_referenceAngle},o.prototype.getJointSpeed=function(){var t=this.m_bodyA;return this.m_bodyB.m_angularVelocity-t.m_angularVelocity},o.prototype.isMotorEnabled=function(){return this.m_enableMotor},o.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},o.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},o.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},o.prototype.getMotorSpeed=function(){return this.m_motorSpeed},o.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},o.prototype.isLimitEnabled=function(){return this.m_enableLimit},o.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},o.prototype.getLowerLimit=function(){return this.m_lowerAngle},o.prototype.getUpperLimit=function(){return this.m_upperAngle},o.prototype.setLimits=function(t,i){n&&r.assert(t<=i),t==this.m_lowerAngle&&i==this.m_upperAngle||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_impulse.z=0,this.m_lowerAngle=t,this.m_upperAngle=i)},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*_.neo(this.m_impulse.x,this.m_impulse.y)},o.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,m=d.neo(i),a=d.neo(s);this.m_rA=d.mul(m,_.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=d.mul(a,_.sub(this.m_localAnchorB,this.m_localCenterB));var l=this.m_invMassA,u=this.m_invMassB,p=this.m_invIA,y=this.m_invIB,f=p+y==0;if(this.m_mass.ex.x=l+u+this.m_rA.y*this.m_rA.y*p+this.m_rB.y*this.m_rB.y*y,this.m_mass.ey.x=-this.m_rA.y*this.m_rA.x*p-this.m_rB.y*this.m_rB.x*y,this.m_mass.ez.x=-this.m_rA.y*p-this.m_rB.y*y,this.m_mass.ex.y=this.m_mass.ey.x,this.m_mass.ey.y=l+u+this.m_rA.x*this.m_rA.x*p+this.m_rB.x*this.m_rB.x*y,this.m_mass.ez.y=this.m_rA.x*p+this.m_rB.x*y,this.m_mass.ex.z=this.m_mass.ez.x,this.m_mass.ey.z=this.m_mass.ez.y,this.m_mass.ez.z=p+y,this.m_motorMass=p+y,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),(0==this.m_enableMotor||f)&&(this.m_motorImpulse=0),this.m_enableLimit&&0==f){var x=s-i-this.m_referenceAngle;c.abs(this.m_upperAngle-this.m_lowerAngle)<2*h.angularSlop?this.m_limitState=3:x<=this.m_lowerAngle?(1!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=1):x>=this.m_upperAngle?(2!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=2):(this.m_limitState=v,this.m_impulse.z=0)}else this.m_limitState=v;if(t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var g=_.neo(this.m_impulse.x,this.m_impulse.y);e.wSub(l,g),o-=p*(_.cross(this.m_rA,g)+this.m_motorImpulse+this.m_impulse.z),n.wAdd(u,g),r+=y*(_.cross(this.m_rB,g)+this.m_motorImpulse+this.m_impulse.z)}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,m=this.m_invIA,a=this.m_invIB,h=m+a==0;if(this.m_enableMotor&&3!=this.m_limitState&&0==h){var u=s-e-this.m_motorSpeed,p=-this.m_motorMass*u,d=this.m_motorImpulse,y=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=c.clamp(this.m_motorImpulse+p,-y,y),e-=m*(p=this.m_motorImpulse-d),s+=a*p}if(this.m_enableLimit&&this.m_limitState!=v&&0==h){var f=_.zero();f.wAdd(1,o,1,_.cross(s,this.m_rB)),f.wSub(1,i,1,_.cross(e,this.m_rA));var x=s-e;u=l(f.x,f.y,x),p=l.neg(this.m_mass.solve33(u));if(3==this.m_limitState)this.m_impulse.add(p);else if(1==this.m_limitState){if(this.m_impulse.z+p.z<0){var g=_.wAdd(-1,f,this.m_impulse.z,_.neo(this.m_mass.ez.x,this.m_mass.ez.y)),A=this.m_mass.solve22(g);p.x=A.x,p.y=A.y,p.z=-this.m_impulse.z,this.m_impulse.x+=A.x,this.m_impulse.y+=A.y,this.m_impulse.z=0}else this.m_impulse.add(p)}else if(2==this.m_limitState){if(this.m_impulse.z+p.z>0){g=_.wAdd(-1,f,this.m_impulse.z,_.neo(this.m_mass.ez.x,this.m_mass.ez.y)),A=this.m_mass.solve22(g);p.x=A.x,p.y=A.y,p.z=-this.m_impulse.z,this.m_impulse.x+=A.x,this.m_impulse.y+=A.y,this.m_impulse.z=0}else this.m_impulse.add(p)}var b=_.neo(p.x,p.y);i.wSub(n,b),e-=m*(_.cross(this.m_rA,b)+p.z),o.wAdd(r,b),s+=a*(_.cross(this.m_rB,b)+p.z)}else{(u=_.zero()).wAdd(1,o,1,_.cross(s,this.m_rB)),u.wSub(1,i,1,_.cross(e,this.m_rA));p=this.m_mass.solve22(_.neg(u));this.m_impulse.x+=p.x,this.m_impulse.y+=p.y,i.wSub(n,p),e-=m*_.cross(this.m_rA,p),o.wAdd(r,p),s+=a*_.cross(this.m_rB,p)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=d.neo(e),r=d.neo(s),m=0,a=0,l=this.m_invIA+this.m_invIB==0;if(this.m_enableLimit&&this.m_limitState!=v&&0==l){var p=s-e-this.m_referenceAngle,y=0;if(3==this.m_limitState){var f=c.clamp(p-this.m_lowerAngle,-h.maxAngularCorrection,h.maxAngularCorrection);y=-this.m_motorMass*f,m=c.abs(f)}else if(1==this.m_limitState){m=-(f=p-this.m_lowerAngle),f=c.clamp(f+h.angularSlop,-h.maxAngularCorrection,0),y=-this.m_motorMass*f}else if(2==this.m_limitState){m=f=p-this.m_upperAngle,f=c.clamp(f-h.angularSlop,0,h.maxAngularCorrection),y=-this.m_motorMass*f}e-=this.m_invIA*y,s+=this.m_invIB*y}n.set(e),r.set(s);var x=d.mul(n,_.sub(this.m_localAnchorA,this.m_localCenterA)),g=d.mul(r,_.sub(this.m_localAnchorB,this.m_localCenterB));(f=_.zero()).wAdd(1,o,1,g),f.wSub(1,i,1,x),a=f.length();var A=this.m_invMassA,b=this.m_invMassB,B=this.m_invIA,w=this.m_invIB,S=new u;S.ex.x=A+b+B*x.y*x.y+w*g.y*g.y,S.ex.y=-B*x.x*x.y-w*g.x*g.y,S.ey.x=S.ex.y,S.ey.y=A+b+B*x.x*x.x+w*g.x*g.x;var C=_.neg(S.solve(f));return i.wSub(A,C),e-=B*_.cross(x,C),o.wAdd(b,C),s+=w*_.cross(g,C),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,a<=h.linearSlop&&m<=h.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],35:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=r(t,p),l.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(s),this.m_localAnchorB=t.localAnchorB||e.getLocalPoint(s),this.m_maxLength=t.maxLength,this.m_mass=0,this.m_impulse=0,this.m_length=0,this.m_state=u,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/options"),m=t("../util/create"),a=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),u=0;o.TYPE="rope-joint";var p={maxLength:0};(o.prototype=m((o._super=l).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.setMaxLength=function(t){this.m_maxLength=t},o.prototype.getMaxLength=function(){return this.m_maxLength},o.prototype.getLimitState=function(){return this.m_state},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*this.m_impulse*this.m_u},o.prototype.getReactionTorque=function(t){return 0},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,m=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,l=_.neo(e),p=_.neo(r);this.m_rA=_.mulSub(l,this.m_localAnchorA,this.m_localCenterA),this.m_rB=_.mulSub(p,this.m_localAnchorB,this.m_localCenterB),this.m_u=c.zero(),this.m_u.wAdd(1,n,1,this.m_rB),this.m_u.wSub(1,i,1,this.m_rA),this.m_length=this.m_u.length();var d=this.m_length-this.m_maxLength;if(this.m_state=d>0?2:u,!(this.m_length>a.linearSlop))return this.m_u.setZero(),this.m_mass=0,void(this.m_impulse=0);this.m_u.mul(1/this.m_length);var y=c.cross(this.m_rA,this.m_u),v=c.cross(this.m_rB,this.m_u),f=this.m_invMassA+this.m_invIA*y*y+this.m_invMassB+this.m_invIB*v*v;if(this.m_mass=0!=f?1/f:0,t.warmStarting){this.m_impulse*=t.dtRatio;var x=c.mul(this.m_impulse,this.m_u);o.wSub(this.m_invMassA,x),s-=this.m_invIA*c.cross(this.m_rA,x),m.wAdd(this.m_invMassB,x),h+=this.m_invIB*c.cross(this.m_rB,x)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(m),this.m_bodyB.c_velocity.w=h},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=c.addCross(i,e,this.m_rA),r=c.addCross(o,s,this.m_rB),m=this.m_length-this.m_maxLength,a=c.dot(this.m_u,c.sub(r,n));m<0&&(a+=t.inv_dt*m);var _=-this.m_mass*a,l=this.m_impulse;this.m_impulse=h.min(0,this.m_impulse+_),_=this.m_impulse-l;var u=c.mul(_,this.m_u);i.wSub(this.m_invMassA,u),e-=this.m_invIA*c.cross(this.m_rA,u),o.wAdd(this.m_invMassB,u),s+=this.m_invIB*c.cross(this.m_rB,u),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=_.neo(e),r=_.neo(s),m=_.mulSub(n,this.m_localAnchorA,this.m_localCenterA),l=_.mulSub(r,this.m_localAnchorB,this.m_localCenterB),u=c.zero();u.wAdd(1,o,1,l),u.wSub(1,i,1,m);var p=u.normalize(),d=p-this.m_maxLength;d=h.clamp(d,0,a.maxLinearCorrection);var y=-this.m_mass*d,v=c.mul(y,u);return i.wSub(this.m_invMassA,v),e-=this.m_invIA*c.cross(m,v),o.wAdd(this.m_invMassB,v),s+=this.m_invIB*c.cross(l,v),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,p-this.m_maxLength<a.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":51,"../util/options":52}],36:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=r(t,d),p.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=i.getLocalPoint(s),this.m_localAnchorB=e.getLocalPoint(s),this.m_referenceAngle=e.getAngle()-i.getAngle(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=_(),this.m_bias=0,this.m_gamma=0,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new l}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/options"),m=t("../util/create"),a=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=t("../common/Vec3"),l=(t("../common/Mat22"),t("../common/Mat33")),u=t("../common/Rot"),p=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="weld-joint";var d={frequencyHz:0,dampingRatio:0};(o.prototype=m((o._super=p).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getReferenceAngle=function(){return this.m_referenceAngle},o.prototype.setFrequency=function(t){this.m_frequencyHz=t},o.prototype.getFrequency=function(){return this.m_frequencyHz},o.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*c.neo(this.m_impulse.x,this.m_impulse.y)},o.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,m=u.neo(i),a=u.neo(s);this.m_rA=u.mul(m,c.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=u.mul(a,c.sub(this.m_localAnchorB,this.m_localCenterB));var _=this.m_invMassA,p=this.m_invMassB,d=this.m_invIA,y=this.m_invIB,v=new l;if(v.ex.x=_+p+this.m_rA.y*this.m_rA.y*d+this.m_rB.y*this.m_rB.y*y,v.ey.x=-this.m_rA.y*this.m_rA.x*d-this.m_rB.y*this.m_rB.x*y,v.ez.x=-this.m_rA.y*d-this.m_rB.y*y,v.ex.y=v.ey.x,v.ey.y=_+p+this.m_rA.x*this.m_rA.x*d+this.m_rB.x*this.m_rB.x*y,v.ez.y=this.m_rA.x*d+this.m_rB.x*y,v.ex.z=v.ez.x,v.ey.z=v.ez.y,v.ez.z=d+y,this.m_frequencyHz>0){v.getInverse22(this.m_mass);var f=d+y,x=f>0?1/f:0,g=s-i-this.m_referenceAngle,A=2*h.PI*this.m_frequencyHz,b=2*x*this.m_dampingRatio*A,B=x*A*A,w=t.dt;this.m_gamma=w*(b+w*B),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=g*w*B*this.m_gamma,f+=this.m_gamma,this.m_mass.ez.z=0!=f?1/f:0}else 0==v.ez.z?(v.getInverse22(this.m_mass),this.m_gamma=0,this.m_bias=0):(v.getSymInverse33(this.m_mass),this.m_gamma=0,this.m_bias=0);if(t.warmStarting){this.m_impulse.mul(t.dtRatio);var S=c.neo(this.m_impulse.x,this.m_impulse.y);e.wSub(_,S),o-=d*(c.cross(this.m_rA,S)+this.m_impulse.z),n.wAdd(p,S),r+=y*(c.cross(this.m_rB,S)+this.m_impulse.z)}else this.m_impulse.setZero();this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,m=this.m_invIA,a=this.m_invIB;if(this.m_frequencyHz>0){var h=s-e,u=-this.m_mass.ez.z*(h+this.m_bias+this.m_gamma*this.m_impulse.z);this.m_impulse.z+=u,e-=m*u,s+=a*u;(y=c.zero()).wAdd(1,o,1,c.cross(s,this.m_rB)),y.wSub(1,i,1,c.cross(e,this.m_rA));var p=c.neg(l.mul(this.m_mass,y));this.m_impulse.x+=p.x,this.m_impulse.y+=p.y;var d=c.clone(p);i.wSub(n,d),e-=m*c.cross(this.m_rA,d),o.wAdd(r,d),s+=a*c.cross(this.m_rB,d)}else{var y;(y=c.zero()).wAdd(1,o,1,c.cross(s,this.m_rB)),y.wSub(1,i,1,c.cross(e,this.m_rA));h=s-e;var v=_(y.x,y.y,h),f=_.neg(l.mul(this.m_mass,v));this.m_impulse.add(f);d=c.neo(f.x,f.y);i.wSub(n,d),e-=m*(c.cross(this.m_rA,d)+f.z),o.wAdd(r,d),s+=a*(c.cross(this.m_rB,d)+f.z)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i,e,o=this.m_bodyA.c_position.c,s=this.m_bodyA.c_position.a,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,m=u.neo(s),p=u.neo(r),d=this.m_invMassA,y=this.m_invMassB,v=this.m_invIA,f=this.m_invIB,x=u.mul(m,c.sub(this.m_localAnchorA,this.m_localCenterA)),g=u.mul(p,c.sub(this.m_localAnchorB,this.m_localCenterB)),A=new l;if(A.ex.x=d+y+x.y*x.y*v+g.y*g.y*f,A.ey.x=-x.y*x.x*v-g.y*g.x*f,A.ez.x=-x.y*v-g.y*f,A.ex.y=A.ey.x,A.ey.y=d+y+x.x*x.x*v+g.x*g.x*f,A.ez.y=x.x*v+g.x*f,A.ex.z=A.ez.x,A.ey.z=A.ez.y,A.ez.z=v+f,this.m_frequencyHz>0){(B=c.zero()).wAdd(1,n,1,g),B.wSub(1,o,1,x),i=B.length(),e=0;var b=c.neg(A.solve22(B));o.wSub(d,b),s-=v*c.cross(x,b),n.wAdd(y,b),r+=f*c.cross(g,b)}else{var B;(B=c.zero()).wAdd(1,n,1,g),B.wSub(1,o,1,x);var w=r-s-this.m_referenceAngle;i=B.length(),e=h.abs(w);var S=_(B.x,B.y,w),C=_();if(A.ez.z>0)C=_.neg(A.solve33(S));else{var M=c.neg(A.solve22(B));C.set(M.x,M.y,0)}b=c.neo(C.x,C.y);o.wSub(d,b),s-=v*(c.cross(x,b)+C.z),n.wAdd(y,b),r+=f*(c.cross(g,b)+C.z)}return this.m_bodyA.c_position.c=o,this.m_bodyA.c_position.a=s,this.m_bodyB.c_position.c=n,this.m_bodyB.c_position.a=r,i<=a.linearSlop&&e<=a.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":51,"../util/options":52}],37:[function(t,i,e){function o(t,i,e,s,n){if(!(this instanceof o))return new o(t,i,e,s,n);t=r(t,u),l.call(this,t,i,e),this.m_type=o.TYPE,this.m_localAnchorA=i.getLocalPoint(s),this.m_localAnchorB=e.getLocalPoint(s),this.m_localXAxisA=i.getLocalVector(n||c.neo(1,0)),this.m_localYAxisA=c.cross(1,this.m_localXAxisA),this.m_mass=0,this.m_impulse=0,this.m_motorMass=0,this.m_motorImpulse=0,this.m_springMass=0,this.m_springImpulse=0,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableMotor=t.enableMotor,this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_bias=0,this.m_gamma=0,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_ax=c.zero(),this.m_ay=c.zero(),this.m_sAx,this.m_sBx,this.m_sAy,this.m_sBy}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/options"),m=t("../util/create"),a=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="wheel-joint";var u={enableMotor:!1,maxMotorTorque:0,motorSpeed:0,frequencyHz:2,dampingRatio:.7};(o.prototype=m((o._super=l).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getLocalAxisA=function(){return this.m_localXAxisA},o.prototype.getJointTranslation=function(){var t=this.m_bodyA,i=this.m_bodyB,e=t.getWorldPoint(this.m_localAnchorA),o=i.getWorldPoint(this.m_localAnchorB)-e,s=t.getWorldVector(this.m_localXAxisA);return Dot(o,s)},o.prototype.getJointSpeed=function(){var t=this.m_bodyA.m_angularVelocity;return this.m_bodyB.m_angularVelocity-t},o.prototype.isMotorEnabled=function(){return this.m_enableMotor},o.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},o.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},o.prototype.getMotorSpeed=function(){return this.m_motorSpeed},o.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},o.prototype.getMaxMotorTorque=function(){return this.m_maxMotorTorque},o.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},o.prototype.setSpringFrequencyHz=function(t){this.m_frequencyHz=t},o.prototype.getSpringFrequencyHz=function(){return this.m_frequencyHz},o.prototype.setSpringDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getSpringDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return t*(this.m_impulse*this.m_ay+this.m_springImpulse*this.m_ax)},o.prototype.getReactionTorque=function(t){return t*this.m_motorImpulse},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_invMassA,e=this.m_invMassB,o=this.m_invIA,s=this.m_invIB,n=this.m_bodyA.c_position.c,r=this.m_bodyA.c_position.a,m=this.m_bodyA.c_velocity.v,a=this.m_bodyA.c_velocity.w,l=this.m_bodyB.c_position.c,u=this.m_bodyB.c_position.a,p=this.m_bodyB.c_velocity.v,d=this.m_bodyB.c_velocity.w,y=_.neo(r),v=_.neo(u),f=_.mul(y,c.sub(this.m_localAnchorA,this.m_localCenterA)),x=_.mul(v,c.sub(this.m_localAnchorB,this.m_localCenterB));if((B=c.zero()).wAdd(1,l,1,x),B.wSub(1,n,1,f),this.m_ay=_.mul(y,this.m_localYAxisA),this.m_sAy=c.cross(c.add(B,f),this.m_ay),this.m_sBy=c.cross(x,this.m_ay),this.m_mass=i+e+o*this.m_sAy*this.m_sAy+s*this.m_sBy*this.m_sBy,this.m_mass>0&&(this.m_mass=1/this.m_mass),this.m_springMass=0,this.m_bias=0,this.m_gamma=0,this.m_frequencyHz>0){this.m_ax=_.mul(y,this.m_localXAxisA),this.m_sAx=c.cross(c.add(B,f),this.m_ax),this.m_sBx=c.cross(x,this.m_ax);var g=i+e+o*this.m_sAx*this.m_sAx+s*this.m_sBx*this.m_sBx;if(g>0){this.m_springMass=1/g;var A=c.dot(B,this.m_ax),b=2*h.PI*this.m_frequencyHz,B=2*this.m_springMass*this.m_dampingRatio*b,w=this.m_springMass*b*b,S=t.dt;this.m_gamma=S*(B+S*w),this.m_gamma>0&&(this.m_gamma=1/this.m_gamma),this.m_bias=A*S*w*this.m_gamma,this.m_springMass=g+this.m_gamma,this.m_springMass>0&&(this.m_springMass=1/this.m_springMass)}}else this.m_springImpulse=0;if(this.m_enableMotor?(this.m_motorMass=o+s,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass)):(this.m_motorMass=0,this.m_motorImpulse=0),t.warmStarting){this.m_impulse*=t.dtRatio,this.m_springImpulse*=t.dtRatio,this.m_motorImpulse*=t.dtRatio;var C=c.wAdd(this.m_impulse,this.m_ay,this.m_springImpulse,this.m_ax),M=this.m_impulse*this.m_sAy+this.m_springImpulse*this.m_sAx+this.m_motorImpulse,I=this.m_impulse*this.m_sBy+this.m_springImpulse*this.m_sBx+this.m_motorImpulse;m.wSub(this.m_invMassA,C),a-=this.m_invIA*M,p.wAdd(this.m_invMassB,C),d+=this.m_invIB*I}else this.m_impulse=0,this.m_springImpulse=0,this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(m),this.m_bodyA.c_velocity.w=a,this.m_bodyB.c_velocity.v.set(p),this.m_bodyB.c_velocity.w=d},o.prototype.solveVelocityConstraints=function(t){var i=this.m_invMassA,e=this.m_invMassB,o=this.m_invIA,s=this.m_invIB,n=this.m_bodyA.c_velocity.v,r=this.m_bodyA.c_velocity.w,m=this.m_bodyB.c_velocity.v,a=this.m_bodyB.c_velocity.w,_=c.dot(this.m_ax,m)-c.dot(this.m_ax,n)+this.m_sBx*a-this.m_sAx*r,l=-this.m_springMass*(_+this.m_bias+this.m_gamma*this.m_springImpulse);this.m_springImpulse+=l;var u=c.zero().wSet(l,this.m_ax),p=l*this.m_sAx,d=l*this.m_sBx;n.wSub(i,u),r-=o*p,m.wAdd(e,u);_=(a+=s*d)-r-this.m_motorSpeed,l=-this.m_motorMass*_;var y=this.m_motorImpulse,v=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=h.clamp(this.m_motorImpulse+l,-v,v),r-=o*(l=this.m_motorImpulse-y),a+=s*l;_=c.dot(this.m_ay,m)-c.dot(this.m_ay,n)+this.m_sBy*a-this.m_sAy*r,l=-this.m_mass*_;this.m_impulse+=l;u=c.zero().wSet(l,this.m_ay),p=l*this.m_sAy,d=l*this.m_sBy;n.wSub(i,u),r-=o*p,m.wAdd(e,u),a+=s*d,this.m_bodyA.c_velocity.v.set(n),this.m_bodyA.c_velocity.w=r,this.m_bodyB.c_velocity.v.set(m),this.m_bodyB.c_velocity.w=a},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=_.neo(e),r=_.neo(s),m=_.mul(n,c.sub(this.m_localAnchorA,this.m_localCenterA)),l=_.mul(r,c.sub(this.m_localAnchorB,this.m_localCenterB)),u=c.zero();u.wAdd(1,o,1,l),u.wSub(1,i,1,m);var p,d=_.mul(n,this.m_localYAxisA),y=c.cross(c.sub(u,m),d),v=c.cross(l,d),f=c.dot(u,d),x=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_sAy*this.m_sAy+this.m_invIB*this.m_sBy*this.m_sBy;p=0!=x?-f/x:0;var g=c.zero().wSet(p,d),A=p*y,b=p*v;return i.wSub(this.m_invMassA,g),e-=this.m_invIA*A,o.wAdd(this.m_invMassB,g),s+=this.m_invIB*b,this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,h.abs(f)<=a.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":51,"../util/options":52}],38:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);o._super.call(this),this._setAsBox(t,i,e,s)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;t("../util/common");var r=t("../util/create"),m=t("./PolygonShape");o.prototype=r((o._super=m).prototype),o.TYPE="polygon"},{"../util/common":50,"../util/create":51,"./PolygonShape":47}],39:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);o._super.call(this),this.m_type=o.TYPE,this.m_radius=c.polygonRadius,this.m_vertices=[],this.m_count=0,this.m_prevVertex=null,this.m_nextVertex=null,this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,t&&t.length&&(i?this._createLoop(t):this._createChain(t))}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/create"),a=(t("../util/options"),t("../common/Math"),t("../common/Transform")),h=(t("../common/Rot"),t("../common/Vec2")),c=(t("../collision/AABB"),t("../Settings")),_=t("../Shape"),l=t("./EdgeShape");o.prototype=m((o._super=_).prototype),o.TYPE="chain",o.prototype._createLoop=function(t){n&&r.assert(0==this.m_vertices.length&&0==this.m_count),n&&r.assert(t.length>=3);for(var i=1;i<t.length;++i){var e=t[i-1],o=t[i];n&&r.assert(h.distanceSquared(e,o)>c.linearSlopSquared)}this.m_vertices.length=0,this.m_count=t.length+1;for(i=0;i<t.length;++i)this.m_vertices[i]=t[i].clone();return this.m_vertices[t.length]=t[0].clone(),this.m_prevVertex=this.m_vertices[this.m_count-2],this.m_nextVertex=this.m_vertices[1],this.m_hasPrevVertex=!0,this.m_hasNextVertex=!0,this},o.prototype._createChain=function(t){n&&r.assert(0==this.m_vertices.length&&0==this.m_count),n&&r.assert(t.length>=2);for(var i=1;i<t.length;++i){var e=t[i-1],o=t[i];n&&r.assert(h.distanceSquared(e,o)>c.linearSlopSquared)}this.m_count=t.length;for(i=0;i<t.length;++i)this.m_vertices[i]=t[i].clone();return this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,this.m_prevVertex=null,this.m_nextVertex=null,this},o.prototype._setPrevVertex=function(t){this.m_prevVertex=t,this.m_hasPrevVertex=!0},o.prototype._setNextVertex=function(t){this.m_nextVertex=t,this.m_hasNextVertex=!0},o.prototype._clone=function(){var t=new o;return t.createChain(this.m_vertices),t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_prevVertex=this.m_prevVertex,t.m_nextVertex=this.m_nextVertex,t.m_hasPrevVertex=this.m_hasPrevVertex,t.m_hasNextVertex=this.m_hasNextVertex,t},o.prototype.getChildCount=function(){return this.m_count-1},o.prototype.getChildEdge=function(t,i){n&&r.assert(0<=i&&i<this.m_count-1),t.m_type=l.TYPE,t.m_radius=this.m_radius,t.m_vertex1=this.m_vertices[i],t.m_vertex2=this.m_vertices[i+1],i>0?(t.m_vertex0=this.m_vertices[i-1],t.m_hasVertex0=!0):(t.m_vertex0=this.m_prevVertex,t.m_hasVertex0=this.m_hasPrevVertex),i<this.m_count-2?(t.m_vertex3=this.m_vertices[i+2],t.m_hasVertex3=!0):(t.m_vertex3=this.m_nextVertex,t.m_hasVertex3=this.m_hasNextVertex)},o.prototype.getVertex=function(t){return n&&r.assert(0<=t&&t<=this.m_count),t<this.m_count?this.m_vertices[t]:this.m_vertices[0]},o.prototype.testPoint=function(t,i){return!1},o.prototype.rayCast=function(t,i,e,o){n&&r.assert(0<=o&&o<this.m_count);return new l(this.getVertex(o),this.getVertex(o+1)).rayCast(t,i,e,0)},o.prototype.computeAABB=function(t,i,e){n&&r.assert(0<=e&&e<this.m_count);var o=a.mul(i,this.getVertex(e)),s=a.mul(i,this.getVertex(e+1));t.combinePoints(o,s)},o.prototype.computeMass=function(t,i){t.mass=0,t.center=h.neo(),t.I=0},o.prototype.computeDistanceProxy=function(t,i){n&&r.assert(0<=i&&i<this.m_count),t.m_buffer[0]=this.getVertex(i),t.m_buffer[1]=this.getVertex(i+1),t.m_vertices=t.m_buffer,t.m_count=2,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"../util/options":52,"./EdgeShape":46}],40:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);o._super.call(this),this.m_type=o.TYPE,this.m_p=c.zero(),this.m_radius=1,"object"==typeof t&&c.isValid(t)?(this.m_p.set(t),"number"==typeof i&&(this.m_radius=i)):"number"==typeof t&&(this.m_radius=t)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/create"),a=(t("../util/options"),t("../common/Math")),h=(t("../common/Transform"),t("../common/Rot")),c=t("../common/Vec2"),_=(t("../collision/AABB"),t("../Settings"),t("../Shape"));o.prototype=m((o._super=_).prototype),o.TYPE="circle",o.prototype.getRadius=function(){return this.m_radius},o.prototype.getCenter=function(){return this.m_p},o.prototype.getSupportVertex=function(t){return this.m_p},o.prototype.getVertex=function(t){return n&&r.assert(0==t),this.m_p},o.prototype.getVertexCount=function(t){return 1},o.prototype._clone=function(){var t=new o;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_p=this.m_p.clone(),t},o.prototype.getChildCount=function(){return 1},o.prototype.testPoint=function(t,i){var e=c.add(t.p,h.mul(t.q,this.m_p)),o=c.sub(i,e);return c.dot(o,o)<=this.m_radius*this.m_radius},o.prototype.rayCast=function(t,i,e,o){var s=c.add(e.p,h.mul(e.q,this.m_p)),n=c.sub(i.p1,s),r=c.dot(n,n)-this.m_radius*this.m_radius,m=c.sub(i.p2,i.p1),_=c.dot(n,m),l=c.dot(m,m),u=_*_-l*r;if(u<0||l<a.EPSILON)return!1;var p=-(_+a.sqrt(u));return 0<=p&&p<=i.maxFraction*l&&(p/=l,t.fraction=p,t.normal=c.add(n,c.mul(p,m)),t.normal.normalize(),!0)},o.prototype.computeAABB=function(t,i,e){var o=c.add(i.p,h.mul(i.q,this.m_p));t.lowerBound.set(o.x-this.m_radius,o.y-this.m_radius),t.upperBound.set(o.x+this.m_radius,o.y+this.m_radius)},o.prototype.computeMass=function(t,i){t.mass=i*a.PI*this.m_radius*this.m_radius,t.center=this.m_p,t.I=t.mass*(.5*this.m_radius*this.m_radius+c.dot(this.m_p,this.m_p))},o.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_p),t.m_count=1,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"../util/options":52}],41:[function(t,i,e){function o(t,i,e,o,s){t.pointCount=0;var n=m.mul(e,i.m_p),r=m.mul(s,o.m_p),h=a.distanceSquared(r,n),_=i.m_radius+o.m_radius;h>_*_||(t.type=c.e_circles,t.localPoint.set(i.m_p),t.localNormal.setZero(),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;var r=t("../util/common"),m=(t("../util/create"),t("../common/Math"),t("../common/Transform")),a=t("../common/Vec2"),h=(t("../Settings"),t("../Shape"),t("../Contact")),c=t("../Manifold"),_=t("./CircleShape");h.addType(_.TYPE,_.TYPE,function(t,i,e,s,m,a,h){n&&r.assert(e.getType()==_.TYPE),n&&r.assert(a.getType()==_.TYPE),o(t,e.getShape(),i,a.getShape(),m)}),e.CollideCircles=o},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"./CircleShape":40}],42:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;var n=t("../util/common"),r=t("../common/Math"),m=t("../common/Transform"),a=(t("../common/Rot"),t("../common/Vec2")),h=(t("../collision/AABB"),t("../Settings"),t("../Manifold")),c=t("../Contact"),_=(t("../Shape"),t("./CircleShape")),l=t("./PolygonShape");c.addType(l.TYPE,_.TYPE,function(t,i,e,o,c,u,p){s&&n.assert(e.getType()==l.TYPE),s&&n.assert(u.getType()==_.TYPE),function(t,i,e,o,s){t.pointCount=0;for(var n=m.mul(s,o.m_p),c=m.mulT(e,n),_=0,l=-1/0,u=i.m_radius+o.m_radius,p=i.m_count,d=i.m_vertices,y=i.m_normals,v=0;v<p;++v){var f=a.dot(y[v],a.sub(c,d[v]));if(f>u)return;f>l&&(l=f,_=v)}var x=_,g=x+1<p?x+1:0,A=d[x],b=d[g];if(l<r.EPSILON)return t.pointCount=1,t.type=h.e_faceA,t.localNormal.set(y[_]),t.localPoint.wSet(.5,A,.5,b),t.points[0].localPoint=o.m_p,void(t.points[0].id.key=0);var B=a.dot(a.sub(c,A),a.sub(b,A)),w=a.dot(a.sub(c,b),a.sub(A,b));if(B<=0){if(a.distanceSquared(c,A)>u*u)return;t.pointCount=1,t.type=h.e_faceA,t.localNormal.wSet(1,c,-1,A),t.localNormal.normalize(),t.localPoint=A,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0}else if(w<=0){if(a.distanceSquared(c,b)>u*u)return;t.pointCount=1,t.type=h.e_faceA,t.localNormal.wSet(1,c,-1,b),t.localNormal.normalize(),t.localPoint.set(b),t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0}else{var S=a.mid(A,b),l=a.dot(c,y[x])-a.dot(S,y[x]);if(l>u)return;t.pointCount=1,t.type=h.e_faceA,t.localNormal.set(y[x]),t.localPoint.set(S),t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0}}(t,e.getShape(),i,u.getShape(),c)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"./CircleShape":40,"./PolygonShape":47}],43:[function(t,i,e){function o(t,i,e,o,s){t.pointCount=0;var h=m.mulT(e,m.mul(s,o.m_p)),_=i.m_vertex1,l=i.m_vertex2,u=a.sub(l,_),p=a.dot(u,a.sub(l,h)),d=a.dot(u,a.sub(h,_)),y=i.m_radius+o.m_radius;if(d<=0){var v=a.clone(_),f=a.sub(h,v);if(a.dot(f,f)>y*y)return;if(i.m_hasVertex0){var x=i.m_vertex0,g=_,A=a.sub(g,x);if(a.dot(A,a.sub(g,h))>0)return}return t.type=c.e_circles,t.localNormal.setZero(),t.localPoint.set(v),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0,t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=c.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=c.e_vertex)}if(p<=0){v=a.clone(l),f=a.sub(h,v);if(a.dot(f,f)>y*y)return;if(i.m_hasVertex3){var b=i.m_vertex3,B=l,w=a.sub(b,B);if(a.dot(w,a.sub(h,B))>0)return}return t.type=c.e_circles,t.localNormal.setZero(),t.localPoint.set(v),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0,t.points[0].id.cf.indexA=1,t.points[0].id.cf.typeA=c.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=c.e_vertex)}var S=a.dot(u,u);n&&r.assert(S>0);v=a.wAdd(p/S,_,d/S,l),f=a.sub(h,v);if(!(a.dot(f,f)>y*y)){var C=a.neo(-u.y,u.x);a.dot(C,a.sub(h,_))<0&&C.set(-C.x,-C.y),C.normalize(),t.type=c.e_faceA,t.localNormal=C,t.localPoint.set(_),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.key=0,t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=c.e_face,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=c.e_vertex}}if(void 0===s)var s=!1;if(void 0===n)var n=!1;var r=t("../util/common"),m=(t("../util/create"),t("../common/Math"),t("../common/Transform")),a=t("../common/Vec2"),h=(t("../common/Rot"),t("../Settings"),t("../Shape"),t("../Contact")),c=t("../Manifold"),_=t("./EdgeShape"),l=t("./ChainShape"),u=t("./CircleShape");h.addType(_.TYPE,u.TYPE,function(t,i,e,s,m,a,h){n&&r.assert(e.getType()==_.TYPE),n&&r.assert(a.getType()==u.TYPE),o(t,e.getShape(),i,a.getShape(),m)}),h.addType(l.TYPE,u.TYPE,function(t,i,e,s,m,a,h){n&&r.assert(e.getType()==l.TYPE),n&&r.assert(a.getType()==u.TYPE);var c=e.getShape(),p=new _;c.getChildEdge(p,s),o(t,p,i,a.getShape(),m)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"./ChainShape":39,"./CircleShape":40,"./EdgeShape":46}],44:[function(t,i,e){function o(){this.type,this.index,this.separation}function s(t,i,e,o,s){n&&m.debug("CollideEdgePolygon");var r=h.mulT(e,s),u=h.mul(r,o.m_centroid),d=i.m_vertex0,y=i.m_vertex1,v=i.m_vertex2,S=i.m_vertex3,C=i.m_hasVertex0,M=i.m_hasVertex3,I=c.sub(v,y);I.normalize();var P=c.neo(I.y,-I.x),T=c.dot(P,c.sub(u,y)),V=0,z=0,L=!1,F=!1;if(C){var q=c.sub(y,d);q.normalize();var k=c.neo(q.y,-q.x);L=c.cross(q,I)>=0,V=c.dot(k,u)-c.dot(k,d)}if(M){var D=c.sub(S,v);D.normalize();var R=c.neo(D.y,-D.x);F=c.cross(I,D)>0,z=c.dot(R,u)-c.dot(R,v)}var E,j=c.zero(),J=c.zero(),O=c.zero();C&&M?L&&F?(E=V>=0||T>=0||z>=0)?(j.set(P),J.set(k),O.set(R)):(j.wSet(-1,P),J.wSet(-1,P),O.wSet(-1,P)):L?(E=V>=0||T>=0&&z>=0)?(j.set(P),J.set(k),O.set(P)):(j.wSet(-1,P),J.wSet(-1,R),O.wSet(-1,P)):F?(E=z>=0||V>=0&&T>=0)?(j.set(P),J.set(P),O.set(R)):(j.wSet(-1,P),J.wSet(-1,P),O.wSet(-1,k)):(E=V>=0&&T>=0&&z>=0)?(j.set(P),J.set(P),O.set(P)):(j.wSet(-1,P),J.wSet(-1,R),O.wSet(-1,k)):C?L?(E=V>=0||T>=0)?(j.set(P),J.set(k),O.wSet(-1,P)):(j.wSet(-1,P),J.set(P),O.wSet(-1,P)):(E=V>=0&&T>=0)?(j.set(P),J.set(P),O.wSet(-1,P)):(j.wSet(-1,P),J.set(P),O.wSet(-1,k)):M?F?(E=T>=0||z>=0)?(j.set(P),J.wSet(-1,P),O.set(R)):(j.wSet(-1,P),J.wSet(-1,P),O.set(P)):(E=T>=0&&z>=0)?(j.set(P),J.wSet(-1,P),O.set(P)):(j.wSet(-1,P),J.wSet(-1,R),O.set(P)):(E=T>=0)?(j.set(P),J.wSet(-1,P),O.wSet(-1,P)):(j.wSet(-1,P),J.set(P),O.set(P)),B.count=o.m_count;for(var N=0;N<o.m_count;++N)B.vertices[N]=h.mul(r,o.m_vertices[N]),B.normals[N]=_.mul(r.q,o.m_normals[N]);var Y=2*l.polygonRadius;t.pointCount=0,A.type=x,A.index=E?0:1,A.separation=1/0;for(N=0;N<B.count;++N){(H=c.dot(j,c.sub(B.vertices[N],y)))<A.separation&&(A.separation=H)}if(A.type!=f&&!(A.separation>Y)){b.type=f,b.index=-1,b.separation=-1/0;var W=c.neo(-j.y,j.x);for(N=0;N<B.count;++N){var H,Z=c.neg(B.normals[N]),K=c.dot(Z,c.sub(B.vertices[N],y)),G=c.dot(Z,c.sub(B.vertices[N],v));if((H=a.min(K,G))>Y){b.type=g,b.index=N,b.separation=H;break}if(c.dot(Z,W)>=0){if(c.dot(c.sub(Z,O),j)<-l.angularSlop)continue}else if(c.dot(c.sub(Z,J),j)<-l.angularSlop)continue;H>b.separation&&(b.type=g,b.index=N,b.separation=H)}if(!(b.type!=f&&b.separation>Y)){var U;U=b.type==f?A:b.separation>.98*A.separation+.001?b:A;var X=[new p.clipVertex,new p.clipVertex];if(U.type==x){t.type=p.e_faceA;var Q=0,$=c.dot(j,B.normals[0]);for(N=1;N<B.count;++N){var tt=c.dot(j,B.normals[N]);tt<$&&($=tt,Q=N)}var it=Q,et=it+1<B.count?it+1:0;X[0].v=B.vertices[it],X[0].id.cf.indexA=0,X[0].id.cf.indexB=it,X[0].id.cf.typeA=p.e_face,X[0].id.cf.typeB=p.e_vertex,X[1].v=B.vertices[et],X[1].id.cf.indexA=0,X[1].id.cf.indexB=et,X[1].id.cf.typeA=p.e_face,X[1].id.cf.typeB=p.e_vertex,E?(w.i1=0,w.i2=1,w.v1=y,w.v2=v,w.normal.set(P)):(w.i1=1,w.i2=0,w.v1=v,w.v2=y,w.normal.wSet(-1,P))}else t.type=p.e_faceB,X[0].v=y,X[0].id.cf.indexA=0,X[0].id.cf.indexB=U.index,X[0].id.cf.typeA=p.e_vertex,X[0].id.cf.typeB=p.e_face,X[1].v=v,X[1].id.cf.indexA=0,X[1].id.cf.indexB=U.index,X[1].id.cf.typeA=p.e_vertex,X[1].id.cf.typeB=p.e_face,w.i1=U.index,w.i2=w.i1+1<B.count?w.i1+1:0,w.v1=B.vertices[w.i1],w.v2=B.vertices[w.i2],w.normal.set(B.normals[w.i1]);w.sideNormal1.set(w.normal.y,-w.normal.x),w.sideNormal2.wSet(-1,w.sideNormal1),w.sideOffset1=c.dot(w.sideNormal1,w.v1),w.sideOffset2=c.dot(w.sideNormal2,w.v2);var ot=[new p.clipVertex,new p.clipVertex],st=[new p.clipVertex,new p.clipVertex];if(!(p.clipSegmentToLine(ot,X,w.sideNormal1,w.sideOffset1,w.i1)<l.maxManifoldPoints||p.clipSegmentToLine(st,ot,w.sideNormal2,w.sideOffset2,w.i2)<l.maxManifoldPoints)){U.type==x?(t.localNormal=c.clone(w.normal),t.localPoint=c.clone(w.v1)):(t.localNormal=c.clone(o.m_normals[w.i1]),t.localPoint=c.clone(o.m_vertices[w.i1]));var nt=0;for(N=0;N<l.maxManifoldPoints;++N){if(c.dot(w.normal,c.sub(st[N].v,w.v1))<=Y){var rt=t.points[nt];U.type==x?(rt.localPoint=h.mulT(r,st[N].v),rt.id=st[N].id):(rt.localPoint=st[N].v,rt.id.cf.typeA=st[N].id.cf.typeB,rt.id.cf.typeB=st[N].id.cf.typeA,rt.id.cf.indexA=st[N].id.cf.indexB,rt.id.cf.indexB=st[N].id.cf.indexA),++nt}}t.pointCount=nt}}}}if(void 0===n)var n=!1;if(void 0===r)var r=!1;var m=t("../util/common"),a=(t("../util/create"),t("../common/Math")),h=t("../common/Transform"),c=t("../common/Vec2"),_=t("../common/Rot"),l=t("../Settings"),u=(t("../Shape"),t("../Contact")),p=t("../Manifold"),d=t("./EdgeShape"),y=t("./ChainShape"),v=t("./PolygonShape");u.addType(d.TYPE,v.TYPE,function(t,i,e,o,n,a,h){r&&m.assert(e.getType()==d.TYPE),r&&m.assert(a.getType()==v.TYPE),s(t,e.getShape(),i,a.getShape(),n)}),u.addType(y.TYPE,v.TYPE,function(t,i,e,o,n,a,h){r&&m.assert(e.getType()==y.TYPE),r&&m.assert(a.getType()==v.TYPE);var c=e.getShape(),_=new d;c.getChildEdge(_,o),s(t,_,i,a.getShape(),n)});var f=-1,x=1,g=2,A=new o,b=new o,B=new function(){this.vertices=[],this.normals=[],this.count=0},w=new function(){this.i1,this.i2,this.v1,this.v2,this.normal=c.zero(),this.sideNormal1=c.zero(),this.sideOffset1,this.sideNormal2=c.zero(),this.sideOffset2}},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"./ChainShape":39,"./EdgeShape":46,"./PolygonShape":47}],45:[function(t,i,e){function o(t,i,e,s){for(var n=t.m_count,r=e.m_count,m=t.m_normals,_=t.m_vertices,l=e.m_vertices,u=a.mulT(s,i),p=0,d=-1/0,y=0;y<n;++y){for(var v=h.mul(u.q,m[y]),f=a.mul(u,_[y]),x=1/0,g=0;g<r;++g){var A=c.dot(v,l[g])-c.dot(v,f);A<x&&(x=A)}x>d&&(d=x,p=y)}o._maxSeparation=d,o._bestIndex=p}function s(t,i,e,s,n){t.pointCount=0;var u=i.m_radius+s.m_radius;o(i,e,s,n);var p=o._bestIndex,d=o._maxSeparation;if(!(d>u)){o(s,n,i,e);var y=o._bestIndex,v=o._maxSeparation;if(!(v>u)){var f,x,g,A,b,B;v>d+.1*_.linearSlop?(f=s,x=i,g=n,A=e,b=y,t.type=l.e_faceB,B=1):(f=i,x=s,g=e,A=n,b=p,t.type=l.e_faceA,B=0);var w=[new l.clipVertex,new l.clipVertex];!function(t,i,e,o,s,n){var _=i.m_normals,u=s.m_count,p=s.m_vertices,d=s.m_normals;r&&m.assert(0<=o&&o<i.m_count);for(var y=h.mulT(n.q,h.mul(e.q,_[o])),v=0,f=1/0,x=0;x<u;++x){var g=c.dot(y,d[x]);g<f&&(f=g,v=x)}var A=v,b=A+1<u?A+1:0;t[0].v=a.mul(n,p[A]),t[0].id.cf.indexA=o,t[0].id.cf.indexB=A,t[0].id.cf.typeA=l.e_face,t[0].id.cf.typeB=l.e_vertex,t[1].v=a.mul(n,p[b]),t[1].id.cf.indexA=o,t[1].id.cf.indexB=b,t[1].id.cf.typeA=l.e_face,t[1].id.cf.typeB=l.e_vertex}(w,f,g,b,x,A);var S=f.m_count,C=f.m_vertices,M=b,I=b+1<S?b+1:0,P=C[M],T=C[I],V=c.sub(T,P);V.normalize();var z=c.cross(V,1),L=c.wAdd(.5,P,.5,T),F=h.mul(g.q,V),q=c.cross(F,1);P=a.mul(g,P),T=a.mul(g,T);var k=c.dot(q,P),D=-c.dot(F,P)+u,R=c.dot(F,T)+u,E=[new l.clipVertex,new l.clipVertex],j=[new l.clipVertex,new l.clipVertex];if(!(l.clipSegmentToLine(E,w,c.neg(F),D,M)<2||l.clipSegmentToLine(j,E,F,R,I)<2)){t.localNormal=z,t.localPoint=L;for(var J=0,O=0;O<j.length;++O){if(c.dot(q,j[O].v)-k<=u){var N=t.points[J];if(N.localPoint.set(a.mulT(A,j[O].v)),N.id=j[O].id,B){var Y=N.id.cf,W=Y.indexA,H=Y.indexB,Z=Y.typeA,K=Y.typeB;Y.indexA=H,Y.indexB=W,Y.typeA=K,Y.typeB=Z}++J}}t.pointCount=J}}}}if(void 0===n)var n=!1;if(void 0===r)var r=!1;var m=t("../util/common"),a=(t("../common/Math"),t("../common/Transform")),h=t("../common/Rot"),c=t("../common/Vec2"),_=(t("../collision/AABB"),t("../Settings")),l=t("../Manifold"),u=t("../Contact"),p=(t("../Shape"),t("./PolygonShape"));i.exports=s,u.addType(p.TYPE,p.TYPE,function(t,i,e,o,n,a,h){r&&m.assert(e.getType()==p.TYPE),r&&m.assert(a.getType()==p.TYPE),s(t,e.getShape(),i,a.getShape(),n)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"./PolygonShape":47}],46:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);o._super.call(this),this.m_type=o.TYPE,this.m_radius=m.polygonRadius,this.m_vertex1=t?_.clone(t):_.zero(),this.m_vertex2=i?_.clone(i):_.zero(),this.m_vertex0=_.zero(),this.m_vertex3=_.zero(),this.m_hasVertex0=!1,this.m_hasVertex3=!1}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/create"),m=(t("../util/options"),t("../Settings")),a=t("../Shape"),h=(t("../common/Math"),t("../common/Transform")),c=t("../common/Rot"),_=t("../common/Vec2");t("../collision/AABB");o.prototype=r((o._super=a).prototype),o.TYPE="edge",o.prototype.setNext=function(t){return t?(this.m_vertex3.set(t),this.m_hasVertex3=!0):(this.m_vertex3.setZero(),this.m_hasVertex3=!1),this},o.prototype.setPrev=function(t){return t?(this.m_vertex0.set(t),this.m_hasVertex0=!0):(this.m_vertex0.setZero(),this.m_hasVertex0=!1),this},o.prototype._set=function(t,i){return this.m_vertex1.set(t),this.m_vertex2.set(i),this.m_hasVertex0=!1,this.m_hasVertex3=!1,this},o.prototype._clone=function(){var t=new o;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_vertex1.set(this.m_vertex1),t.m_vertex2.set(this.m_vertex2),t.m_vertex0.set(this.m_vertex0),t.m_vertex3.set(this.m_vertex3),t.m_hasVertex0=this.m_hasVertex0,t.m_hasVertex3=this.m_hasVertex3,t},o.prototype.getChildCount=function(){return 1},o.prototype.testPoint=function(t,i){return!1},o.prototype.rayCast=function(t,i,e,o){var s=c.mulT(e.q,_.sub(i.p1,e.p)),n=c.mulT(e.q,_.sub(i.p2,e.p)),r=_.sub(n,s),m=this.m_vertex1,a=this.m_vertex2,h=_.sub(a,m),l=_.neo(h.y,-h.x);l.normalize();var u=_.dot(l,_.sub(m,s)),p=_.dot(l,r);if(0==p)return!1;var d=u/p;if(d<0||i.maxFraction<d)return!1;var y=_.add(s,_.mul(d,r)),v=_.sub(a,m),f=_.dot(v,v);if(0==f)return!1;var x=_.dot(_.sub(y,m),v)/f;return!(x<0||1<x)&&(t.fraction=d,t.normal=u>0?c.mul(e.q,l).neg():c.mul(e.q,l),!0)},o.prototype.computeAABB=function(t,i,e){var o=h.mul(i,this.m_vertex1),s=h.mul(i,this.m_vertex2);t.combinePoints(o,s),t.extend(this.m_radius)},o.prototype.computeMass=function(t,i){t.mass=0,t.center.wSet(.5,this.m_vertex1,.5,this.m_vertex2),t.I=0},o.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_vertex1),t.m_vertices.push(this.m_vertex2),t.m_count=2,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/create":51,"../util/options":52}],47:[function(t,i,e){function o(t){if(!(this instanceof o))return new o(t);o._super.call(this),this.m_type=o.TYPE,this.m_radius=l.polygonRadius,this.m_centroid=_.zero(),this.m_vertices=[],this.m_normals=[],this.m_count=0,t&&t.length&&this._set(t)}if(void 0===s)var s=!1;if(void 0===n)var n=!1;i.exports=o;var r=t("../util/common"),m=t("../util/create"),a=(t("../util/options"),t("../common/Math")),h=t("../common/Transform"),c=t("../common/Rot"),_=t("../common/Vec2"),l=(t("../collision/AABB"),t("../Settings")),u=t("../Shape");o.prototype=m((o._super=u).prototype),o.TYPE="polygon",o.prototype.getVertex=function(t){return n&&r.assert(0<=t&&t<this.m_count),this.m_vertices[t]},o.prototype._clone=function(){var t=new o;t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_count=this.m_count,t.m_centroid.set(this.m_centroid);for(var i=0;i<this.m_count;i++)t.m_vertices.push(this.m_vertices[i].clone());for(i=0;i<this.m_normals.length;i++)t.m_normals.push(this.m_normals[i].clone());return t},o.prototype.getChildCount=function(){return 1},o.prototype._set=function(t){if(n&&r.assert(3<=t.length&&t.length<=l.maxPolygonVertices),t.length<3)this._setAsBox(1,1);else{for(var i=a.min(t.length,l.maxPolygonVertices),e=[],o=0,s=0;s<i;++s){for(var m=t[s],h=!0,c=0;c<o;++c)if(_.distanceSquared(m,e[c])<.25*l.linearSlopSquared){h=!1;break}h&&(e[o++]=m)}if((i=o)<3)return n&&r.assert(!1),void this._setAsBox(1,1);var u=0,p=e[0].x;for(s=1;s<i;++s){var d=e[s].x;(d>p||d==p&&e[s].y<e[u].y)&&(u=s,p=d)}for(var y=[],v=0,f=u;;){y[v]=f;var x=0;for(c=1;c<i;++c)if(x!=f){var g=_.sub(e[x],e[y[v]]),A=(m=_.sub(e[c],e[y[v]]),_.cross(g,m));A<0&&(x=c),0==A&&m.lengthSquared()>g.lengthSquared()&&(x=c)}else x=c;if(++v,f=x,x==u)break}if(v<3)return n&&r.assert(!1),void this._setAsBox(1,1);this.m_count=v;for(s=0;s<v;++s)this.m_vertices[s]=e[y[s]];for(s=0;s<v;++s){var b=s,B=s+1<v?s+1:0,w=_.sub(this.m_vertices[B],this.m_vertices[b]);n&&r.assert(w.lengthSquared()>a.EPSILON*a.EPSILON),this.m_normals[s]=_.cross(w,1),this.m_normals[s].normalize()}this.m_centroid=function(t,i){n&&r.assert(i>=3);for(var e=_.zero(),o=0,s=_.zero(),m=0;m<i;++m){var h=s,c=t[m],l=m+1<i?t[m+1]:t[0],u=_.sub(c,h),p=_.sub(l,h),d=.5*_.cross(u,p);o+=d,e.wAdd(d*(1/3),h),e.wAdd(d*(1/3),c),e.wAdd(d*(1/3),l)}return n&&r.assert(o>a.EPSILON),e.mul(1/o),e}(this.m_vertices,v)}},o.prototype._setAsBox=function(t,i,e,o){if(this.m_vertices[0]=_.neo(-t,-i),this.m_vertices[1]=_.neo(t,-i),this.m_vertices[2]=_.neo(t,i),this.m_vertices[3]=_.neo(-t,i),this.m_normals[0]=_.neo(0,-1),this.m_normals[1]=_.neo(1,0),this.m_normals[2]=_.neo(0,1),this.m_normals[3]=_.neo(-1,0),this.m_count=4,_.isValid(e)){o=o||0,this.m_centroid.set(e);var s=h.identity();s.p.set(e),s.q.set(o);for(var n=0;n<this.m_count;++n)this.m_vertices[n]=h.mul(s,this.m_vertices[n]),this.m_normals[n]=c.mul(s.q,this.m_normals[n])}},o.prototype.testPoint=function(t,i){for(var e=c.mulT(t.q,_.sub(i,t.p)),o=0;o<this.m_count;++o){if(_.dot(this.m_normals[o],_.sub(e,this.m_vertices[o]))>0)return!1}return!0},o.prototype.rayCast=function(t,i,e,o){for(var s=c.mulT(e.q,_.sub(i.p1,e.p)),m=c.mulT(e.q,_.sub(i.p2,e.p)),a=_.sub(m,s),h=0,l=i.maxFraction,u=-1,p=0;p<this.m_count;++p){var d=_.dot(this.m_normals[p],_.sub(this.m_vertices[p],s)),y=_.dot(this.m_normals[p],a);if(0==y){if(d<0)return!1}else y<0&&d<h*y?(h=d/y,u=p):y>0&&d<l*y&&(l=d/y);if(l<h)return!1}return n&&r.assert(0<=h&&h<=i.maxFraction),u>=0&&(t.fraction=h,t.normal=c.mul(e.q,this.m_normals[u]),!0)},o.prototype.computeAABB=function(t,i,e){for(var o=1/0,s=1/0,n=-1/0,r=-1/0,m=0;m<this.m_count;++m){var c=h.mul(i,this.m_vertices[m]);o=a.min(o,c.x),n=a.max(n,c.x),s=a.min(s,c.y),r=a.max(r,c.y)}t.lowerBound.set(o,s),t.upperBound.set(n,r),t.extend(this.m_radius)},o.prototype.computeMass=function(t,i){n&&r.assert(this.m_count>=3);for(var e=_.zero(),o=0,s=0,m=_.zero(),h=0;h<this.m_count;++h)m.add(this.m_vertices[h]);m.mul(1/this.m_count);for(h=0;h<this.m_count;++h){var c=_.sub(this.m_vertices[h],m),l=h+1<this.m_count?_.sub(this.m_vertices[h+1],m):_.sub(this.m_vertices[0],m),u=_.cross(c,l),p=.5*u;o+=p,e.wAdd(p*(1/3),c,p*(1/3),l);var d=c.x,y=c.y,v=l.x,f=l.y;s+=1/3*.25*u*(d*d+v*d+v*v+(y*y+f*y+f*f))}t.mass=i*o,n&&r.assert(o>a.EPSILON),e.mul(1/o),t.center.wSet(1,e,1,m),t.I=i*s,t.I+=t.mass*(_.dot(t.center,t.center)-_.dot(e,e))},o.prototype.validate=function(){for(var t=0;t<this.m_count;++t)for(var i=t,e=t<this.m_count-1?i+1:0,o=this.m_vertices[i],s=_.sub(this.m_vertices[e],o),n=0;n<this.m_count;++n)if(n!=i&&n!=e){var r=_.sub(this.m_vertices[n],o);if(_.cross(s,r)<0)return!1}return!0},o.prototype.computeDistanceProxy=function(t){t.m_vertices=this.m_vertices,t.m_count=this.m_count,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"../util/options":52}],48:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;i.exports=function(t){var i=[],e=t.max||1/0,o=t.create,s=t.allocate,n=t.release,r=t.discard,m=0,a=0,h=0,c=0;this.max=function(t){return"number"==typeof t?(e=t,this):e},this.size=function(){return i.length},this.allocate=function(){var t;return i.length>0?t=i.shift():(m++,t="function"==typeof o?o():{}),a++,"function"==typeof s&&s(t),t},this.release=function(t){i.length<e?(h++,"function"==typeof n&&n(t),i.push(t)):(c++,"function"==typeof r&&(t=r(t)))},this.toString=function(){return" +"+m+" >"+a+" <"+h+" -"+c+" ="+i.length+"/"+e}}},{}],49:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;i.exports.now=function(){return Date.now()},i.exports.diff=function(t){return Date.now()-t}},{}],50:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;e.debug=function(){o&&console.log.apply(console,arguments)},e.assert=function(t,i,e){if(s&&!t)throw e&&console.log(e),new Error(i)}},{}],51:[function(t,i,e){function o(){}"function"==typeof Object.create?i.exports=function(t,i){return Object.create.call(Object,t,i)}:i.exports=function(t,i){if(i)throw Error("Second argument is not supported!");if("object"!=typeof t||null===t)throw Error("Invalid prototype!");return o.prototype=t,new o}},{}],52:[function(t,i,e){if(void 0===o)var o=!1;if(void 0===s)var s=!1;Object.prototype.propertyIsEnumerable;i.exports=function(t,i){null!==t&&void 0!==t||(t={});for(var e in i)i.hasOwnProperty(e)&&void 0===t[e]&&(t[e]=i[e]);if("function"==typeof Object.getOwnPropertySymbols)for(var o=Object.getOwnPropertySymbols(i),s=0;s<o.length;s++){var n=o[s];i.propertyIsEnumerable(n)&&void 0===t[e]&&(t[n]=i[n])}return t}},{}]},{},[1])(1)});